INSERT INTO `cms_groups` (`id`, `group_name`, `position`, `published`, `user_privilege`) VALUES
(1, 'General', 1, 1, 'all'),
(3, 'Configuration', 5, 1, 's'),
(9, 'Setup', 2, 1, 'all'),
(10, 'Contents', 2, 1, 'all');


INSERT INTO `dummy` (`num`) VALUES(0);
INSERT INTO `dummy` (`num`) VALUES(1);
INSERT INTO `dummy` (`num`) VALUES(2);
INSERT INTO `dummy` (`num`) VALUES(3);

INSERT INTO `cms_sections` (`id`, `group_id`, `section_name`, `section_alias`, `table_name`, `section_config`, `visibilty`, `display_order`, `user_privilege`) VALUES
(6, 1, 'Plans', 'plans', 'tbl_ProductServices', '{"customAction":"true","controller":"products","method":"listplans","module":"admin"}\r\n', '1', 8, 'all'),
(1, 3, 'Manage Groups', 'groups', 'cms_groups', '{\r\n"keyColumn":"id",\r\n"orderBy":{"id":"ASC"},\r\n"publishColumn":"published",\r\n"listColumns":["group_name","user_privilege"],\r\n"showColumns":["id","group_name","position","user_privilege"],\r\n"detailColumns":["id","group_name","position","user_privilege"],\r\n"detailHeaderColumns":["group_name"],\r\n"columns":{\r\n    "id":{"name":"ID","sortable":"true","editoptions":{"type":"hidden"}},\r\n    "group_name":{"name":"Group Name","sortable":"true","searchable":"searchable","editoptions":{"type":"textbox","label":"Group Name","class":"textbox"}},\r\n    "position":{"name":"Display Order","sortable":"true","editoptions":{"type":"textbox","label":"Display Order","class":"textbox"}},\r\n    "user_privilege":{"name":"Privilege","sortable":"true","searchable":"searchable","editoptions":{"type":"select","source":{"all":"All","s":"Superadmin"},"source_type":"array","label":"Privilege","class":"select","enumvalues":{"all":"All","s":"Superadmin"}}}\r\n    },\r\n"opertations":["add","edit","delete","view","publish"]\r\n}', '1', 2, 'all'),
(2, 3, 'Manage Sections', 'sections', 'cms_sections', '{\r\n"keyColumn":"id",\r\n"orderBy":{"id":"ASC"},\r\n"listColumns":["group_id","section_name","section_alias","visibilty","display_order"],\r\n"showColumns":["id","group_id","section_name","section_alias","table_name","section_config","visibilty","display_order"],\r\n"detailColumns":["id","group_id","section_name","section_alias","table_name","section_config","visibilty","display_order"],\r\n"detailHeaderColumns":["section_name"],\r\n"columns":{\r\n    "id":{"name":"ID","sortable":"true","editoptions":{"type":"hidden"}},\r\n    "group_id":{"name":"Group ID","sortable":"true","searchable":"searchable","editoptions":{"validations":["required"],"type":"select","source":"Cms::getAllGroups","source_type":"function","label":"Group Name","class":"select"},"external":"true","externalOptions":{"externalTable":"cms_groups","externalColumn":"id","externalShowColumn":"group_name"}},\r\n    "section_name":{"name":"Section Name","sortable":"true","searchable":"searchable","editoptions":{"validations":["required"],"type":"textbox","label":"Section Name","class":"textbox"}},\r\n    "section_alias":{"name":"Section Alias","sortable":"true","searchable":"searchable","editoptions":{"validations":["required"],"type":"textbox","label":"Section Alias","class":"textbox"}},\r\n    "table_name":{"name":"Table Name","editoptions":{"validations":["required"],"type":"textbox","label":"Table Name","class":"textbox"}},\r\n    "section_config":{"name":"Section Config","editoptions":{"validations":["required"],"type":"textarea","label":"Section Config","class":"textarea"}},\r\n    "visibilty":{"name":"Make Visible","sortable":"true","searchable":"searchable","editoptions":{"type":"checkbox","label":"Make Visible","class":"inline","default":"yes","enumvalues":{"1":"Visible","0":"Invisible"}}},\r\n    "display_order":{"name":"Display Order","sortable":"true","searchable":"searchable","editoptions":{"type":"textbox","label":"Display Order","class":"textbox"}}\r\n    },\r\n"opertations":["add","edit","delete","view","publish"]\r\n}', '1', 3, 'all'),
(3, 3, 'Manage Settings', 'manage_settings', 'tbl_cms_settings', '{\r\n"keyColumn":"id",\r\n"listColumns":["cms_set_name","cms_set_value"],\r\n"showColumns":["cms_set_name","cms_set_value"],\r\n"detailColumns":["id","cms_set_name","cms_set_value"],\r\n"detailHeaderColumns":["cms_set_name"],\r\n"columns":{\r\n    "id":{"name":"ID","sortable":"true","editoptions":{"type":"hidden"}},\r\n    "cms_set_name":{"name":"Name","sortable":"true","searchable":"searchable","editoptions":{"type":"disabled","label":"Name"}},\r\n    "cms_set_value":{"name":"Value","sortable":"true","searchable":"searchable","editoptions":{"type":"textbox","label":"Value","class":"textbox"}}\r\n},\r\n"opertations":["edit","view"]\r\n}', '1', 1, 'all'),
(17, 10, 'Admin Help', 'adminHelp', 'tbl_Help', '{\r\n    "keyColumn": "nId",\r\n"detailHeaderColumns":["vTitle"],\r\n    "orderBy": {\r\n        "vTitle": "ASC"\r\n    },\r\n    "where": "tbl_Help.eType=''Admin''",\r\n    "listColumns": [\r\n        "vTitle",\r\n        "eStatus"\r\n    ],\r\n    "showColumns": [\r\n        "nId",\r\n        "vTitle",\r\n        "tDescription",\r\n        "eType",\r\n        "eStatus"\r\n    ],\r\n    "detailColumns": [\r\n        "nId",\r\n        "vTitle",\r\n        "tDescription",\r\n        "eStatus",\r\n        "eType"\r\n    ],\r\n    "columns": {\r\n        "nId": {\r\n            "name": "ID"\r\n        },\r\n        "vTitle": {\r\n            "name": "Title",\r\n            "sortable": "true",\r\n            "searchable": "searchable",\r\n            "editoptions": {\r\n                "validations": [\r\n                    "required"\r\n                ],\r\n                "type": "textbox",\r\n                "label": "Title",\r\n                "class": "textbox"\r\n            }\r\n        },\r\n        "tDescription": {\r\n            "name": "Description",\r\n            "sortable": "true",\r\n            "searchable": "searchable",\r\n            "editoptions": {\r\n                "validations": [\r\n                    "required"\r\n                ],\r\n                "type": "htmlEditor",\r\n                "label": "Description"\r\n            }\r\n        },\r\n        "eType": {\r\n            "name": "Help Category",\r\n            "sortable": "true",\r\n            "editoptions": {\r\n                "type": "select",\r\n                "source": {\r\n                    "Admin": "Admin",\r\n                    "User": "User"\r\n                },\r\n                "source_type": "array",\r\n                "label": "Category",\r\n                "enumvalues": {\r\n                    "Admin": "Admin",\r\n                    "User": "User"\r\n                }\r\n            }\r\n        },\r\n        "eStatus": {\r\n            "name": "Status",\r\n            "editoptions": {\r\n                "type": "select",\r\n                "source": {\r\n                    "Active": "Active",\r\n                    "Disabled": "Disabled"\r\n                },\r\n                "label": "Status",\r\n                "enumvalues": {\r\n                    "Active": "Active",\r\n                    "Disabled": "Disabled"\r\n                }\r\n            }\r\n        }\r\n    },\r\n    "opertations": [\r\n        "add",\r\n        "edit",\r\n        "delete",\r\n        "view"\r\n    ]\r\n}', '1', 10, 'all'),
(7, 9, 'Settings', 'settings', ' tbl_Settings', '{"customAction":"true","controller":"module","method":"settingsdisplay","module":"admin"}\r\n', '1', 1, 'all'),
(8, 1, 'Users', 'user', 'tbl_User', '{\r\n    "keyColumn": "nUId",\r\n    "detailHeaderColumns": [\r\n        "vFirstName",\r\n        "vLastName"\r\n    ],\r\n    "detailHeaderColumnPrefix": "User: ",\r\n    "orderBy": {\r\n        "vFirstName": "ASC"\r\n    },\r\n    "listColumns": [\r\n        "vFirstName",\r\n        "vLastName",\r\n        "vEmail",\r\n        "nStatus",\r\n        "plans"\r\n    ],\r\n    "detailColumns": [\r\n        "nUId",\r\n        "vFirstName",\r\n        "vLastName",\r\n        "vEmail",\r\n        "vInvoiceEmail",\r\n        "vAddress",\r\n        "vCity",\r\n        "vState",\r\n        "vCountry",\r\n        "vZipcode",\r\n        "vPhoneNumber",\r\n        "vFax",\r\n        "nStatus",\r\n        "plans"\r\n    ],\r\n    "showColumns": [\r\n        "nUId",\r\n        "vFirstName",\r\n        "vLastName",\r\n        "vEmail",\r\n        "vInvoiceEmail",\r\n        "vAddress",\r\n        "vCity",\r\n        "vState",\r\n        "vCountry",\r\n        "vZipcode",\r\n        "vPhoneNumber",\r\n        "vFax",\r\n        "nStatus"\r\n    ],\r\n    "columns": {\r\n        "nUId": {\r\n            "name": "ID"\r\n        },\r\n        "vFirstName": {\r\n            "name": "First Name",\r\n            "searchable": "searchable",\r\n            "sortable": "true",\r\n            "editoptions": {\r\n                "validations": [\r\n                    "required"\r\n                ],\r\n                "type": "textbox",\r\n                "label": "First Name",\r\n                "class": "textbox"\r\n            }\r\n        },\r\n        "vLastName": {\r\n            "name": "Last Name",\r\n            "searchable": "searchable",\r\n            "sortable": "true",\r\n            "editoptions": {\r\n                "validations": [\r\n                    "required"\r\n                ],\r\n                "type": "textbox",\r\n                "label": "Last Name",\r\n                "class": "textbox"\r\n            }\r\n        },\r\n        "vEmail": {\r\n            "name": "Contact Email",\r\n            "searchable": "searchable",\r\n            "sortable": "true",\r\n            "editoptions": {\r\n                "validations": [\r\n                    "required"\r\n                ],\r\n                "type": "textbox",\r\n                "label": "Contact Email",\r\n                "class": "textbox"\r\n            }\r\n        },\r\n        "vInvoiceEmail": {\r\n            "name": "Invoice Email",\r\n            "searchable": "searchable",\r\n            "sortable": "true",\r\n            "editoptions": {\r\n                "type": "textbox",\r\n                "label": "Invoice Email",\r\n                "class": "textbox"\r\n            }\r\n        },\r\n        "vAddress": {\r\n            "name": "Address",\r\n            "editoptions": {\r\n                "type": "textbox",\r\n                "label": "Address",\r\n                "class": "textbox"\r\n            }\r\n        },\r\n        "vCity": {\r\n            "name": "City",\r\n            "editoptions": {\r\n                "type": "textbox",\r\n                "label": "City",\r\n                "class": "textbox"\r\n            }\r\n        },\r\n        "vState": {\r\n            "name": "State",\r\n            "editoptions": {\r\n                "type": "textbox",\r\n                "label": "State",\r\n                "class": "textbox"\r\n            }\r\n        },\r\n        "vCountry": {\r\n            "name": "Country",\r\n            "editoptions": {\r\n                "type": "textbox",\r\n                "label": "Country",\r\n                "class": "textbox"\r\n            }\r\n        },\r\n        "vZipcode": {\r\n            "name": "Zip Code",\r\n            "editoptions": {\r\n                "type": "textbox",\r\n                "label": "Zip Code",\r\n                "class": "textbox"\r\n            }\r\n        },\r\n        "vPhoneNumber": {\r\n            "name": "Phone",\r\n            "editoptions": {\r\n                "type": "textbox",\r\n                "label": "Phone",\r\n                "class": "textbox"\r\n            }\r\n        },\r\n        "vFax": {\r\n            "name": "Fax",\r\n            "editoptions": {\r\n                "type": "textbox",\r\n                "label": "Fax",\r\n                "class": "textbox"\r\n            }\r\n        },\r\n        "nStatus": {\r\n            "name": "Status",\r\n            "editoptions": {\r\n                "type": "select",\r\n                "source": {\r\n                    "1": "Active",\r\n                    "2": "Inactive"\r\n                },\r\n                "source_type": "array",\r\n                "label": "Status",\r\n                "class": "select",\r\n                "enumvalues": {\r\n                    "1": "Active",\r\n                    "2": "Inactive"\r\n                }\r\n            },\r\n            "listoptions": {\r\n                "type": "button",\r\n                "customaction": "Admin::changeUserStatus",\r\n                "enumvalues": {\r\n                    "1": "Active",\r\n                    "2": "Inactive"\r\n                },\r\n                "buttonColors": {\r\n                    "1": "green",\r\n                    "2": "red"\r\n                }\r\n            }\r\n        },\r\n        "plans": {\r\n            "name": "Plans",\r\n            "customColumn": "true",\r\n            "customaction": "Admincomponents::getCmsUserPlanDetails"\r\n        }\r\n    },\r\n    "customOperations": {\r\n        "login": {\r\n            "options": {\r\n                "target": "newtab",\r\n                "name": "Login",\r\n                "linkSource": "Admin::getuserLogInUrl"\r\n            }\r\n        }\r\n    },\r\n    "opertations": [\r\n        "view",\r\n        "edit",\r\n        "add",\r\n        "delete"\r\n    ]\r\n}', '1', 7, 'all'),
(9, 1, 'Dashboard', 'dashboard', 'tbl_ProductLookup', '{\r\n    "dashboardPanel": "true",\r\n    "graphPanel": "true",\r\n    "graphpanelRow": "2",\r\n    "graphPanel1": {\r\n        "columns": "2",\r\n        "graph1": {\r\n            "type": "MSColumn3D",\r\n            "caption":"Total Domain Registrations",\r\n            "xAxisName":"Last 7 Days",\r\n             "yAxisName":"Domain Registaration Count",\r\n            "width":"480",\r\n             "height":"300",\r\n             "dataSetsCount":"2",\r\n             "dataSets":{"dataset1":{"name":"","color":"#D3AC4F","fetchValue":"Admin::getRegistredDomainCount"}}\r\n\r\n        },\r\n        "graph2": {\r\n            "type": "MSLine",\r\n             "caption":"Total Users",\r\n             "xAxisName":"Last 7 Days",\r\n             "yAxisName":"User Count",\r\n            "width":"480",\r\n             "height":"300",\r\n               "dataSetsCount":"1",\r\n              "dataSets":{"dataset1":{"name":"","color":"#D3AC4F","fetchValue":"Admin::getUsersCount"}}\r\n\r\n        }\r\n    },\r\n    "graphPanel2": {\r\n        "columns": "2",\r\n        "graph1": {\r\n            "type": "MSColumn3D",\r\n             "caption":"Total Stores Created",\r\n             "xAxisName":"Last 7 Days",\r\n             "yAxisName":"Store Count",\r\n            "width":"480",\r\n             "height":"300",\r\n               "dataSetsCount":"1",\r\n              "dataSets":{"dataset1":{"name":"","color":"#D3AC4F","fetchValue":"Admin::getStoresCount"}}\r\n        },\r\n        "graph2": {\r\n            "type": "MSColumn3D",\r\n             "caption":"Free Trials By Month",\r\n             "xAxisName":"Last 7 Days",\r\n             "yAxisName":"Free Trails Count",\r\n            "width":"480",\r\n             "height":"300",\r\n               "dataSetsCount":"1",\r\n              "dataSets":{"dataset1":{"name":"","color":"#D3AC4F","fetchValue":"Admin::getFreeTrialsCount"}}\r\n\r\n        }\r\n    }\r\n}', '1', 0, 'all'),
(10, 1, 'Invoices', 'invoice', 'tbl_Invoice', '{\r\n  "includeJsFiles": [\r\n    "dateformats.js"\r\n    ],\r\n    "keyColumn": "nInvId",\r\n    "orderBy": {\r\n        "dGeneratedDate": "DESC"\r\n    },\r\n    "detailHeaderColumns": ["vInvNo"],\r\n    "detailHeaderColumnPrefix": "Invoice: ",\r\n    "listColumns": [\r\n        "vInvNo",\r\n        "vSubscriptionType",\r\n        "nUId",\r\n        "dGeneratedDate",\r\n        "dDueDate",\r\n        "dPayment",\r\n        "pStatus",\r\n        "nTotal"\r\n    ],\r\n    "detailColumns": [\r\n        "nInvId",\r\n        "vInvNo",\r\n        "vSubscriptionType",\r\n        "vTxnId",\r\n        "nUId",\r\n        "dGeneratedDate",\r\n        "dDueDate",\r\n        "dPayment",\r\n        "pStatus",\r\n        "nTotal"\r\n    ],\r\n    "columns": {\r\n        "nInvId": {\r\n            "name": "ID"\r\n        },\r\n        "vInvNo": {\r\n            "name": "Invoice Number",\r\n            "sortable": "true",\r\n            "customColumn": "true",\r\n            "customaction": "Admincomponents::getCmsInvoiceDetails"\r\n        },\r\n        "pStatus": {\r\n            "name": "Payment Status",\r\n            "customColumn": "true",\r\n            "customaction": "Admincomponents::getPaymentStatus"\r\n        },\r\n\r\n        "vSubscriptionType": {\r\n            "name": "Subscription",\r\n            "searchable": "searchable",\r\n            "sortable": "true"\r\n        },\r\n        "vTxnId": {\r\n            "name": "Transaction ID"\r\n        },\r\n        "nUId": {\r\n            "name": "User",\r\n            "sortable": "true",\r\n            "customColumn": "true",\r\n            "customaction": "Admincomponents::getUsernameFromInvoice"\r\n        },\r\n        "dGeneratedDate": {\r\n            "name": "Generated On",\r\n            "searchable": "searchable",\r\n            "sortable": "true",\r\n            "dbFormat": "timestamp",\r\n            "displayFormat": "m/d/Y"\r\n        },\r\n        "dDueDate": {\r\n            "name": "Due On",\r\n            "searchable": "searchable",\r\n            "sortable": "true",\r\n            "dbFormat": "timestamp",\r\n            "displayFormat": "m/d/Y"\r\n        },\r\n        "dPayment": {\r\n            "name": "Paid On",\r\n            "searchable": "searchable",\r\n            "sortable": "true",\r\n            "customColumn": "true",\r\n            "customaction": "Admincomponents::getInvoicePaidDateForCMS"\r\n        },\r\n        "nTotal": {\r\n            "name": "Total Amount",\r\n            "searchable": "searchable",\r\n            "sortable": "true"\r\n            }\r\n    },\r\n    "opertations": [\r\n        "view"\r\n    ],\r\n    "report": {\r\n        "reportTitle": "Invoices",\r\n        "columns": [\r\n            "vInvNo",\r\n            "vSubscriptionType",\r\n            "vTxnId",\r\n            "nUId",\r\n            "dGeneratedDate",\r\n            "dDueDate",\r\n            "dPayment",\r\n            "pStatus",\r\n            "nTotal"\r\n        ],\r\n        "dateColumn": "dGeneratedDate"\r\n    }\r\n}', '1', 3, 'all'),
(40, 9, 'Screenshots', 'screenshots', 'tbl_DemoScreenshots', '{\r\n    "keyColumn": "nScreenId",\r\n    "handleFile": "true",\r\n    "orderBy": {\r\n        "nScreenId": "DESC"\r\n    },\r\n    "listColumns": [\r\n        "eType",       \r\n        "vScreenImageId",\r\n        "vActive"       \r\n    ],\r\n    "showColumns": [\r\n        "nScreenId",\r\n        "eType",        \r\n        "vScreenImageId",\r\n        "vActive"       \r\n    ],\r\n    "detailColumns": [\r\n        "nScreenId",\r\n        "eType",       \r\n        "vScreenImageId",\r\n        "vActive"        \r\n    ],\r\n    "columns": {\r\n        "eType": {\r\n            "name": "Screen Type",\r\n            "sortable": "true",\r\n            "searchable": "searchable",\r\n            "editoptions": {\r\n                "type": "select",\r\n                "validations": [\r\n                    "required"\r\n                ],\r\n                "source": {\r\n                    "User": "User Panel Screen",\r\n                    "Admin": "Admin Panel Screen"\r\n                },\r\n                "source_type": "array",\r\n                "label": "Screen Type",\r\n                "class": "select",\r\n                "enumvalues": {\r\n                    "User": "User Panel Screen",\r\n                    "Admin": "Admin Panel Screen"\r\n                }\r\n            }\r\n        },               \r\n        "vScreenImageId": {\r\n            "name": "Screen Image",\r\n            "editoptions": {\r\n                "validations": [\r\n                    "required"\r\n                ],\r\n                "type": "file",\r\n                "label": "Screen Image",\r\n                "class": "file",\r\n                "hint": "User Panel Screen : Ideal Width & Height - 400px X 231px <br> Admin Panel Screen : Ideal Width & Height - 400px X 231px"\r\n            },\r\n            "customColumn": "true",\r\n            "customaction": "Admincomponents::getCmsScreenImage"\r\n        },        \r\n        "vActive": {\r\n            "name": "Status",\r\n            "editoptions": {\r\n                "type": "checkbox",\r\n                "label": "Enable Screen",\r\n                "default": "yes",\r\n                "enumvalues": {\r\n                    "0": "Inactive",\r\n                    "1": "Active"\r\n                }\r\n            },\r\n            "listoptions": {\r\n                "type": "button",\r\n                "customaction": "Admin::changeScreenStatus",\r\n                "enumvalues": {\r\n                    "1": "Active",\r\n                    "0": "Inactive"\r\n                },\r\n                "buttonColors": {\r\n                    "1": "green",\r\n                    "0": "red"\r\n                }\r\n            }\r\n        }\r\n    },\r\n    "opertations": [\r\n        "add",\r\n        "edit",\r\n        "delete",\r\n        "publish"\r\n    ]\r\n}', '1', 7, 'all'),
(12, 1, 'Feedback', 'feedback', 'tbl_contacts', '{\r\n    "keyColumn": "id",\r\n    "orderBy": {\r\n        "cdate": "ASC"\r\n    },\r\n    "detailHeaderColumns": ["cname"],\r\n    "detailHeaderColumnPrefix": "Feedback: ",\r\n    "listColumns": [\r\n        "cname",\r\n        "cemail",\r\n        "cdescr",\r\n        "cdate"\r\n    ],\r\n    "detailColumns": [\r\n        "id",\r\n        "cname",\r\n        "cemail",\r\n        "cdescr",\r\n        "cdate"\r\n    ],\r\n    "columns": {\r\n    "id":{"name":"ID"},\r\n        "cname": {\r\n            "name": "Customer",\r\n            "searchable": "searchable",\r\n            "sortable": "true"\r\n        },\r\n        "cemail": {\r\n            "name": "Email",\r\n            "searchable": "searchable",\r\n            "sortable": "true"\r\n        },\r\n        "cdescr": {\r\n            "name": "Feedbacks",\r\n            "sortable": "true"\r\n        },\r\n        "cdate": {\r\n            "name": "Date",\r\n            "sortable": "true",\r\n            "dbFormat":"datetime",\r\n            "displayFormat":"m/d/Y"\r\n        }\r\n    },\r\n    "opertations": [\r\n        "view",\r\n        "delete"\r\n    ]\r\n}', '1', 6, 'all'),
(13, 9, 'Server Info', 'serverinfo', 'tbl_ServerInfo', '{\r\n    "keyColumn": "nserver_id",\r\n    "orderBy": {\r\n        "vserver_name": "ASC"\r\n    },\r\n    "listColumns": [\r\n        "vserver_name",\r\n        "vmakethisserver_default",\r\n        "whm_port",\r\n        "cpanel_port"\r\n    ],\r\n    "showColumns": [\r\n        "nserver_id",\r\n        "vserver_name",\r\n        "whmuser",\r\n        "whmpass",\r\n        "whmip",\r\n        "vserver_hosting_plan",\r\n        "vserver_configfilename",\r\n        "vserver_configfilepath",\r\n\r\n        "whm_port",\r\n        "cpanel_port",\r\n\r\n        "vmakethisserver_default"\r\n    ],\r\n    "detailColumns": [\r\n        "nserver_id",\r\n        "vserver_name",\r\n        "whmuser",\r\n        "whmpass",\r\n        "whmip",\r\n        "vserver_hosting_plan",\r\n        "vserver_configfilename",\r\n        "vserver_configfilepath",\r\n\r\n        "whm_port",\r\n        "cpanel_port",\r\n\r\n        "vmakethisserver_default"\r\n    ],\r\n    "detailHeaderColumns": [\r\n        "vserver_name"\r\n    ],\r\n    "detailHeaderColumnPrefix": "Server Info: ",\r\n    "columns": {\r\n        "nserver_id": {\r\n            "name": "ID",\r\n            "sortable": "true",\r\n            "editoptions": {\r\n                "type": "hidden"\r\n            }\r\n        },\r\n        "vserver_name": {\r\n            "name": "Server",\r\n            "sortable": "true",\r\n            "searchable": "searchable",\r\n            "editoptions": {\r\n                "validations": [\r\n                    "required"\r\n                ],\r\n                "type": "textbox",\r\n                "label": "Server Name",\r\n                "class": "textbox",\r\n                "hint": "Enter your Host name eg: yoursitename.com"\r\n            }\r\n        },\r\n        "whmuser": {\r\n            "name": "WHM User",\r\n            "sortable": "true",\r\n            "editoptions": {\r\n                "validations": [\r\n                    "required"\r\n                ],\r\n                "type": "textbox",\r\n                "label": "WHM User",\r\n                "class": "textbox",\r\n                 "hint": "Enter the WHM user name"\r\n            }\r\n        },\r\n        "whmpass": {\r\n            "name": "WHM Password",\r\n            "editoptions": {\r\n                "validations": [\r\n                    "required"\r\n                ],\r\n                "type": "password",\r\n                "label": "WHM Password",\r\n"noEncryption" : "true",\r\n                "source":"Admincomponents::cipherPassword",           \r\n                "source_type":"function",\r\n                "class": "textbox",\r\n                 "hint": "Enter the WHM password"\r\n            }\r\n        },\r\n        "whmip": {\r\n            "name": "WHM IP",\r\n            "editoptions": {\r\n                "validations": [\r\n                    "required"\r\n                ],\r\n                "type": "textbox",\r\n                "label": "WHM IP",\r\n                "class": "textbox",\r\n                 "hint": "Enter WHM IP"\r\n            }\r\n        },\r\n        "vserver_hosting_plan": {\r\n            "name": "Server Package Name",\r\n            "editoptions": {\r\n                "validations": [\r\n                    "required"\r\n                ],\r\n                "type": "textbox",\r\n                "label": "Server Package Name",\r\n                "class": "textbox",\r\n                 "hint": "Enter the server package name/ hosting package name"\r\n            }\r\n        },\r\n        "vserver_configfilename": {\r\n            "name": "Product Pack Location",\r\n            "editoptions": {\r\n                "validations": [\r\n                    "required"\r\n                ],\r\n                "type": "textbox",\r\n                "label": "Product Pack Location",\r\n                "source":"Admincomponents::getDefaultPackLocation",\r\n                "source_type":"function",\r\n                "class": "textbox",\r\n                 "hint": "Enter the product pack locaton eg: /home/yourWHMusername/public_html/project/products/"\r\n            }\r\n        },\r\n        "vserver_configfilepath": {\r\n            "name": "Setup Landing Location",\r\n            "editoptions": {\r\n                "validations": [\r\n                    "required"\r\n                ],\r\n                "type": "textbox",\r\n                "label": "Setup Landing Location",\r\n"source":"Admincomponents::getDefaultLandingLocation",\r\n                "source_type":"function",\r\n                "class": "textbox",\r\n                 "hint": "Enter the setup landing location eg: /public_html/"\r\n            }\r\n        },\r\n\r\n\r\n         "whm_port": {\r\n            "name": "WHM Port",\r\n            "editoptions": {\r\n                "validations": [\r\n                    "required"\r\n                ],\r\n                "type": "textbox",\r\n                "label": "WHM Port",\r\n                "class": "textbox",\r\n                 "hint": "Enter the WHM Port eg: 2086 / 2087(secure)"\r\n            }\r\n        },\r\n         "cpanel_port": {\r\n            "name": "CPanel Port",\r\n            "editoptions": {\r\n                "validations": [\r\n                    "required"\r\n                ],\r\n                "type": "textbox",\r\n                "label": "CPanel Port",\r\n                "class": "textbox",\r\n                 "hint": "Enter the CPanel Port eg : 2082 / 2083(secure)"\r\n            }\r\n        },\r\n\r\n\r\n\r\n\r\n        "vmakethisserver_default": {\r\n            "name": "Default Server",\r\n            "editoptions": {\r\n                "type": "checkbox",\r\n                "label": "Make Default Server",\r\n                "class": "inline",\r\n                 "hint": "Check this to enable this as default server",\r\n                "default": "NO",\r\n                "enumvalues": {\r\n                    "1": "YES",\r\n                    "0": "NO"\r\n                }\r\n            },\r\n            "listoptions": {\r\n                "type": "button",\r\n                "customaction": "Admin::getServerDefaultUrl",\r\n                "enumvalues": {\r\n                    "1": "YES",\r\n                    "0": "NO"\r\n                },\r\n                "buttonColors": {\r\n                    "1": "green",\r\n                    "0": "red"\r\n                }\r\n            }\r\n        }\r\n    },\r\n    "customActions": {\r\n        "afterEditRecord": "Admincomponents::updateDomainStatus",\r\n        "afterAddRecord": "Admincomponents::updateDomainStatus"\r\n    },\r\n    "opertations": [\r\n        "add",\r\n      "edit",\r\n"delete"\r\n\r\n    ]\r\n}', '1', 5, 'all'),
(14, 1, 'Plan Features', 'product_service_features', 'tbl_ServiceFeatures', '{\r\n"keyColumn": "nFeatureId",\r\n"orderBy": {\r\n    "nFeatureId": "DESC"\r\n},\r\n"detailHeaderColumns": ["tFeatureName"],\r\n"detailHeaderColumnPrefix": "Plan Feature: ",\r\n"listColumns": [\r\n    "tFeatureName",\r\n    "tValue",\r\n    "eStatus"\r\n],\r\n"showColumns": [\r\n    "nFeatureId",\r\n    "tFeatureName",\r\n    "tValue",\r\n    "eStatus"\r\n],\r\n"detailColumns": [\r\n    "nFeatureId",\r\n    "tFeatureName",\r\n    "tValue",\r\n    "eStatus"\r\n],\r\n"columns": {\r\n    "nFeatureId": {\r\n        "name": "ID",\r\n        "editoptions": {\r\n            "type": "hidden"\r\n        }\r\n    },\r\n    "tFeatureName": {\r\n        "name": "Name",\r\n        "sortable": "true",\r\n        "editoptions": {\r\n            "validations": [\r\n                    "required"\r\n                ],\r\n            "type": "textbox",\r\n            "label": "Name"\r\n        }\r\n    },\r\n    "tValue": {\r\n        "name": "Value",\r\n        "sortable": "true",\r\n        "editoptions": {\r\n            "validations": [\r\n                    "required"\r\n                ],\r\n            "type": "textbox",\r\n            "label": "Value"\r\n        }\r\n    },\r\n    "eStatus": {\r\n        "name": "Status",\r\n        "editoptions": {\r\n            "validations": [\r\n                    "required"\r\n                ],\r\n            "type": "select",\r\n            "source": {\r\n            "Active": "Active",\r\n            "Disabled": "Inactive"\r\n            },\r\n            "source_type": "array",\r\n            "label": "Status",\r\n            "class": "select",\r\n            "enumvalues": {\r\n                "Active": "Active",\r\n                "Disabled": "Inactive"\r\n            }\r\n        },\r\n        "listoptions": {\r\n                "type": "button",\r\n                "customaction": "Admin::changeServiceFeatureStatus",\r\n                "enumvalues": {\r\n                    "Active": "Active",\r\n                    "Disabled": "Inactive"\r\n                },\r\n                "buttonColors": {\r\n                    "Active": "green",\r\n                    "Disabled": "red"\r\n                }\r\n            }\r\n\r\n    }\r\n},\r\n"opertations": [\r\n    "view",\r\n    "edit",\r\n    "add"\r\n    ]\r\n}', '0', 0, 'all'),
(16, 10, 'User Help ', 'userHelp', 'tbl_Help', '{\r\n    "keyColumn": "nId",\r\n"detailHeaderColumns":["vTitle"],\r\n    "orderBy": {\r\n        "vTitle": "ASC"\r\n    },\r\n    "where": "tbl_Help.eType=''User''",\r\n    "listColumns": [\r\n        "vTitle",\r\n        "eStatus"\r\n    ],\r\n    "showColumns": [\r\n        "nId",\r\n        "vTitle",\r\n        "tDescription",\r\n        "eType",\r\n        "eStatus"\r\n    ],\r\n    "detailColumns": [\r\n        "nId",\r\n        "vTitle",\r\n        "tDescription",\r\n        "eStatus",\r\n        "eType"\r\n    ],\r\n    "columns": {\r\n        "nId": {\r\n            "name": "ID"\r\n        },\r\n        "vTitle": {\r\n            "name": "Title",\r\n            "sortable": "true",\r\n            "searchable": "searchable",\r\n            "editoptions": {\r\n                "validations": [\r\n                    "required"\r\n                ],\r\n                "type": "textbox",\r\n                "label": "Title",\r\n                "class": "textbox"\r\n            }\r\n        },\r\n        "tDescription": {\r\n            "name": "Description",\r\n            "editoptions": {\r\n                "validations": [\r\n                    "required"\r\n                ],\r\n                "type": "htmlEditor",\r\n                "label": "Description"\r\n            }\r\n        },\r\n        "eType": {\r\n            "name": "Help Category",\r\n            "sortable": "true",\r\n            "editoptions": {\r\n                "type": "select",\r\n                "source": {\r\n                    "Admin": "Admin",\r\n                    "User": "User"\r\n                },\r\n                "source_type": "array",\r\n                "label": "Category",\r\n                "enumvalues": {\r\n                    "Admin": "Admin",\r\n                    "User": "User"\r\n                }\r\n            }\r\n        },\r\n        "eStatus": {\r\n            "name": "Status",\r\n            "editoptions": {\r\n                "type": "select",\r\n                "source": {\r\n                    "Active": "Active",\r\n                    "Disabled": "Disabled"\r\n                },\r\n                "label": "Status",\r\n                "enumvalues": {\r\n                    "Active": "Active",\r\n                    "Disabled": "Disabled"\r\n                }\r\n            }\r\n        }\r\n    },\r\n    "opertations": [\r\n        "add",\r\n        "edit",\r\n        "delete",\r\n        "view"\r\n    ]\r\n}', '1', 9, 'all'),
(15, 1, 'Domains', 'domains', 'tbl_ProductLookup', '{\r\n    "keyColumn": "nPLId",\r\n    "dataSource": "external",\r\n    "dataSourceFunction": "Admincomponents::fetchDomaindata",\r\n    "dataSourceCountFunction": "Admincomponents::fetchDomaindataCount",\r\n    "detailHeaderColumns": [\r\n        "vDomain"\r\n    ],\r\n    "detailHeaderColumnPrefix": "Domain: ",\r\n    "listColumns": [\r\n        "vDomain",\r\n        "nUId",\r\n        "dDateStop",\r\n        "account_operations"\r\n    ],\r\n    "detailColumns": [\r\n        "nPLId",\r\n        "vDomain",\r\n        "nUId",\r\n       "dDateStop",\r\n        "account_operations"\r\n    ],\r\n    "columns": {\r\n        "nPLId": {\r\n            "name": "ID"\r\n        },\r\n        "vDomain": {\r\n            "name": "Domain",\r\n            "sortable": "true",\r\n            "searchable": "searchable",\r\n            "customColumn": "true",\r\n            "customaction": "Admincomponents::getStoreHostWithAdminNav"\r\n        },\r\n        "nUId": {\r\n            "name": "User",\r\n            "sortable": "true",\r\n            "searchable": "searchable",\r\n            "customColumn": "true",\r\n            "customaction": "Admincomponents::getUsername"\r\n        },\r\n        "dDateStop": {\r\n            "name": "Plan Expiry Date",\r\n            "sortable": "true",\r\n            "searchable": "searchable",\r\n            "customColumn": "true",\r\n            "customaction": "Admincomponents::getPlanExpiryCms"\r\n        },\r\n         "account_operations": {\r\n            "name": "Account",\r\n"disableDetailedView":"false",\r\n            "customColumn": "true",\r\n            "customaction": "Admincomponents::getAccountSuspendLink"\r\n            }\r\n    },\r\n    "opertations": [\r\n        "view"\r\n    ],\r\n    "includeJsFiles":["cmshelper.js"]\r\n\r\n}', '1', 5, 'all'),
(18, 1, 'Service History', 'orders', 'tbl_Invoice ', '{"customAction":"true","controller":"service","method":"index","module":"admin"}', '1', 2, 'all'),
(19, 10, 'Email Template', 'emailtemplates', 'tbl_Cms', '{\n    "keyColumn": "cms_id",\n    "orderBy": {\n        "cms_id": "ASC"\n    },\n    "where": "tbl_Cms.cms_type=''email_settings''",\n    "listColumns": [\n        "cms_name",\n        "cms_status"\n    ],\n    "showColumns": [\n        "cms_id",\n        "cms_name",\n        "cms_title",\n        "cms_desc",\n        "cms_status"\n    ],\n    "detailColumns": [\n        "cms_id",\n        "cms_name",\n        "cms_title",\n        "cms_desc",\n        "cms_status"\n    ],\n    "detailHeaderColumns": [\n        "cms_title"\n    ],\n    "columns": {\n        "cms_id": {\n            "name": "ID",\n            "sortable": "true",\n            "editoptions": {\n                "type": "hidden"\n            }\n        },\n        "cms_name": {\n            "name": "Name",\n            "sortable": "true",\n            "editoptions": {\n                "type": "hidden"\n            }\n        },\n        "cms_title": {\n            "name": "Title",\n            "sortable": "true",\n            "editoptions": {\n                "validations": [\n                    "required"\n                ],\n                "type": "textbox",\n                "label": "Title",\n                "class": "textbox"\n            }\n        },\n        "cms_desc": {\n            "name": "Content",\n            "sortable": "true",\n            "editoptions": {\n                "validations": [\n                    "required"\n                ],\n                "type": "htmlEditor",\n                "label": "Content",\n                "class": "textarea"\n            }\n        },\n        "cms_status": {\n            "name": "Status",\n            "editoptions": {\n                "type": "select",\n                "source": {\n                    "0": "Inactive",\n                    "1": "Active"\n                },\n                "source_type": "array",\n                "label": "Status",\n                "class": "select",\n                "enumvalues": {\n                    "0": "Inactive",\n                    "1": "Active"\n                }\n            }\n        }\n    },\n    "opertations": [\n        "edit"\n    ]\n}', '1', 5, 'all'),
(20, 9, 'Banner Management', 'bannerManagement', 'tbl_Banners', '{\r\n    "keyColumn": "nBannerId",\r\n    "handleFile": "true",\r\n    "orderBy": {\r\n        "nBannerId": "DESC"\r\n    },\r\n    "listColumns": [\r\n        "eType",\r\n        "vBannerUrl",\r\n        "vBannerText",\r\n        "vBannerImageId",\r\n        "vActive",\r\n        "showcount",\r\n        "clickcount",\r\n        "displayOrder"\r\n    ],\r\n    "showColumns": [\r\n        "nBannerId",\r\n        "eType",\r\n        "vBannerText",\r\n        "vBannerUrl",\r\n        "vBannerImageId",\r\n        "vActive",\r\n        "showcount",\r\n        "clickcount",\r\n        "displayOrder"\r\n    ],\r\n    "detailColumns": [\r\n        "nBannerId",\r\n        "eType",\r\n        "vBannerUrl",\r\n        "vBannerText",\r\n        "vBannerImageId",\r\n        "vActive",\r\n        "showcount",\r\n        "clickcount",\r\n        "displayOrder"\r\n    ],\r\n    "columns": {\r\n        "eType": {\r\n            "name": "Banner Type",\r\n            "sortable": "true",\r\n            "searchable": "searchable",\r\n            "editoptions": {\r\n                "type": "select",\r\n                "validations": [\r\n                    "required"\r\n                ],\r\n                "source": {\r\n                    "Home Page Sliding Banner": "Home Page Sliding Banner",\r\n                    "Footer": "Footer"\r\n                },\r\n                "source_type": "array",\r\n                "label": "Banner Type",\r\n                "class": "select",\r\n                "enumvalues": {\r\n                    "Home Page Sliding Banner": "Home Page Sliding Banner",\r\n                    "Footer": "Footer"\r\n                }\r\n            }\r\n        },\r\n        "vBannerUrl": {\r\n            "name": "Banner Url",\r\n            "sortable": "true",\r\n            "searchable": "searchable",\r\n            "editoptions": {\r\n                "validations": [\r\n                    "required"\r\n                ],\r\n                "type": "textbox",\r\n                "label": "Banner Url"\r\n            }\r\n        },\r\n        "vBannerText": {\r\n            "name": "Banner Text",\r\n            "sortable": "true",\r\n            "editoptions": {\r\n                "type": "textbox",\r\n                "label": "Banner Text"\r\n            }\r\n        },\r\n        "vBannerImageId": {\r\n            "name": "Banner Image",\r\n            "editoptions": {\r\n                "validations": [\r\n                    "required"\r\n                ],             \r\n                "type": "file",\r\n                "label": "Banner Image",\r\n                "class": "file",\r\n                "hint": "Home Page Sliding Banner should be with : Width & Height - 1250px X 400px <br> Footer should be with: Width & Height - 468px X 60px"\r\n            },\r\n            "customColumn": "true",\r\n            "customaction": "Admincomponents::getCmsBannerImage"\r\n        },\r\n        "showcount": {\r\n            "name": "Impressions",\r\n            "sortable": "true"\r\n        },\r\n        "clickcount": {\r\n            "name": "Click  Count",\r\n            "sortable": "true"\r\n        },\r\n        "displayOrder": {\r\n            "name": "Display  Order",\r\n            "sortable": "true",\r\n            "editoptions": {\r\n                "validations": [\r\n                    "required"\r\n                ],\r\n                "type": "textbox",\r\n                "label": "Display Order"\r\n            }\r\n        },\r\n        "vActive": {\r\n            "name": "Status",\r\n            "editoptions": {\r\n                "type": "checkbox",\r\n                "label": "Enable Banner",\r\n                "default": "yes",\r\n                "enumvalues": {\r\n                    "0": "Inactive",\r\n                    "1": "Active"\r\n                }\r\n            },\r\n            "listoptions": {\r\n                "type": "button",\r\n                "customaction": "Admin::changeBannerStatus",\r\n                "enumvalues": {\r\n                    "1": "Active",\r\n                    "0": "Inactive"\r\n                },\r\n                "buttonColors": {\r\n                    "1": "green",\r\n                    "0": "red"\r\n                }\r\n            }\r\n        }\r\n    },\r\n    "opertations": [\r\n        "add",\r\n        "edit",\r\n        "delete",\r\n        "publish"\r\n    ]\r\n}', '1', 3, 'all'),
(21, 10, 'Email Scheduler', 'emailscheduler', 'tbl_EmailTemplatesMails', '{\r\n    "keyColumn": "nETMId",\r\n    "detailHeaderColumns": [\r\n        "vMailName"\r\n    ],\r\n    "detailHeaderColumnPrefix": "Email Scheduler: ",\r\n    "orderBy": {\r\n        "nETMId": "DESC"\r\n    },\r\n    "listColumns": [\r\n        "vMailName",\r\n        "nETID",\r\n        "tScheduleTime",\r\n        "eStatus",\r\n        "nMailMode"\r\n    ],\r\n    "detailColumns": [\r\n        "nETMId",\r\n        "vMailName",\r\n        "nETID",\r\n        "tScheduleTime",\r\n        "eStatus",\r\n        "nMailMode"\r\n    ],\r\n    "showColumns": [\r\n        "nETMId",\r\n        "vMailName",\r\n        "nETID",\r\n        "tScheduleTime",\r\n        "eStatus",\r\n        "nMailMode"\r\n    ],\r\n    "columns": {\r\n        "nETMId": {\r\n            "name": "ID",\r\n            "sortable": "true"\r\n        },\r\n        "vMailName": {\r\n            "name": "Mail Name",\r\n            "searchable": "searchable",\r\n            "sortable": "true",\r\n            "editoptions": {\r\n                "validations": [\r\n                    "required"\r\n                ],\r\n                "type": "textbox",\r\n                "label": "Mail Name",\r\n                "class": "textbox"\r\n            }\r\n        },\r\n        "nETID": {\r\n            "name": "Email Template Name",\r\n            "searchable": "searchable",\r\n            "sortable": "true",\r\n            "editoptions": {\r\n                "validations": [\r\n                    "required"\r\n                ],\r\n                "type": "select",\r\n                "source": "Streamsendlogic::getemailTemplateList",\r\n                "source_type": "function",\r\n                "label": "Email Template Name",\r\n                "class": "select"\r\n            },\r\n            "external": "true",\r\n            "externalOptions": {\r\n                "externalTable": "tbl_EmailTemplates",\r\n                "externalColumn": "nETID",\r\n                "externalShowColumn": "vemailTemplateName"\r\n            }\r\n        },\r\n        "tScheduleTime": {\r\n            "name": "Schedule Time",\r\n            "searchable": "searchable",\r\n            "sortable": "true",\r\n            "editoptions": {\r\n                "validations": [\r\n                    "required"\r\n                ],\r\n                "type": "datepicker",\r\n                "label": "Schedule Time",\r\n                "class": "datepicker",\n                "dbFormat": "datetime",\n                "displayFormat": "m/d/Y"\r\n            },\n                "dbFormat": "datetime",\n                "displayFormat": "m/d/Y"\r\n        },\r\n        "eStatus": {\r\n            "name": "Status",\r\n            "searchable": "searchable",\r\n            "editoptions": {\r\n                "type": "hidden",\r\n                "class": "hidden",\r\n                "value": "Active"\r\n                \r\n            },\r\n            "listoptions": {\r\n                "type": "button",\r\n                "customaction": "Admin::changeEmailSchedulerStatus",\r\n                "enumvalues": {\r\n                    "Active": "Active",\r\n                    "Deactive": "Inactive"\r\n                },\r\n                "buttonColors": {\r\n                    "Active": "green",\r\n                    "Deactive": "red"\r\n                }\r\n            }\r\n        },\r\n        "nMailMode": {\r\n            "name": "Mail Mode",\r\n            "searchable": "searchable",\r\n            "sortable": "true",\r\n            "editoptions": {\r\n                "type": "hidden",\r\n                "class": "hidden",\r\n                "value": "Streamsend"\r\n            }\r\n        }\r\n    },\r\n    "customActions": {\r\n        "afterAddRecord": "Streamsendlogic::setScheduleMail",\r\n        "afterEditRecord": "Streamsendlogic::setScheduleMailEdit"\r\n    },\r\n    "opertations": [\r\n        "view",\r\n        "edit",\r\n        "add",\r\n        "delete"\r\n    ]\r\n}', '1', 2, 'all'),
(22, 1, 'Billing', 'billing', 'tbl_User', '{\r\n    "keyColumn": "nUId",\r\n    "orderBy": { "vFirstName": "ASC"},\r\n    "listColumns": ["vName","vEmail","vInvoiceEmail","vPlan","vStatus"],\r\n    "detailColumns": ["nUId","vName","vEmail","vInvoiceEmail","vPlan","vStatus"],\r\n    "columns": {\r\n        "nUId": {},\r\n        "vName": { "name": "Name","customColumn": "true","customaction": "User::getNameById"},\r\n        "vEmail": {"name": "Email","searchable": "searchable","sortable": "true"},\r\n        "vInvoiceEmail": {"name": "Invoice Email","searchable": "searchable","sortable": "true"},\r\n        "vPlan": {"name": "Plans","customColumn": "true","customaction": "Admincomponents::getUserPlansForCmsListing"},\r\n        "vStatus": {"name": "User Status","customColumn": "true","customaction": "User::getUserStatusById"}\r\n    },\r\n    "opertations": ["view"]\r\n}', '0', 4, 'all'),
(23, 1, 'User Plans', 'user_plans', 'tbl_ProductServices', '{"customAction":"true","controller":"products","method":"listuserplans","module":"admin"}', '0', 0, 'all'),
(24, 9, 'Paid Templates', 'paid_templates', 'tbl_PaidTemplates', '{\r\n    "keyColumn": "nTemplateId",\r\n    "handleFile": "true",\r\n    "orderBy": {\r\n        "vTemplateName": "ASC"\r\n    },\r\n    "listColumns": [\r\n        "vTemplateName",\r\n        "vTemplateZipId",\r\n        "vHomeScreenshotId",\r\n        "vInnerScreenshot1Id",\r\n        "vInnerScreenshot2Id",\r\n        "nCost",\r\n        "vActive"\r\n    ],\r\n    "showColumns": [\r\n        "nTemplateId",\r\n        "vTemplateName",\r\n        "vDescription",\r\n        "vTemplateZipId",\r\n        "vHomeScreenshotId",\r\n        "vInnerScreenshot1Id",\r\n        "vInnerScreenshot2Id",\r\n        "nCost",\r\n        "vActive"\r\n    ],\r\n    "detailColumns": [\r\n        "nTemplateId",\r\n        "vTemplateName",\r\n        "vDescription",\r\n        "vTemplateZipId",\r\n        "vHomeScreenshotId",\r\n        "vInnerScreenshot1Id",\r\n        "vInnerScreenshot2Id",\r\n        "nCost",\r\n        "vActive"\r\n    ],\r\n    "columns": {\r\n        "vTemplateName": {\r\n            "name": "Template Name",\r\n            "sortable": "true",\r\n            "searchable": "true",\r\n            "editoptions": {\r\n                "type": "textbox",\r\n                "label": "Template Name"\r\n            }\r\n        },\r\n        "vDescription": {\r\n            "name": "Description",\r\n            "sortable": "true",\r\n            "searchable": "true",\r\n            "editoptions": {\r\n                "type": "textarea",\r\n                "label": "Description"\r\n            }\r\n        },\r\n        "vTemplateZipId": {\r\n            "name": "Template Zip",\r\n            "customColumn": "true",\r\n            "customaction": "Admincomponents::downloadTemplateZip",\r\n            "editoptions": {\r\n                "validations": [\r\n                    "required"\r\n                ],\r\n                "type": "file",\r\n                "label": "Template Zip",\r\n                "class": "file",\r\n                "hint": "Upload type : .zip file with folders img/TemplateName/ with images and css/ with TemplateName.css file"\r\n            },\r\n            "external": "true",\r\n            "externalOptions": {\r\n                "externalTable": "tbl_files",\r\n                "externalColumn": "file_id",\r\n                "externalShowColumn": "file_id"\r\n            }\r\n        },\r\n         "vHomeScreenshotId": {\r\n            "name": "Home Page Screenshot",\r\n            "editoptions": {\r\n                "validations": [\r\n                    "required"\r\n                ],\r\n                "type": "file",\r\n                "label": "Home Page Screenshot",\r\n                "class": "file",\r\n                "hint": "Ideal size 295x235"\r\n            },\r\n            "external": "true",\r\n            "externalOptions": {\r\n                "externalTable": "tbl_files",\r\n                "externalColumn": "file_id",\r\n                "externalShowColumn": "file_id"\r\n            }\r\n        },\r\n         "vInnerScreenshot1Id": {\r\n            "name": "Inner Page Screenshot 1",\r\n            "editoptions": {\r\n                "validations": [\r\n                    "required"\r\n                ],\r\n                "type": "file",\r\n                "label": "Inner Page Screenshot1",\r\n                "class": "file",\r\n                "hint": "Ideal size 295x235"\r\n            },\r\n            "external": "true",\r\n            "externalOptions": {\r\n                "externalTable": "tbl_files",\r\n                "externalColumn": "file_id",\r\n                "externalShowColumn": "file_id"\r\n            }\r\n        },\r\n         "vInnerScreenshot2Id": {\r\n            "name": "Inner Page Screenshot 2",\r\n            "editoptions": {\r\n                "validations": [\r\n                    "required"\r\n                ],\r\n                "type": "file",\r\n                "label": "Inner Page Screenshot 2",\r\n                "class": "file",\r\n                "hint": "Ideal size 295x235"\r\n            },\r\n            "external": "true",\r\n            "externalOptions": {\r\n                "externalTable": "tbl_files",\r\n                "externalColumn": "file_id",\r\n                "externalShowColumn": "file_id"\r\n            }\r\n        },\r\n        "nCost": {\r\n            "name": "Price",\r\n            "sortable": "true",\r\n            "searchable": "true",\r\n            "editoptions": {\r\n                "type": "textbox",\r\n                "label": "Price",\r\n                "validations": [\r\n                    "required"\r\n                ]\r\n                \r\n            }\r\n            \r\n        },\r\n        "vActive": {\r\n            "name": "Publish",\r\n            "editoptions": {\r\n                "type": "checkbox",\r\n                "label": "Enable Template",\r\n                "default": "yes",\r\n                "enumvalues": {\r\n                    "1": "Active",\r\n                    "0": "Inactive"\r\n                }\r\n            }\r\n        }\r\n    },\r\n    "opertations": [\r\n        "add",\r\n        "edit",\r\n        "delete",\r\n        "publish"\r\n    ]\r\n}', '1', 5, 'all'),
(25, 9, 'Themes', 'themes', 'tbl_themes', '{\r\n    "keyColumn": "theme_id",\r\n    "orderBy": {\r\n        "theme_id": "ASC"\r\n    },\r\n    "listColumns": [\r\n        "theme_title",\r\n        "theme_name",\r\n        "theme_status",\r\n        "theme_thumbnail"\r\n    ],\r\n    "showColumns": [\r\n        "theme_id",\r\n        "theme_title",\r\n        "theme_name",\r\n        "theme_status"\r\n    ],\r\n    "detailColumns": [\r\n        "theme_id",\r\n        "theme_title",\r\n        "theme_name",\r\n        "theme_status",\r\n        "theme_thumbnail"\r\n    ],\r\n    "columns": {\r\n        "theme_id": {},\r\n        "theme_title": {\r\n            "name": "Theme Title",\r\n            "searchable": "searchable",\r\n            "sortable": "true",\r\n            "editoptions": {\r\n                "type": "disabled",\r\n                "label": "Theme Title"\r\n            }\r\n        },\r\n        "theme_name": {\r\n            "name": "Theme Name",\r\n            "searchable": "searchable",\r\n            "sortable": "true",\r\n            "editoptions": {\r\n                "type": "disabled",\r\n                "label": "Theme Name"\r\n            }\r\n            \r\n        },\r\n        "theme_status": {\r\n            "name": "Theme Status",\r\n            "editoptions": {\r\n                "type": "checkbox",\r\n                "label": "Enable Theme",\r\n                "enumvalues": {\r\n                    "0": "Inactive",\r\n                    "1": "Active"\r\n                }\r\n            },\r\n            "listoptions": {\r\n                "type": "button",\r\n                "customaction": "Admin::changeThemeStatus",\r\n                "enumvalues": {\r\n                    "1": "Active",\r\n                    "0": "Inactive"\r\n                },\r\n                "buttonColors": {\r\n                    "1": "green",\r\n                    "0": "red"\r\n                }\r\n            }\r\n        },\r\n        "theme_thumbnail": {\r\n            "name": "Thumbnail",\r\n            "customColumn": "true",\r\n            "customaction": "Admincomponents::showthumbnail"\r\n        }\r\n    },\r\n    "customActions": {\r\n        "afterEditRecord": "Admincomponents::statusUpdate"\r\n    },\r\n    "opertations": [\r\n        "edit"\r\n    ]\r\n}', '1', 6, 'all'),
(26, 1, 'Settlements', 'settlements', 'tbl_BillingSettlement', '{\r\n    "keyColumn": "nId",\r\n    "orderBy": {\r\n        "dCreatedOn": "DESC"\r\n    },\r\n    "listColumns": [\r\n        "nUId",\r\n        "nRequestedAmount",\r\n        "tUserComments",\r\n        "dCreatedOn",\r\n        "eStatus"\r\n    ],\r\n    "showColumns": [\r\n        "nId",\r\n        "nSettledAmount",\r\n        "tAdminComments",\r\n        "eStatus"\r\n    ],\r\n    "detailColumns": [\r\n        "nId",\r\n        "nUId",\r\n        "nRequestedAmount",\r\n        "tUserComments",\r\n        "nSettledAmount",\r\n        "tAdminComments",\r\n        "dCreatedOn",\r\n        "eStatus"\r\n    ],\r\n    "columns": {\r\n        "nId": {\r\n            "name": "Settlement Id",\r\n            "editoptions": {\r\n                "type": "hidden"\r\n            }\r\n        },\r\n        "nUId": {\r\n            "name": "User",\r\n            "sortable": "true",\r\n            "searchable": "searchable",\r\n            "external": "true",\r\n            "externalOptions": {\r\n                "externalTable": "tbl_User",\r\n                "externalColumn": "nUId",\r\n                "externalShowColumn": "vUsername"\r\n            }\r\n        },\r\n        "nRequestedAmount": {\r\n            "name": "Requested Amount"\r\n        },\r\n        "tUserComments": {\r\n            "name": "Comments"\r\n        },\r\n        "dCreatedOn": {\r\n            "name": "Sent On",\r\n            "searchable": "searchable",\r\n            "sortable": "true",\r\n            "displayFormat": "m/d/Y"\r\n        },\r\n        "eStatus": {\r\n            "name": "Status",\r\n            "searchable": "searchable",\r\n            "sortable": "true",\r\n            "editoptions": {\r\n                "validations": [\r\n                    "required"\r\n                ],\r\n                "source_type": "array",\r\n                "source": {\r\n                    "Pending": "Pending",\r\n                    "Approved": "Approved",\r\n                    "Rejected": "Rejected"\r\n                },\r\n                "type": "select",\r\n                "label": "Status",\r\n                "class": "select"\r\n            }\r\n        },\r\n        "nSettledAmount": {\r\n            "editoptions": {\r\n                "validations": [\r\n                    "required"\r\n                ],\r\n                "type": "textbox",\r\n                "label": "Settled Amount",\r\n                "class": "textbox"\r\n            },\r\n            "name": "Settled Amount"\r\n        },\r\n        "tAdminComments": {\r\n            "editoptions": {\r\n                "validations": [\r\n                    "required"\r\n                ],\r\n                "type": "textarea",\r\n                "label": "Comments",\r\n                "class": "textarea"\r\n            },\r\n            "name": "Admin Comments"\r\n        }\r\n    },\r\n    "opertations": [\r\n        "view",\r\n        "edit"\r\n    ],\r\n    "report": {\r\n        "reportTitle": "Settlements",\r\n        "columns": [\r\n            "nUId",\r\n            "nRequestedAmount",\r\n            "tUserComments",\r\n            "nSettledAmount",\r\n            "tAdminComments",\r\n            "dCreatedOn",\r\n            "eStatus"\r\n        ],\r\n        "dateColumn": "dCreatedOn"\r\n    }\r\n}', '0', 4, 'all'),
(27, 9, 'Support', 'support', 'tbl_BillingSettlement', '{"customAction":"true","controller":"index","method":"gotosupport","module":"admin"}', '1', 8, 'all'),
(28, 1, 'Service Details', 'service_details', 'tbl_ProductServices', '{"customAction":"true","controller":"service","method":"servicedetails","module":"admin"}', '0', 6, 'all'),
(29, 1, 'User', 'domain_user_tag', 'tbl_User', '{\r\n    "keyColumn": "nUId",\r\n    "orderBy": {\r\n        "vFirstName": "ASC"\r\n    },\r\n    "reference": {\r\n        "referenceTable": "tbl_ProductLookup",\r\n        "referenceColumn": "nUId",\r\n        "referenceTableForiegnKey": "nUId"\r\n    },\r\n    "listColumns": [\r\n        "vFirstName",\r\n        "vLastName",\r\n        "vEmail"\r\n    ],\r\n    "detailColumns": [\r\n        "nUId",\r\n        "vFirstName",\r\n        "vLastName",\r\n        "vEmail"\r\n    ],\r\n    "showColumns": [\r\n        "nUId",\r\n        "vFirstName",\r\n        "vLastName",\r\n        "vEmail"\r\n    ],\r\n    "columns": {\r\n        "nUId": {\r\n            "name": "ID"\r\n        },\r\n        "vFirstName": {\r\n            "name": "First name",\r\n            "searchable": "searchable",\r\n            "sortable": "true",\r\n            "editoptions": {\r\n                "validations": [\r\n                    "required"\r\n                ],\r\n                "type": "textbox",\r\n                "label": "First Name",\r\n                "class": "textbox"\r\n            }\r\n        },\r\n        "vLastName": {\r\n            "name": "Last name",\r\n            "searchable": "searchable",\r\n            "sortable": "true",\r\n            "editoptions": {\r\n                "validations": [\r\n                    "required"\r\n                ],\r\n                "type": "textbox",\r\n                "label": "Last Name",\r\n                "class": "textbox"\r\n            }\r\n        },\r\n        "vEmail": {\r\n            "name": "Email",\r\n            "searchable": "searchable",\r\n            "sortable": "true",\r\n            "editoptions": {\r\n                "validations": [\r\n                    "required"\r\n                ],\r\n                "type": "textbox",\r\n                "label": "Email",\r\n                "class": "textbox"\r\n            }\r\n        }\r\n    },\r\n    "opertations": [\r\n        "view"\r\n    ]\r\n}', '0', 0, 'all'),
(30, 1, 'Invoice Details', 'invoice_details', 'tbl_Invoice', '{"customAction":"true","controller":"service","method":"invoicedetails","module":"admin"}', '0', 0, 'all'),
(31, 10, 'Contents', 'static_content', 'tbl_Cms', '{\r\n"keyColumn": "cms_id",\r\n    "orderBy": {\r\n        "cms_id": "ASC"\r\n    },\r\n"where":"tbl_Cms.cms_type=''cms''",\r\n\r\n    "listColumns": [\r\n        "cms_name",\r\n        "cms_title",\r\n        "cms_status"\r\n    ],\r\n    "showColumns": [\r\n        "cms_id",\r\n        "cms_name",\r\n        "cms_title",\r\n        "cms_desc",\r\n        "cms_status"\r\n    ],\r\n    "detailColumns": [\r\n        "cms_id",\r\n        "cms_name",\r\n        "cms_title",\r\n        "cms_desc",\r\n        "cms_status"\r\n    ],\r\n    "detailHeaderColumns": [\r\n        "cms_title"\r\n    ],\r\n    "detailHeaderColumnPrefix": "Content: ",\r\n    "columns": {\r\n        "cms_id": {\r\n            "name": "ID",\r\n            "sortable": "true",\r\n            "editoptions": {\r\n                "type": "hidden"\r\n            }\r\n        },\r\n        "cms_name": {\r\n            "name": "Page Name",\r\n            "sortable": "true",\r\n            "searchable": "searchable",\r\n            "editoptions": {\r\n                "type": "hidden"\r\n            }\r\n        },\r\n        "cms_title": {\r\n            "name": "Display Title",\r\n            "sortable": "true",\r\n            "searchable": "searchable",\r\n            "editoptions": {\r\n                "validations": [\r\n                    "required"\r\n                ],\r\n                "type": "textbox",\r\n                "label": "Title",\r\n                "class": "textbox"\r\n            }\r\n        },\r\n        "cms_desc": {\r\n            "name": "Content",\r\n            "sortable": "true",\r\n            "editoptions": {\r\n                "validations": [\r\n                    "required"\r\n                ],\r\n                "type": "htmlEditor",\r\n                "label": "Content",\r\n                "class": "textarea"\r\n            }\r\n        },\r\n        "cms_status": {\r\n            "name": "Status",\r\n            "editoptions": {\r\n                "type": "select",\r\n                "source": {\r\n                    "1": "Active",\r\n                    "0": "Inactive"\r\n                },\r\n                "source_type": "array",\r\n                "label": "Status",\r\n                "class": "select",\r\n                "enumvalues": {\r\n                    "1": "Active",\r\n                    "0": "Inactive"\r\n                }\r\n            },\r\n            "listoptions": {\r\n                "type": "button",\r\n                "customaction": "Admin::changeContentStatus",\r\n                "enumvalues": {\r\n                    "1": "Active",\r\n                    "0": "Inactive"\r\n                },\r\n                "buttonColors": {\r\n                    "1": "green",\r\n                    "0": "red"\r\n                }\r\n            }\r\n        }\r\n    },\r\n    "opertations": [\r\n        "edit",\r\n        "view"\r\n    ]\r\n}', '1', 2, 'all'),
(33, 1, 'Coupons', 'coupons', ' tbl_Coupon', '{\r\n    "keyColumn": "nCouponId",\r\n    "orderBy": {\r\n        "dCreatedOn": "DESC"\r\n    },\r\n    "detailHeaderColumns": ["vCouponCode"],\r\n    "detailHeaderColumnPrefix": "Coupon: ",\r\n    "listColumns": [\r\n        "vCouponCode",\r\n        "vPricingMode",\r\n        "nCouponValue",\r\n        "dExpireOn",\r\n        "nCouponCount",\r\n        "nCouponUsed"\r\n    ],\r\n    "showColumns": [\r\n        "nCouponId",\r\n        "vCouponCode",\r\n        "nCouponCount",\r\n        "vPricingMode",\r\n        "nCouponValue",\r\n        "dCreatedOn",\r\n        "dExpireOn",\r\n        "vCouponDescription"\r\n    ],\r\n    "detailColumns": [\r\n        "nCouponId",\r\n        "vCouponCode",\r\n        "vCouponDescription",\r\n        "vPricingMode",\r\n        "nCouponValue",\r\n        "dCreatedOn",\r\n        "dExpireOn",\r\n        "nCouponCount",\r\n        "nCouponUsed"\r\n    ],\r\n    "columns": {\r\n        "nCouponId": {\r\n            "name": "ID",\r\n            "editoptions":{"type":"hidden"}\r\n        },\r\n        "nCouponUsed": {\r\n            "name": "Number Of Coupons Used"\r\n        },\r\n        "vCouponCode": {\r\n            "name": "Coupon Code",\r\n            "searchable": "searchable",\r\n            "sortable": "true",\r\n            "editoptions":{\n                "validations":["required"],\n                "type":"textbox",\n                "label":"Coupon Code",\n                "class":"textbox"\n            }\r\n        },\r\n        "nCouponCount": {\r\n            "name": "Number Of Coupons",\r\n            "sortable": "true",\r\n            "editoptions":{\n                  "validations":["required"],\n                  "type":"textbox",\n                  "label":"Number of Coupons",\n                  "class":"textbox"\n            }\r\n        },\r\n        "dCreatedOn": {\r\n            "name": "Created Date",\r\n            "editoptions":{\n                "validations":["required"],\n                "type":"datepicker",\n                "label":"Created Date",\n                "class":"textbox",\n            "dbFormat":"date",\n            "displayFormat":"m/d/Y"\n            },\n            "dbFormat":"date",\n            "displayFormat":"m/d/Y"\r\n        },\r\n        "dExpireOn": {\r\n            "name": "Expiry Date",\r\n            "sortable": "true",\r\n            "editoptions":{\n                "validations":["required"],\n                "type":"datepicker",\n                "label":"Expiry Date",\n                "class":"textbox",\n            "dbFormat":"date",\n            "displayFormat":"m/d/Y"\n            },\n            "dbFormat":"date",\n            "displayFormat":"m/d/Y"\r\n        },\r\n        "vPricingMode": {\r\n            "name": "Pricing Mode",\r\n            "sortable": "true",\r\n            "searchable": "searchable",\r\n            "editoptions":{\r\n                "validations":["required"],\r\n                "type":"select",\r\n                "label":"Pricing Mode",\r\n                "class":"select",\r\n                "source":{"percentage":"Percentage","rate":"Rate"},\r\n                "source_type":"array",\r\n                "enumvalues":{"percentage":"Percentage","rate":"Rate"}\r\n            }\r\n        },\r\n        "nCouponValue": {\r\n            "name": "Coupon Value",\r\n            "sortable": "true",\r\n            "editoptions":{\n                "validations":["required"],\n                "type":"textbox",\n                "label":"Coupon Value",\n                "class":"textbox"\n            }\r\n        },\r\n        "vCouponDescription": {\r\n            "name": "Description",\r\n            "sortable": "true",\r\n            "editoptions":{"type":"textbox","label":"Description","class":"textbox"}\r\n        }\r\n\r\n    },\r\n    "opertations": [\r\n        "add","edit","delete","view"\r\n    ],\r\n    "report": {\r\n        "reportTitle": "Coupons",\r\n        "columns": [\r\n            "vCouponCode",\r\n            "vPricingMode",\r\n            "nCouponValue",\r\n            "dCreatedOn",\r\n            "dExpireOn",\r\n            "nCouponCount",\r\n            "nCouponUsed",\r\n            "vCouponDescription"\r\n        ],\r\n        "dateColumn": "dCreatedOn"\r\n    }\r\n}', '1', 9, 'all'),
(34, 10, 'Email Content', 'email_content', 'tbl_Cms', '{\r\n"keyColumn": "cms_id",\r\n    "orderBy": {\r\n        "cms_id": "ASC"\r\n    },\r\n"where":"tbl_Cms.cms_type=''email''",\r\n\r\n    "listColumns": [\r\n        "cms_name",\r\n        "cms_title",\r\n        "cms_status"\r\n    ],\r\n    "showColumns": [\r\n        "cms_id",\r\n        "cms_name",\r\n        "cms_title",\r\n        "cms_desc",\r\n        "cms_status"\r\n    ],\r\n    "detailColumns": [\r\n        "cms_id",\r\n        "cms_name",\r\n        "cms_title",\r\n        "cms_desc",\r\n        "cms_status"\r\n    ],\r\n    "detailHeaderColumns": [\r\n        "cms_title"\r\n    ],\r\n    "columns": {\r\n        "cms_id": {\r\n            "name": "ID",\r\n            "sortable": "true",\r\n            "editoptions": {\r\n                "type": "hidden"\r\n            }\r\n        },\r\n        "cms_name": {\r\n            "name": "Name",\r\n            "sortable": "true",\r\n            "searchable": "searchable",\r\n            "editoptions": {\r\n                "type": "hidden"\r\n            }\r\n        },\r\n        "cms_title": {\r\n            "name": "Subject",\r\n            "sortable": "true",\r\n            "searchable": "searchable",\r\n            "editoptions": {\r\n                "validations": [\r\n                    "required"\r\n                ],\r\n                "type": "textbox",\r\n                "label": "Subject",\r\n                "class": "textbox"\r\n            }\r\n        },\r\n        "cms_desc": {\r\n            "name": "Content",\r\n            "sortable": "true",\r\n            "editoptions": {\r\n                "validations": [\r\n                    "required"\r\n                ],\r\n                "type": "htmlEditor",\r\n                "label": "Content",\r\n                "class": "textarea"\r\n            }\r\n        },\r\n        "cms_status": {\r\n            "name": "Status",\r\n            "editoptions": {\r\n                "type": "select",\r\n                "source": {\r\n                    "1": "Active",\r\n                    "0": "Inactive"\r\n                },\r\n                "source_type": "array",\r\n                "label": "Status",\r\n                "class": "select",\r\n                "enumvalues": {\r\n                    "1": "Active",\r\n                    "0": "Inactive"\r\n                }\r\n            }\r\n        }\r\n    },\r\n    "opertations": [\r\n        "edit",\r\n        "view"      \r\n    ]\r\n}', '1', 6, 'all'),
(35, 1, 'Settlement Request', 'settlement_request', 'tbl_BillingSettlement', '{\r\n    "keyColumn": "nId",\r\n    "orderBy": {\r\n        "dCreatedOn": "DESC"\r\n    },\r\n    "detailHeaderColumns": ["nUId"],\r\n    "detailHeaderColumnPrefix": "Request From: ",\r\n    "listColumns": [\r\n        "nUId",\r\n        "nRequestedAmount",\r\n        "tUserComments",\r\n        "eStatus",\r\n		"dCreatedOn"\r\n    ],\r\n    "detailColumns": [\r\n        "nId",\r\n        "nUId",\r\n        "nRequestedAmount",\r\n        "tUserComments",\r\n        "eStatus",\r\n		"dCreatedOn"\r\n    ],\r\n    "columns": {\r\n    "nId":{"name":"ID"},\r\n        "nUId": {\r\n            "name": "Customer",\r\n            "sortable": "true",\r\n			"customColumn": "true",\r\n			"customaction": "Admincomponents::getUsernameOfSettledRequest"\r\n        },\r\n        "nRequestedAmount": {\r\n            "name": "Request Amount",\r\n            "searchable": "searchable",\r\n            "sortable": "true"\r\n        },\r\n        "tUserComments": {\r\n            "name": "Comment",\r\n            "sortable": "true"\r\n        },\r\n        "eStatus": {\r\n            "name": "Status",\r\n            "sortable": "true"\r\n        },\r\n		"dCreatedOn": {\r\n            "name": "Requested On",\r\n            "sortable": "true",\r\n			"dbFormat": "date",\r\n            "displayFormat": "m/d/Y"\r\n        }\r\n    },\r\n    "opertations": [\r\n        "view",\r\n        "delete"\r\n    ]\r\n}', '1', 9, 'all'),
(39, 10, 'Meta Tags', 'meta_tags', 'fw_metadata', '{\r\n "keyColumn": "id",\r\n "detailHeaderColumnPrefix": "Meta Tag : ",\r\n    "detailHeaderColumns": [\r\n        "url"\r\n    ],\r\n    "orderBy": {\r\n        "id": "ASC"\r\n    },\r\n    "listColumns": [\r\n        "url",\r\n        "title",\r\n        "keyword"\r\n    ],\r\n    "showColumns": [\r\n        "id",\r\n        "url",\r\n        "title",\r\n        "keyword",\r\n        "description"\r\n    ],\r\n    "detailColumns": [\r\n        "id",\r\n        "url",\r\n        "title",\r\n        "keyword",\r\n        "description"\r\n    ],\r\n    "columns": {\r\n        "id": {\r\n            "name": "ID",\r\n            "editoptions": {\r\n                "type": "hidden"\r\n            }\r\n        },\r\n        "title": {\r\n            "name": "Meta Title",\r\n            "editoptions": {\r\n                "type": "textbox",\r\n                "label": "Meta Title",\r\n                "class": "textbox",\r\n                "validations": [\r\n                    "required"\r\n                ]\r\n            }\r\n        },\r\n        "keyword": {\r\n            "name": "Meta Keywords",\r\n            "editoptions": {\r\n                "type": "textarea",\r\n                "label": "Meta Keywords",\r\n                "class": "textarea"\r\n            }\r\n        },\r\n        "description": {\r\n            "name": "Meta Description",\r\n            "editoptions": {\r\n                "type": "textarea",\r\n                "label": "Meta Description",\r\n                "class": "textarea"\r\n            }\r\n        },\r\n        "url": {\r\n            "name": "Page Url",\r\n            "sortable": "true",\r\n            "searchable": "searchable",\r\n            "editoptions": {\r\n                "label": "Page Url",\r\n                "type": "textbox",\r\n                "class": "textbox",\r\n                "hint":"<b>Url combinations can be : </b><br/><b style=''color:red''> /abc/</b> [exact location abc after your domain name] eg : www.domainname.com/abc/ ,<br/> <b style=''color:red''>/abc/* </b> [any combination after location abc after your domain name] eg : www.domainname.com/abc/test1,<br/> <b style=''color:red''>* </b>[default value] ",\r\n                "validations": [\r\n                    "required"\r\n                ]\r\n            }\r\n        }\r\n    },\r\n    "opertations": [\r\n        "add",\r\n        "view",\r\n        "edit",\r\n        "delete"\r\n    ]\r\n}', '1', 2, 'all'),
(37, 10, 'Newsletter Template', 'newsletter_template', 'tbl_EmailTemplates', '{\r\n"keyColumn": "nETId",\r\n"detailHeaderColumns":["vemailTemplateName"],\r\n"detailHeaderColumnPrefix": "Newsletter Template: ",\r\n    "orderBy": {\r\n        "nETId": "DESC"\r\n    },\r\n    "listColumns": [\r\n        "vemailTemplateName",\r\n        "estatus"\r\n    ],\r\n    "detailColumns": [\r\n        "nETId",\r\n        "vemailTemplateName",\r\n        "temailTemplate",\r\n        "estatus"\r\n    ],\r\n    "showColumns": [\r\n        "nETId",\r\n        "vemailTemplateName",\r\n        "temailTemplate",\r\n        "estatus"\r\n    ],\r\n    "columns": {\r\n        "nETId": {\r\n            "name": "ID",\r\n            "editoptions": {\r\n                "type": "hidden"\r\n            }\r\n        },\r\n        "vemailTemplateName": {\r\n            "name": "Template Name",\r\n            "searchable": "searchable",\r\n            "sortable": "true",\r\n            "editoptions": {\r\n                "validations": [\r\n                    "required"\r\n                ],\r\n                "type": "textbox",\r\n                "label": "Template Name",\r\n                "class": "textbox"\r\n            }\r\n        },\r\n        "temailTemplate": {\r\n            "name": "Template",\r\n            "editoptions": {\r\n                "validations": [\r\n                    "required"\r\n                ],\r\n                "type": "htmlEditor",\r\n                "label": "Template",\r\n                "class": "textarea"\r\n            }\r\n        },\r\n        "estatus": {\r\n            "name": "Status",\r\n            "editoptions": {\r\n                "validations": [\r\n                        "required"\r\n                    ],\r\n                "type": "select",\r\n                "source": {\r\n                    "Active": "Active",\r\n                    "Inactive": "Inactive"\r\n                },\r\n                "source_type": "array",\r\n                "label": "Status",\r\n                "class": "select",\r\n                "enumvalues": {\r\n                    "Active": "Active",\r\n                    "Inactive": "Inactive"\r\n                }\r\n            },\r\n            "listoptions": {\r\n                    "type": "button",\r\n                    "customaction": "Admin::changeNewsletterScheduleStatus",\r\n                    "enumvalues": {\r\n                        "Active": "Active",\r\n                        "Inactive": "Inactive"\r\n                    },\r\n                    "buttonColors": {\r\n                        "Active": "green",\r\n                        "Inactive": "red"\r\n                    }\r\n                }\r\n        }\r\n    },\r\n    "opertations": [\r\n        "view",\r\n        "edit",\r\n        "add",\r\n        "delete"\r\n    ]\r\n}', '1', 3, 'all'),
(38, 1, 'godaddycertify', 'godaddycertify', 'test', '{"customAction":"true","controller":"module","method":"godaddycertify","module":"admin"}\r\n', '0', 1, 'all'),
(41, 1, 'Domain Renewal Log', 'domain_renewal_log', 'tbl_DomainRenewalLog', '{\r\n    "keyColumn": "id",\r\n     "orderBy": {\r\n                "createdOn": "DESC"\r\n                },\r\n    "detailHeaderColumns": ["vDomain"],\r\n    "detailHeaderColumnPrefix": "Domain Renewal Log for : ",\r\n\r\n    "listColumns": [\r\n        "vDomain",\r\n                    "nUId",\r\n                    "comments",\r\n                    "expireOn",\r\n                    "createdOn",\r\n                    "lastModified",\r\n                    "actionRenew"\r\n    ],\r\n    "detailColumns": [\r\n        "vDomain",\r\n                    "nUId",\r\n                    "comments",\r\n                    "expireOn",\r\n                    "createdOn",\r\n                    "lastModified",\r\n                    "actionRenew"\r\n    ],\r\n    "columns": {\r\n   "vDomain":{\r\n                "name":"Domain",\r\n                "sortable": "true",\r\n                "searchable": "searchable"\r\n                },\r\n       "nUId": {\r\n                "name": "Customer",\r\n                "sortable": "true",\r\n                "customColumn": "true",\r\n                "customaction": "Admincomponents::getUsernameOfSettledRequest",\r\n                "sortable": "true",\r\n                "searchable": "searchable"\r\n            },\r\n       "comments": {\r\n            "name": "Status",\r\n            "sortable": "true",\r\n            "searchable": "searchable"\r\n        },\r\n "expireOn": {\r\n            "name": "Domain Expiry Date",\r\n            "sortable": "true",\r\n            "dbFormat": "date",\r\n            "displayFormat": "m/d/Y",\r\n            "sortable": "true",\r\n            "searchable": "searchable"\r\n        },\r\n         "createdOn": {\r\n            "name": "Log Created On",\r\n            "sortable": "true",\r\n            "dbFormat": "date",\r\n            "displayFormat": "m/d/Y",\r\n            "sortable": "true",\r\n            "searchable": "searchable"\r\n        },\r\n       "lastModified": {\r\n            "name": "Log Modified On",\r\n            "sortable": "true",\r\n            "dbFormat": "date",\r\n            "displayFormat": "m/d/Y",\r\n            "sortable": "true",\r\n            "searchable": "searchable"\r\n        },\r\n            "actionRenew": {\r\n            "name": "Action",\r\n            "disableDetailedView":"false",\r\n            "customColumn": "true",\r\n            "customaction": "Admincomponents::getDomainRenewalLink"\r\n            }\r\n    },\r\n    "opertations": [\r\n        "view"\r\n    ],\r\n    "includeJsFiles":["cmshelper.js"]\r\n}', '1', 10, 'all'),
(42, 1, 'Sold Template History', 'sold_templates', 'tbl_PaidTemplatePurchase', '{\r\n  "includeJsFiles": [\r\n    "dateformats.js"\r\n    ],\r\n    "keyColumn": "id",\r\n    "orderBy": {\r\n        "paidOn": "DESC"\r\n    },\r\n    "listColumns": [\r\n\r\n        "nTemplateId",\r\n        "nUId",\r\n        "nPLId",\r\n        "amount",\r\n        "paymentMethod",\r\n        "transactionId",\r\n        "comments",\r\n        "paidOn"\r\n    ],\r\n    "showColumns": [\r\n\r\n        "nTemplateId",\r\n        "nUId",\r\n        "nPLId",\r\n        "amount",\r\n        "paymentMethod",\r\n        "transactionId",\r\n        "comments",\r\n        "paidOn"\r\n    ],\r\n    "detailHeaderContent": "Sold Template",\r\n    "detailColumns": [\r\n\r\n        "nTemplateId",\r\n        "nUId",\r\n        "nPLId",\r\n        "amount",\r\n        "paymentMethod",\r\n        "transactionId",\r\n        "comments",        \r\n        "paidOn"\r\n    ],\r\n    "columns": {\r\n        "nTemplateId": {\r\n            "name": "Template Name",\r\n            "sortable": "true",\r\n            "searchable": "true",\r\n            "external": "true",\r\n            "externalOptions": {\r\n            "externalTable": "tbl_PaidTemplates",\r\n            "externalColumn": "nTemplateId",\r\n            "externalShowColumn": "vTemplateName"}\r\n        },\r\n        "nUId": {\r\n            "name": "User",\r\n            "sortable": "true",\r\n            "customColumn": "true",\r\n	    "customaction": "Admincomponents::getUsernameOfSoldTemplateCMS"\r\n        },\r\n        "nPLId": {\r\n            "name": "Store",\r\n            "sortable": "true",\r\n            "customColumn": "true",\r\n	    "customaction": "Admincomponents::getStoreHostForSoldTemplatePurchaseCms"\r\n        },\r\n        "amount": {\r\n            "name": "Amount",\r\n            "sortable": "true",\r\n            "searchable": "true"\r\n            },\r\n        "paymentMethod": {\r\n            "name": "Payment Method",\r\n            "sortable": "true",\r\n            "searchable": "true"\r\n        },\r\n         "transactionId": {\r\n            "name": "Transaction Id",\r\n            "sortable": "true",\r\n            "searchable": "true"\r\n        },\r\n        "comments": {\r\n            "name": "Status",\r\n            "sortable": "true",\r\n            "searchable": "true"\r\n        },\r\n        "paidOn": {\r\n            "name": "Purchase Date",\r\n            "sortable": "true",\r\n            "searchable": "searchable",\r\n           "dbFormat": "timestamp",\r\n            "displayFormat": "m/d/Y"\r\n        }\r\n\r\n\r\n\r\n    },"opertations": [\r\n        "view"]\r\n\r\n}', '1', 10, 'all');

INSERT INTO `cms_users` (`id`, `type`, `username`, `password`, `status`) VALUES
(1, 'sadmin', 'sadmin', 'c5edac1b8c1d58bad90a246d8f08f53b ', 'active'),
(2, 'admin', 'admin', '21232f297a57a5a743894a0e4a801fc3 ', 'active');


INSERT INTO `sptbl_companies` (`nCompId`, `vCompName`, `vCompAddress1`, `vCompAddress2`, `vCompCity`, `vCompState`, `nCompZip`, `vCompCountry`, `vCompPhone`, `vCompFax`, `vCompMail`, `vCompContact`, `vDelStatus`, `vChatWelcomeMessage`, `vChatIcon`, `vChatOperatorRating`) VALUES
(1, 'iScripts goStores', 'localhost', NULL, 'city', NULL, '11111', 'UnitedStates', NULL, NULL, 'company1@yoursite.com', '', '0', 'Welcome', '1', '0');



INSERT INTO `sptbl_css` (`nCSSId`, `vCSSName`, `vCSSURL`, `dDate`) VALUES
(1, 'Copper Penny', 'styles/CopperPenny/style.css', '2012-10-08 10:50:03'),
(2, 'Aqua Blue', 'styles/AquaBlue/style.css', '2012-10-08 10:50:03'),
(3, 'African Violet', 'styles/AfricanViolet/style.css', '2012-10-08 10:50:03'),
(4, 'Coffee Brown', 'styles/CoffeeBrown/style.css', '2012-10-08 10:50:03'),
(5, 'Escastic Blue', 'styles/EscasticBlue/style.css', '2012-10-08 10:50:03'),
(6, 'Feminine Pink', 'styles/FemininePink/style.css', '2012-10-08 10:50:03'),
(7, 'Pale Green', 'styles/PaleGreen/style.css', '2012-10-08 10:50:03'),
(8, 'Pantone Skin', 'styles/PantoneSkin/style.css', '2012-10-08 10:50:03'),
(9, 'Parrot Green', 'styles/ParrotGreen/style.css', '2012-10-08 10:50:03'),
(10, 'Tan Brick', 'styles/TanBrick/style.css', '2012-10-08 10:50:03');


INSERT INTO `sptbl_depts` (`nDeptId`, `nCompId`, `vDeptDesc`, `nDeptParent`, `vDeptMail`, `vDeptCode`, `nResponseTime`) VALUES
(1, 1, 'Support', 0, 'dept@yoursite.com', 'D01', 0);


INSERT INTO `sptbl_fields` (`nFieldId`, `vFieldName`, `vFieldDesc`) VALUES
(1, 'vRefNo', 'TEXT_REF_NO'),
(2, 'vTitle', 'TEXT_TITLE'),
(3, 'dPostDate', 'TEXT_POST_DATE'),
(4, 'vStatus', 'TEXT_STATUS'),
(5, 'vUserName', 'TEXT_USER_NAME'),
(6, 'vPriority', 'TEXT_PRIORITY'),
(7, 'vStaffLogin', 'TEXT_STAFF'),
(8, 'nLockStatus', 'TEXT_LOCK_STATUS');


INSERT INTO `sptbl_lang` (`vLangCode`, `VLangDesc`) VALUES
('en', 'English'),
('de', 'German'),
('fr', 'French'),
('es', 'Spanish');


INSERT INTO `sptbl_lookup` (`nLookUpId`, `vLookUpName`, `vLookUpValue`) VALUES
(1, 'MailAdmin', 'admin@iscripts.com'),
(2, 'MailTechnical', 'admin@iscripts.com'),
(3, 'MailEscalation', 'admin@iscripts.com'),
(4, 'MailFromName', 'Administrator'),
(5, 'MailFromMail', 'admin@iscripts.com'),
(6, 'MailReplyName', 'Administrator'),
(7, 'MailReplyMail', 'admin@iscripts.com'),
(8, 'SiteURL', 'http://localhost/gostores/project/support/'),
(9, 'HelpDeskURL', 'http://localhost/gostores/project/support/'),
(10, 'LangChoice', '1'),
(11, 'DefaultLang', 'en'),
(12, 'Post2PostGap', '0'),
(13, 'AutoLock', '1'),
(14, 'VerifyTemplate', '1'),
(15, 'VerifyKB', '1'),
(16, 'EmailURL', 'http://localhost/gostores/project/support/'),
(37, 'MaxfileSize', '2097150'),
(38, 'HelpdeskTitle', 'iScripts goStores'),
(39, 'Logourl', 'custom/logoo.gif'),
(40, 'Emailfooter', '<table  width=''100%''><tr><td bgcolor=''red''>&nbsp;</td></tr></table>'),
(41, 'Emailheader', '<table width=''100%''><tr><td bgcolor=''green''>&nbsp; </td></tr></table>'),
(42, 'vLicenceKey', '123'),
(87, 'ExtraStatus', 'InProcess'),
(90, 'ExtraStatus', 'New'),
(88, 'Attachments', 'bmp|image/bmp'),
(89, 'Attachments', 'jpg|image/jpeg'),
(96, 'Attachments', 'mid|audio/mid'),
(97, 'Attachments', 'mp3|audio/mp3'),
(98, 'Attachments', 'wma|audio/x-ms-wma'),
(92, 'Attachments', 'gif|image/gif'),
(93, 'RunLevel', '0'),
(94, 'logactivity', '0'),
(95, 'LoginURL', 'http://localhost/gostores/project/support/'),
(99, 'EmailPiping', '1'),
(100, 'MaxPostsPerPage', '30'),
(101, 'OldestMessageFirst', '1'),
(102, 'UserAuthenticate', '1'),
(103, 'PostTicketBeforeLogin', '1'),
(104, 'spamfiltertype', 'OFF'),
(105, 'MessageRule', '0'),
(106, 'SMTPSettings', '0'),
(107, 'SMTPServer', ''),
(108, 'SMTPPort', ''),
(109, 'Attachments', 'txt|text/plain'),
(110, 'Attachments', 'zip|application/x-zip'),
(111, 'Attachments', 'html|text/html'),
(112, 'Attachments', 'htm|text/html'),
(113, 'Attachments', 'doc|application/msword'),
(114, 'Attachments', 'crt|application/x-x509-ca-cert'),
(115, 'Attachments', 'key|key|application/octet-stream'),
(116, 'Attachments', 'csv|text/plain'),
(117, 'Attachments', 'csv|application/octet-stream'),
(118, 'LiveChat', '1'),
(119, 'AD_AUTHENTICATION', 'N'),
(120, 'AD_USER', ''),
(121, 'AD_PASS', ''),
(122, 'AD_DOMAIN', ''),
(123, 'AD_HOST', ''),
(124, 'AD_USER_DIR', 'CN=USER'),
(125, 'NewTicketAutoReturnMail', '1'),
(126, 'Theme', '1'),
(127, 'Version', '4.2');


INSERT INTO `sptbl_priorities` (`nPriorityId`, `nPriorityValue`, `vPriorityDesc`, `vTicketColor`, `vPrioritie_icon`) VALUES
(1, 3, 'High', '#FFFFFF', ''),
(2, 2, 'Medium', '#FFFFFF', ''),
(8, 1, 'Normal', '#00FF00', ''),
(3, 4, 'Urgent', '#56dfdf', ''),
(9, 0, 'Low', '#e8dc54', '');


INSERT INTO `sptbl_spam_categories` (`category_id`, `probability`, `word_count`) VALUES
('spam', 0.887777777778, 799),
('notspam', 0.112222222222, 101);


INSERT INTO `sptbl_staffdept` (`nStaffId`, `nDeptId`) VALUES
(2, 1),
(1, 1);


INSERT INTO `sptbl_stafffields` (`nStaffId`, `nFieldId`) VALUES
(1, 1),
(1, 2),
(1, 3),
(1, 4),
(2, 1),
(2, 2),
(2, 3),
(2, 4);



INSERT INTO `sptbl_staffs` (`nStaffId`, `vStaffname`, `vLogin`, `vPassword`, `vOnline`, `vMail`, `vYIM`, `vSMSMail`, `vMobileNo`, `nCSSId`, `nRefreshRate`, `nNotifyAssign`, `nNotifyPvtMsg`, `nNotifyKB`, `nNotifyArrival`, `vType`, `vDelStatus`, `tSignature`, `nWatcher`, `vStaffImg`) VALUES
(1, 'Administrator', 'admin', '21232f297a57a5a743894a0e4a801fc3', '0', 'admin@iscripts.com', 'adminsms@yoursite.com', 'adminaol@yoursite.com', '23453453', 1, 1, 1, 1, 0, 1, 'A', '0', 'Thank You\r\nAdministrator\r\nSupportdesk\r\n', 0, NULL),
(2, 'staff', 'staff', '1253208465b1efa876f982d8a9e73eef', '0', 'staff@yoursite.com', 'staffsms@yoursite.com', 'staffaol@yoursite.com', '23453453', 1, 1, 1, 1, 0, 1, 'S', '0', 'Thank You\r\nStaff\r\nSupportdesk\r\n', 0, NULL);


INSERT INTO `goStores_Cms` (`cms_id`, `cms_name`, `cms_ref_title`, `cms_type`, `cms_title`, `cms_desc`, `cms_shortdesc`, `cms_status`) VALUES
	(2, 'aboutus', '', 'cms', 'About Us', '', '', 1),
	(3, 'USER_REGISTRATION', '', 'email', 'User Registration', '<p>Hi {USERNAME},</p> <p>Your {SITE_NAME} account setup completed. Please find your details below</p> <p>Login&#160; Address: {USEREMAIL}</p> <p>Password : {USERPASSWORD}</p> <p>&#160;</p> <p>Thanks</p> <p>{SITE_NAME} Team</p>', '', 1),
	(5, 'LOGIN_CREDENTIALS_CHANGE', '', 'email', 'Changed Login Credentials {SITE_NAME}', '<p>\r\n	Dear {MEMBER_NAME},</p>\r\n<br />\r\n<br />\r\n<table border="0" cellpadding="4" cellspacing="1" width="100%">\r\n	<tbody>\r\n		<tr bgcolor="#ffffff">\r\n			<td align="left" colspan="2">\r\n				Welcome to {SITE_NAME}.<br />\r\n				<b><u>Your changed account details as follows :</u></b></td>\r\n		</tr>\r\n		<tr bgcolor="#ffffff">\r\n			<td align="left" width="14%">\r\n				User Name</td>\r\n			<td width="86%">\r\n				{USER_NAME}</td>\r\n		</tr>\r\n		<tr bgcolor="#ffffff">\r\n			<td align="left">\r\n				Password</td>\r\n			<td>\r\n				{PASSWORD}</td>\r\n		</tr>\r\n		<tr bgcolor="#ffffff">\r\n			<td align="left" colspan="2">\r\n				<b><u>Click the following link to login to your account :</u></b></td>\r\n		</tr>\r\n		<tr bgcolor="#ffffff">\r\n			<td align="left" colspan="2">\r\n				{LOGIN_LINK}</td>\r\n		</tr>\r\n		<tr bgcolor="#ffffff">\r\n			<td align="left" colspan="2">\r\n				Thank You,</td>\r\n		</tr>\r\n		<tr bgcolor="#ffffff">\r\n			<td align="left" colspan="2">\r\n				{SITE_URL}</td>\r\n		</tr>\r\n	</tbody>\r\n</table>\r\n<p>\r\n	&nbsp;</p>', '', 1),
	(6, 'forgotpassword', '', 'email', 'Changed Login Credentials {SITE_NAME}', '<p>\r\n	Dear {MEMBER_NAME},</p>\r\n<br />\r\n<br />\r\n<table border=\\"0\\" cellpadding=\\"4\\" cellspacing=\\"1\\" width=\\"100%\\">\r\n	<tbody>\r\n		<tr bgcolor=\\"#ffffff\\">\r\n			<td align=\\"left\\" colspan=\\"2\\">\r\n				Welcome to {SITE_NAME}.<br />\r\n				<b><u>Your changed account details as follows :</u></b></td>\r\n		</tr>\r\n		<tr bgcolor=\\"#ffffff\\">\r\n			<td align=\\"left\\" width=\\"14%\\">\r\n				User Name</td>\r\n			<td width=\\"86%\\">\r\n				{USER_NAME}</td>\r\n		</tr>\r\n		<tr bgcolor=\\"#ffffff\\">\r\n			<td align=\\"left\\">\r\n				Password</td>\r\n			<td>\r\n				{PASSWORD}</td>\r\n		</tr>\r\n		<tr bgcolor=\\"#ffffff\\">\r\n			<td align=\\"left\\" colspan=\\"2\\">\r\n				<b><u>Click the following link to login to your account :</u></b></td>\r\n		</tr>\r\n		<tr bgcolor=\\"#ffffff\\">\r\n			<td align=\\"left\\" colspan=\\"2\\">\r\n				{ACTIVATION_LINK}</td>\r\n		</tr>\r\n		<tr bgcolor=\\"#ffffff\\">\r\n			<td align=\\"left\\" colspan=\\"2\\">\r\n				Thank You,</td>\r\n		</tr>\r\n		<tr bgcolor=\\"#ffffff\\">\r\n			<td align=\\"left\\" colspan=\\"2\\">\r\n				{SITE_URL}</td>\r\n		</tr>\r\n	</tbody>\r\n</table>\r\n<p>\r\n	&nbsp;</p>', '', 1),
	(8, 'contactus', '', 'cms', 'Contact Us', '\r\n', '', 1),
	(10, 'forgotpasswordemail', '', 'email', 'Forgot Password', '<p>Hi {USERNAME},</p> <p>We have received  your password reset request.</p><p>{PASSWORDLINK}</p>  <p>Thanks</p>  <p>{SITE_NAME} Team</p>', '', 1),
	(14, 'invoice', '', 'email', 'Purchase Details {SITE_NAME}', '<p>Dear {MEMBER_NAME},<br> 	<br> 	Thank you for the interest shown in {COMPANY_NAME}.<br> 	The following is the invoice details, not receipt in regard to the purchase with {COMPANY_NAME}.</p>', '', 1),
	(13, 'disclaimernotice', '', 'cms', 'Disclaimer Notice', '', '', 1),
	(15, 'free_trial_expiry_notification', '', 'email', 'Your {SITE_NAME} {PRODUCT_NAME} Free Trial will expire on {EXPIRY_DATE}', '<p>\r\n	Dear {MEMBER_NAME},<br />\r\n	<br />\r\n	Your {SITE_NAME} {PRODUCT_NAME} Free Trial will expire on {EXPIRY_DATE}.<br />\r\n	Hurry up! login to your account and upgrade the service to avail the site in {SITE_NAME} environment.</p>\r\n<p>\r\n	{SITE_NAME} Team</p>', '', 1),
	(16, 'free_trial_expired_notification', '', 'email', 'Your {SITE_NAME} {PRODUCT_NAME} Free Trial  expired', '<p>\r\n	Dear {MEMBER_NAME},<br />\r\n	<br />\r\n	Your {SITE_NAME} {PRODUCT_NAME} Free Trial has expired on {EXPIRY_DATE}.<br />\r\n	Hurry up! login to your account and upgrade the service immediately to avail the site in {SITE_NAME} environment.</p>\r\n<p>\r\n	{SITE_NAME} Team</p>', '', 1),
	(19, 'email_template', '', 'email_settings', 'Email Template', '<table width="600" cellspacing="0" cellpadding="0" border="0" style="border:1px solid #ccc;background-color:#fdfdfd">      <tbody>         <tr>             <td height="5" colspan="3">&#160;</td>         </tr>         <tr>             <td width="5">&#160;</td>             <td width="586"><table width="100%" cellspacing="0" cellpadding="0" border="0">                     <tbody>                         <tr>                             <td height="56"><table width="100%" cellspacing="0" cellpadding="0" border="0">                                     <tbody>                                         <tr>                                             <td width="2%" height="80">&#160;</td>                                             <td width="37%"><img height="40" src="{SITE_LOGO}" alt=""></td>                                             <td width="61%"><p style="font-family:Arial,Helvetica,sans-serif;font-size:12px;color:#cccccc;text-align:right;padding:0 15px 0 0">{DATE}</p></td>                                         </tr>                                     </tbody>                                 </table></td>                         </tr>                         <tr>                             <td height="10">&#160;</td>                         </tr>                         <tr>                             <td>&#160;</td>                         </tr>                         <tr>                             <td><table width="100%" cellspacing="0" cellpadding="0" border="0">                                     <tbody>                                         <tr>                                             <td width="2%">&#160;</td>                                             <td width="97%">{MAIL_CONTENT}</td>                                             <td width="2%">&#160;</td>                                         </tr>                                         <tr>                                             <td>&#160;</td>                                             <td>&#160;</td>                                             <td>&#160;</td>                                         </tr>                                         <tr>                                             <td>&#160;</td>                                             <td>&#160;</td>                                             <td>&#160;</td>                                         </tr>                                                                             </tbody>                                 </table></td>                         </tr>                                             </tbody>                 </table></td>             <td width="4">&#160;</td>         </tr>         <tr>             <td height="10" colspan="3">&#160;</td>         </tr>     </tbody> </table>', '', 1),
	(20, 'bill_notification', '', 'email', 'Your {SITE_NAME} {PRODUCT_NAME} Service bill is due for payment on {PAYMENT_DATE}', '<p>\r\n	Dear {MEMBER_NAME},<br />\r\n	<br />\r\n	Your {SITE_NAME} {PRODUCT_NAME} Service bill is due for payment of {AMOUNT} on {PAYMENT_DATE}. Auto payment will be made in regard to the billing information you provided. Please make the changes if any, by logging in to your account prior to the payment date.<br />\r\n	Thank you for the interest shown in {COMPANY_NAME}.</p>\r\n<p>\r\n	{SITE_NAME} Team</p>', '', 1),
	(23, 'features', '', 'cms', 'Features', '<h3></h3><h5><span style="font-size: medium;"><span style="font-family: Arial, serif; color: rgb(102, 102, 102); line-height: 100%;">Your store will be equipped with similar features to Volusion.com and Shopify.com.</span></span></h5><h5><span style="font-size: medium;"><span style="font-family: Arial, serif; color: rgb(102, 102, 102); line-height: 100%;">Edit this page to let visitors know why they should use your site to build an online store. Sample:</span></span><font color="#666666"><font face="Arial, serif"><br></font></font></h5><br> 	<p></p><ul> 	<li><p style="margin-top: 0.05cm; margin-bottom: 0.05cm;"><span style="font-size: small;"><font color="#666666"><font face="Arial, serif">No 	programming required. We believe you shouldnâ€™t have to know coding 	or pay a lot for a website to get your online business started.</font></font></span></p></li><li><p style="margin-top: 0.05cm; margin-bottom: 0.05cm;"><span style="font-size: small;"><font color="#666666"><font face="Arial, serif">Integrated 	help desk system for supporting store owners</font></font></span></p></li>    <li><p style="margin-top: 0.05cm; margin-bottom: 0.05cm;"><span style="font-size: small;">                 <font face="Arial, serif" color="#666666">Multiple payment gateways</font>             </span></p></li>     </ul>    <h3><font color="#666666">                 <font face="Arial, serif">                     <b>                         <br>                     </b>                 </font>             </font>             <font color="#666666" face="Arial, serif">Store Features</font></h3><br>                    <ul>         <li><span style="font-size: small;"><font color="#666666"><font face="Arial, serif">SEO 	friendly shopping cart. Give users an easy-to-remember URL and rank 	above your competition in search engines.</font></font></span></li><li><span style="font-size: small;"><font color="#666666"><font face="Arial, serif">Multiple 	photo options per product to improve the conversion rate.</font></font></span></li><li><span style="font-size: small;"><font color="#666666"><font face="Arial, serif">Automatic 	photo resizing, eliminating the need to use other photo editing 	programs.</font></font></span></li><li><span style="font-size: small;"><font color="#666666"><font face="Arial, serif">Supports 	custom form fields for products and categories.</font></font></span></li><li><span style="font-size: small;"><font color="#666666"><font face="Arial, serif">Supports 	digital products like eBooks, pictures, videos, software, and 	templates in addition to physical products.</font></font></span></li><li><span style="font-size: small;"><font color="#666666"><font face="Arial, serif">Optional 	affiliate program to increase your new customers without breaking 	the bank.</font></font></span></li><li><span style="font-size: small;"><font color="#666666"><font face="Arial, serif">Supports 	promo codes for tracking the effectiveness of marketing campaigns.</font></font></span></li><li><span style="font-size: small;"><font color="#666666"><font face="Arial, serif">Supports 	an efficient and simple Return Merchandize Authorization process 	(RMA) to turn refunds and returns into a positive experience for 	your clients.</font></font></span></li><li><span style="font-size: small;"><font color="#666666"><font face="Arial, serif">Supports 	bulk import of products and images.</font></font></span></li><li><span style="font-size: small;"><font color="#666666"><font face="Arial, serif">Supports 	export users, orders, products and other reports into .csv format.</font></font></span></li><li><span style="font-size: small;"><font color="#666666"><font face="Arial, serif">Supports 	multiple administrator logins with different privileges for staff.</font></font></span></li><li><span style="font-size: small;"><font color="#666666"><font face="Arial, serif">Built-in 	content management system for static pages like Terms, About Us, and 	Refund Policy. Edit the website without knowing html.</font></font></span></li><li><span style="font-size: small;"><font color="#666666"><font face="Arial, serif">Supports 	unlimited products, categories, and subcategories.</font></font></span></li><li><span style="font-size: small;"><font color="#666666"><font face="Arial, serif">Includes 	multiple themes to fit the type of store you want to create. You can 	select a theme with a click and change the appearance of the entire 	online store.</font></font></span></li><li><span style="font-size: small;"><font color="#666666"><font face="Arial, serif">Supports 	payment gateways like Paypal, Google Checkout, World Pay, Your Pay 	and Authorize.net.</font></font></span></li><li><span style="font-size: small;"><font color="#666666"><font face="Arial, serif">Supports 	offline credit card payments so that you can process payments using 	your existing POS.</font></font></span></li><li><span style="font-size: small;"><font color="#666666"><font face="Arial, serif">Supports 	order notification and package slip through fax.</font></font></span></li><li><span style="font-size: small;"><font color="#666666"><font face="Arial, serif">Supports 	UPS, USPS, FEDEX, Canada Post and Australia Post Shipping Methods 	for real-time shipping calculations. For simple shipping it supports 	multiple flat rate shipping.</font></font></span></li><li><span style="font-size: small;"><font color="#666666"><font face="Arial, serif">Administrator 	can change the home page layout by drag and drop in a browser. You 	can configure the site without any html or FTP.<br></font></font></span><span style="font-size: small;"><font color="#666666"><font face="Arial, serif"><br></font></font></span><span style="font-size: small;"><font color="#666666"><font face="Arial, serif"><br><br></font></font></span></li></ul>', '', 1),
	(26, 'account_cancellation_notification', '', 'email', 'Your {SITE_NAME} Account : {ACCOUNT} has been cancelled', '<p>Dear {MEMBER_NAME},<br> 	<br> 	Your {SITE_NAME} &#160;Account :{ACCOUNT} has been cancelled.<br><br>Thank you for doing business with us! .</p> <p>{SITE_NAME} Team</p>', '', 1),
	(25, 'failed_invoce_alert', '', 'email', 'Failed Invoice Alert {SITE_NAME}', 'Hi {USER},<br><br>The payment for your invoice no. {INVOICENO} dated {INVOICEDATE} could not be captured. Please contact {ADMIN_CONTACT_EMAIL} to keep your service active. Thank you for using {SITE_NAME}  services.<br><br><p>Thanks</p>  <p>{SITE_NAME} Team</p>', '', 1);

INSERT INTO `goStores_cms_settings` (`id`, `cms_set_name`, `cms_set_value`, `created_on`) VALUES
(1, 'admin_logo', 'project/styles/themes/theme1/images/gostores_logo.jpg', '2012-11-16 19:01:30'),
(2, 'admin_copyright', 'Powered by <a href="http://iscripts.com/gostores/" target="_blank" class="cms_list_operation">iScripts GoStores</a>. A premium product from <a href="http://iscripts.com/" target="_blank" class="cms_list_operation">iScripts.com</a>', '2012-12-18 16:21:13'),
(4, 'admin_page_count', '8', '2012-10-03 16:33:33'),
(5, 'site_logo', 'Admincomponents::bindSiteLogoCms', '2012-12-19 20:24:53');

INSERT INTO `goStores_Help` (`nId`, `vTitle`, `tDescription`, `eType`, `eStatus`) VALUES
(6, 'Features', 'Features\r\n	Previous  Next\r\nFew features of this site are listed below\r\n\r\n\r\n    Automated Recurring Billing\r\n\r\n    Simple Web-Based Interface\r\n\r\n    Automated Scheduled Invoicing\r\n\r\n    Access to Billing Records\r\n\r\n    Integrated Help Desk\r\n\r\n    Integrated Store Builder\r\n\r\n    Hosting Support', 'User', 'Active'),
(5, 'Introduction', 'GoStores gives you an instant online store with a new domain name or a subdomain name or to your existing domain as you opt.', 'User', 'Active'),
(7, 'Registration', 'The registration section contains minimal user details. Please enter your Login name, Password, and Email. All the fields marked with a red star are mandatory. Your Log in Name must contain (a-z, A-Z) and digits (0-9). Now your account is activated and you can login to your site immediately. Make sure to completely fill out your profile under the ''Edit Profile'' link.\r\n', 'User', 'Active'),
(8, 'Introduction', 'GoStores gives you an instant online store with a new domain name or a subdomain name or to your existing domain as you opt.', 'Admin', 'Active'),
(9, 'Settings', '<table width="576" cellspacing="0" cellpadding="3" border="1" style="border-collapse: collapse; border: none">\r\n    <tbody><tr>\r\n    <td width="15" valign="top" height="34" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">01</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="213" valign="top" height="34" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">ENOM Reseller User Name:</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="321" valign="top" height="34" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">Reseller account user name with ENOM.</span></font><font color="#010101"></font></div>\r\n    </td></tr>\r\n    <tr>\r\n    <td width="15" valign="top" height="31" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">02</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="213" valign="top" height="31" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">ENOM Reseller Password:</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="321" valign="top" height="31" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">Reseller account password.</span></font><font color="#010101"></font></div>\r\n    </td></tr>\r\n    <tr>\r\n    <td width="15" valign="top" height="31" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">03</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="213" valign="top" height="31" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">ENOM User IP:</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="321" valign="top" height="31" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">IP allowed for the Reseller account with ENOM.</span></font><font color="#010101"></font></div>\r\n    </td></tr>\r\n    <tr>\r\n    <td width="15" valign="top" height="33" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">04</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="213" valign="top" height="33" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">ENOM Mode:&nbsp; &nbsp;&nbsp;&nbsp;&nbsp;</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="321" valign="top" height="33" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">Test/Live mode of ENOM Reseller account.</span></font><font color="#010101"></font></div>\r\n    </td></tr>\r\n    <tr>\r\n    <td width="15" valign="top" height="31" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">05</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="213" valign="top" height="31" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">Administrator Name:</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="321" valign="top" height="31" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">Name of the administrator of the site.</span></font><font color="#010101"></font></div>\r\n    </td></tr>\r\n    <tr>\r\n    <td width="15" valign="top" height="30" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">06</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="213" valign="top" height="30" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">Administrator Signature:</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="321" valign="top" height="30" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">Signature of the administrator of the site.</span></font><font color="#010101"></font></div>\r\n    </td></tr>\r\n    <tr>\r\n    <td width="15" valign="top" height="31" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">07</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="213" valign="top" height="31" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">Administrator Password:&nbsp; &nbsp;&nbsp;&nbsp;&nbsp;</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="321" valign="top" height="31" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">Password of the administrator of the site.</span></font><font color="#010101"></font></div>\r\n    </td></tr>\r\n    <tr>\r\n    <td width="15" valign="top" height="33" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">08</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="213" valign="top" height="33" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">Adminstrator Mail:</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="321" valign="top" height="33" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">Mail address of the administrator of the site.</span></font><font color="#010101"></font></div>\r\n    </td></tr>\r\n    <tr>\r\n    <td width="15" valign="top" height="31" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">09</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="213" valign="top" height="31" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">Company Name:</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="321" valign="top" height="31" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">Name of the company.</span></font><font color="#010101"></font></div>\r\n    </td></tr>\r\n    <tr>\r\n    <td width="15" valign="top" height="31" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">10</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="213" valign="top" height="31" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">Name of the Site:</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="321" valign="top" height="31" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">Name of the Site.</span></font><font color="#010101"></font></div>\r\n    </td></tr>\r\n    <tr>\r\n    <td width="15" valign="top" height="30" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">11</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="213" valign="top" height="30" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">Invoice From:</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="321" valign="top" height="30" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">Invoice from details, which are used with invoices.</span></font><font color="#010101"></font></div>\r\n    </td></tr>\r\n    <tr>\r\n    <td width="15" valign="top" height="31" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">12</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="213" valign="top" height="31" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">Site URL:</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="321" valign="top" height="31" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">URL of the site, it gets displayed automatically.</span></font><font color="#010101"></font></div>\r\n    </td></tr>\r\n    <tr>\r\n    <td width="15" valign="top" height="34" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">13</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="213" valign="top" height="34" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">Sub Domain Hosting URL:</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="321" valign="top" height="34" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">Domain name where you allow your customers to \r\n    create </span></font><font color="#010101"></font></div>\r\n    <div align="left"><br>\r\n    </div>\r\n    <font color="#010101">\r\n    </font><div align="left"><font color="#010101"></font><font face="Arial" color="#010101"><span style="font-size:10pt">their store as a subdomain.</span></font><font color="#010101"></font></div>\r\n    </td></tr>\r\n    <tr>\r\n    <td width="15" valign="top" height="30" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">14</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="213" valign="top" height="30" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">Subdomain Sever CPanel</span></font><font color="#010101"></font></div>\r\n    <div align="left"><br>\r\n    </div>\r\n    <font color="#010101">\r\n    </font><div align="left"><font color="#010101"></font><font face="Arial" color="#010101"><span style="font-size:10pt"> User Name:</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="321" valign="top" height="30" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">CPANEL Username of the above Subdomain Sever</span></font><font color="#010101"></font></div>\r\n    </td></tr>\r\n    <tr>\r\n    <td width="15" valign="top" height="30" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">15</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="213" valign="top" height="30" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">Subdomain Sever CPanel</span></font><font color="#010101"></font></div>\r\n    <div align="left"><br>\r\n    </div>\r\n    <font color="#010101">\r\n    </font><div align="left"><font color="#010101"></font><font face="Arial" color="#010101"><span style="font-size:10pt"> Password:</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="321" valign="top" height="30" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">CPANEL Password of the above Subdomain Sever</span></font><font color="#010101"></font></div>\r\n    </td></tr>\r\n    <tr>\r\n    <td width="15" valign="top" height="32" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">16</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="213" valign="top" height="32" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">Subdomain Sever CPanel</span></font><font color="#010101"></font></div>\r\n    <div align="left"><br>\r\n    </div>\r\n    <font color="#010101">\r\n    </font><div align="left"><font color="#010101"></font><font face="Arial" color="#010101"><span style="font-size:10pt"> Skin</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="321" valign="top" height="32" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">CPANEL Skin of the above Subdomain Sever</span></font><font color="#010101"></font></div>\r\n    </td></tr>\r\n    <tr>\r\n    <td width="15" valign="top" height="29" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">17</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="213" valign="top" height="29" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">Control Panel Type </span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="321" valign="top" height="29" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">The type of the Control Panel of the server, where \r\n    your</span></font><font color="#010101"></font></div>\r\n    <div align="left"><br>\r\n    </div>\r\n    <font color="#010101">\r\n    </font><div align="left"><font color="#010101"></font><font face="Arial" color="#010101"><span style="font-size:10pt"> site is hosted.</span></font><font color="#010101"></font></div>\r\n    </td></tr>\r\n    <tr>\r\n    <td width="15" valign="top" height="32" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">18</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="213" valign="top" height="32" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">Control Panel Scripts Path:</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="321" valign="top" height="32" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">Path to the folder where the Control Panel Scripts \r\n    resides. It needs to be entered only when the Control \r\n    Panel is of "CPANEL" type.</span></font><font color="#010101"></font></div>\r\n    </td></tr>\r\n    <tr>\r\n    <td width="15" valign="top" height="35" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">19</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="213" valign="top" height="35" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">Site URL of Secure Server:</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="321" valign="top" height="35" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">URL of the secure version of this site. By default it will \r\n    take ''Site URL'' as ''Secure Server URL'' and you can \r\n    change this.</span></font><font color="#010101"></font></div>\r\n    </td></tr>\r\n    <tr>\r\n    <td width="15" valign="top" height="29" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">20</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="213" valign="top" height="29" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">Support creating cart in a</span></font><font color="#010101"></font></div>\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt"> subdomain : &nbsp;&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;&nbsp;</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="321" valign="top" height="29" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">Option to support create store as subdomain</span></font><font color="#010101"></font></div>\r\n    </td></tr>\r\n    <tr>\r\n    <td width="15" valign="top" height="30" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">21</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="213" valign="top" height="30" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">Support creating cart in an </span></font><font color="#010101"></font></div>\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">existing domain:</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="321" valign="top" height="30" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">Option to support create store with an existing domain \r\n    name.</span></font><font color="#010101"></font></div>\r\n    </td></tr>\r\n    <tr>\r\n    <td width="15" valign="top" height="32" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">22</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="213" valign="top" height="32" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">Support creating cart in a new \r\n    domain&nbsp; :</span></font><font color="#010101"></font></div>\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">&nbsp;&nbsp;&nbsp;&nbsp;</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="321" valign="top" height="32" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">Option to support create store by registering a new \r\n    domain name.</span></font><font color="#010101"></font></div>\r\n    </td></tr>\r\n    <tr>\r\n    <td width="15" valign="top" height="32" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">23</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="213" valign="top" height="32" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">Enable PayPal:&nbsp; &nbsp;&nbsp;&nbsp;&nbsp;</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="321" valign="top" height="32" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">Decide wheather to enable paypal or not.</span></font><font color="#010101"></font></div>\r\n    </td></tr>\r\n    <tr>\r\n    <td width="15" valign="top" height="33" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">24</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="213" valign="top" height="33" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">Paypal Email Address:&nbsp; &nbsp;&nbsp;&nbsp;&nbsp;</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="321" valign="top" height="33" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">Paypal Login ID.</span></font><font color="#010101"></font></div>\r\n    </td></tr>\r\n    <tr>\r\n    <td width="15" valign="top" height="35" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">25</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="213" valign="top" height="35" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">Paypal Identity Token:&nbsp; &nbsp;&nbsp;&nbsp;&nbsp;</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="321" valign="top" height="35" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">Identity Token issued from Paypal.</span></font><font color="#010101"></font></div>\r\n    </td></tr>\r\n    <tr>\r\n    <td width="15" valign="top" height="33" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">26</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="213" valign="top" height="33" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">Payment Gateway:&nbsp; &nbsp;&nbsp;&nbsp;&nbsp;</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="321" valign="top" height="33" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">Decide which payment gateway needed.</span></font><font color="#010101"></font></div>\r\n    </td></tr>\r\n    <tr>\r\n    <td width="15" valign="top" height="30" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">27</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="213" valign="top" height="30" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">Authorize.net Login Id:</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="321" valign="top" height="30" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">Your Login ID with the authorize.net payment \r\n    gateway.</span></font><font color="#010101"></font></div>\r\n    </td></tr>\r\n    <tr>\r\n    <td width="15" valign="top" height="29" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">28</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="213" valign="top" height="29" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">Authorize.net Password:</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="321" valign="top" height="29" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">Authorize.net account''s password.</span></font><font color="#010101"></font></div>\r\n    </td></tr>\r\n    <tr>\r\n    <td width="15" valign="top" height="32" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">29</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="213" valign="top" height="32" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">Authorize.net Transaction Key:</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="321" valign="top" height="32" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">Your transaction key with the Authorize.net account.</span></font><font color="#010101"></font></div>\r\n    </td></tr>\r\n    <tr>\r\n    <td width="15" valign="top" height="34" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">30</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="213" valign="top" height="34" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">Authorize.net Merchant Email:</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="321" valign="top" height="34" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">Your email address with the Authorize.net account.</span></font><font color="#010101"></font></div>\r\n    </td></tr>\r\n    <tr>\r\n    <td width="15" valign="top" height="34" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">31</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="213" valign="top" height="34" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">Site Logo:</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="321" valign="top" height="34" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">Logo of your site, it will be better if you upload a \r\n    transparent background logo.</span></font><font color="#010101"></font></div>\r\n    </td></tr>\r\n    <tr>\r\n    <td width="15" valign="top" height="30" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">32</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="213" valign="top" height="30" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">Center HTML Part of User</span></font><font color="#010101"></font></div>\r\n    <div align="left"><br>\r\n    </div>\r\n    <font color="#010101">\r\n    </font><div align="left"><font color="#010101"></font><font face="Arial" color="#010101"><span style="font-size:10pt"> Side of the Site </span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="321" valign="top" height="30" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">Content for the home page of your website.</span></font><font color="#010101"></font></div>\r\n    </td></tr>\r\n    <tr>\r\n    <td width="15" valign="top" height="29" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">33</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="213" valign="top" height="29" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">Enable About Us </span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="321" valign="top" height="29" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">Option to show or hide about us page in your site.</span></font><font color="#010101"></font></div>\r\n    </td></tr>\r\n    <tr>\r\n    <td width="15" valign="top" height="34" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">34</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="213" valign="top" height="34" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">About Us Page</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="321" valign="top" height="34" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">Content For the about us page.</span></font><font color="#010101"></font></div>\r\n    </td></tr>\r\n    <tr>\r\n    <td width="15" valign="top" height="34" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">35</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="213" valign="top" height="34" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">Price of Domain Registration Plan:</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="321" valign="top" height="34" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">Price for domain registration</span></font><font color="#010101"></font></div>\r\n    </td></tr>\r\n    <tr>\r\n    <td width="15" valign="top" height="39" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">36</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="213" valign="top" height="39" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">Price of Domain Renewal Plan:</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="321" valign="top" height="39" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">Cost for renewing a domain in the site.</span></font><font color="#010101"></font></div>\r\n    </td></tr>\r\n    <tr>\r\n    <td width="15" valign="top" height="35" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">37</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="213" valign="top" height="35" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">Name Server 1 - 4:</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="321" valign="top" height="35" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">Name servers, if you enable hosting service. If you \r\n    enable hosting service, there name servers will get \r\n    added to all domains that are registered, transfered \r\n    and renewed in the site.</span></font><font color="#010101"></font></div>\r\n    </td></tr>\r\n    <tr>\r\n    <td width="15" valign="top" height="31" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">38</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="213" valign="top" height="31" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">Administrator Password Settings:</span></font><font color="#010101"></font></div>\r\n    </td>\r\n    <td width="321" valign="top" height="31" style="border: solid #010101 1px;">\r\n    <div align="left"><font face="Arial" color="#010101"><span style="font-size:10pt">Gives the option to change the password of \r\n    administrator of the site.</span></font><font color="#010101"></font></div>\r\n    </td></tr>\r\n    <tr>\r\n    <td width="15" valign="top" height="35" style="border: solid #010101 1px;">\r\n    <div align="left">&nbsp;<font color="#010101"></font></div>\r\n    </td>\r\n    <td width="213" valign="top" height="35" style="border: solid #010101 1px;">\r\n    <div align="left">&nbsp;<font color="#010101"></font></div>\r\n    </td>\r\n    <td width="321" valign="top" height="35" style="border: solid #010101 1px;">\r\n    <div align="left">&nbsp;<font color="#010101"></font></div>\r\n    </td></tr>\r\n    <tr>\r\n    <td width="15" valign="top" height="36" style="border: solid #010101 1px;">\r\n    <div align="left">&nbsp;<font color="#010101"></font></div>\r\n    </td>\r\n    <td width="213" valign="top" height="36" style="border: solid #010101 1px;">\r\n    <div align="left">&nbsp;<font color="#010101"></font></div>\r\n    </td>\r\n    <td width="321" valign="top" height="36" style="border: solid #010101 1px;">\r\n    <div align="left">&nbsp;<font color="#010101"></font></div>\r\n    </td></tr></tbody></table>', 'Admin', 'Active');



INSERT INTO `goStores_PlanPackages` (`nPPId`, `nPlanId`, `vDescription`, `nPlanAmount`, `dCreatedOn`, `nStatus`, `nDeleteStatus`) VALUES
(1, 1, 'Free Trial for Product', 50, '2012-09-06 17:29:34', 0, 0),
(2, 2, 'Discount Pack', 30, '2012-09-11 16:05:12', 1, 0);


INSERT INTO `goStores_ProductPermission` (`nId`, `nPId`, `vPermissions`) VALUES
(1, 1, 'app/webroot/img/,app/webroot/img/products/,app/webroot/img/csv/,app/tmp/,app/tmp/logs/,app/tmp/sessions/,app/tmp/cache/,app/tmp/cache/models/,app/tmp/cache/views/,app/tmp/cache/persistent/,app/webroot/files/,app/webroot/files/File,app/webroot/files/Flash,app/webroot/files/Image,app/webroot/files/Media,app/webroot/files/Graph,app/config/database.php,app/webroot/config.php,app/webroot/img/SiteLogo.gif,app/webroot/img/SiteLogo_disp.gif,app/webroot/blog/wp-content/,app/webroot/blog/wp-config.php,app/controllers/components/pple.xml,app/webroot/configxml.xml,');


INSERT INTO `goStores_Products` (`nPId`, `vPName`, `vProductCaption`, `vProductPack`, `vProductlogoSmall`, `vProductlogo`, `vProductDescription`, `vProductScreens`, `dLastUpdated`, `nPRId`, `nStatus`) VALUES
(1, 'VistaCart', 'Online shopping Cart', 'vistacart.zip', 'Socialware_small_disp.gif', 'Socialware_main_disp.gif', 'Social Networking Sites', 'Socialware_small_disp.gif', '2012-12-11 20:06:13', 4, 1);


INSERT INTO `goStores_ServiceCategories` (`nSCatId`, `vCategory`, `vDescription`, `vInputType`, `vOrderofDisplay`, `dCreatedOn`, `nStatus`) VALUES
(1, 'Domain Registration', 'Domain Registration', 'C', NULL, '2012-09-14', 1),
(2, 'License Plans', 'License Plans', 'C', NULL, '2012-09-14', 1),
(3, 'Professional Installation Service', 'Professional Installation Service', 'C', NULL, '2012-09-14', 1),
(4, 'Support Options', 'Support Options', 'C', NULL, '2012-09-14', 1),
(5, 'Copyright Removal License', 'Copyright Removal License', 'C', NULL, '2012-09-14', 0),
(6, 'Product Purchase', 'Product Purchase', 'C', NULL, '2012-09-14', 1),
(7, 'Graphic Design Service', 'Graphic Design Service', 'R', NULL, '2012-09-14', 1),
(8, 'Support Upgrade', 'Support Upgrade', 'C', NULL, '2012-09-14', 1),
(9, 'Product Upgrade', 'Product Upgrade', 'C', NULL, '2012-09-14', 1),
(10, 'Free Product Upgrade', 'Free Product Upgrade', 'C', NULL, '2012-09-14', 1),
(12, 'Product Upgrade1', 'hh\\''g', 'C', NULL, '2012-09-18', 1);



INSERT INTO `goStores_Settings` (`settingfield`, `settinglabel`, `value`, `groupLabel`, `type`, `fieldOrder`, `helpText`) VALUES
('siteName', 'Site Name', '', 'General', '', 0, 'Name your site. This name is the website title. This will be visible to users within the browser tab. Try to use keywords describing your site to help visitors understand your page quickly.'),
('siteTitle', 'Site Title', '', 'General', '', 0, 'The contents of this field will appear in several places including the title of the website.'),
('secureURL', 'Secure URL', '', 'General', '', 0, 'This is for SSL certificates only. This information is provided by your hosting company.'),
('adminEmail', 'Admin Email', '', 'General', '', 0, 'This is the email where all site notifications, alerts and approvals will be sent.'),
('siteLogo', 'Site Logo', '', '', '', 0, 'This is where you can change the logo of the site. Click �Browse� to upload a file saved on your computer.'),
('enablesiteBanner', 'Enablesite Banner', 'N', 'General', '', 0, ''),
('siteBanner', 'Site Banner', '', 'General', '', 0, ''),
('metaKeywords', 'Meta Keywords', '', 'General', 'textarea', 0, 'Meta Keywords, or tags, are additional copy included in your website''s HTML.<br>(1)keep your list of keywords or keyword phrases down to 10 - 15 unique words or phrases;<br> (2) separate the words or phrases using a comma (you do not need to leave a space between words separated by commas); <br>(3) do not repeat words or phrases; <br>(4) put your most important word or phrases at the beginning of your list.'),
('metaDescription', 'Meta Description', '', 'General', 'textarea', 0, 'The meta description is a meta tag that is used to describe the current Web page. It provides a short summary of the page so that readers can decide whether the page is what they are looking for or looks interesting.'),
('enableGoogleAdsense', 'Enable Google Adsense', 'N', 'General', 'checkbox', 0, 'Enable this if you have a Google AdSense account. '),
('googleAdsense', 'Google Adsense', '', 'General', 'textarea', 0, 'If you have an AdSense account, enter your code here for analytics purposes.'),
('enablepaypal', 'Enable Paypal', 'N', 'Payment', 'checkbox', 0, ''),
('enablepaypalsandbox', 'Paypal Test Mode', 'N', 'Payment', 'checkbox', 0, ''),
('paypalidentitytoken', 'Paypal Identity Token', '', 'Payment', '', 0, ''),
('paypalemail', 'Paypal Email', '', 'Payment', '', 0, ''),
('paypal_api_username', 'Paypal username', '', 'Payment', '', 0, ''),
('paypal_api_password', 'Paypal Password', '', 'Payment', '', 0, ''),
('paypal_api_signature', 'Paypal Signature', '', 'Payment', '', 0, ''),
('paypal_application_app_id', 'Paypal Application ID', '', 'Payment', '', 0, ''),
('authorize_enable', 'Enable Authorize.Net ', 'N', 'Payment', '', 0, 'Note : Authorize.Net will support only US dollars.'),
('authorize_loginid', 'Authorize.Net Login Id', '', 'Payment', '', 0, ''),
('authorize_transkey', 'Authorize.Net Transaction Key', '', 'Payment', '', 0, ''),
('nFeatured_Amount', 'Featured Amount', '', 'General', '', 0, ''),
('authorize_email', 'Authorize.Net Email', '', 'Payment', '', 0, ''),
('authorize_test_mode', 'Authorize.Net Test Mode', 'N', 'Payment', 'checkbox', 0, ''),
('admin_currency', 'Currency', 'USD', 'General', '', 0, ''),
('currency_symbol', 'Currency Symbol', '$', 'General', '', 0, 'Currency symbol for transaction'),
('enable_multicurrency', 'Enable Multicurrency', 'N', 'General', 'checkbox', 0, ''),
('banner_link', 'Banner Link', '', 'General', '', 0, ''),
('googleAnalytics', 'Google Analytics', '', 'General', 'textarea', 0, 'Add Google Analytics code here if you wish to track your site activities'),
('godaddy_id', 'GoDaddy API Login ID', '', 'Domain Registrar', '', 0, ''),
('link', 'Click link to certify your Godaddy account', '', 'Domain Registrar', 'link', 0, ''),
('godaddy_password', 'GoDaddy API Password ', '', 'Domain Registrar', '', 0, ''),
('godaddy_testmode', 'GoDaddy Test Mode', 'N', 'Domain Registrar', 'checkbox', 0, ''),
('enable_fb', 'Enable Facebook', 'N', 'Social Settings', 'checkbox', 0, 'Would you like your site linked to Facebook?'),
('facebookUrl', 'Facebook Link', '', 'Social Settings', '', 0, ''),
('enable_twitter', 'Enable Twitter', 'N', 'Social Settings', 'checkbox', 0, 'Would you like your site linked to Twitter?'),
('twitterUrl', 'Twitter Link', '', 'Social Settings', '', 0, ''),
('enable_ln', 'Enable LinkedIn', 'N', 'Social Settings', 'checkbox', 0, ''),
('linkedInUrl', 'LinkedIn Link', '', 'Social Settings', '', 0, ''),
('yourpay_pemfile', 'YourPay PEM file', '', 'Payment', '', 0, ''),
('twoco_testmode', 'Twocheckout Test Mode', 'N', 'Payment', 'checkbox', 0, ''),
('twoco_vendorId', 'Twocheckout Vendor Id', '', 'Payment', '', 0, ''),
('paypalpro_testmode', 'Paypalpro Test Mode', 'N', 'Payment', 'checkbox', 0, ''),
('twoco_enable', 'Enable Twocheckout', 'N', 'Payment', 'checkbox', 0, ''),
('paypalpro_password', 'Paypalpro Password', '', 'Payment', '', 0, ''),
('paypalpro_enable', 'Enable Paypalpro', 'N', 'Payment', 'checkbox', 0, ''),
('paypalpro_username', 'Paypalpro User Name', '', 'Payment', '', 0, ''),
('paypalpro_signature', 'Paypalpro Signature', '', 'Payment', '', 0, ''),
('payflow_password', 'Paypalflow Password', '', 'Payment', '', 0, ''),
('paypalexpress_testmode', 'Paypal Express Test Mode', 'N', 'Payment', 'checkbox', 0, ''),
('paypalexpress_signature', 'Paypal Express Signature', '', 'Payment', '', 0, ''),
('paypalexpress_password', 'Paypal Express Password', '', 'Payment', '', 0, ''),
('paypalexpress_username', 'PayPal Express Username', '', 'Payment', '', 0, ''),
('paypalexpress_enable', 'Enable Paypal Express', 'N', 'Payment', 'checkbox', 0, ''),
('paypaladvanced_password', 'Paypal Advanced Password', '', 'Payment', '', 0, ''),
('paypaladvanced_username', 'Paypal Advanced Username', '', 'Payment', '', 0, ''),
('paypalflowlink_enable', 'Enable Paypal Flow link', 'N', 'Payment', 'checkbox', 0, ''),
('paypalflowlink_partnerid', 'Payflow Link Partner ID', '', 'Payment', '', 0, ''),
('paypalflowlink_vendorid', 'Payflow Link Vendor ID', '', 'Payment', '', 0, ''),
('paypalflowlink_testmode', 'Payflow Link Test Mode', 'N', 'Payment', 'checkbox', 0, ''),
('ogone_enable', 'Enable Ogone', 'N', 'Payment', 'checkbox', 0, ''),
('ogone_partnerid', 'Ogone PSPID', '', 'Payment', '', 0, ''),
('ogone_vendorid', 'Ogone Passphrase', '', 'Payment', '', 0, ''),
('ogone_testmode', 'Ogone Test Mode', 'N', 'Payment', 'checkbox', 0, ''),
('moneybookers_enable', 'Enable Moneybookers', 'N', 'Payment', 'checkbox', 0, ''),
('moneybookers_emailid', 'Money Booker Email Id ', '', 'Payment', '', 0, ''),
('moneybookers_testmode', 'Money Bookers Test Mode', 'N', 'Payment', 'checkbox', 0, ''),
('braintree_enable', 'Enable Braintree', 'N', 'Payment', 'checkbox', 0, ''),
('braintree_merchantId', 'Braintree Merchant ID', '', 'Payment', '', 0, ''),
('braintree_publickey', 'Braintree Public Key', '', 'Payment', '', 0, ''),
('braintree_privatekey', 'Braintree Private Key', '', 'Payment', '', 0, ''),
('braintree_testmode', 'Braintree Test Mode', 'N', 'Payment', 'checkbox', 0, ''),
('paypaladvanced_vendorid', 'Paypal Advanced Vendor ID', '', 'Payment', '', 0, ''),
('paypaladvanced_enable', 'Enable Paypal Advanced', 'N', 'Payment', 'checkbox', 0, ''),
('streamsend_enable', 'Enable Streamsend', 'N', 'General', 'checkbox', 0, 'Enable this if you want to bulk email your customers'),
('streamsend_loginid', 'Streamsend Login ID', '', 'General', '', 0, 'LoginId of http://streamsend.com/ account '),
('streamsend_key', 'Streamsend Key', '', 'General', '', 0, 'Key generated from http://streamsend.com/ account'),
('streamsend_listid', 'Streamsend List ID', '', 'General', '', 0, 'List Id from http://streamsend.com/'),
('paypaladvanced_partnerid', 'Paypal Advanced Partner ID', '', 'Payment', '', 0, ''),
('paypaladvanced_testmode', 'Paypal Advanced Test Mode', 'N', 'Payment', 'checkbox', 0, ''),
('company_name', 'Company Name', '', 'General', '', 0, 'Enter your company name'),
('company_address', 'Company Address', '', 'General', 'textarea', 0, ''),
('company_website', 'Company Website', '', 'General', '', 0, 'Enter your company website'),
('company_email', 'Company Email', '', 'General', '', 0, 'Enter your company email'),
('company_phone', 'Company Phone', '', 'General', '', 0, 'Enter your company phone'),
('enable_googlecheckout', 'Enable Google Checkout', 'N', 'Payment', '', 0, ''),
('gcheck_merchant_id', 'Google Checkout Merchant id', '', 'Payment', '', 0, ''),
('gcheck_merchant_key', 'Google Checkout Merchant key', '', 'Payment', '', 0, ''),
('gcheck_server_type', 'Google Checkout Server Type', '', 'Payment', '', 0, ''),
('gcheck_currency', 'Google Checkout Currency', '', 'Payment', '', 0, ''),
('gcheck_btn_checkout', 'Google Checkout Button Type', '', 'Payment', '', 0, ''),
('yourpay_enable', 'Enable Yourpay', 'N', 'Payment', '', 0, ''),
('yourpay_storeid', 'Yourpay Store ID', '', 'Payment', '', 0, ''),
('yourpay_demo', 'Yourpay Demo', 'N', 'Payment', '', 0, ''),
('enom_password', 'Enom Password', '', 'Domain Registrar', '', 0, ''),
('enom_testmode', 'Enom Testmode', 'N', 'Domain Registrar', 'checkbox', 0, ''),
('enom_user', 'Enom User', '', 'Domain Registrar', '', 4, ''),
('domain_registrar', 'Domain Registrar', '', 'Domain Registrar', '', 6, 'Domain'),
('quickbook_appname', 'Quickbook Application Name', '', 'Payment', '', 0, ''),
('quickbook_key', 'Quickbook Key', '', 'Payment', '', 0, ''),
('quickbook_enable', 'Enable Quickbooke', 'N', 'Payment', '', 0, ''),
('quickbook_testmode', 'Quickbook Test Mode', 'N', 'Payment', '', 0, ''),
('name_server_1', 'Name Server 1', '', 'Name Servers', '', 1, ''),
('name_server_2', 'Name Server 2', '', 'Name Servers', '', 2, ''),
('name_server_3', 'Name Server 3', '', 'Name Servers', '', 3, ''),
('name_server_4', 'Name Server 4', '', 'Name Servers', '', 4, ''),
('paypalflow_enable', 'Enable Payflow', 'N', 'Payment', 'checkbox', 0, ''),
('paypalflow_partnerid', 'Payflow Partner ID', '', 'Payment', '', 0, ''),
('paypalflow_vendorid', 'Payflow Vendorid', '', 'Payment', '', 0, ''),
('payflowlink_password', 'Payflowlink Password', '', 'Payment', '', 0, ''),
('paypalflow_testmode', 'Payflow Test Mode', 'N', 'Payment', 'checkbox', 0, ''),
('site_email', 'Site Email', '', 'General', '', 0, ''),
('site_phone', 'Site Phone', '', 'General', '', 0, ''),
('company_phone_internat', 'Company Phone(International)', '', 'General', '', 0, 'Enter your company phone'),
('whm_host', 'WHM Host', NULL, 'Hosting', '', 0, ''),
('whm_user', 'WHM Username', NULL, 'Hosting', '', 0, ''),
('whm_pass', 'WHM Password', NULL, 'Hosting', '', 0, ''),
('whm_package', 'WHM Package', NULL, 'Hosting', '', 0, ''),
('whm_ip', 'WHM IP', NULL, 'Hosting', '', 0, ''),
('whm_product_pack_location', '', NULL, '', '', 0, ''),
('whm_landing_location', '', NULL, '', '', 0, ''),
('priceDomiainRegistration', 'Price of Domain Registration Plan', '', 'Domain Registrar', '', 0, ''),
('licenseKey', 'License Key', '', 'General', '', 0, 'Your license key is emailed to you after purchase. The license key should be entered here to verify and activate the software.'),
('recaptcha_enable', 'Enable Recaptcha', 'N', 'General', '', 0, 'You can enable / disable recaptcha in site.'),
('recaptcha_public_key', 'Recaptcha Public Key', '', 'General', '', 0, 'Enter Recaptcha Public Key'),
('recaptcha_private_key', 'Recaptcha Private Key', '', 'General', '', 0, 'Enter Recaptcha Private Key');


INSERT INTO `goStores_themes` (`theme_id`, `theme_title`, `theme_name`, `theme_status`, `theme_thumbnail`) VALUES
(1, 'Clean Grey', 'theme1', 1, '<img style="width:60px; height:60px; " src="http://localhost/gostores/project/styles/themes/theme1/preview.jpg">'),
(2, 'Aqua Blue', 'theme2', 0, ' <img style="width:60px; height:60px; " src="http://localhost/gostores/project/styles/themes/theme2/preview.jpg">'),
(3, 'Elegent Red', 'theme3', 0, '<img style="width:60px; height:60px; " src="http://localhost/gostores/project/styles/themes/theme3/preview.jpg">'),
(4, 'Emerald Green', 'theme4', 0, '<img style="width:60px; height:60px; " src="http://localhost/gostores/project/styles/themes/theme4/preview.jpg">'),
(5, 'Lifestyle', 'theme5', 0, '<img style="width:60px; height:60px; " src="http://localhost/gostores/project/styles/themes/theme5/preview.jpg">');

INSERT INTO `goStores_tld` (`id`, `registrar`, `tld`, `register_fee`, `renewal_fee`, `transfer_fee`, `tocidreg`, `tocidren`, `tocidtra`) VALUES
(11, 'ENOM', 'biz', 10.00, 10.00, 10.00, '', '', ''),
(12, 'ENOM', 'com', 10.00, 10.00, 10.00, '', '', ''),
(13, 'ENOM', 'info', 10.00, 10.00, 10.00, '', '', ''),
(14, 'ENOM', 'mobi', 10.00, 10.00, 10.00, '', '', ''),
(15, 'ENOM', 'name', 10.00, 10.00, 10.00, '', '', ''),
(16, 'ENOM', 'net', 10.00, 10.00, 10.00, '', '', ''),
(17, 'ENOM', 'org', 10.00, 10.00, 10.00, '', '', ''),
(20, 'ENOM', 'ca', 10.00, 10.00, 10.00, '', '', '');


INSERT INTO `goStores_Vista_admins` (`id`, `admin_name`, `admin_pword`, `settings`, `custom`, `category`, `products`, `feedback`, `users`, `orders`, `refund`, `promocodes`, `websitecontent`, `reports`, `homepage`, `help`, `adminusers`, `newsletter`, `newsletterusers`, `sentnewsletters`, `giftcards`, `giftcardusers`, `email`, `blog_pword`) VALUES
(1, 'admin', '21232f297a57a5a743894a0e4a801fc3', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '', 'admin');

INSERT INTO `goStores_Vista_categories` (`id`, `cname`, `parent_id`, `custom_combination`) VALUES (1, 'Root', 0, '');

INSERT INTO `goStores_Vista_cmspages` (`id`, `title`, `content`, `type`, `status`) VALUES
(1, 'Order confirm mail', '<p>&nbsp;</p>\r\n<p>Dear [User_Name],</p>\r\n<p>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Your order has been successfully placed at [SITE_NAME]. The order details is follows.</p>\r\n<p>[ORDER_DETAILS]</p>\r\n<p>Thanks,</p>\r\n<p>Administrator , [SITE_NAME]</p>', 'email', 'Y'),
(2, 'Registration intimation mail to admin', '<h3 style="color: Red;">&nbsp;</h3>\r\n<h3 style="color: Red;">Hi Admin,</h3>\r\n<h3 style="color: Red;">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; A new user&nbsp; [User_Name]&nbsp; is registered with [SITE_NAME].</h3>\r\n<h3 style="color: Red;">&nbsp;</h3>\r\n<h3 style="color: Red;">Thanks,</h3>\r\n<h3 style="color: Red;">Staff. [SITE_NAME]</h3>', 'email', 'Y'),
(3, 'AboutUS', '<h2>Who We Are</h2>\r\n<p class="style1">Hello, and welcome to Online Toys.</p>\r\n<p class="style1">Online Toys is owned and operated by our  family owned company - American Online Commerce Pty. Ltd. We are a purely internet based toy store which means we  specialise in the sale of toys only through the World Wide Web. We are  an independent toy retailer and we are located at Los Angeles. Our web site www.etoys.com officially  opened for business October 2010 with the ultimate aim of one day  becoming America''s best known, and loved, online toy store.</p>\r\n<p class="style1">We despatch orders US-wide and to several  international destinations. We allow customer pickups, customer  enquiries via phone or email, and in many cases we can ship orders same  day. Our warehouse allows us to hold stock while our web site tracks  stock in real-time so we can despatch orders quickly and efficiently at  all times.</p>\r\n<p class="style2">Our goals are to:</p>\r\n<table width="100%" cellspacing="5" cellpadding="0" border="0">\r\n    <tbody>\r\n        <tr>\r\n            <td>\r\n            <ul>\r\n                <li class="style1">Provide our customers with a great selection of toys,</li>\r\n                <li class="style1">Offer the toys at the lowest possible price,</li>\r\n                <li class="style1">Provide a friendly, fast, and reliable service at all times,</li>\r\n                <li class="style1">Give our customers total piece-of-mind should anything go wrong,</li>\r\n                <li class="style1">And make our store as easy as possible to use and navigate.</li>\r\n            </ul>\r\n            </td>\r\n        </tr>\r\n    </tbody>\r\n</table>', 'content', 'Y'),
(4, 'Forgot password mail', '<p>Hi [User_Name],</p>\r\n<p>&nbsp; Your Password on [SITE_NAME] has been reset. </p>\r\n<p>Your new password is&nbsp; :&nbsp; [PASSWORD]</p>\r\n<p>&nbsp;</p>\r\n<p>Thanks,</p>\r\n<p>Administrator&nbsp; [SITE_NAME]</p>', 'email', 'Y'),
(5, 'Registration confirm mail', '<p>&nbsp;</p>\r\n<p>&nbsp;</p>\r\n<p><em><span style="font-size: larger;">Hi Dear [User_Name],<br />\r\n</span></em></p>\r\n<p><em><span style="font-size: larger;">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Your Registration with&nbsp; [SITE_NAME] is completed......<br />\r\n</span></em></p>\r\n<p><em><span style="font-size: larger;">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Your User Name is&nbsp; : [User_Name]</span></em> </p>\r\n<p>&nbsp;&nbsp;<em><span style="font-size: larger;">&nbsp;&nbsp;&nbsp; Your Password is&nbsp;&nbsp;&nbsp;&nbsp; :&nbsp; [PASSWORD]</span></em></p>\r\n<p><em><span style="font-size: larger;">&nbsp; [LOGIN_URL]<br />\r\n</span></em></p>\r\n<p><em><span style="font-size: larger;">Thanks and Regards,<br />\r\n</span></em></p>\r\n<p><em><span style="font-size: larger;">Administrator [SITE_NAME]<br />\r\n</span></em></p>', 'email', 'Y'),
(6, 'Order status change mail', '<p>Dear [User_Name],</p>\r\n<p>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Your order&nbsp; status has been changed at [SITE_NAME]. The order details is follows.</p>\r\n<p>[ORDER_DETAILS]</p>\r\n<p>Thanks,</p>\r\n<p>Administrator , [SITE_NAME]</p>', 'email', 'Y'),
(7, 'FAQ', '<p><b>Frequently Asked Questions</b>&nbsp;</p>\r\n<p><strong>Q:&nbsp;</strong> &nbsp;&nbsp;&nbsp; My toy has arrived broken. What do I do?<br />\r\n<strong>A: </strong>&nbsp;&nbsp;&nbsp; If you suspect that the toy you ordered from us is damaged, please do not accept delivery. Ask the driver/postman that it be returned to sender by crossing out your delivery address and writing, in big letters, &quot;RTS&quot; (Return To Sender). Notify us of what''s happened and we will take care of the rest by having a replacement toy sent out to you once the damaged toy is received by us.<br />\r\n<br />\r\nIf, on the other hand, you accepted delivery and discovered your toy to be broken much later, don''t stress. The first thing to do is to notify us about the problem, we will provide you with a special number called a Return Merchandise Authority (RMA) number and further instructions. Repack the damaged toy, in its original packaging, together with the original receipt (if you have one) and everything else that came with it and return it back to us using the ''Reply Paid'' address we give you. A replacement toy will be sent to you once the damaged toy is received by us.<br />\r\n<br />\r\n<strong>Q:&nbsp;</strong> &nbsp;&nbsp;&nbsp; How does the Customer Reward Points programme work?<br />\r\n<strong>A: </strong>&nbsp;&nbsp;&nbsp; In a nutshell, you will receive 10 points for every $1 you spend. Toys labelled &quot;BONUS&quot; will reward you with more points (sometimes twice more). You can accumulate your points (and save for something big) or you can use them upon subsequent visits. The choice is yours. To convert points back into dollars, you will need 250 points to make up $1. Please click here for further information and click on the &quot;Terms &amp; Conditions&quot; tab above to read our Terms &amp; Conditions.<br />\r\n<br />\r\n<br />\r\n<strong>Q:&nbsp;</strong> &nbsp;&nbsp;&nbsp; I bought the wrong toy. What do I do?<br />\r\nA: &nbsp;&nbsp;&nbsp; It is important that when selecting the toy you want that you do so carefully. We understand that many toys look the same, some of them have very similar names, while others do exactly the same things, however, we cannot be held responsible if you make a wrong selection or change your mind.<br />\r\n<br />\r\nIf you are unsure about anything, we are here to help. Please use our Live Help service, email, or call us by telephone and ask us questions that will help you make the right choice. <br />\r\n<br />\r\n<strong>Q:&nbsp;</strong> &nbsp;&nbsp;&nbsp; Can I pay by cheque?<br />\r\n<strong>A: &nbsp;</strong>&nbsp;&nbsp; Yes you can. In addition to credit cards, we also accept bank cheques, personal cheques, and money orders. But please keep in mind that no orders will be despatched until cheque payments have been cleared by the bank. Cheques normally take around 3 working days to clear.<br />\r\n<br />\r\n<strong>Q:&nbsp;</strong> &nbsp;&nbsp;&nbsp; I''ve selected a gift-tag, why cant I include a message?<br />\r\n<strong>A: </strong>&nbsp;&nbsp;&nbsp; Gift-tags generally are not very big which means after including the recipients and senders names there generally isn''t much room for anything else. However, our Greeting Cards do have the option to include messages if required.<br />\r\n<br />\r\n<strong>Q:&nbsp;</strong> &nbsp;&nbsp;&nbsp; Do you sell/trade on eBay?<br />\r\n<strong>A: &nbsp;</strong>&nbsp;&nbsp; No, we don''t.</p>', 'content', 'Y'),
(8, 'Terms', '<p class="style1">By continuing to browse, shop, purchase, and view  content on the Online Toys US web site, you , any person, body,  company, or institution acting on your behalf, the customer or visitor  is deemed to fully and unconditionally agree to these Terms &amp;  Conditions. You are bound by these Terms and Conditions so long as you  continue to shop, buy, or browse this web site. This web site is  governed and protected by the state judicial laws of Victoria and  Federal Laws of US .</p>\r\n<p><strong class="style2">Copyright</strong></p>\r\n<p class="style1">All content/material found on our web site is owned by  Online Toys US and is protected by United States, and international  copyright laws. Such content/material includes, but is not limited to,  text, images, logos, buttons, software code, audio, and video. Where  content is supplied by external provides, including manufacturers,  wholesalers, and distributors, such content is deemed to be owned by the  said organisations and are likewise protected by copyright laws. No  content/material may be used, in any way, without the written permission  of Online Toys US , its parent company, or original copyright  owners.</p>\r\n<p class="style1">You are prohibited from transmitting, broadcasting,  editing, adapting, or making use of any intellectual property,  trademarks, or logos owned and found on the Online Toys&nbsp;US  web  site without the expressed permission of Online Toys United Statesor its  parent company.</p>\r\n<p class="style1">As a result of browsing the Online Toys US  web  site where content is downloaded, printed, or viewed, such content is  permissible for private, non-commercial use for the sole purpose of  evaluating goods, making a purchase of goods, or promoting the sale of  goods to others.</p>\r\n<p><strong class="style2">Security</strong></p>\r\n<p class="style1">The integrity and security of information between you  and our web site cannot be assured or guaranteed to the full extent.  Likewise, we cannot and will not accept responsibility for the safe  keeping, transmitting, and the overall security of information sent to  and from our web site/server(s). The customer, visitor, or any other  person should take steps to ensure they are protected by relevant  third-party software including, but not limited to, firewall software,  anti-virus software, and other security protection software at all  times. Failure to do so may result in adverse and undesirable effects to  your computer as well as the potential loss and/or theft of sensitive  information. Whilst efforts are made to reduce such risk on our  server(s), the customer, visitor, or any other person acknowledges that  any information sent to or from our web site, is done so at their own  risk.</p>\r\n<p><strong class="style2">Access and Restrictions</strong></p>\r\n<p class="style1">From time to time, access to our web site may be denied for any one or all of the following reasons:</p>\r\n<p class="style1">a)	Maintenance and/or repair,<br />\r\nb)	Upgrades and enhancements,<br />\r\nc)	Server downtime/failure,<br />\r\nd)	Systems downtime/failure,<br />\r\ne)	Software corruption/failure.</p>\r\n<p class="style1">Online Toys US  may, at its own discretion,  prevent a customer, visitor, or any other person from gaining access to  our web site through any means/technologies available at it&rsquo;s disposal.  Any person identified as a potential security threat or anyone who has  attempted to claim/purchase goods in a fraudulent or dishonest manner  will immediately have their IP blocked. Where State or Federal laws are  broken or a crime is committed towards the store, Online Toys US may also report  such matters to the appropriate law enforcing bodies,  Government agencies, and/or Federal bureaus.</p>\r\n<p><strong class="style2">Payment</strong></p>\r\n<p class="style1">Payment for goods purchased is not final until funds  have been cleared. This means that no goods or services will be provided  until monies have been cleared by the relevant financial institutions,  processed and approved by all parties concerned,  all financial entities  are satisfied  that fraud, deceptive, or misleading conduct had not  been carried out, and the full purchase amount had been credited to the  online Toys US bank account.</p>\r\n<p><strong class="style2">Store Sale/Promotions</strong></p>\r\n<p class="style1">Online Toys US will offer, from time to time,  either exclusively or to the general public at large, products at  reduced prices (otherwise commonly known as a ''Sale''). Customers who  place orders for sale items will be deemed to have read, and agree to,  all the terms and conditions, placed by Online Toys US , for that  particular sale. Such terms and conditions will be placed behind  promotional banners or made available through text links throughout the  store.</p>', 'content', 'Y'),
(12, 'Order payment received mail', '<p>Dear [User_Name],</p>\r\n<p>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Your order&nbsp; payment has been received at [SITE_NAME]. The order details is follows.</p>\r\n<p>[ORDER_DETAILS]</p>\r\n<p>Thanks,</p>\r\n<p>Administrator , [SITE_NAME]</p>', 'email', 'Y'),
(9, 'Admin order confirm mail', '<p>&nbsp;</p>\r\n<p>Dear Administrator,</p>\r\n<p>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; An Order has been successfully placed at [SITE_NAME]. The order details is follows.</p>\r\n<p>[ORDER_DETAILS]</p>', 'email', 'Y'),
(10, 'Testimonials', 'Add Testimonials Here...............................', 'content', 'N'),
(11, 'Community', 'Add Community details Here...............................', 'content', 'N');



INSERT INTO `goStores_Vista_countries` (`country_id`, `country_name`, `country_iso_code_2`) VALUES
(1, 'Afghanistan', 'AF'),
(2, 'Albania', 'AL'),
(3, 'Algeria', 'DZ'),
(4, 'American Samoa', 'AS'),
(5, 'Andorra', 'AD'),
(6, 'Angola', 'AO'),
(7, 'Anguilla', 'AI'),
(8, 'Antarctica', 'AQ'),
(9, 'Antigua and Barbuda', 'AG'),
(10, 'Argentina', 'AR'),
(11, 'Armenia', 'AM'),
(12, 'Aruba', 'AW'),
(13, 'Australia', 'AU'),
(14, 'Austria', 'AT'),
(15, 'Azerbaijan', 'AZ'),
(16, 'Bahamas', 'BS'),
(17, 'Bahrain', 'BH'),
(18, 'Bangladesh', 'BD'),
(19, 'Barbados', 'BB'),
(20, 'Belarus', 'BY'),
(21, 'Belgium', 'BE'),
(22, 'Belize', 'BZ'),
(23, 'Benin', 'BJ'),
(24, 'Bermuda', 'BM'),
(25, 'Bhutan', 'BT'),
(26, 'Bolivia', 'BO'),
(27, 'Bosnia and Herzegowina', 'BA'),
(28, 'Botswana', 'BW'),
(29, 'Bouvet Island', 'BV'),
(30, 'Brazil', 'BR'),
(31, 'British Indian Ocean Territory', 'IO'),
(32, 'Brunei Darussalam', 'BN'),
(33, 'Bulgaria', 'BG'),
(34, 'Burkina Faso', 'BF'),
(35, 'Burundi', 'BI'),
(36, 'Cambodia', 'KH'),
(37, 'Cameroon', 'CM'),
(38, 'Canada', 'CA'),
(39, 'Cape Verde', 'CV'),
(40, 'Cayman Islands', 'KY'),
(41, 'Central African Republic', 'CF'),
(42, 'Chad', 'TD'),
(43, 'Chile', 'CL'),
(44, 'China', 'CN'),
(45, 'Christmas Island', 'CX'),
(46, 'Cocos (Keeling) Islands', 'CC'),
(47, 'Colombia', 'CO'),
(48, 'Comoros', 'KM'),
(49, 'Congo', 'CG'),
(50, 'Cook Islands', 'CK'),
(51, 'Costa Rica', 'CR'),
(52, 'Cote D''Ivoire', 'CI'),
(53, 'Croatia', 'HR'),
(54, 'Cuba', 'CU'),
(55, 'Cyprus', 'CY'),
(56, 'Czech Republic', 'CZ'),
(57, 'Denmark', 'DK'),
(58, 'Djibouti', 'DJ'),
(59, 'Dominica', 'DM'),
(60, 'Dominican Republic', 'DO'),
(61, 'East Timor', 'TP'),
(62, 'Ecuador', 'EC'),
(63, 'Egypt', 'EG'),
(64, 'El Salvador', 'SV'),
(65, 'Equatorial Guinea', 'GQ'),
(66, 'Eritrea', 'ER'),
(67, 'Estonia', 'EE'),
(68, 'Ethiopia', 'ET'),
(69, 'Falkland Islands (Malvinas)', 'FK'),
(70, 'Faroe Islands', 'FO'),
(71, 'Fiji', 'FJ'),
(72, 'Finland', 'FI'),
(73, 'France', 'FR'),
(74, 'France, Metropolitan', 'FX'),
(75, 'French Guiana', 'GF'),
(76, 'French Polynesia', 'PF'),
(77, 'French Southern Territories', 'TF'),
(78, 'Gabon', 'GA'),
(79, 'Gambia', 'GM'),
(80, 'Georgia', 'GE'),
(81, 'Germany', 'DE'),
(82, 'Ghana', 'GH'),
(83, 'Gibraltar', 'GI'),
(84, 'Greece', 'GR'),
(85, 'Greenland', 'GL'),
(86, 'Grenada', 'GD'),
(87, 'Guadeloupe', 'GP'),
(88, 'Guam', 'GU'),
(89, 'Guatemala', 'GT'),
(90, 'Guinea', 'GN'),
(91, 'Guinea-bissau', 'GW'),
(92, 'Guyana', 'GY'),
(93, 'Haiti', 'HT'),
(94, 'Heard and Mc Donald Islands', 'HM'),
(95, 'Honduras', 'HN'),
(96, 'Hong Kong', 'HK'),
(97, 'Hungary', 'HU'),
(98, 'Iceland', 'IS'),
(99, 'India', 'IN'),
(100, 'Indonesia', 'ID'),
(101, 'Iran (Islamic Republic of)', 'IR'),
(102, 'Iraq', 'IQ'),
(103, 'Ireland', 'IE'),
(104, 'Israel', 'IL'),
(105, 'Italy', 'IT'),
(106, 'Jamaica', 'JM'),
(107, 'Japan', 'JP'),
(108, 'Jordan', 'JO'),
(109, 'Kazakhstan', 'KZ'),
(110, 'Kenya', 'KE'),
(111, 'Kiribati', 'KI'),
(112, 'Korea, Democratic People''s Republic of', 'KP'),
(113, 'Korea, Republic of', 'KR'),
(114, 'Kuwait', 'KW'),
(115, 'Kyrgyzstan', 'KG'),
(116, 'Lao People''s Democratic Republic', 'LA'),
(117, 'Latvia', 'LV'),
(118, 'Lebanon', 'LB'),
(119, 'Lesotho', 'LS'),
(120, 'Liberia', 'LR'),
(121, 'Libyan Arab Jamahiriya', 'LY'),
(122, 'Liechtenstein', 'LI'),
(123, 'Lithuania', 'LT'),
(124, 'Luxembourg', 'LU'),
(125, 'Macau', 'MO'),
(126, 'Macedonia, The Former Yugoslav Republic of', 'MK'),
(127, 'Madagascar', 'MG'),
(128, 'Malawi', 'MW'),
(129, 'Malaysia', 'MY'),
(130, 'Maldives', 'MV'),
(131, 'Mali', 'ML'),
(132, 'Malta', 'MT'),
(133, 'Marshall Islands', 'MH'),
(134, 'Martinique', 'MQ'),
(135, 'Mauritania', 'MR'),
(136, 'Mauritius', 'MU'),
(137, 'Mayotte', 'YT'),
(138, 'Mexico', 'MX'),
(139, 'Micronesia, Federated States of', 'FM'),
(140, 'Moldova, Republic of', 'MD'),
(141, 'Monaco', 'MC'),
(142, 'Mongolia', 'MN'),
(143, 'Montserrat', 'MS'),
(144, 'Morocco', 'MA'),
(145, 'Mozambique', 'MZ'),
(146, 'Myanmar', 'MM'),
(147, 'Namibia', 'NA'),
(148, 'Nauru', 'NR'),
(149, 'Nepal', 'NP'),
(150, 'Netherlands', 'NL'),
(151, 'Netherlands Antilles', 'AN'),
(152, 'New Caledonia', 'NC'),
(153, 'New Zealand', 'NZ'),
(154, 'Nicaragua', 'NI'),
(155, 'Niger', 'NE'),
(156, 'Nigeria', 'NG'),
(157, 'Niue', 'NU'),
(158, 'Norfolk Island', 'NF'),
(159, 'Northern Mariana Islands', 'MP'),
(160, 'Norway', 'NO'),
(161, 'Oman', 'OM'),
(162, 'Pakistan', 'PK'),
(163, 'Palau', 'PW'),
(164, 'Panama', 'PA'),
(165, 'Papua New Guinea', 'PG'),
(166, 'Paraguay', 'PY'),
(167, 'Peru', 'PE'),
(168, 'Philippines', 'PH'),
(169, 'Pitcairn', 'PN'),
(170, 'Poland', 'PL'),
(171, 'Portugal', 'PT'),
(172, 'Puerto Rico', 'PR'),
(173, 'Qatar', 'QA'),
(174, 'Reunion', 'RE'),
(175, 'Romania', 'RO'),
(176, 'Russian Federation', 'RU'),
(177, 'Rwanda', 'RW'),
(178, 'Saint Kitts and Nevis', 'KN'),
(179, 'Saint Lucia', 'LC'),
(180, 'Saint Vincent and the Grenadines', 'VC'),
(181, 'Samoa', 'WS'),
(182, 'San Marino', 'SM'),
(183, 'Sao Tome and Principe', 'ST'),
(184, 'Saudi Arabia', 'SA'),
(185, 'Senegal', 'SN'),
(186, 'Seychelles', 'SC'),
(187, 'Sierra Leone', 'SL'),
(188, 'Singapore', 'SG'),
(189, 'Slovakia (Slovak Republic)', 'SK'),
(190, 'Slovenia', 'SI'),
(191, 'Solomon Islands', 'SB'),
(192, 'Somalia', 'SO'),
(193, 'South Africa', 'ZA'),
(194, 'South Georgia and the South Sandwich Islands', 'GS'),
(195, 'Spain', 'ES'),
(196, 'Sri Lanka', 'LK'),
(197, 'St. Helena', 'SH'),
(198, 'St. Pierre and Miquelon', 'PM'),
(199, 'Sudan', 'SD'),
(200, 'Suriname', 'SR'),
(201, 'Svalbard and Jan Mayen Islands', 'SJ'),
(202, 'Swaziland', 'SZ'),
(203, 'Sweden', 'SE'),
(204, 'Switzerland', 'CH'),
(205, 'Syrian Arab Republic', 'SY'),
(206, 'Taiwan', 'TW'),
(207, 'Tajikistan', 'TJ'),
(208, 'Tanzania, United Republic of', 'TZ'),
(209, 'Thailand', 'TH'),
(210, 'Togo', 'TG'),
(211, 'Tokelau', 'TK'),
(212, 'Tonga', 'TO'),
(213, 'Trinidad and Tobago', 'TT'),
(214, 'Tunisia', 'TN'),
(215, 'Turkey', 'TR'),
(216, 'Turkmenistan', 'TM'),
(217, 'Turks and Caicos Islands', 'TC'),
(218, 'Tuvalu', 'TV'),
(219, 'Uganda', 'UG'),
(220, 'Ukraine', 'UA'),
(221, 'United Arab Emirates', 'AE'),
(222, 'United Kingdom', 'GB'),
(223, 'United States', 'US'),
(224, 'United States Minor Outlying Islands', 'UM'),
(225, 'Uruguay', 'UY'),
(226, 'Uzbekistan', 'UZ'),
(227, 'Vanuatu', 'VU'),
(228, 'Vatican City State (Holy See)', 'VA'),
(229, 'Venezuela', 'VE'),
(230, 'Viet Nam', 'VN'),
(231, 'Virgin Islands (British)', 'VG'),
(232, 'Virgin Islands (U.S.)', 'VI'),
(233, 'Wallis and Futuna Islands', 'WF'),
(234, 'Western Sahara', 'EH'),
(235, 'Yemen', 'YE'),
(236, 'Yugoslavia', 'YU'),
(237, 'Zaire', 'ZR'),
(238, 'Zambia', 'ZM'),
(239, 'Zimbabwe', 'ZW');



INSERT INTO `goStores_Vista_currencies` (`id`, `code`, `name`, `logo`) VALUES
(1, 'USD', 'USD - U.S. Dollars', '$'),
(2, 'AUD', 'AUD - Australian Dollars', '$'),
(3, 'GBP', 'GBP - British Pounds', '£'),
(4, 'CAD', 'CAD - Canadian Dollars', '$'),
(5, 'CZK', 'CZK - Czech Koruna', 'Kc'),
(6, 'DKK', 'DKK - Danish Kroner', 'kr'),
(7, 'EUR', 'EUR - Euros', '€'),
(8, 'HKD', 'HKD - Hong Kong Dollars', 'HK$'),
(9, 'HUF', 'HUF - Hungarian Forint', 'Ft'),
(10, 'ILS', 'ILS - Israeli New Shekels', '?'),
(11, 'JPY', 'JPY - Japanese Yen', ''),
(12, 'MXN', 'MXN - Mexican Pesos', '$'),
(13, 'NZD', 'NZD - New Zealand Dollars', '$'),
(14, 'NOK', 'NOK - Norwegian Kroner', 'kr'),
(15, 'PLN', 'PLN - Polish Zlotych', 'zl'),
(16, 'SGD', 'SGD - Singapore Dollars', '$'),
(17, 'SEK', 'SEK - Swedish Kronor', 'kr'),
(18, 'CHF', 'CHF - Swiss Francs', 'CHF');



INSERT INTO `goStores_Vista_helps` (`id`, `title`, `content`, `type`, `order`) VALUES
(1, 'Home Page', '<ul>\r\n    <li><span class="rvts10">The List of categories will be displayed on the left side with the option to navigate to subcategories and the related products.</span></li>\r\n    <li>A list of featured products and their thumbnails are displayed with a &lsquo;view more&rsquo; button for the combined products. The &lsquo;Add to cart&rsquo; button is for products without combinations</li>\r\n    <li>If the user logged in is a whole sale user then the whole sale price of the products will be shown otherwise the retail price will be shown.</li>\r\n    <li>A list of 5 new products and 5 top rated items appear on the right side of the page with a link to the details page.</li>\r\n    <li>A user can search for any product by entering the keyword in the &lsquo;search box&rsquo; provided in the top right of the page. Enter the keyword, and then select &lsquo;Search&rsquo; and you will see a search results page. From there, make your selection.\r\n    <meta content="text/html; charset=utf-8" http-equiv="CONTENT-TYPE" />\r\n    <meta content="OpenOffice.org 3.1  (Win32)" name="GENERATOR" /><style type="text/css">\r\n	<!--\r\n		@page { margin: 0.79in }\r\n		P { margin-bottom: 0.08in }\r\n	-->\r\n	</style></li>\r\n</ul>\r\n<p><br />\r\n&nbsp;</p>', 'U', 0),
(2, 'Log in', '<ul>\r\n    <li>\r\n    <meta content="text/html; charset=utf-8" http-equiv="CONTENT-TYPE" />\r\n    <meta content="OpenOffice.org 3.1  (Win32)" name="GENERATOR" /><style type="text/css">\r\n	<!--\r\n		@page { margin: 0.79in }\r\n		P { margin-bottom: 0.08in }\r\n	--></style>A user can log in to the website using the log in link at the top of every page.</li>\r\n    <li>The user will then be asked to enter their user name and password.</li>\r\n    <li>The user can subscribe for Newsletters if needed.</li>\r\n    <li>The user will be registered as a Retail user by default.</li>\r\n    <li>When finished, the user will select the &lsquo;Log In&rsquo; button to enter the website.</li>\r\n</ul>', 'U', 0),
(3, 'Sign Up', '<ul>\r\n    <li>\r\n    <meta http-equiv="CONTENT-TYPE" content="text/html;\r\n    charset=utf-8">\r\n    <meta name="GENERATOR" content="OpenOffice.org 3.1\r\n    (Win32)">The user can sign up with the store by selecting the &lsquo;Sign Up&rsquo; link at the top of every page.          </meta>\r\n    </meta>\r\n    </li>\r\n    <li>In the sign up page, the user must enter their user name, password, re enter the password, and add an email address.</li>\r\n    <li>The user name must be unique and all fields are mandatory. Passwords are stored in the database in an encrypted format.</li>\r\n</ul>', 'U', 0),
(4, 'Forgot password', '<ul>\r\n    <li><span class="rvts10">The login&nbsp; page will have a link to forgot password  page.</span></li>\r\n    <li><span class="rvts10">A user can reset his/her password from the forgot  password page.</span></li>\r\n    <li>If the user provides a valid user name and email address, the store will reset the password and then email the new password to the user.</li>\r\n</ul>\r\n<p>&nbsp;</p>', 'U', 0),
(5, 'My Account', '<ul style="list-style-position: outside; text-indent: 0px; margin-left: 24px">\r\n    <li class="rvps2"><span class="rvts11">A&nbsp; My Account page link will be shown on the&nbsp; the top of every page for a logged in User.</span></li>\r\n    <li class="rvps2"><span class="rvts11">The My Account page will have links to&nbsp; </span><span class="rvts13">My Profile</span><span class="rvts11">,</span><a class="rvts13" href="file:///C:/Documents%20and%20Settings/Administrator/My%20Documents/Downloads/changes/fwvistacartedits/vistacartuserhelp/vistacartuserhelp/files/CartPage.html">My Cart</a><span class="rvts11">,</span><span class="rvts13"> My Orders</span><span class="rvts11">, My Shipping Address and My Billing Address pages.</span><span class="rvts11"><br />\r\n    </span>&nbsp;</li>\r\n</ul>\r\n<p class="rvps2" style="text-align: left"><strong><span class="rvts12">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </span></strong><span class="rvts12"><u><strong>My Profile</strong></u><br />\r\n</span></p>\r\n<ul style="list-style-position: outside; text-indent: 0px; margin-left: 24px">\r\n    <li><span class="rvts11">In this page,the user can edit&nbsp; his email address/password .</span></li>\r\n    <li><span class="rvts11">A user can view the items that has been added to the cart.</span></li>\r\n    <li><span class="rvts11">The user can remove any added item or update the quantity of a particular item.</span></li>\r\n    <li><span class="rvts11">The user can enter promo codes to get a discount.</span></li>\r\n    <li><span class="rvts11">The&nbsp; cart can contain either Digital or Non Digital products at a time.</span></li>\r\n    <li><span class="rvts11">The user can continue adding products to the cart by clicking on the Continue Shopping button.</span></li>\r\n    <li><span class="rvts11">The user can checkout by clicking on the checkout button.</span><span class="rvts11"><br />\r\n    </span></li>\r\n</ul>\r\n<p><strong><span class="rvts12">&nbsp;&nbsp;</span></strong><span class="rvts12">&nbsp;&nbsp;&nbsp;&nbsp;<strong> </strong><u><strong>My Orders</strong></u><br />\r\n</span></p>\r\n<ul style="list-style-position: outside; text-indent: 0px; margin-left: 24px">\r\n    <li><span class="rvts11">In this page, the user can view all their orders.</span><span class="rvts11"><br />\r\n    </span></li>\r\n</ul>\r\n<p class="rvps2"><strong><span class="rvts12">&nbsp;&nbsp;&nbsp;&nbsp; &nbsp; </span></strong><u><strong><span class="rvts12">My Billing Address</span></strong></u><span class="rvts12"><br />\r\n</span></p>\r\n<ul style="list-style-position: outside; text-indent: 0px; margin-left: 24px">\r\n    <li><span class="rvts11">In this page,the user can add/edit the Billing address Information . </span><u><strong><span class="rvts12"><br />\r\n    </span></strong></u></li>\r\n</ul>\r\n<p class="rvps2"><strong><span class="rvts12">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </span></strong><u><strong><span class="rvts12">My Shipping Address</span></strong></u><span class="rvts12"><br />\r\n</span></p>\r\n<ul style="list-style-position: outside; text-indent: 0px; margin-left: 24px">\r\n    <li><span class="rvts11">In this page,the user can add/edit the Shipping address Information . </span></li>\r\n</ul>\r\n<p class="rvps2"><strong><span class="rvts12">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </span></strong><u><strong><span class="rvts12">My Refund Request</span></strong></u></p>\r\n<ul style="list-style-position: outside; text-indent: 0px; margin-left: 24px">\r\n    <li><span class="rvts11">In this page,the user can&nbsp;make request for&nbsp;refund for the products that he/she has purchased&nbsp;&nbsp;. </span></li>\r\n</ul>\r\n<p class="rvps2"><strong><span class="rvts12">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </span></strong><u><strong><span class="rvts12">My Giftcards</span></strong></u><span class="rvts12"><br />\r\n</span></p>\r\n<ul style="list-style-position: outside; text-indent: 0px; margin-left: 24px">\r\n    <li><span class="rvts11">In this page,the user can&nbsp;view the giftcards and the&nbsp;balance amount of&nbsp;each giftcard that he/she has purchased&nbsp;. </span></li>\r\n</ul>\r\n<p class="rvps2"><strong><span class="rvts12">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </span></strong><u><strong><span class="rvts12">My Giftcard Usage</span></strong></u></p>\r\n<ul style="list-style-position: outside; text-indent: 0px; margin-left: 24px">\r\n    <li><span class="rvts11">In this page,the user can view the list of giftcards&nbsp; that he has used for&nbsp;the product purchases from the website along with the amount used for each purchase.</span>&nbsp;</li>\r\n</ul>\r\n<p><strong>&nbsp;&nbsp;&nbsp;&nbsp; <u>Unsubscribe Newsletter</u></strong><span class="rvts12"><br />\r\n</span></p>\r\n<ul style="list-style-position: outside; text-indent: 0px; margin-left: 24px">\r\n    <li><span class="rvts11">This link allows the user to subscribe/unsubscribe newsletter.</span>&nbsp;</li>\r\n</ul>\r\n<p>&nbsp;</p>\r\n<p class="rvps2"><span class="rvts12"><br />\r\n</span></p>', 'U', 0),
(6, 'Product Details Page', '<ul style="list-style-position: outside; text-indent: 0px; margin-left: 24px">\r\n    <li class="rvps2"><span class="rvts10">The details of each product such as the name and description are displayed here.</span></li>\r\n    <li class="rvps2"><span class="rvts10">The images of the product appear in an image slider with a &lsquo;next&rsquo; and &lsquo;previous&rsquo; button to help navigate.</span></li>\r\n    <li class="rvps2"><span class="rvts10">The current rating and price of the product are shown under the &lsquo;Product Image Slider&rsquo;.</span></li>\r\n    <li class="rvps2">If the logged in user is a wholesale user then both wholesale and retail price of products will be shown.</li>\r\n    <li class="rvps2"><span class="rvts10">The product is rated by selecting the stars, so viewers can determine what the best selection will be.</span></li>\r\n    <li class="rvps2"><span class="rvts10">Various combinations of the product appear when the user selects the desired option from the select box. The image, SKU number, and price appear here with an &lsquo;Add to Cart&rsquo; button. <br />\r\n    </span></li>\r\n    <li class="rvps2"><span class="rvts10">Any user can view/post feedback on a product by selecting the &lsquo;post&rsquo; and &lsquo;view&rsquo; feedback links on the bottom. To post, the customer must purchase the same product at least once.<br />\r\n    </span></li>\r\n</ul>\r\n<p>&nbsp;</p>', 'U', 0),
(7, 'Cart Page', '<ul style="text-indent: 0px; margin-left: 24px; list-style-position: outside;">\r\n    <li class="rvps2"><span class="rvts10">A user can view the items that are added to the cart.<br />\r\n    </span></li>\r\n    <li class="rvps2"><span class="rvts10">The user can remove any added  item or update the quantity of a particular item.</span></li>\r\n    <li class="rvps2"><span class="rvts10">If you have a promo code, you can enter it here.</span></li>\r\n    <li class="rvps2"><span class="rvts10">The cart can contain all physical products or all downloadable products here.</span></li>\r\n    <li class="rvps2"><span class="rvts10">The user can continue adding  products to the cart by clicking on the Continue Shopping button.</span></li>\r\n    <li class="rvps2"><span class="rvts10">Select the &lsquo;Check out&rsquo; button when you are finished adding products.</span></li>\r\n</ul>', 'U', 0),
(8, 'Checkout', '<p style="margin-left: 40px;"><span class="rvts10">When you select the &lsquo;Check out from Carts Page&rsquo;, if you aren&rsquo;t logged in, the system will allow you to do so if you register to the store, or purchase as a guest. </span><span class="rvts10"><br />\r\n</span></p>\r\n<ul style="text-indent: 0px; margin-left: 24px; list-style-position: outside;">\r\n    <li class="rvps2"><span class="rvts10">When you select the &lsquo;Check out&rsquo; button on the carts page, the user will then have two options. You can log in by registering to the store, or purchase the product as a guest. <br />\r\n    </span></li>\r\n    <li class="rvps2"><span class="rvts10">When you select the &lsquo;Check out as a guest&rsquo; button a link will automatically create your log in credentials as a &lsquo;guest user&rsquo;. From here, you have full access to the store. <br />\r\n    </span></li>\r\n    <li><span class="rvts10">The guest user must enter the correct shipping and billing information. Just select the &lsquo;Billing email address&rsquo; text box.&nbsp; The new log in details of the guest user are then sent to that email address.</span></li>\r\n</ul>\r\n<p>&nbsp;</p>\r\n<p>&nbsp;</p>', 'U', 0),
(9, 'Billing/ Shipping Address', '<p>\r\n<meta http-equiv="CONTENT-TYPE" content="text/html; charset=utf-8">\r\n<meta name="GENERATOR" content="OpenOffice.org 3.1  (Win32)"><style type="text/css">\r\n	<!--\r\n		@page { margin: 0.79in }\r\n		P { margin-bottom: 0.08in }\r\n	-->\r\n	</style></meta>\r\n</meta>\r\n</p>\r\n<p style="margin-bottom: 0in; margin-left: 40px;">During the check out process, the system will ask for the user&rsquo;s billing &amp; shipping address for non digital products and billing address for digital products. If the user has already entered these addresses, then the&nbsp;user can edit them here. For a non digital product, the user can select a shipping option. After they select the &lsquo;Save Addresses&rsquo; button, the store will lead the user to the shipping address page and show the rate available.&nbsp;</p>', 'U', 0),
(10, 'Payment Selection', '<p style="margin-left: 40px;">The store will show a &lsquo;Payment Selection&rsquo; page that shows all of the payment options available. Please enter the payment information as directed. The store will send you an email with all the details.</p>', 'U', 0),
(11, 'Search For a product', '<ul>\r\n    <li>The store supports category and keyword searches.</li>\r\n    <li>For category searches- the user can navigate through the category. When they select a leaf level category, the website will show all products under that category.</li>\r\n    <li>For keyword searches- the user has to enter the item in the search text box at the top of the home page. When they select the &lsquo;Search&rsquo; button, the user will get their search results. </li>\r\n</ul>', 'U', 0),
(12, 'View your orders', '<p style="margin-left: 40px;">In order to see the orders placed by a customer, they can select &lsquo;My account page&rsquo;-&gt; My Orders links. This page will list all the orders. To view other details, the customer has to select the &lsquo;order number&rsquo;. From the order details page, the customer can change the order status to &lsquo;Order Accepted&rsquo;.</p>', 'U', 0),
(13, 'Settings', '<p>\r\n<meta content="text/html; charset=utf-8" http-equiv="CONTENT-TYPE">\r\n<meta content="OpenOffice.org 3.1  (Win32)" name="GENERATOR"><style type="text/css">\r\n	<!--\r\n		@page { margin: 0.79in }\r\n		P { margin-bottom: 0.08in }\r\n	-->\r\n	</style>      </meta>\r\n</meta>\r\n</p>\r\n<p style="margin-bottom: 0in; ">In this page, the administrator can manage the website configurations. It consists of 4 Submenus:</p>\r\n<p style="margin-bottom: 0in;"><u><strong>General</strong></u></p>\r\n<p style="margin-bottom: 0in; ">In the General Settings Page, the administrator can change the Name, email, logo, template, page title, Meta tag description, URL store location, and the number of images per products.<br />\r\nThe administrator can enable/disable the Gift Coupons (Promo code), rating on products by customers, feedback posts on products, and send orders to administrator via fax.<br />\r\nThey can also give a time limit to customers for downloading the digital products they purchase from the store.&nbsp;</p>\r\n<p style="margin-bottom: 0in; "><strong><u>Shipping</u></strong></p>\r\n<p style="margin-bottom: 0in; ">The store supports five flat rate shipping and shipping API&rsquo;S: UPS, USPS, FEDEX, Canada Post, and Australia Post. Use flat rate shipping if you don&rsquo;t want to calculate the real time shipping costs using the shipping API&rsquo;s. For flat rate shipping, admin can set the shipping charge for the first item and a separate charge for any additional items. The administrator can enable/disable all the shipping methods if they want.They can also give the shipping service name.In shipping tab,the administrator must enter the shipping orirgin postal code and country.</p>\r\n<p style="margin-bottom: 0in;">&nbsp;<strong><u>Payment</u></strong></p>\r\n<p style="margin-bottom: 0in; ">\r\n<meta content="text/html; charset=utf-8" http-equiv="CONTENT-TYPE">\r\n<meta content="OpenOffice.org 3.1  (Win32)" name="GENERATOR"><style type="text/css">\r\n	<!--\r\n		@page { margin: 0.79in }\r\n		P { margin-bottom: 0.08in }\r\n		A:link { so-language: zxx }\r\n	-->\r\n	</style>      </meta>\r\n</meta>\r\n</p>\r\n<p style="margin-bottom: 0in; ">In the payment Page, the administrator can enable/disable the payment gateways.&nbsp; They can also select the currency for all transactions. The store supports offline credit card payment, and payment gateways like: PayPal, Authorize.net, Your Pay, World Pay, Blue Pay and Google Checkout.<br />\r\n&nbsp;If offline payment is selected the credit card information is not verified online, so please verify and charge using POS before shipping. This offline payment is a good solution for physical retail stores. If you enable an offline credit card payment, the site will not receive any payment transactions from your customers; it will send the credit card information in an email to the site administrator. <br />\r\nIt is necessary to enable at least one payment method&nbsp; for your site.</p>\r\n<p style="margin-bottom: 0in; "><strong><u>Tax</u></strong></p>\r\n<p style="margin-bottom: 0in; ">In the tax settings  page, the administrator can manage the tax settings in the website. This  page has two tabs: General, and Tax Rates</p>\r\n<p style="margin-bottom: 0in; ">In the General  settings tab- the administrator can opt for no tax to all customers, a  fixed tax rate, or tax based on any country/state. The administrator can  also choose the base to categorize the taxes as subtotal or subtotal +  shipping. The administrator can use taxable address as a billing address  or shipping address.</p>\r\n<p style="margin-bottom: 0in;">If the administrator opts fixed tax rates, they can create a tax name.&nbsp;</p>\r\n<p style="margin-bottom: 0in; ">If the administrator wants a specific tax based on a state and/or country, the tax rate tab is enabled.</p>\r\n<p style="margin-bottom: 0in; ">In this tab, the  administrator can add/edit/delete any/tax rates for states or countries.  In most jurisdictions you collect taxes for states with nexus, based on  the shipping address. For example: if you have a store in the state of  California, you have to collect taxes from all customers in California.  Please obtain legal advice for your local tax laws.</p>\r\n<p style="margin-bottom: 0in; ">&nbsp;</p>', 'A', 1),
(17, 'Import Product & Images', '<p>\r\n<meta content="text/html; charset=utf-8" http-equiv="CONTENT-TYPE" />\r\n<meta content="OpenOffice.org 3.1  (Win32)" name="GENERATOR" /><style type="text/css">\r\n	<!--\r\n		@page { margin: 0.79in }\r\n		P { margin-bottom: 0.08in }\r\n	-->\r\n	</style></p>\r\n<p style="margin-bottom: 0in; margin-left: 40px">The shopping cart allows you to import products in bulk using .csv file (comma separated values) and .zip format(s).</p>\r\n<p style="margin-bottom: 0in; margin-left: 40px">To import products- you must upload the csv file to the site using the sample csv format provided and match the data fields. When you select the &lsquo;save&rsquo; button all of your products will import into the website</p>\r\n<p style="margin-bottom: 0in; margin-left: 40px">To import product images- you must&nbsp;create a zip files with&nbsp;the images you want to upload for a particular product.The name of the zip file should be same as that of the product name.</p>\r\n<p style="margin-bottom: 0in; margin-left: 40px">&nbsp;</p>', 'A', 7),
(14, 'Custom Variables', '<p>\r\n<meta http-equiv="CONTENT-TYPE" content="text/html; charset=utf-8">\r\n<title></title>\r\n<meta name="GENERATOR" content="OpenOffice.org 3.1  (Win32)"><style type="text/css">\r\n	<!--\r\n		@page { margin: 0.79in }\r\n		P { margin-bottom: 0.08in }\r\n	-->\r\n	</style>     </meta>\r\n</meta>\r\n</p>\r\n<p style="margin-bottom: 0in; margin-left: 40px;">In the custom fields and values tab, the administrator can manage all product variables and their values. For example: if your site sells clothes, you may have a shirt in your product list. The shirt can have different variants like size (XL,XXL,etc) color (blue, red), and fabric (cotton, polyester).</p>\r\n<p style="margin-bottom: 0in; margin-left: 40px;">For the site you can add The Size, Color, and Fabric as custom fields. The XL,XXL, Blue, Red, and Cotton, Polyester, are the custom field values.</p>\r\n<p style="margin-bottom: 0in; margin-left: 40px;">&nbsp;</p>', 'A', 4),
(15, 'Categories', '<p>\r\n<meta http-equiv="CONTENT-TYPE" content="text/html; charset=utf-8">\r\n<title></title>\r\n<meta name="GENERATOR" content="OpenOffice.org 3.1  (Win32)"><style type="text/css">\r\n	<!--\r\n		@page { margin: 0.79in }\r\n		P { margin-bottom: 0.08in }\r\n	-->\r\n	</style> </meta>\r\n</meta>\r\n</p>\r\n<p style="margin-bottom: 0in; margin-left: 40px;">The store allows you to create any number of levels of categories on your site. You can add products to leaf level categories only. When adding categories you can assign custom fields and values only applicable to that category.</p>\r\n<p style="margin-bottom: 0in; margin-left: 40px;">&nbsp;</p>', 'A', 5),
(16, 'Products', '<p style="margin-left: 200px;">\r\n<meta content="text/html; charset=utf-8" http-equiv="CONTENT-TYPE" />\r\n<title></title>\r\n<meta content="OpenOffice.org 3.1  (Win32)" name="GENERATOR" /><style type="text/css">\r\n	<!--\r\n		@page { margin: 0.79in }\r\n		P { margin-bottom: 0.08in }\r\n	-->\r\n	</style></p>\r\n<p>\r\n<p style="margin-bottom: 0in; margin-left: 40px;">In the products tab, you can add/edit/delete products.</p>\r\n<p style="margin-bottom: 0in; margin-left: 40px;">To add a product- you must first select a category, enter the product name, description, price, weight, and then select physical or downloadable, set feature/not feature, browse images, select the SKU number, additional amount, and re order level for each custom value combination.</p>\r\n<p style="margin-bottom: 0in; margin-left: 40px;">For custom value combinations- you can upload the product image</p>\r\n<p style="margin-bottom: 0in; margin-left: 40px;">Examples: if you upload a t-shirt, it might be red,XL, cotton, Blue, XXL, cotton, and red XXL, cotton. Each one will have a different image, stock, re order number, and batch number. Some combinations might have an additional price. That can also be managed here.</p>\r\n<p style="margin-bottom: 0in; margin-left: 40px;">&nbsp;</p>\r\n</p>', 'A', 6),
(18, 'Feedback', '<p>\r\n<meta content="text/html; charset=utf-8" http-equiv="CONTENT-TYPE" />\r\n<title></title>\r\n<meta content="OpenOffice.org 3.1  (Win32)" name="GENERATOR" /><style type="text/css">\r\n	<!--\r\n		@page { margin: 0.79in }\r\n		P { margin-bottom: 0.08in }\r\n	-->\r\n	</style>\r\n<p style="margin-bottom: 0in; margin-left: 40px;">In the feedback page, the administrator can view customer feedback about the website and the products. Only customers who purchased a product at least once are allowed to give feedback on that product.</p>\r\n<p style="margin-bottom: 0in;">&nbsp;</p>\r\n</p>', 'A', 8),
(19, 'Users', '<p>\r\n<meta content="text/html; charset=utf-8" http-equiv="CONTENT-TYPE" />\r\n<meta content="OpenOffice.org 3.1  (Win32)" name="GENERATOR" /><style type="text/css">\r\n	<!--\r\n		@page { margin: 0.79in }\r\n		P { margin-bottom: 0.08in }\r\n	-->\r\n	</style></p>\r\n<p style="margin-bottom: 0in; margin-left: 40px">In the user page, the administrator can view, edit, and delete customers registered with the site.</p>\r\n<p style="margin-bottom: 0in; margin-left: 40px">&nbsp;</p>\r\n<p>&nbsp;</p>', 'A', 9),
(20, 'Orders', '<p>\r\n<meta http-equiv="CONTENT-TYPE" content="text/html; charset=utf-8">\r\n<title></title>\r\n<meta name="GENERATOR" content="OpenOffice.org 3.1  (Win32)"><style type="text/css">\r\n	<!--\r\n		@page { margin: 0.79in }\r\n		P { margin-bottom: 0.08in }\r\n	-->\r\n	</style> </meta>\r\n</meta>\r\n</p>\r\n<p style="margin-bottom: 0in; margin-left: 40px;">In the orders page, the administrator can view the details of the orders. They can change the order status and add comments for internal use.</p>\r\n<p style="margin-bottom: 0in; margin-left: 40px;">&nbsp;</p>', 'A', 15),
(21, 'Website Contents', '<p>\r\n<meta content="text/html; charset=utf-8" http-equiv="CONTENT-TYPE">\r\n<title></title>\r\n<meta content="OpenOffice.org 3.1  (Win32)" name="GENERATOR"><style type="text/css">\r\n	<!--\r\n		@page { margin: 0.79in }\r\n		P { margin-bottom: 0.08in }\r\n	-->\r\n	</style>   </meta>\r\n</meta>\r\n</p>\r\n<p style="margin-bottom: 0in; margin-left: 40px;">In the website content page, the administrator can edit content for the About Us section, the FAQ section, and the Terms and Conditions pages. </p>\r\n<p style="margin-bottom: 0in; margin-left: 40px;">&nbsp;</p>', 'A', 2),
(22, 'Email Templates', '<p>\r\n<meta content="text/html; charset=utf-8" http-equiv="CONTENT-TYPE" />\r\n<title></title>\r\n<meta content="OpenOffice.org 3.1  (Win32)" name="GENERATOR" /><style type="text/css">\r\n	<!--\r\n		@page { margin: 0.79in }\r\n		P { margin-bottom: 0.08in }\r\n	-->\r\n	</style>\r\n<p style="margin-bottom: 0in; margin-left: 40px;">In the email templates page, the administrator can view and edit the email templates for emails to send from the website.</p>\r\n<p style="margin-bottom: 0in; margin-left: 40px;">&nbsp;</p>\r\n</p>', 'A', 3),
(24, 'Promo Codes', '<p>\r\n<meta content="text/html; charset=utf-8" http-equiv="CONTENT-TYPE">\r\n<title></title>\r\n<meta content="OpenOffice.org 3.1  (Win32)" name="GENERATOR"><style type="text/css">\r\n	<!--\r\n		@page { margin: 0.79in }\r\n		P { margin-bottom: 0.08in }\r\n	-->\r\n	</style>   </meta>\r\n</meta>\r\n</p>\r\n<p style="margin-bottom: 0in; margin-left: 40px;">In the promo codes tab, the administrators can add/edit/delete promo codes.</p>\r\n<p style="margin-bottom: 0in; margin-left: 40px;">For the promo codes, the administrator inputs a promo code, discount type as a fixed amount or rate, discount value, start and end dates, the minimum amount required, and the description of the promo code.</p>\r\n<p style="margin-bottom: 0in; margin-left: 40px;">&nbsp;</p>', 'A', 10),
(25, 'Reports', '<p style="margin-left: 40px">Product reports, sales reports,user activity reports, user reports, and promo code reports are the reports generated in the store. All of the reports can be be exported in. CSV and .XLS file formats.</p>\r\n<p><b><u>\r\n<p style="margin-left: 40px"><span id="1285830993889S" style="display: none">&nbsp;</span>Product Report</p>\r\n</u></b></p>\r\n<p style="margin-left: 40px">In the products report, the website will show the Product name,Stock available, and the Total revenue.</p>\r\n<p><b><u>\r\n<p style="margin-left: 40px">Sales Report</p>\r\n</u></b></p>\r\n<p style="margin-left: 40px">In the sales report,the website will show the Order number,sales date, purchased user, Order status, promo code used to purchase, discount given and the total price.</p>\r\n<p><b><u>\r\n<p style="margin-left: 40px">User Report</p>\r\n</u></b></p>\r\n<p style="margin-left: 40px">In user reports , the website will show the details like username, Name of the customer,Email address, registration date in the website, address and other customer details.</p>\r\n<p><b><u>\r\n<p style="margin-left: 40px">User Activity Report</p>\r\n</u></b></p>\r\n<p style="margin-left: 40px">In user activity reports , the website will show the details like Order date,Order status,Shipping address,Billing address,Total of all the purchases made by a particular customer.</p>\r\n<p><b><u>\r\n<p style="margin-left: 40px">Promo Code Report</p>\r\n</u></b></p>\r\n<p style="margin-left: 40px">In promo code report, the system will show the details of the promo codes used by the customers.This details include code, Order number,Order date,Order status and discount value.</p>', 'A', 16),
(26, 'Newsletter Subscribers', '<p style="margin-left: 40px">In this page, the user can view the list of the users subscribed for Newsletters,add new newsletter users,activiate or deactivate the users for newsletter subscription.</p>', 'A', 14),
(27, 'Newsletters', '<p style="margin-left: 40px">In this page, the administrator can add/edit Newsletters,Send newsletter to retail users or wholesale users or both.</p>', 'A', 13),
(28, 'Giftcards', '<p style="margin-left: 40px">In this page administrator can add/edit giftcards.These gift cards will be displayed along with the products for purchase&nbsp;on user side.</p>', 'A', 11),
(29, 'Giftcard Users', '<p style="margin-left: 40px">In this page,the administrator can view the list of users who has used giftcards for purchases.It shows details such as Card name,Used card code,date,Amount used.</p>', 'A', 12);



INSERT INTO `goStores_Vista_homelayouts` (`id`, `prod_type`, `section`, `status`, `ordering`) VALUES
(1, 'featured', 'middle', 'Y', 1),
(2, 'latest', 'right', 'Y', 2),
(3, 'toprated', 'right', 'Y', 1),
(4, 'onsale', 'right', 'Y', 3);


INSERT INTO `goStores_Vista_order_statuses` (`id`, `name`) VALUES
(1, 'Item Ordered'),
(2, 'Item Shipped'),
(3, 'Item Accepted By Customer'),
(4, 'Order Pending');



INSERT INTO `goStores_Vista_refundoptions` (`id`, `title`) VALUES
(1, 'Refund'),
(2, 'Repair'),
(3, 'Replacement');


INSERT INTO `goStores_Vista_refundreasons` (`id`, `title`) VALUES
(1, 'Can not make it work'),
(2, 'Damaged during shipping'),
(3, 'Dead on arrival'),
(4, 'Manufacturer defect'),
(5, 'Out of Warranty'),
(6, 'Wrong item ordered'),
(7, 'Wrong description online'),
(8, 'Wrong item delivered');


INSERT INTO `goStores_Vista_refundstatuses` (`id`, `title`) VALUES
(1, 'Waiting for review'),
(2, 'Reviewed'),
(3, 'Rejected'),
(4, 'Closed'),
(5, 'Approved');


INSERT INTO `goStores_Vista_settings` (`fieldname`, `value`) VALUES
('admin_email', ''),
('site_name', ''),
('payment_method', ''),
('paypal_email', ''),
('paypal_idtoken', ''),
('paypal_testmode', 'Y'),
('authorize_loginid', ''),
('authorize_transactionkey', ''),
('authorize_email', ''),
('authorize_password', ''),
('authorize_testmode', 'Y'),
('shipping_origin_country', ''),
('shipping_origin_zip', ''),
('sitebasefolder', ''),
('smtpHostNames', ''),
('smtpUserName', ''),
('smtpPassword', ''),
('meta_description', ''),
('meta_keywords', ''),
('shipping_require', 'Y'),
('currency', ''),
('style', 'Garments'),
('page_title', ''),
('no_tax_home', 'Y'),
('home_state', ''),
('tax_foreign', ''),
('digitalproduct_download_limit', ''),
('shipping_require_usps', 'Y'),
('shipping_require_fedex', 'Y'),
('shipping_require_canada', 'Y'),
('shipping_require_australia', 'N'),
('USPS_Username', ''),
('fedexaccno', ''),
('fedexmeterno', ''),
('canadamerchantid', ''),
('enable_twitter', 'N'),
('worldpay_inst_Id', ''),
('worldpay_email', ''),
('worldpay_transact_method', ''),
('google_merchantId', ''),
('google_merchantkey', ''),
('google_testmode', ''),
('yourpay_testmod', ''),
('yourpay_storeid', ''),
('yourpay_certificate_file', ''),
('allow_rating', 'Y'),
('allow_product_feedback', 'Y'),
('flat_shipping_first', ''),
('flat_shipping_additional', ''),
('tax_option', ''),
('fixedtax_name', ''),
('fixedtax_rate', ''),
('taxable_address', ''),
('taxto', ''),
('product_images', ''),
('flat_ship_name', ''),
('secflat_shipping_first', ''),
('secflat_shipping_additional', ''),
('secflat_ship_name', ''),
('thirdflat_shipping_first', ''),
('thirdflat_shipping_additional', ''),
('thirdflat_ship_name', ''),
('forthflat_shipping_first', ''),
('forthflat_shipping_additional', ''),
('forthflat_ship_name', ''),
('fflat_shipping_require', 'Y'),
('sflat_shipping_require', 'Y'),
('tflat_shipping_require', 'Y'),
('foflat_shipping_require', 'Y'),
('allow_giftcoupon', 'Y'),
('allow_fax', 'N'),
('fax_email', ''),
('fax_number', ''),
('guestnumber', ''),
('offline_creditpay', 'N'),
('allow_rma', 'Y'),
('allow_giftcard', 'Y'),
('offline_creditpay', 'N'),
('allow_rma', 'Y'),
('fedexshipaccno', ''),
('fedexbillaccno', ''),
('fedexdutyaccno', ''),
('fedexkey', ''),
('fedexpaswd', ''),
('items_perpage', ''),
('allow_fedexlabel', 'Y'),
('shipping_origin_state', ''),
('bp_account', ''),
('bp_secret', ''),
('bp_testmode', 'Y'),
(' vLicenceKey', ''),
('vLicenceKey', ''),
('enable_googleanalytics', 'Y'),
('googleanalytic_id', ''),
('admin_blog_settings', 'Y'),
('enable_paypal_express', 'Y'),
('paypal_express_password', ''),
('twocheckout_testmode', 'Y'),
('twoco_vendorId', ''),
('paypal_express_username', ''),
('paypal_express_signature', ''),
('moneybookers_emailId', ''),
('paypalpro_username', ''),
('paypal_express_testmode', 'Y'),
('paypalpro_password', ''),
('paypalpro_signature', ''),
('paypalpro_testmode', 'Y'),
('pay_paypalpro', ''),
('paypalflow_partnerid', ''),
('paypalflow_vendorid', ''),
('paypalflow_password', ''),
('paypalflow_testmode', 'Y'),
('paypallink_partnerid', ''),
('paypallink_vendorid', ''),
('paypallink_testmode', 'Y'),
('user_credit', ''),
('worldpay_merchantcode', ''),
('worldpay_password', ''),
('worldpay_testmode', ''),
('enable_facebook', 'N'),
('facebook_url', ''),
('twitter_url', ''),
('ogone_PSPID', ''),
('ogone_passphrase', ''),
('ogone_testmode', 'Y'),
('shipping_origin_phone', ''),
('shipping_origin_street', ''),
('shipping_origin_city', ''),
('streamsendLoginID', ''),
('streamsendKey', ''),
('streamsendListID', ''),
('streamsendEnable', 'Y'),
('paypal_advancedPWD', ''),
('paypal_advancedUSER', ''),
('paypal_advancedVENDOR', ''),
('paypal_advancedPARTNER', ''),
('paypal_advancedtestmode', 'Y'),
('allow_uspslabel', 'N'),
('braintree_merchantId', ''),
('braintree_publicKey', ''),
('braintree_privateKey', ''),
('braintree_testmode', 'Y');

INSERT INTO `goStores_Vista_settings` VALUES ('paypal_bn_code', '');

INSERT INTO `goStores_Vista_settings` VALUES ('paypaladvanced_bn_code', '');

INSERT INTO `goStores_Vista_settings` VALUES ('paypalpro_bn_code', '');


INSERT INTO `goStores_Vista_statecodes` (`id`, `code`, `name`, `country_id`) VALUES
(1, 'AK', 'Alaska', '223'),
(2, 'AL', 'Alabama', '223'),
(3, 'AR', 'Arkansas', '223'),
(4, 'AS', 'American Samoa', '223'),
(5, 'AZ', 'Arizona', '223'),
(6, 'CA', 'California', '223'),
(7, 'CO', 'Colorado', '223'),
(8, 'CT', 'Connecticut', '223'),
(9, 'DC', 'D.C.', '223'),
(10, 'DE', 'Delaware', '223'),
(11, 'FL', 'Florida', '223'),
(12, 'FM', 'Micronesia', '223'),
(13, 'GA', 'Georgia', '223'),
(14, 'GU', 'Guam', '223'),
(15, 'HI', 'Hawaii', '223'),
(16, 'IA', 'Iowa', '223'),
(17, 'ID', 'Idaho', '223'),
(18, 'IL', 'Illinois', '223'),
(19, 'IN', 'Indiana', '223'),
(20, 'KS', 'Kansas', '223'),
(21, 'KY', 'Kentucky', '223'),
(22, 'LA', 'Louisiana', '223'),
(23, 'MA', 'Massachusetts', '223'),
(24, 'MD', 'Maryland', '223'),
(25, 'ME', 'Maine', '223'),
(26, 'MH', 'Marshall Islands', '223'),
(27, 'MI', 'Michigan', '223'),
(28, 'MN', 'Minnesota', '223'),
(29, 'MO', 'Missouri', '223'),
(30, 'MP', 'Marianas', '223'),
(31, 'MS', 'Mississippi', '223'),
(32, 'MT', 'Montana', '223'),
(33, 'NC', 'North Carolina', '223'),
(34, 'ND', 'North Dakota', '223'),
(35, 'NE', 'Nebraska', '223'),
(36, 'NH', 'New Hampshire', '223'),
(37, 'NJ', 'New Jersey', '223'),
(38, 'NM', 'New Mexico', '223'),
(39, 'NV', 'Nevada', '223'),
(40, 'NY', 'New York', '223'),
(41, 'OH', 'Ohio', '223'),
(42, 'OK', 'Oklahoma', '223'),
(43, 'OR', 'Oregon', '223'),
(44, 'PA', 'Pennsylvania', '223'),
(45, 'PR', 'Puerto Rico', '223'),
(46, 'PW', 'Palau', '223'),
(47, 'RI', 'Rhode Island', '223'),
(48, 'SC', 'South Carolina', '223'),
(49, 'SD', 'South Dakota', '223'),
(50, 'TN', 'Tennessee', '223'),
(51, 'TX', 'Texas', '223'),
(52, 'UT', 'Utah', '223'),
(53, 'VA', 'Virginia', '223'),
(54, 'VI', 'Virgin Islands', '223'),
(55, 'VT', 'Vermont', '223'),
(56, 'WA', 'Washington', '223'),
(57, 'WI', 'Wisconsin', '223'),
(58, 'WV', 'West Virginia', '223'),
(59, 'WY', 'Wyoming', '223'),
(60, 'AA', 'Military Americas', '223'),
(61, 'AE', 'Military Europe)ME)Canada', '223'),
(62, 'AP', 'Military Pacific', '223');



INSERT INTO `goStores_Vista_states` (`id`, `code`, `name`, `country_id`, `tax_rate`, `tax_name`) VALUES
(1, 'AK', 'Alaska', 'US', 2.00, 'Test tax'),
(2, 'AL', 'Alabama', 'US', 2.00, 'Test tax'),
(3, 'AR', 'Arkansas', 'US', 2.00, 'Test tax'),
(4, 'AS', 'American Samoa', 'US', 2.00, 'Test tax'),
(5, 'AZ', 'Arizona', 'US', 2.00, 'Test tax'),
(6, 'CA', 'California', 'US', 2.00, 'Test tax'),
(7, 'CO', 'Colorado', 'US', 2.00, 'Test tax'),
(8, 'CT', 'Connecticut', 'US', 2.00, 'Test tax'),
(9, 'DC', 'D.C.', 'US', 2.00, 'Test tax'),
(10, 'DE', 'Delaware', 'US', 2.00, 'Test tax'),
(11, 'FL', 'Florida', 'US', 2.00, 'Test tax'),
(12, 'FM', 'Micronesia', 'US', 2.00, 'Test tax'),
(13, 'GA', 'Georgia', 'US', 2.00, 'Test tax'),
(14, 'GU', 'Guam', 'US', 2.00, 'Test tax'),
(15, 'HI', 'Hawaii', 'US', 2.00, 'Test tax'),
(16, 'IA', 'Iowa', 'US', 2.00, 'Test tax'),
(17, 'ID', 'Idaho', 'US', 2.00, 'Test tax'),
(18, 'IL', 'Illinois', 'US', 2.00, 'Test tax'),
(19, 'IN', 'Indiana', 'US', 2.00, 'Test tax'),
(20, 'KS', 'Kansas', 'US', 2.00, 'Test tax'),
(21, 'KY', 'Kentucky', 'US', 2.00, 'Test tax'),
(22, 'LA', 'Louisiana', 'US', 2.00, 'Test tax'),
(23, 'MA', 'Massachetts', 'US', 2.00, 'Test tax'),
(24, 'MD', 'Maryland', 'US', 2.00, 'Test tax'),
(25, 'ME', 'Maine', 'US', 2.00, 'Test tax'),
(26, 'MH', 'Marshall Islands', 'US', 2.00, 'Test tax'),
(27, 'MI', 'Michigan', 'US', 2.00, 'Test tax'),
(28, 'MN', 'Minnesota', 'US', 2.00, 'Test tax'),
(29, 'MO', 'Missouri', 'US', 2.00, 'Test tax'),
(30, 'MP', 'Marianas', 'US', 2.00, 'Test tax'),
(31, 'MS', 'Mississippi', 'US', 2.00, 'Test tax'),
(32, 'MT', 'Montana', 'US', 2.00, 'Test tax'),
(33, 'NC', 'North Carolina', 'US', 2.00, 'Test tax'),
(34, 'ND', 'North Dakota', 'US', 2.00, 'Test tax'),
(35, 'NE', 'Nebraska', 'US', 2.00, 'Test tax'),
(36, 'NH', 'New Hampshire', 'US', 2.00, 'Test tax'),
(37, 'NJ', 'New Jersey', 'US', 2.00, 'Test tax'),
(38, 'NM', 'New Mexico', 'US', 2.00, 'Test tax'),
(39, 'NV', 'Nevada', 'US', 2.00, 'Test tax'),
(40, 'NY', 'New York', 'US', 2.00, 'Test tax'),
(41, 'OH', 'Ohio', 'US', 2.00, 'Test tax'),
(42, 'OK', 'Oklahoma', 'US', 2.00, 'Test tax'),
(43, 'OR', 'Oregon', 'US', 2.00, 'Test tax'),
(44, 'PA', 'Pennsylvania', 'US', 2.00, 'Test tax'),
(45, 'PR', 'Puerto Rico', 'US', 2.00, 'Test tax'),
(46, 'PW', 'Palau', 'US', 2.00, 'Test tax'),
(47, 'RI', 'Rhode Island', 'US', 2.00, 'Test tax'),
(48, 'SC', 'South Carolina', 'US', 2.00, 'Test tax'),
(49, 'SD', 'South Dakota', 'US', 2.00, 'Test tax'),
(50, 'TN', 'Tennessee', 'US', 2.00, 'Test tax'),
(51, 'TX', 'Texas', 'US', 2.00, 'Test tax'),
(52, 'UT', 'Utah', 'US', 2.00, 'Test tax'),
(53, 'VA', 'Virginia', 'US', 2.00, 'Test tax'),
(54, 'VI', 'Virgin Islands', 'US', 2.00, 'Test tax'),
(55, 'VT', 'Vermont', 'US', 2.00, 'Test tax'),
(56, 'WA', 'Washington', 'US', 2.00, 'Test tax'),
(57, 'WI', 'Wisconsin', 'US', 2.00, 'Test tax'),
(58, 'WV', 'West Virginia', 'US', 2.00, 'Test tax'),
(59, 'WY', 'Wyoming', 'US', 2.00, 'Test tax'),
(60, 'AA', 'Military Americas', 'US', 2.00, 'Test tax'),
(61, 'AE', 'Military Europe)ME)Canada', 'US', 2.00, 'Test tax'),
(62, 'AP', 'Military Pacific', 'US', 2.00, 'Test tax');



INSERT INTO `goStores_Vista_users` (`id`, `uname`, `password`, `email`, `reg_date`, `usertype`, `reg_status`, `user_credit`) VALUES
(1, 'user', '1a1dc91c907325c69271ddf0c944bc72', 'jamessmith121212@gmail.com', '0000-00-00 00:00:00', 'R', '', 0);

INSERT INTO `goStores_Vista_wp_comments` (`comment_ID`, `comment_post_ID`, `comment_author`, `comment_author_email`, `comment_author_url`, `comment_author_IP`, `comment_date`, `comment_date_gmt`, `comment_content`, `comment_karma`, `comment_approved`, `comment_agent`, `comment_type`, `comment_parent`, `user_id`) VALUES
(1, 1, 'Mr WordPress', '', 'http://wordpress.org/', '', '2014-02-24 11:55:05', '2014-02-24 11:55:05', 'Hi, this is a comment.\nTo delete a comment, just log in and view the post&#039;s comments. There you will have the option to edit or delete them.', 0, '1', '', '', 0, 0);


INSERT INTO `goStores_Vista_wp_options` (`option_id`, `option_name`, `option_value`, `autoload`) VALUES
(1, 'siteurl', 'http://localhost/vistacart/app/webroot/blog', 'yes'),
(2, 'blogname', 'Store Blog', 'yes'),
(3, 'blogdescription', 'Just another WordPress site', 'yes'),
(4, 'users_can_register', '0', 'yes'),
(5, 'admin_email', 'jamessmith121212@gmail.com', 'yes'),
(6, 'start_of_week', '1', 'yes'),
(7, 'use_balanceTags', '0', 'yes'),
(8, 'use_smilies', '1', 'yes'),
(9, 'require_name_email', '1', 'yes'),
(10, 'comments_notify', '1', 'yes'),
(11, 'posts_per_rss', '10', 'yes'),
(12, 'rss_use_excerpt', '0', 'yes'),
(13, 'mailserver_url', 'mail.example.com', 'yes'),
(14, 'mailserver_login', 'login@example.com', 'yes'),
(15, 'mailserver_pass', 'password', 'yes'),
(16, 'mailserver_port', '110', 'yes'),
(17, 'default_category', '1', 'yes'),
(18, 'default_comment_status', 'open', 'yes'),
(19, 'default_ping_status', 'open', 'yes'),
(20, 'default_pingback_flag', '1', 'yes'),
(21, 'posts_per_page', '10', 'yes'),
(22, 'date_format', 'F j, Y', 'yes'),
(23, 'time_format', 'g:i a', 'yes'),
(24, 'links_updated_date_format', 'F j, Y g:i a', 'yes'),
(25, 'links_recently_updated_prepend', '<em>', 'yes'),
(26, 'links_recently_updated_append', '</em>', 'yes'),
(27, 'links_recently_updated_time', '120', 'yes'),
(28, 'comment_moderation', '0', 'yes'),
(29, 'moderation_notify', '1', 'yes'),
(30, 'permalink_structure', '', 'yes'),
(31, 'gzipcompression', '0', 'yes'),
(32, 'hack_file', '0', 'yes'),
(33, 'blog_charset', 'UTF-8', 'yes'),
(34, 'moderation_keys', '', 'no'),
(35, 'active_plugins', 'a:1:{i:0;s:37:"custom-admin-bar/custom-admin-bar.php";}', 'yes'),
(36, 'home', 'http://localhost/vistacart/app/webroot/blog', 'yes'),
(37, 'category_base', '', 'yes'),
(38, 'ping_sites', 'http://rpc.pingomatic.com/', 'yes'),
(39, 'advanced_edit', '0', 'yes'),
(40, 'comment_max_links', '2', 'yes'),
(41, 'gmt_offset', '0', 'yes'),
(42, 'default_email_category', '1', 'yes'),
(43, 'recently_edited', 'a:3:{i:0;s:104:"/var/www/html/testing/vistacart/crimea/vistacart/app/webroot/blog/wp-content/plugins/akismet/akismet.php";i:1;s:136:"/var/www/html/testing/vistacart/crimea/vistacart/app/webroot/blog/wp-content/plugins/wp-gallery-custom-links/wp-gallery-custom-links.php";i:2;s:0:"";}', 'no'),
(44, 'template', 'twentyfourteen', 'yes'),
(45, 'stylesheet', 'twentyfourteen', 'yes'),
(46, 'comment_whitelist', '1', 'yes'),
(47, 'blacklist_keys', '', 'no'),
(48, 'comment_registration', '0', 'yes'),
(49, 'html_type', 'text/html', 'yes'),
(50, 'use_trackback', '0', 'yes'),
(51, 'default_role', 'subscriber', 'yes'),
(52, 'db_version', '26691', 'yes'),
(53, 'uploads_use_yearmonth_folders', '1', 'yes'),
(54, 'upload_path', '', 'yes'),
(55, 'blog_public', '1', 'yes'),
(56, 'default_link_category', '2', 'yes'),
(57, 'show_on_front', 'posts', 'yes'),
(58, 'tag_base', '', 'yes'),
(59, 'show_avatars', '1', 'yes'),
(60, 'avatar_rating', 'G', 'yes'),
(61, 'upload_url_path', '', 'yes'),
(62, 'thumbnail_size_w', '150', 'yes'),
(63, 'thumbnail_size_h', '150', 'yes'),
(64, 'thumbnail_crop', '1', 'yes'),
(65, 'medium_size_w', '300', 'yes'),
(66, 'medium_size_h', '300', 'yes'),
(67, 'avatar_default', 'mystery', 'yes'),
(68, 'large_size_w', '1024', 'yes'),
(69, 'large_size_h', '1024', 'yes'),
(70, 'image_default_link_type', 'file', 'yes'),
(71, 'image_default_size', '', 'yes'),
(72, 'image_default_align', '', 'yes'),
(73, 'close_comments_for_old_posts', '0', 'yes'),
(74, 'close_comments_days_old', '14', 'yes'),
(75, 'thread_comments', '1', 'yes'),
(76, 'thread_comments_depth', '5', 'yes'),
(77, 'page_comments', '0', 'yes'),
(78, 'comments_per_page', '50', 'yes'),
(79, 'default_comments_page', 'newest', 'yes'),
(80, 'comment_order', 'asc', 'yes'),
(81, 'sticky_posts', 'a:0:{}', 'yes'),
(82, 'widget_categories', 'a:2:{i:2;a:4:{s:5:"title";s:0:"";s:5:"count";i:0;s:12:"hierarchical";i:0;s:8:"dropdown";i:0;}s:12:"_multiwidget";i:1;}', 'yes'),
(83, 'widget_text', 'a:0:{}', 'yes'),
(84, 'widget_rss', 'a:0:{}', 'yes'),
(85, 'uninstall_plugins', 'a:0:{}', 'no'),
(86, 'timezone_string', '', 'yes'),
(87, 'page_for_posts', '0', 'yes'),
(88, 'page_on_front', '0', 'yes'),
(89, 'default_post_format', '0', 'yes'),
(90, 'link_manager_enabled', '0', 'yes'),
(91, 'initial_db_version', '26691', 'yes'),
(92, 'Vista_wp_user_roles', 'a:5:{s:13:"administrator";a:2:{s:4:"name";s:13:"Administrator";s:12:"capabilities";a:62:{s:13:"switch_themes";b:1;s:11:"edit_themes";b:1;s:16:"activate_plugins";b:1;s:12:"edit_plugins";b:1;s:10:"edit_users";b:1;s:10:"edit_files";b:1;s:14:"manage_options";b:1;s:17:"moderate_comments";b:1;s:17:"manage_categories";b:1;s:12:"manage_links";b:1;s:12:"upload_files";b:1;s:6:"import";b:1;s:15:"unfiltered_html";b:1;s:10:"edit_posts";b:1;s:17:"edit_others_posts";b:1;s:20:"edit_published_posts";b:1;s:13:"publish_posts";b:1;s:10:"edit_pages";b:1;s:4:"read";b:1;s:8:"level_10";b:1;s:7:"level_9";b:1;s:7:"level_8";b:1;s:7:"level_7";b:1;s:7:"level_6";b:1;s:7:"level_5";b:1;s:7:"level_4";b:1;s:7:"level_3";b:1;s:7:"level_2";b:1;s:7:"level_1";b:1;s:7:"level_0";b:1;s:17:"edit_others_pages";b:1;s:20:"edit_published_pages";b:1;s:13:"publish_pages";b:1;s:12:"delete_pages";b:1;s:19:"delete_others_pages";b:1;s:22:"delete_published_pages";b:1;s:12:"delete_posts";b:1;s:19:"delete_others_posts";b:1;s:22:"delete_published_posts";b:1;s:20:"delete_private_posts";b:1;s:18:"edit_private_posts";b:1;s:18:"read_private_posts";b:1;s:20:"delete_private_pages";b:1;s:18:"edit_private_pages";b:1;s:18:"read_private_pages";b:1;s:12:"delete_users";b:1;s:12:"create_users";b:1;s:17:"unfiltered_upload";b:1;s:14:"edit_dashboard";b:1;s:14:"update_plugins";b:1;s:14:"delete_plugins";b:1;s:15:"install_plugins";b:1;s:13:"update_themes";b:1;s:14:"install_themes";b:1;s:11:"update_core";b:1;s:10:"list_users";b:1;s:12:"remove_users";b:1;s:9:"add_users";b:1;s:13:"promote_users";b:1;s:18:"edit_theme_options";b:1;s:13:"delete_themes";b:1;s:6:"export";b:1;}}s:6:"editor";a:2:{s:4:"name";s:6:"Editor";s:12:"capabilities";a:34:{s:17:"moderate_comments";b:1;s:17:"manage_categories";b:1;s:12:"manage_links";b:1;s:12:"upload_files";b:1;s:15:"unfiltered_html";b:1;s:10:"edit_posts";b:1;s:17:"edit_others_posts";b:1;s:20:"edit_published_posts";b:1;s:13:"publish_posts";b:1;s:10:"edit_pages";b:1;s:4:"read";b:1;s:7:"level_7";b:1;s:7:"level_6";b:1;s:7:"level_5";b:1;s:7:"level_4";b:1;s:7:"level_3";b:1;s:7:"level_2";b:1;s:7:"level_1";b:1;s:7:"level_0";b:1;s:17:"edit_others_pages";b:1;s:20:"edit_published_pages";b:1;s:13:"publish_pages";b:1;s:12:"delete_pages";b:1;s:19:"delete_others_pages";b:1;s:22:"delete_published_pages";b:1;s:12:"delete_posts";b:1;s:19:"delete_others_posts";b:1;s:22:"delete_published_posts";b:1;s:20:"delete_private_posts";b:1;s:18:"edit_private_posts";b:1;s:18:"read_private_posts";b:1;s:20:"delete_private_pages";b:1;s:18:"edit_private_pages";b:1;s:18:"read_private_pages";b:1;}}s:6:"author";a:2:{s:4:"name";s:6:"Author";s:12:"capabilities";a:10:{s:12:"upload_files";b:1;s:10:"edit_posts";b:1;s:20:"edit_published_posts";b:1;s:13:"publish_posts";b:1;s:4:"read";b:1;s:7:"level_2";b:1;s:7:"level_1";b:1;s:7:"level_0";b:1;s:12:"delete_posts";b:1;s:22:"delete_published_posts";b:1;}}s:11:"contributor";a:2:{s:4:"name";s:11:"Contributor";s:12:"capabilities";a:5:{s:10:"edit_posts";b:1;s:4:"read";b:1;s:7:"level_1";b:1;s:7:"level_0";b:1;s:12:"delete_posts";b:1;}}s:10:"subscriber";a:2:{s:4:"name";s:10:"Subscriber";s:12:"capabilities";a:2:{s:4:"read";b:1;s:7:"level_0";b:1;}}}', 'yes'),
(93, 'widget_search', 'a:2:{i:2;a:1:{s:5:"title";s:0:"";}s:12:"_multiwidget";i:1;}', 'yes'),
(94, 'widget_recent-posts', 'a:2:{i:2;a:2:{s:5:"title";s:0:"";s:6:"number";i:5;}s:12:"_multiwidget";i:1;}', 'yes'),
(95, 'widget_recent-comments', 'a:2:{i:2;a:2:{s:5:"title";s:0:"";s:6:"number";i:5;}s:12:"_multiwidget";i:1;}', 'yes'),
(96, 'widget_archives', 'a:2:{i:2;a:3:{s:5:"title";s:0:"";s:5:"count";i:0;s:8:"dropdown";i:0;}s:12:"_multiwidget";i:1;}', 'yes'),
(97, 'widget_meta', 'a:2:{i:2;a:1:{s:5:"title";s:0:"";}s:12:"_multiwidget";i:1;}', 'yes'),
(98, 'sidebars_widgets', 'a:5:{s:19:"wp_inactive_widgets";a:0:{}s:9:"sidebar-1";a:6:{i:0;s:8:"search-2";i:1;s:14:"recent-posts-2";i:2;s:17:"recent-comments-2";i:3;s:10:"archives-2";i:4;s:12:"categories-2";i:5;s:6:"meta-2";}s:9:"sidebar-2";a:0:{}s:9:"sidebar-3";a:0:{}s:13:"array_version";i:3;}', 'yes'),
(99, '_transient_random_seed', 'ced8f2bdcefa983fc671007bb958b0e3', 'yes'),
(100, 'logged_in_key', '32meQ,c>X(By4`$i%/,`FYBty8GCZ~*V8UE4r~gT6b)Iv4*7R,hYg!2GqL4_z*)x', 'yes'),
(101, 'logged_in_salt', 'w0?]v]%,vi(UE|TfHo C[su9mk I6h;[/C0?eu5yZfS<K6NZO08%5TWBXskFbLiM', 'yes'),
(102, 'cron', 'a:5:{i:1393314240;a:1:{s:20:"wp_maybe_auto_update";a:1:{s:32:"40cd750bba9870f18aada2478b24840a";a:3:{s:8:"schedule";s:10:"twicedaily";s:4:"args";a:0:{}s:8:"interval";i:43200;}}}i:1393329308;a:3:{s:16:"wp_version_check";a:1:{s:32:"40cd750bba9870f18aada2478b24840a";a:3:{s:8:"schedule";s:10:"twicedaily";s:4:"args";a:0:{}s:8:"interval";i:43200;}}s:17:"wp_update_plugins";a:1:{s:32:"40cd750bba9870f18aada2478b24840a";a:3:{s:8:"schedule";s:10:"twicedaily";s:4:"args";a:0:{}s:8:"interval";i:43200;}}s:16:"wp_update_themes";a:1:{s:32:"40cd750bba9870f18aada2478b24840a";a:3:{s:8:"schedule";s:10:"twicedaily";s:4:"args";a:0:{}s:8:"interval";i:43200;}}}i:1393330064;a:1:{s:19:"wp_scheduled_delete";a:1:{s:32:"40cd750bba9870f18aada2478b24840a";a:3:{s:8:"schedule";s:5:"daily";s:4:"args";a:0:{}s:8:"interval";i:86400;}}}i:1393331001;a:1:{s:30:"wp_scheduled_auto_draft_delete";a:1:{s:32:"40cd750bba9870f18aada2478b24840a";a:3:{s:8:"schedule";s:5:"daily";s:4:"args";a:0:{}s:8:"interval";i:86400;}}}s:7:"version";i:2;}', 'yes'),
(113, '_site_transient_timeout_browser_8bac2e9dd23af317afb2d66d17b2dcfb', '1393847718', 'yes'),
(104, '_site_transient_update_core', 'O:8:"stdClass":4:{s:7:"updates";a:1:{i:0;O:8:"stdClass":10:{s:8:"response";s:6:"latest";s:8:"download";s:41:"https://wordpress.org/wordpress-3.8.1.zip";s:6:"locale";s:5:"en_US";s:8:"packages";O:8:"stdClass":5:{s:4:"full";s:41:"https://wordpress.org/wordpress-3.8.1.zip";s:10:"no_content";s:52:"https://wordpress.org/wordpress-3.8.1-no-content.zip";s:11:"new_bundled";s:53:"https://wordpress.org/wordpress-3.8.1-new-bundled.zip";s:7:"partial";b:0;s:8:"rollback";b:0;}s:7:"current";s:5:"3.8.1";s:7:"version";s:5:"3.8.1";s:11:"php_version";s:5:"5.2.4";s:13:"mysql_version";s:3:"5.0";s:11:"new_bundled";s:3:"3.8";s:15:"partial_version";s:0:"";}}s:12:"last_checked";i:1393300735;s:15:"version_checked";s:5:"3.8.1";s:12:"translations";a:0:{}}', 'yes'),
(105, 'auth_key', 'EHE`7vW9C-Ln1)XDVG+-| g2!1#yl?$K()O42O{$s6ER~L_+vITUK6r*#Lq:v<W/', 'yes'),
(106, 'auth_salt', '7I,<u0r#)B<YtD/~(aue`7K|-jK,5g7EP,uM{cm?jTo5]]tWuD )9rVYdakPF@WS', 'yes'),
(143, '_site_transient_timeout_theme_roots', '1393302533', 'yes'),
(107, 'nonce_key', 'STPP|nJq0)UJ,Yv}~~2 ~V+KE7y tOT4ol_dg?RVsvID5S}!,3L7a&_cy[5VkCmR', 'yes'),
(108, 'nonce_salt', 'y2u%|GXU9vvY#FY%@9G>J=b3K{FD-6OYVI|_H16G9WQ8nbOt0}.U=q6%S=T~i<sO', 'yes'),
(109, '_site_transient_update_plugins', 'O:8:"stdClass":4:{s:12:"last_checked";i:1393301189;s:7:"checked";a:3:{s:19:"akismet/akismet.php";s:5:"2.5.9";s:37:"custom-admin-bar/custom-admin-bar.php";s:3:"1.3";s:9:"hello.php";s:3:"1.6";}s:8:"response";a:0:{}s:12:"translations";a:0:{}}', 'yes'),
(144, '_site_transient_theme_roots', 'a:3:{s:14:"twentyfourteen";s:7:"/themes";s:14:"twentythirteen";s:7:"/themes";s:12:"twentytwelve";s:7:"/themes";}', 'yes'),
(112, '_site_transient_update_themes', 'O:8:"stdClass":4:{s:12:"last_checked";i:1393300734;s:7:"checked";a:3:{s:14:"twentyfourteen";s:3:"1.0";s:14:"twentythirteen";s:3:"1.1";s:12:"twentytwelve";s:3:"1.3";}s:8:"response";a:0:{}s:12:"translations";a:0:{}}', 'yes'),
(114, '_site_transient_browser_8bac2e9dd23af317afb2d66d17b2dcfb', 'a:9:{s:8:"platform";s:7:"Windows";s:4:"name";s:7:"Firefox";s:7:"version";s:4:"27.0";s:10:"update_url";s:23:"http://www.firefox.com/";s:7:"img_src";s:50:"http://s.wordpress.org/images/browsers/firefox.png";s:11:"img_src_ssl";s:49:"https://wordpress.org/images/browsers/firefox.png";s:15:"current_version";s:2:"16";s:7:"upgrade";b:0;s:8:"insecure";b:0;}', 'yes'),
(115, 'can_compress_scripts', '1', 'yes'),
(147, '_transient_timeout_feed_mod_ac0b00fe65abe10e0c5b588f3ed8c7ca', '1393344307', 'no'),
(148, '_transient_feed_mod_ac0b00fe65abe10e0c5b588f3ed8c7ca', '1393301107', 'no'),
(145, '_transient_timeout_feed_ac0b00fe65abe10e0c5b588f3ed8c7ca', '1393344307', 'no');
INSERT INTO `goStores_Vista_wp_options` (`option_id`, `option_name`, `option_value`, `autoload`) VALUES
(146, '_transient_feed_ac0b00fe65abe10e0c5b588f3ed8c7ca', 'a:4:{s:5:"child";a:1:{s:0:"";a:1:{s:3:"rss";a:1:{i:0;a:6:{s:4:"data";s:3:"\n\n\n";s:7:"attribs";a:1:{s:0:"";a:1:{s:7:"version";s:3:"2.0";}}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:1:{s:0:"";a:1:{s:7:"channel";a:1:{i:0;a:6:{s:4:"data";s:51:"\n	\n	\n	\n	\n	\n	\n		\n		\n	\n	\n		\n		\n		\n		\n		\n		\n		\n		\n		\n	";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:3:{s:0:"";a:7:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:14:"WordPress News";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:25:"http://wordpress.org/news";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:14:"WordPress News";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:13:"lastBuildDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Thu, 23 Jan 2014 20:54:06 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:8:"language";a:1:{i:0;a:5:{s:4:"data";s:5:"en-US";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:9:"generator";a:1:{i:0;a:5:{s:4:"data";s:39:"http://wordpress.org/?v=3.9-alpha-27234";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"item";a:10:{i:0;a:6:{s:4:"data";s:42:"\n		\n		\n		\n		\n		\n				\n\n		\n		\n				\n			\n		\n		";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:5:{s:0:"";a:7:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:35:"WordPress 3.8.1 Maintenance Release";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:50:"http://wordpress.org/news/2014/01/wordpress-3-8-1/";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:8:"comments";a:1:{i:0;a:5:{s:4:"data";s:59:"http://wordpress.org/news/2014/01/wordpress-3-8-1/#comments";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Thu, 23 Jan 2014 20:37:49 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:8:"category";a:1:{i:0;a:5:{s:4:"data";s:8:"Releases";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:33:"http://wordpress.org/news/?p=3063";s:7:"attribs";a:1:{s:0:"";a:1:{s:11:"isPermaLink";s:5:"false";}}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:358:"After six weeks and more than 9.3 million downloads of WordPress 3.8, we&#8217;re pleased to announce WordPress 3.8.1 is now available. Version 3.8.1 is a maintenance releases that addresses 31 bugs in 3.8, including various fixes and improvements for the new dashboard design and new themes admin screen. An issue with taxonomy queries in WP_Query [&#8230;]";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:12:"Andrew Nacin";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:40:"http://purl.org/rss/1.0/modules/content/";a:1:{s:7:"encoded";a:1:{i:0;a:5:{s:4:"data";s:3809:"<p>After six weeks and more than <a href="http://wordpress.org/download/counter/">9.3 million downloads</a> of WordPress 3.8, we&#8217;re pleased to announce WordPress 3.8.1 is now available.</p>\n<p>Version 3.8.1 is a maintenance releases that addresses 31 bugs in 3.8, including various fixes and improvements for the new dashboard design and new themes admin screen. An issue with taxonomy queries in WP_Query was resolved. And if you&#8217;ve been frustrated by submit buttons that won&#8217;t do anything when you click on them (or thought you were going crazy, like some of us), we&#8217;ve found and fixed this &#8220;dead zone&#8221; on submit buttons.</p>\n<p>It also contains a fix for <strong>embedding tweets</strong> (by placing the URL to the tweet on its own line), which was broken due to a recent Twitter API change. (For more on Embeds, see <a href="http://codex.wordpress.org/Embeds">the Codex</a>.)</p>\n<p>For a full list of changes, consult the <a href="http://core.trac.wordpress.org/query?milestone=3.8.1">list of tickets</a> and <a href="https://core.trac.wordpress.org/log/branches/3.8?rev=27018&amp;stop_rev=26862">the changelog</a>. There&#8217;s also a <a href="http://make.wordpress.org/core/2014/01/22/wordpress-3-8-1-release-candidate/">detailed summary</a> for developers on the development blog.</p>\n<p>If you are one of the millions already running WordPress 3.8, we will start rolling out automatic background updates for WordPress 3.8.1 in the next few hours. For sites <a href="http://wordpress.org/plugins/background-update-tester/">that support them</a>, of course.</p>\n<p><a href="http://wordpress.org/download/">Download WordPress 3.8.1</a> or venture over to <strong>Dashboard → Updates</strong> and simply click &#8220;Update Now.&#8221;</p>\n<p>Thanks to all of these fine individuals for contributing to 3.8.1:</p>\n<p><a href="http://profiles.wordpress.org/jorbin">Aaron Jorbin</a>, <a href="http://profiles.wordpress.org/collinsinternet">Allan Collins</a>, <a href="http://profiles.wordpress.org/nacin">Andrew Nacin</a>, <a href="http://profiles.wordpress.org/azaozz">Andrew Ozz</a>, <a href="http://profiles.wordpress.org/aubreypwd">Aubrey Portwood</a>, <a href="http://profiles.wordpress.org/empireoflight">Ben Dunkle</a>, <a href="http://profiles.wordpress.org/cojennin">Connor Jennings</a>, <a href="http://profiles.wordpress.org/dd32">Dion Hulse</a>, <a href="http://profiles.wordpress.org/ocean90">Dominik Schilling</a>, <a href="http://profiles.wordpress.org/fboender">fboender</a>, <a href="http://profiles.wordpress.org/avryl">Janneke Van Dorpe</a>, <a href="http://profiles.wordpress.org/janrenn">janrenn</a>, <a href="http://profiles.wordpress.org/joedolson">Joe Dolson</a>, <a href="http://profiles.wordpress.org/johnbillion">John Blackbourn</a>, <a href="#">José Pino</a>, <a href="http://profiles.wordpress.org/kovshenin">Konstantin Kovshenin</a>, <a href="http://profiles.wordpress.org/matveb">Matias Ventura</a>, <a href="http://profiles.wordpress.org/mattheu">Matthew Haines-Young</a>, <a href="http://profiles.wordpress.org/iammattthomas">Matt Thomas</a>, <a href="http://profiles.wordpress.org/melchoyce">Mel Choyce</a>, <a href="http://profiles.wordpress.org/batmoo">Mohammad Jangda</a>, <a href="http://profiles.wordpress.org/morganestes">Morgan Estes</a>, <a href="http://profiles.wordpress.org/nivijah">nivijah</a>, <a href="http://profiles.wordpress.org/wonderboymusic">Scott Taylor</a>, <a href="http://profiles.wordpress.org/sergeybiryukov">Sergey Biryukov</a>, <a href="http://profiles.wordpress.org/undergroundnetwork">undergroundnetwork</a>, and <a href="http://profiles.wordpress.org/yurivictor">Yuri Victor</a>.</p>\n<p><em>WordPress three eight one<br />\nWe heard you didn&#8217;t like bugs<br />\nSo we took them out</em></p>\n";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:36:"http://wellformedweb.org/CommentAPI/";a:1:{s:10:"commentRss";a:1:{i:0;a:5:{s:4:"data";s:55:"http://wordpress.org/news/2014/01/wordpress-3-8-1/feed/";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:38:"http://purl.org/rss/1.0/modules/slash/";a:1:{s:8:"comments";a:1:{i:0;a:5:{s:4:"data";s:1:"0";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:1;a:6:{s:4:"data";s:42:"\n		\n		\n		\n		\n		\n				\n\n		\n		\n				\n			\n		\n		";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:5:{s:0:"";a:7:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:26:"WordPress 3.8 “Parker�?";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:41:"http://wordpress.org/news/2013/12/parker/";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:8:"comments";a:1:{i:0;a:5:{s:4:"data";s:50:"http://wordpress.org/news/2013/12/parker/#comments";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Thu, 12 Dec 2013 17:00:06 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:8:"category";a:1:{i:0;a:5:{s:4:"data";s:8:"Releases";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:33:"http://wordpress.org/news/?p=2765";s:7:"attribs";a:1:{s:0:"";a:1:{s:11:"isPermaLink";s:5:"false";}}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:354:"Version 3.8 of WordPress, named “Parker�? in honor of Charlie Parker, bebop innovator, is available for download or update in your WordPress dashboard. We hope you&#8217;ll think this is the most beautiful update yet. Introducing a modern new design WordPress has gotten a facelift. 3.8 brings a fresh new look to the entire admin dashboard. [&#8230;]";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:14:"Matt Mullenweg";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:40:"http://purl.org/rss/1.0/modules/content/";a:1:{s:7:"encoded";a:1:{i:0;a:5:{s:4:"data";s:18740:"<p>Version 3.8 of WordPress, named “Parker�? in honor of <a href="http://en.wikipedia.org/wiki/Charlie_Parker">Charlie Parker</a>, bebop innovator, is available <a href="http://wordpress.org/download/">for download</a> or update in your WordPress dashboard. We hope you&#8217;ll think this is the most beautiful update yet.</p>\n<div id="v-6wORgoGb-1" class="video-player"><embed id="v-6wORgoGb-1-video" src="http://s0.videopress.com/player.swf?v=1.03&amp;guid=6wORgoGb&amp;isDynamicSeeking=true" type="application/x-shockwave-flash" width="692" height="388" wmode="direct" seamlesstabbing="true" allowfullscreen="true" allowscriptaccess="always" overstretch="true"></embed></div>\n<h2 class="aligncenter">Introducing a modern new design</h2>\n<p><img class="wp-image-2951 aligncenter" alt="overview" src="http://i0.wp.com/wpdotorg.files.wordpress.com/2013/12/overview.jpg?resize=623%2C193" data-recalc-dims="1" /></p>\n<p>WordPress has gotten a facelift. 3.8 brings a fresh new look to the entire admin dashboard. Gone are overbearing gradients and dozens of shades of grey — bring on a bigger, bolder, more colorful design!</p>\n<p><img class="aligncenter  wp-image-2856" style="margin-left: 0;margin-right: 0" alt="about-modern-wordpress" src="http://i2.wp.com/wpdotorg.files.wordpress.com/2013/12/design.png?resize=623%2C151" data-recalc-dims="1" /></p>\n<h3>Modern aesthetic</h3>\n<p>The new WordPress dashboard has a fresh, uncluttered design that embraces clarity and simplicity.</p>\n<h3>Clean typography</h3>\n<p>The Open Sans typeface provides simple, friendly text that is optimized for both desktop and mobile viewing. It’s even open source, just like WordPress.</p>\n<h3>Refined contrast</h3>\n<p>We think beautiful design should never sacrifice legibility. With superior contrast and large, comfortable type, the new design is easy to read and a pleasure to navigate.</p>\n<hr />\n<h2 class="aligncenter">WordPress on every device</h2>\n<p><img class="alignright  wp-image-2984" alt="responsive" src="http://i2.wp.com/wpdotorg.files.wordpress.com/2013/12/responsive.jpg?resize=255%2C255" data-recalc-dims="1" />We all access the internet in different ways. Smartphone, tablet, notebook, desktop — no matter what you use, WordPress will adapt and you’ll feel right at home.</p>\n<h3>High definition at high speed</h3>\n<p>WordPress is sharper than ever with new vector-based icons that scale to your screen. By ditching pixels, pages load significantly faster, too.</p>\n<hr />\n<h2 class="aligncenter">Admin color schemes to match your personality</h2>\n<p><img class="aligncenter  wp-image-2954" alt="colors" src="http://i0.wp.com/wpdotorg.files.wordpress.com/2013/12/colors.jpg?resize=623%2C339" data-recalc-dims="1" /></p>\n<p>WordPress just got a colorful new update. We’ve included eight new admin color schemes so you can pick the one that suits you best.</p>\n<p>Color schemes can be previewed and changed from your Profile page.</p>\n<hr />\n<h2 class="aligncenter">Refined theme management</h2>\n<p><img class="alignright  wp-image-2967" alt="themes" src="http://i0.wp.com/wpdotorg.files.wordpress.com/2013/12/themes.jpg?resize=360%2C344" data-recalc-dims="1" />The new themes screen lets you survey your themes at a glance. Or want more information? Click to discover more. Then sit back and use your keyboard’s navigation arrows to flip through every theme you’ve got.</p>\n<h3>Smoother widget experience</h3>\n<p>Drag-drag-drag. Scroll-scroll-scroll. Widget management can be complicated. With the new design, we’ve worked to streamline the widgets screen.</p>\n<p>Have a large monitor? Multiple widget areas stack side-by-side to use the available space. Using a tablet? Just tap a widget to add it.</p>\n<hr />\n<h2 class="aligncenter">Twenty Fourteen, a sleek new magazine theme</h2>\n<p><img class="aligncenter size-large wp-image-2789" alt="The new Twenty Fourteen theme displayed on a laptop. tablet and phone" src="http://i0.wp.com/wpdotorg.files.wordpress.com/2013/12/twentyfourteen.jpg?resize=692%2C275" data-recalc-dims="1" /></p>\n<h3>Turn your blog into a magazine</h3>\n<p>Create a beautiful magazine-style site with WordPress and Twenty Fourteen. Choose a grid or a slider to display featured content on your homepage. Customize your site with three widget areas or change your layout with two page templates.</p>\n<p>With a striking design that does not compromise our trademark simplicity, Twenty Fourteen is our most intrepid default theme yet.</p>\n<hr />\n<h2>Beginning of a new era</h2>\n<p>This release was led by Matt Mullenweg. This is our second release using the new plugin-first development process, with a much shorter timeframe than in the past. We think it’s been going great. You can check out the features currently in production on the <a title="Make WordPress Core" href="http://make.wordpress.org/core/" target="_blank">make/core blog</a>.</p>\n<p>There are 188 contributors with props in this release:</p>\n<p><a href="http://profiles.wordpress.org/aaronholbrook">Aaron Holbrook</a>, <a href="http://profiles.wordpress.org/jorbin">Aaron Jorbin</a>, <a href="http://profiles.wordpress.org/adamsilverstein">adamsilverstein</a>, <a href="http://profiles.wordpress.org/admiralthrawn">admiralthrawn</a>, <a href="http://profiles.wordpress.org/ahoereth">Alexander Hoereth</a>, <a href="http://profiles.wordpress.org/collinsinternet">Allan Collins</a>, <a href="http://profiles.wordpress.org/sabreuse">Amy Hendrix (sabreuse)</a>, <a href="http://profiles.wordpress.org/nacin">Andrew Nacin</a>, <a href="http://profiles.wordpress.org/azaozz">Andrew Ozz</a>, <a href="http://profiles.wordpress.org/aralbald">Andrey Kabakchiev</a>, <a href="http://profiles.wordpress.org/apeatling">Andy Peatling</a>, <a href="http://profiles.wordpress.org/ankitgadertcampcom">Ankit Gade</a>, <a href="http://profiles.wordpress.org/atimmer">Anton Timmermans</a>, <a href="http://profiles.wordpress.org/fliespl">Arkadiusz Rzadkowolski</a>, <a href="http://profiles.wordpress.org/aubreypwd">Aubrey Portwood</a>, <a href="http://profiles.wordpress.org/bassgang">bassgang</a>, <a href="http://profiles.wordpress.org/empireoflight">Ben Dunkle</a>, <a href="http://profiles.wordpress.org/bananastalktome">Billy (bananastalktome)</a>, <a href="http://profiles.wordpress.org/binarymoon">binarymoon</a>, <a href="http://profiles.wordpress.org/bradyvercher">Brady Vercher</a>, <a href="http://profiles.wordpress.org/kraftbj">Brandon Kraft</a>, <a href="http://profiles.wordpress.org/rzen">Brian Richards</a>, <a href="http://profiles.wordpress.org/bpetty">Bryan Petty</a>, <a href="http://profiles.wordpress.org/calin">Calin Don</a>, <a href="http://profiles.wordpress.org/carldanley">Carl Danley</a>, <a href="http://profiles.wordpress.org/sixhours">Caroline Moore</a>, <a href="http://profiles.wordpress.org/caspie">Caspie</a>, <a href="http://profiles.wordpress.org/chrisbliss18">Chris Jean</a>, <a href="http://profiles.wordpress.org/iblamefish">Clinton Montague</a>, <a href="http://profiles.wordpress.org/cojennin">cojennin</a>, <a href="http://profiles.wordpress.org/corphi">Corphi</a>, <a href="http://profiles.wordpress.org/dbernar1">Dan Bernardic</a>, <a href="http://profiles.wordpress.org/danieldudzic">Daniel Dudzic</a>, <a href="http://profiles.wordpress.org/koop">Daryl Koopersmith</a>, <a href="http://profiles.wordpress.org/datafeedrcom">datafeedr</a>, <a href="http://profiles.wordpress.org/lessbloat">Dave Martin</a>, <a href="http://profiles.wordpress.org/drw158">Dave Whitley</a>, <a href="http://profiles.wordpress.org/dd32">Dion Hulse</a>, <a href="http://profiles.wordpress.org/ocean90">Dominik Schilling</a>, <a href="http://profiles.wordpress.org/dougwollison">Doug Wollison</a>, <a href="http://profiles.wordpress.org/drewapicture">Drew Jaynes</a>, <a href="http://profiles.wordpress.org/dziudek">dziudek</a>, <a href="http://profiles.wordpress.org/ericlewis">Eric Andrew Lewis</a>, <a href="http://profiles.wordpress.org/ericmann">Eric Mann</a>, <a href="http://profiles.wordpress.org/ethitter">Erick Hitter</a>, <a href="http://profiles.wordpress.org/evansolomon">Evan Solomon</a>, <a href="http://profiles.wordpress.org/faison">Faison</a>, <a href="http://profiles.wordpress.org/fboender">fboender</a>, <a href="http://profiles.wordpress.org/frank-klein">Frank Klein</a>, <a href="http://profiles.wordpress.org/garyj">Gary Jones</a>, <a href="http://profiles.wordpress.org/pento">Gary Pendergast</a>, <a href="http://profiles.wordpress.org/soulseekah">Gennady Kovshenin</a>, <a href="http://profiles.wordpress.org/georgestephanis">George Stephanis</a>, <a href="http://profiles.wordpress.org/gnarf37">gnarf37</a>, <a href="http://profiles.wordpress.org/tivnet">Gregory Karpinsky</a>, <a href="http://profiles.wordpress.org/hanni">hanni</a>, <a href="http://profiles.wordpress.org/helen">Helen Hou-Sandi</a>, <a href="http://profiles.wordpress.org/iandunn">Ian Dunn</a>, <a href="http://profiles.wordpress.org/ipstenu">Ipstenu (Mika Epstein)</a>, <a href="http://profiles.wordpress.org/isaackeyet">Isaac Keyet</a>, <a href="http://profiles.wordpress.org/jdgrimes">J.D. Grimes</a>, <a href="http://profiles.wordpress.org/jacklenox">Jack Lenox</a>, <a href="http://profiles.wordpress.org/janhenckens">janhenckens</a>, <a href="http://profiles.wordpress.org/avryl">Janneke Van Dorpe</a>, <a href="http://profiles.wordpress.org/janrenn">janrenn</a>, <a href="http://profiles.wordpress.org/jblz">Jeff Bowen</a>, <a href="http://profiles.wordpress.org/jeffr0">Jeff Chandler</a>, <a href="http://profiles.wordpress.org/jenmylo">Jen Mylo</a>, <a href="http://profiles.wordpress.org/buffler">Jeremy Buller</a>, <a href="http://profiles.wordpress.org/jeremyfelt">Jeremy Felt</a>, <a href="http://profiles.wordpress.org/jeherve">Jeremy Herve</a>, <a href="http://profiles.wordpress.org/jpry">Jeremy Pry</a>, <a href="http://profiles.wordpress.org/jayjdk">Jesper Johansen (jayjdk)</a>, <a href="http://profiles.wordpress.org/jhned">jhned</a>, <a href="http://profiles.wordpress.org/jim912">jim912</a>, <a href="http://profiles.wordpress.org/jartes">Joan Artes</a>, <a href="http://profiles.wordpress.org/joedolson">Joe Dolson</a>, <a href="http://profiles.wordpress.org/joen">Joen Asmussen</a>, <a href="http://profiles.wordpress.org/johnbillion">John Blackbourn</a>, <a href="http://profiles.wordpress.org/johnafish">John Fish</a>, <a href="http://profiles.wordpress.org/johnjamesjacoby">John James Jacoby</a>, <a href="http://profiles.wordpress.org/duck_">Jon Cave</a>, <a href="http://profiles.wordpress.org/joostdevalk">Joost de Valk</a>, <a href="http://profiles.wordpress.org/joshuaabenazer">Joshua Abenazer</a>, <a href="http://profiles.wordpress.org/nukaga">Junko Nukaga</a>, <a href="http://profiles.wordpress.org/devesine">Justin de Vesine</a>, <a href="http://profiles.wordpress.org/justinsainton">Justin Sainton</a>, <a href="http://profiles.wordpress.org/kadamwhite">K. Adam White</a>, <a href="http://profiles.wordpress.org/trepmal">Kailey (trepmal)</a>, <a href="http://profiles.wordpress.org/codebykat">Kat Hagan</a>, <a href="http://profiles.wordpress.org/littlethingsstudio">Kate Whitley</a>, <a href="http://profiles.wordpress.org/ryelle">Kelly Dwan</a>, <a href="http://profiles.wordpress.org/kpdesign">Kim Parsell</a>, <a href="http://profiles.wordpress.org/kwight">Kirk Wight</a>, <a href="http://profiles.wordpress.org/koki4a">Konstantin Dankov</a>, <a href="http://profiles.wordpress.org/kovshenin">Konstantin Kovshenin</a>, <a href="http://profiles.wordpress.org/obenland">Konstantin Obenland</a>, <a href="http://profiles.wordpress.org/drozdz">Krzysiek Drozdz</a>, <a href="http://profiles.wordpress.org/lancewillett">Lance Willett</a>, <a href="http://profiles.wordpress.org/leewillis77">Lee Willis</a>, <a href="http://profiles.wordpress.org/lite3">lite3</a>, <a href="http://profiles.wordpress.org/lucp">Luc Princen</a>, <a href="http://profiles.wordpress.org/latz">Lutz Schroer</a>, <a href="http://profiles.wordpress.org/mako09">Mako</a>, <a href="http://profiles.wordpress.org/markjaquith">Mark Jaquith</a>, <a href="http://profiles.wordpress.org/markmcwilliams">Mark McWilliams</a>, <a href="http://profiles.wordpress.org/markoheijnen">Marko Heijnen</a>, <a href="http://profiles.wordpress.org/matt">Matt Mullenweg</a>, <a href="http://profiles.wordpress.org/iammattthomas">Matt Thomas</a>, <a href="http://profiles.wordpress.org/mattwiebe">Matt Wiebe</a>, <a href="http://profiles.wordpress.org/mdbitz">Matthew Denton</a>, <a href="http://profiles.wordpress.org/mattheu">Matthew Haines-Young</a>, <a href="http://profiles.wordpress.org/matveb">Matías Ventura</a>, <a href="http://profiles.wordpress.org/megane9988">megane9988</a>, <a href="http://profiles.wordpress.org/melchoyce">Mel Choyce</a>, <a href="http://profiles.wordpress.org/micahwave">micahwave</a>, <a href="http://profiles.wordpress.org/cainm">Michael Cain</a>, <a href="http://profiles.wordpress.org/mitchoyoshitaka">Michael Erlewine</a>, <a href="http://profiles.wordpress.org/michelwppi">Michel - xiligroup dev</a>, <a href="http://profiles.wordpress.org/chellycat">Michelle Langston</a>, <a href="http://profiles.wordpress.org/gradyetc">Mike Burns</a>, <a href="http://profiles.wordpress.org/mikehansenme">Mike Hansen</a>, <a href="http://profiles.wordpress.org/mikelittle">Mike Little</a>, <a href="http://profiles.wordpress.org/dh-shredder">Mike Schroder</a>, <a href="http://profiles.wordpress.org/dimadin">Milan Dinic</a>, <a href="http://profiles.wordpress.org/batmoo">Mohammad Jangda</a>, <a href="http://profiles.wordpress.org/morganestes">Morgan Estes</a>, <a href="http://profiles.wordpress.org/mt8biz">moto hachi</a>, <a href="http://profiles.wordpress.org/Nao">Naoko Takano</a>, <a href="http://profiles.wordpress.org/neil_pie">Neil Pie</a>, <a href="http://profiles.wordpress.org/nickdaugherty">Nick Daugherty</a>, <a href="http://profiles.wordpress.org/celloexpressions">Nick Halsey</a>, <a href="http://profiles.wordpress.org/nbachiyski">Nikolay Bachiyski</a>, <a href="http://profiles.wordpress.org/ninio">ninio</a>, <a href="http://profiles.wordpress.org/ninnypants">ninnypants</a>, <a href="http://profiles.wordpress.org/nivijah">nivijah</a>, <a href="http://profiles.wordpress.org/nofearinc">nofearinc</a>, <a href="http://profiles.wordpress.org/nvwd">Nowell VanHoesen</a>, <a href="http://profiles.wordpress.org/odysseygate">odyssey</a>, <a href="http://profiles.wordpress.org/originalexe">OriginalEXE</a>, <a href="http://profiles.wordpress.org/swissspidy">Pascal Birchler</a>, <a href="http://profiles.wordpress.org/pauldewouters">Paul de Wouters</a>, <a href="http://profiles.wordpress.org/pavelevap">pavelevap</a>, <a href="http://profiles.wordpress.org/westi">Peter Westwood</a>, <a href="http://profiles.wordpress.org/senlin">Piet</a>, <a href="http://profiles.wordpress.org/ptahdunbar">Ptah Dunbar</a>, <a href="http://profiles.wordpress.org/raamdev">Raam Dev</a>, <a href="http://profiles.wordpress.org/bamadesigner">Rachel Carden</a>, <a href="http://profiles.wordpress.org/rachelbaker">rachelbaker</a>, <a href="http://profiles.wordpress.org/radices">Radices</a>, <a href="http://profiles.wordpress.org/mauryaratan">Ram Ratan Maurya</a>, <a href="http://profiles.wordpress.org/defries">Remkus de Vries</a>, <a href="http://profiles.wordpress.org/ounziw">Rescuework Support</a>, <a href="http://profiles.wordpress.org/rickalee">Ricky Lee Whittemore</a>, <a href="http://profiles.wordpress.org/rdall">Robert Dall</a>, <a href="http://profiles.wordpress.org/wet">Robert Wetzlmayr, PHP-Programmierer</a>, <a href="http://profiles.wordpress.org/rodrigosprimo">Rodrigo Primo</a>, <a href="http://profiles.wordpress.org/ryan">Ryan Boren</a>, <a href="http://profiles.wordpress.org/otto42">Samuel Wood</a>, <a href="http://profiles.wordpress.org/sanchothefat">sanchothefat</a>, <a href="http://profiles.wordpress.org/sboisvert">sboisvert</a>, <a href="http://profiles.wordpress.org/scottbasgaard">Scott Basgaard</a>, <a href="http://profiles.wordpress.org/coffee2code">Scott Reilly</a>, <a href="http://profiles.wordpress.org/wonderboymusic">Scott Taylor</a>, <a href="http://profiles.wordpress.org/scribu">scribu</a>, <a href="http://profiles.wordpress.org/seanchayes">Sean Hayes</a>, <a href="http://profiles.wordpress.org/sergeybiryukov">Sergey Biryukov</a>, <a href="http://profiles.wordpress.org/shaunandrews">Shaun Andrews</a>, <a href="http://profiles.wordpress.org/designsimply">Sheri Bigelow (designsimply)</a>, <a href="http://profiles.wordpress.org/shinichin">ShinichiN</a>, <a href="http://profiles.wordpress.org/simonwheatley">Simon Wheatley</a>, <a href="http://profiles.wordpress.org/siobhan">Siobhan</a>, <a href="http://profiles.wordpress.org/siobhyb">Siobhan Bamber (siobhyb)</a>, <a href="http://profiles.wordpress.org/sirbrillig">sirbrillig</a>, <a href="http://profiles.wordpress.org/solarissmoke">solarissmoke</a>, <a href="http://profiles.wordpress.org/netweb">Stephen Edgar</a>, <a href="http://profiles.wordpress.org/stephenharris">Stephen Harris</a>, <a href="http://profiles.wordpress.org/stevenkword">Steven Word</a>, <a href="http://profiles.wordpress.org/iamtakashi">Takashi Irie</a>, <a href="http://profiles.wordpress.org/miyauchi">Takayuki Miyauchi</a>, <a href="http://profiles.wordpress.org/tmtoy">Takuma Morikawa</a>, <a href="http://profiles.wordpress.org/thomasguillot">Thomas Guillot</a>, <a href="http://profiles.wordpress.org/tierra">tierra</a>, <a href="http://profiles.wordpress.org/tillkruess">Till Krüss</a>, <a href="http://profiles.wordpress.org/tlamedia">TLA Media</a>, <a href="http://profiles.wordpress.org/tobiasbg">TobiasBg</a>, <a href="http://profiles.wordpress.org/tommcfarlin">tommcfarlin</a>, <a href="http://profiles.wordpress.org/zodiac1978">Torsten Landsiedel</a>, <a href="http://profiles.wordpress.org/taupecat">Tracy Rotton</a>, <a href="http://profiles.wordpress.org/trishasalas">trishasalas</a>, <a href="http://profiles.wordpress.org/mbmufffin">Tyler Smith</a>, <a href="http://profiles.wordpress.org/grapplerulrich">Ulrich</a>, <a href="http://profiles.wordpress.org/undergroundnetwork">undergroundnetwork</a>, <a href="http://profiles.wordpress.org/l10n">Vladimir</a>, <a href="http://profiles.wordpress.org/westonruter">Weston Ruter</a>, <a href="http://profiles.wordpress.org/yoavf">Yoav Farhi</a>, <a href="http://profiles.wordpress.org/yonasy">yonasy</a>, <a href="http://profiles.wordpress.org/yurivictor">Yuri Victor</a>, and <a href="http://profiles.wordpress.org/tollmanz">Zack Tollman</a>. Also thanks to <a href="http://benmorrison.org/">Ben Morrison</a> and <a href="http://christineswebb.com/">Christine Webb</a> for help with the video.</p>\n<p>Thanks for choosing WordPress. See you soon for version 3.9!</p>\n";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:36:"http://wellformedweb.org/CommentAPI/";a:1:{s:10:"commentRss";a:1:{i:0;a:5:{s:4:"data";s:46:"http://wordpress.org/news/2013/12/parker/feed/";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:38:"http://purl.org/rss/1.0/modules/slash/";a:1:{s:8:"comments";a:1:{i:0;a:5:{s:4:"data";s:1:"0";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:2;a:6:{s:4:"data";s:45:"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:5:{s:0:"";a:7:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:7:"3.8 RC2";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:42:"http://wordpress.org/news/2013/12/3-8-rc2/";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:8:"comments";a:1:{i:0;a:5:{s:4:"data";s:51:"http://wordpress.org/news/2013/12/3-8-rc2/#comments";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Tue, 10 Dec 2013 01:08:38 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:8:"category";a:2:{i:0;a:5:{s:4:"data";s:11:"Development";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}i:1;a:5:{s:4:"data";s:8:"Releases";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:33:"http://wordpress.org/news/?p=2805";s:7:"attribs";a:1:{s:0:"";a:1:{s:11:"isPermaLink";s:5:"false";}}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:343:"Release candidate 2 of WordPress 3.8 is now available for download. This is the last pre-release, and we expect it to be effectively identical to what&#8217;s officially released to the public on Thursday. This means if you are a plugin or theme developer, start your engines! (If they&#8217;re not going already.) Lots of admin code [&#8230;]";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:14:"Matt Mullenweg";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:40:"http://purl.org/rss/1.0/modules/content/";a:1:{s:7:"encoded";a:1:{i:0;a:5:{s:4:"data";s:1180:"<p>Release candidate 2 of WordPress 3.8 is <a href="http://wordpress.org/wordpress-3.8-RC2.zip">now available for download</a>. This is the last pre-release, and we expect it to be effectively identical to what&#8217;s officially released to the public on Thursday.</p>\n<p>This means if you are a plugin or theme developer, start your engines! (If they&#8217;re not going already.) Lots of admin code has changed so it&#8217;s especially important to see if your plugin works well within the new admin design and layout, and update <a href="http://wordpress.org/plugins/about/readme.txt">the &#8220;Tested up to:&#8221; part of your plugin readme.txt</a>.</p>\n<p>If there is something in your plugin that you&#8217;re unable to fix, or if you think you&#8217;ve found a bug, join us <a href="http://codex.wordpress.org/IRC">in #wordpress-dev in IRC</a>, especially if you&#8217;re able to join during the dev chat on Wednesday, or post in the <a href="http://wordpress.org/support/forum/alphabeta">alpha/beta forum</a>. The developers and designers who worked on this release are happy to help anyone update their code before the 3.8 release.</p>\n<p>Happy hacking, everybody!</p>\n";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:36:"http://wellformedweb.org/CommentAPI/";a:1:{s:10:"commentRss";a:1:{i:0;a:5:{s:4:"data";s:47:"http://wordpress.org/news/2013/12/3-8-rc2/feed/";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:38:"http://purl.org/rss/1.0/modules/slash/";a:1:{s:8:"comments";a:1:{i:0;a:5:{s:4:"data";s:1:"0";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:3;a:6:{s:4:"data";s:45:"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:5:{s:0:"";a:7:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:17:"WordPress 3.8 RC1";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:45:"http://wordpress.org/news/2013/12/3-8-almost/";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:8:"comments";a:1:{i:0;a:5:{s:4:"data";s:54:"http://wordpress.org/news/2013/12/3-8-almost/#comments";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Wed, 04 Dec 2013 09:54:48 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:8:"category";a:2:{i:0;a:5:{s:4:"data";s:11:"Development";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}i:1;a:5:{s:4:"data";s:8:"Releases";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:33:"http://wordpress.org/news/?p=2760";s:7:"attribs";a:1:{s:0:"";a:1:{s:11:"isPermaLink";s:5:"false";}}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:345:"We&#8217;re entering the quiet but busy part of a release, whittling down issues to bring you all of the new features you&#8217;re excited about with the stability you expect from WordPress. There are just a few days from the &#8220;code freeze&#8221; for our 3.8 release, which includes a number of exciting enhancements, so the focus [&#8230;]";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:14:"Matt Mullenweg";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:40:"http://purl.org/rss/1.0/modules/content/";a:1:{s:7:"encoded";a:1:{i:0;a:5:{s:4:"data";s:1873:"<p>We&#8217;re entering the quiet but busy part of a release, whittling down issues to bring you all of the new features you&#8217;re excited about with the stability you expect from WordPress. There are just a few days from the &#8220;code freeze&#8221; for our 3.8 release, <a href="http://wordpress.org/news/2013/11/wordpress-3-8-beta-1/">which includes a number of exciting enhancements</a>, so the focus is on identifying any major issues and resolving them as soon as possible.</p>\n<p>If you&#8217;ve ever wondered about how to contribute to WordPress, here&#8217;s a time you can: download this release candidate and use it in as many ways as you can imagine. Try to break it, and if you do, let us know how you did it so we can make sure it never happens again. If you work for a web host, this is the release you should test as much as possible and start getting your automatic upgrade systems and 1-click installers ready.</p>\n<p><a href="http://wordpress.org/wordpress-3.8-RC1.zip">Download WordPress 3.8 RC1</a> (zip) or use the <a href="http://wordpress.org/plugins/wordpress-beta-tester/">WordPress Beta Tester</a> plugin (you&#8217;ll want &#8220;bleeding edge nightlies&#8221;).</p>\n<p>If you think you’ve found a bug, you can post to the <a href="http://wordpress.org/support/forum/alphabeta">Alpha/Beta area</a> in the support forums. Or, if you’re comfortable writing a reproducible bug report, <a href="http://core.trac.wordpress.org/">file one on the WordPress Trac</a>. There, you can also find <a href="http://core.trac.wordpress.org/report/5">a list of known bugs</a> and <a href="http://core.trac.wordpress.org/query?status=closed&amp;group=component&amp;milestone=3.8">everything we’ve fixed</a> so far.</p>\n<p><em>We&#8217;re so close to the</em><br />\n<em>finish line, jump in and help</em><br />\n<em>good karma is yours.</em></p>\n";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:36:"http://wellformedweb.org/CommentAPI/";a:1:{s:10:"commentRss";a:1:{i:0;a:5:{s:4:"data";s:50:"http://wordpress.org/news/2013/12/3-8-almost/feed/";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:38:"http://purl.org/rss/1.0/modules/slash/";a:1:{s:8:"comments";a:1:{i:0;a:5:{s:4:"data";s:1:"0";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:4;a:6:{s:4:"data";s:45:"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:5:{s:0:"";a:7:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:20:"WordPress 3.8 Beta 1";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:55:"http://wordpress.org/news/2013/11/wordpress-3-8-beta-1/";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:8:"comments";a:1:{i:0;a:5:{s:4:"data";s:64:"http://wordpress.org/news/2013/11/wordpress-3-8-beta-1/#comments";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Thu, 21 Nov 2013 05:21:56 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:8:"category";a:2:{i:0;a:5:{s:4:"data";s:11:"Development";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}i:1;a:5:{s:4:"data";s:8:"Releases";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:33:"http://wordpress.org/news/?p=2754";s:7:"attribs";a:1:{s:0:"";a:1:{s:11:"isPermaLink";s:5:"false";}}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:307:"The first beta of the 3.8 is now available, and the next dates to watch out for are code freeze on December 5th and a final release on December 12th. 3.8 brings together several of the features as plugins projects and while this isn&#8217;t our first rodeo, expect this to be more beta than usual. [&#8230;]";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:14:"Matt Mullenweg";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:40:"http://purl.org/rss/1.0/modules/content/";a:1:{s:7:"encoded";a:1:{i:0;a:5:{s:4:"data";s:2236:"<p>The first beta of the 3.8 is now available, and the next dates to watch out for are code freeze on December 5th and a final release on December 12th.</p>\n<p>3.8 brings together <a href="http://make.wordpress.org/core/features-as-plugins/">several of the features as plugins projects</a> and while this isn&#8217;t our first rodeo, expect this to be more beta than usual. The headline things to test out in this release are:</p>\n<ul>\n<li>The new admin design, especially the responsive aspect of it. Try it out on different devices and browsers, see how it goes, especially the more complex pages like widgets or seldom-looked-at-places like Press This. Color schemes, which you can change on your profile, have also been spruced up.</li>\n<li>The dashboard homepage has been refreshed, poke and prod it.</li>\n<li>Choosing themes under Appearance is completely different, try to break it however possible.</li>\n<li>There&#8217;s a new default theme, Twenty Fourteen.</li>\n<li>Over 250 issues closed already.</li>\n</ul>\n<p>Given how many things in the admin have changed it&#8217;s extra super duper important to test as many plugins and themes with admin pages against the new stuff. Also if you&#8217;re a developer consider how you can make your admin interface fit the MP6 aesthetic better.</p>\n<p>As always, if you think you’ve found a bug, you can post to the <a href="http://wordpress.org/support/forum/alphabeta">Alpha/Beta area</a> in the support forums. Or, if you’re comfortable writing a reproducible bug report, <a href="http://core.trac.wordpress.org/">file one on the WordPress Trac</a>. There, you can also find <a href="http://core.trac.wordpress.org/report/5">a list of known bugs</a> and <a href="http://core.trac.wordpress.org/query?status=closed&amp;group=component&amp;milestone=3.8">everything we’ve fixed</a> so far.</p>\n<p><a href="http://wordpress.org/wordpress-3.8-beta-1.zip">Download WordPress 3.8 Beta 1</a> (zip) or use the <a href="http://wordpress.org/plugins/wordpress-beta-tester/">WordPress Beta Tester</a> plugin (you&#8217;ll want &#8220;bleeding edge nightlies&#8221;).</p>\n<p><em>Alphabet soup of</em><br />\n<em>Plugins as features galore</em><br />\n<em>The future is here</em></p>\n";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:36:"http://wellformedweb.org/CommentAPI/";a:1:{s:10:"commentRss";a:1:{i:0;a:5:{s:4:"data";s:60:"http://wordpress.org/news/2013/11/wordpress-3-8-beta-1/feed/";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:38:"http://purl.org/rss/1.0/modules/slash/";a:1:{s:8:"comments";a:1:{i:0;a:5:{s:4:"data";s:1:"0";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:5;a:6:{s:4:"data";s:45:"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:5:{s:0:"";a:7:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:35:"WordPress 3.7.1 Maintenance Release";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:50:"http://wordpress.org/news/2013/10/wordpress-3-7-1/";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:8:"comments";a:1:{i:0;a:5:{s:4:"data";s:59:"http://wordpress.org/news/2013/10/wordpress-3-7-1/#comments";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Tue, 29 Oct 2013 21:04:59 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:8:"category";a:2:{i:0;a:5:{s:4:"data";s:8:"Releases";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}i:1;a:5:{s:4:"data";s:8:"Security";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:33:"http://wordpress.org/news/?p=2745";s:7:"attribs";a:1:{s:0:"";a:1:{s:11:"isPermaLink";s:5:"false";}}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:371:"WordPress 3.7.1 is now available! This maintenance release addresses 11 bugs in WordPress 3.7, including: Images with captions no longer appear broken in the visual editor. Allow some sites running on old or poorly configured servers to continue to check for updates from WordPress.org. Avoid fatal errors with certain plugins that were incorrectly calling some [&#8230;]";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:12:"Andrew Nacin";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:40:"http://purl.org/rss/1.0/modules/content/";a:1:{s:7:"encoded";a:1:{i:0;a:5:{s:4:"data";s:1594:"<p>WordPress 3.7.1 is now available! This maintenance release addresses 11 bugs in WordPress 3.7, including:</p>\n<ul>\n<li>Images with captions no longer appear broken in the visual editor.</li>\n<li>Allow some sites running on old or poorly configured servers to continue to check for updates from WordPress.org.</li>\n<li>Avoid fatal errors with certain plugins that were incorrectly calling some WordPress functions too early.</li>\n<li>Fix hierarchical sorting in get_pages(), exclusions in wp_list_categories(), and in_category() when called with empty values.</li>\n<li>Fix a warning that may occur in certain setups while performing a search, and a few other notices.</li>\n</ul>\n<p>For a full list of changes, consult the <a href="http://core.trac.wordpress.org/query?milestone=3.7.1">list of tickets</a> and <a href="http://core.trac.wordpress.org/log/branches/3.7?stop_rev=25914&amp;rev=25986">the changelog</a>.</p>\n<p>If you are one of the <a href="http://wordpress.org/download/counter/">nearly two million</a> already running WordPress 3.7, we will start rolling out the all-new <a href="http://wordpress.org/news/2013/10/basie/">automatic background updates</a> for WordPress 3.7.1 in the next few hours. For sites <a href="http://wordpress.org/plugins/background-update-tester/">that support them</a>, of course.</p>\n<p><a href="http://wordpress.org/download/">Download WordPress 3.7.1</a> or venture over to <strong>Dashboard → Updates</strong> and simply click &#8220;Update Now.&#8221;</p>\n<p><em>Just a few fixes<br />\nYour new update attitude:<br />\nZero clicks given</em></p>\n";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:36:"http://wellformedweb.org/CommentAPI/";a:1:{s:10:"commentRss";a:1:{i:0;a:5:{s:4:"data";s:55:"http://wordpress.org/news/2013/10/wordpress-3-7-1/feed/";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:38:"http://purl.org/rss/1.0/modules/slash/";a:1:{s:8:"comments";a:1:{i:0;a:5:{s:4:"data";s:1:"0";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:6;a:6:{s:4:"data";s:42:"\n		\n		\n		\n		\n		\n				\n\n		\n		\n				\n			\n		\n		";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:5:{s:0:"";a:7:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:25:"WordPress 3.7 “Basie�?";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:40:"http://wordpress.org/news/2013/10/basie/";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:8:"comments";a:1:{i:0;a:5:{s:4:"data";s:49:"http://wordpress.org/news/2013/10/basie/#comments";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Thu, 24 Oct 2013 22:35:10 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:8:"category";a:1:{i:0;a:5:{s:4:"data";s:8:"Releases";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:33:"http://wordpress.org/news/?p=2736";s:7:"attribs";a:1:{s:0:"";a:1:{s:11:"isPermaLink";s:5:"false";}}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:357:"Version 3.7 of WordPress, named &#8220;Basie&#8221; in honor of Count Basie, is available for download or update in your WordPress dashboard. This release features some of the most important architectural updates we&#8217;ve made to date. Here are the big ones: Updates while you sleep: With WordPress 3.7, you don&#8217;t have to lift a finger to [&#8230;]";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:14:"Matt Mullenweg";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:40:"http://purl.org/rss/1.0/modules/content/";a:1:{s:7:"encoded";a:1:{i:0;a:5:{s:4:"data";s:17229:"<p>Version 3.7 of WordPress, named &#8220;Basie&#8221; in honor of <a href="http://en.wikipedia.org/wiki/Count_basie">Count Basie</a>, is available <a href="http://wordpress.org/download/">for download</a> or update in your WordPress dashboard. This release features some of the most important architectural updates we&#8217;ve made to date. Here are the big ones:</p>\n<ul>\n<li><strong>Updates while you sleep</strong>: With WordPress 3.7, you don&#8217;t have to lift a finger to apply maintenance and security updates. Most sites are now able to automatically apply these updates in the background. The update process also has been made even more reliable and secure, with dozens of new checks and safeguards.</li>\n<li><strong>Stronger password recommendations</strong>: Your password is your site&#8217;s first line of defense. It&#8217;s best to create passwords that are complex, long, and unique. To that end, our password meter has been updated in WordPress 3.7 to recognize common mistakes that can weaken your password: dates, names, keyboard patterns (123456789), and even pop culture references.</li>\n<li><strong>Better global support</strong>: Localized versions of WordPress will receive faster and more complete translations. WordPress 3.7 adds support for automatically installing the right language files and keeping them up to date, a boon for the many millions who use WordPress in a language other than English.</li>\n</ul>\n<p>For developers there are lots of options around how to control the new updates feature, including allowing it to handle major upgrades as well as minor ones, more sophisticated date query support, and multisite improvements. As always, if you&#8217;re hungry for more <a href="http://codex.wordpress.org/Version_3.7">dive into the Codex</a> or browse the <a href="http://core.trac.wordpress.org/query?status=closed&amp;group=resolution&amp;milestone=3.7">over 400 closed tickets on Trac</a>.</p>\n<h3>A New Wave</h3>\n<p>This release was led by Andrew Nacin, backed up by Dion Hulse and Jon Cave. This is our first release using the new plugin-first development process, with a much shorter timeframe than in the past. (3.6 was released in August.) The 3.8 release, due in December, will continue this plugin-led development cycle that gives much more autonomy to plugin leads and allows us to decouple feature development from a release. You can follow this grand experiment, and what we&#8217;re learning from it, <a href="http://make.wordpress.org/core/">on the make/core blog</a>. There are 211 contributors with props in this release:</p>\n<p><a href="http://profiles.wordpress.org/technosailor">Aaron Brazell</a>, <a href="http://profiles.wordpress.org/aaroncampbell">Aaron D. Campbell</a>, <a href="http://profiles.wordpress.org/aaronholbrook">Aaron Holbrook</a>, <a href="http://profiles.wordpress.org/jorbin">Aaron Jorbin</a>, <a href="http://profiles.wordpress.org/adamsilverstein">adamsilverstein</a>, <a href="http://profiles.wordpress.org/ahoereth">Alexander Hoereth</a>, <a href="http://profiles.wordpress.org/viper007bond">Alex Mills (Viper007Bond)</a>, <a href="http://profiles.wordpress.org/sabreuse">Amy Hendrix (sabreuse)</a>, <a href="http://profiles.wordpress.org/andg">andg</a>, <a href="http://profiles.wordpress.org/nacin">Andrew Nacin</a>, <a href="http://profiles.wordpress.org/norcross">Andrew Norcross</a>, <a href="http://profiles.wordpress.org/azaozz">Andrew Ozz</a>, <a href="http://profiles.wordpress.org/andrewspittle">Andrew Spittle</a>, <a href="http://profiles.wordpress.org/askapache">askapache</a>, <a href="http://profiles.wordpress.org/atimmer">atimmer</a>, <a href="http://profiles.wordpress.org/barry">Barry</a>, <a href="http://profiles.wordpress.org/beaulebens">Beau Lebens</a>, <a href="http://profiles.wordpress.org/benmoody">ben.moody</a>, <a href="http://profiles.wordpress.org/bhengh">Ben Miller</a>, <a href="http://profiles.wordpress.org/neoxx">Bernhard Riedl</a>, <a href="http://profiles.wordpress.org/bftrick">BFTrick</a>, <a href="http://profiles.wordpress.org/bananastalktome">Billy (bananastalktome)</a>, <a href="http://profiles.wordpress.org/bmb">bmb</a>, <a href="http://profiles.wordpress.org/kraftbj">Brandon Kraft</a>, <a href="http://profiles.wordpress.org/brianhogg">brianhogg</a>, <a href="http://profiles.wordpress.org/rzen">Brian Richards</a>, <a href="http://profiles.wordpress.org/bpetty">Bryan Petty</a>, <a href="http://profiles.wordpress.org/carldanley">Carl Danley</a>, <a href="http://profiles.wordpress.org/charlesclarkson">CharlesClarkson</a>, <a href="http://profiles.wordpress.org/chipbennett">Chip Bennett</a>, <a href="http://profiles.wordpress.org/chouby">Chouby</a>, <a href="http://profiles.wordpress.org/c3mdigital">Chris Olbekson</a>, <a href="http://profiles.wordpress.org/chrisrudzki">Chris Rudzki</a>, <a href="http://profiles.wordpress.org/aeg0125">coderaaron</a>, <a href="http://profiles.wordpress.org/coenjacobs">Coen Jacobs</a>, <a href="http://profiles.wordpress.org/crrobi01">Colin Robinson</a>, <a href="http://profiles.wordpress.org/andreasnrb">cyonite</a>, <a href="http://profiles.wordpress.org/daankortenbach">Daan Kortenbach</a>, <a href="http://profiles.wordpress.org/danielbachhuber">Daniel Bachhuber</a>, <a href="http://profiles.wordpress.org/convissor">Daniel Convissor</a>, <a href="http://profiles.wordpress.org/dartiss">dartiss</a>, <a href="http://profiles.wordpress.org/koop">Daryl Koopersmith</a>, <a href="http://profiles.wordpress.org/csixty4">Dave Ross</a>, <a href="http://profiles.wordpress.org/davidjlaietta">David Laietta</a>, <a href="http://profiles.wordpress.org/dd32">Dion Hulse</a>, <a href="http://profiles.wordpress.org/dllh">dllh</a>, <a href="http://profiles.wordpress.org/ocean90">Dominik Schilling (ocean90)</a>, <a href="http://profiles.wordpress.org/dpash">dpash</a>, <a href="http://profiles.wordpress.org/drewapicture">Drew Jaynes</a>, <a href="http://profiles.wordpress.org/drprotocols">DrProtocols</a>, <a href="http://profiles.wordpress.org/dustyf">Dustin Filippini</a>, <a href="http://profiles.wordpress.org/dzver">dzver</a>, <a href="http://profiles.wordpress.org/cais">Edward Caissie</a>, <a href="http://profiles.wordpress.org/enej">enej</a>, <a href="http://profiles.wordpress.org/ericlewis">Eric Andrew Lewis</a>, <a href="http://profiles.wordpress.org/ericmann">Eric Mann</a>, <a href="http://profiles.wordpress.org/evansolomon">Evan Solomon</a>, <a href="http://profiles.wordpress.org/faishal">faishal</a>, <a href="http://profiles.wordpress.org/faison">Faison</a>, <a href="http://profiles.wordpress.org/foofy">Foofy</a>, <a href="http://profiles.wordpress.org/fjarrett">Frankie Jarrett</a>, <a href="http://profiles.wordpress.org/frank-klein">Frank Klein</a>, <a href="http://profiles.wordpress.org/garyc40">Gary Cao</a>, <a href="http://profiles.wordpress.org/pento">Gary Pendergast</a>, <a href="http://profiles.wordpress.org/gayadesign">Gaya Kessler</a>, <a href="http://profiles.wordpress.org/georgestephanis">George Stephanis</a>, <a href="http://profiles.wordpress.org/gizburdt">Gizburdt</a>, <a href="http://profiles.wordpress.org/goldenapples">goldenapples</a>, <a href="http://profiles.wordpress.org/gradyetc">gradyetc</a>, <a href="http://profiles.wordpress.org/gcorne">Gregory Cornelius</a>, <a href="http://profiles.wordpress.org/webord">Gustavo Bordoni</a>, <a href="http://profiles.wordpress.org/hakre">hakre</a>, <a href="http://profiles.wordpress.org/helen">Helen Hou-Sandi</a>, <a href="http://profiles.wordpress.org/iandunn">Ian Dunn</a>, <a href="http://profiles.wordpress.org/ipstenu">Ipstenu (Mika Epstein)</a>, <a href="http://profiles.wordpress.org/creativeinfusion">itinerant</a>, <a href="http://profiles.wordpress.org/jdgrimes">J.D. Grimes</a>, <a href="http://profiles.wordpress.org/jakubtyrcha">jakub.tyrcha</a>, <a href="http://profiles.wordpress.org/jamescollins">James Collins</a>, <a href="http://profiles.wordpress.org/jenmylo">Jen Mylo</a>, <a href="http://profiles.wordpress.org/buffler">Jeremy Buller</a>, <a href="http://profiles.wordpress.org/jeremyfelt">Jeremy Felt</a>, <a href="http://profiles.wordpress.org/jayjdk">Jesper Johansen (jayjdk)</a>, <a href="http://profiles.wordpress.org/joehoyle">Joe Hoyle</a>, <a href="http://profiles.wordpress.org/jkudish">Joey Kudish</a>, <a href="http://profiles.wordpress.org/johnnyb">John Beales</a>, <a href="http://profiles.wordpress.org/johnbillion">John Blackbourn (johnbillion)</a>, <a href="http://profiles.wordpress.org/johnafish">John Fish</a>, <a href="http://profiles.wordpress.org/johnjamesjacoby">John James Jacoby</a>, <a href="http://profiles.wordpress.org/johnpbloch">John P. Bloch</a>, <a href="http://profiles.wordpress.org/jond3r">Jonas Bolinder (jond3r)</a>, <a href="http://profiles.wordpress.org/jchristopher">Jonathan Christopher</a>, <a href="http://profiles.wordpress.org/desrosj">Jonathan Desrosiers</a>, <a href="http://profiles.wordpress.org/duck_">Jon Cave</a>, <a href="http://profiles.wordpress.org/jonlynch">Jon Lynch</a>, <a href="http://profiles.wordpress.org/joostdevalk">Joost de Valk</a>, <a href="http://profiles.wordpress.org/josephscott">Joseph Scott</a>, <a href="http://profiles.wordpress.org/betzster">Josh Betz</a>, <a href="http://profiles.wordpress.org/devesine">Justin de Vesine</a>, <a href="http://profiles.wordpress.org/justinsainton">Justin Sainton</a>, <a href="http://profiles.wordpress.org/kadamwhite">K.Adam White</a>, <a href="http://profiles.wordpress.org/trepmal">Kailey (trepmal)</a>, <a href="http://profiles.wordpress.org/ketwaroo">Ketwaroo</a>, <a href="http://profiles.wordpress.org/kevinb">kevinB</a>, <a href="http://profiles.wordpress.org/kpdesign">Kim Parsell</a>, <a href="http://profiles.wordpress.org/kitchin">kitchin</a>, <a href="http://profiles.wordpress.org/kovshenin">Konstantin Kovshenin</a>, <a href="http://profiles.wordpress.org/obenland">Konstantin Obenland</a>, <a href="http://profiles.wordpress.org/koopersmith">koopersmith</a>, <a href="http://profiles.wordpress.org/kurtpayne">Kurt Payne</a>, <a href="http://profiles.wordpress.org/lancewillett">Lance Willett</a>, <a href="http://profiles.wordpress.org/leewillis77">Lee Willis (leewillis77)</a>, <a href="http://profiles.wordpress.org/lessbloat">lessbloat</a>, <a href="http://profiles.wordpress.org/layotte">Lew Ayotte</a>, <a href="http://profiles.wordpress.org/lgedeon">Luke Gedeon</a>, <a href="http://profiles.wordpress.org/iworks">Marcin Pietrzak</a>, <a href="http://profiles.wordpress.org/cimmo">Marco Cimmino</a>, <a href="http://profiles.wordpress.org/marco_teethgrinder">Marco Galasso</a>, <a href="http://profiles.wordpress.org/markjaquith">Mark Jaquith</a>, <a href="http://profiles.wordpress.org/markmcwilliams">Mark McWilliams</a>, <a href="http://profiles.wordpress.org/markoheijnen">Marko Heijnen</a>, <a href="http://profiles.wordpress.org/melchoyce">Mel Choyce</a>, <a href="http://profiles.wordpress.org/tw2113">Michael Beckwith</a>, <a href="http://profiles.wordpress.org/mikehansenme">Mike Hansen</a>, <a href="http://profiles.wordpress.org/mikeschinkel">Mike Schinkel</a>, <a href="http://profiles.wordpress.org/dh-shredder">Mike Schroder</a>, <a href="http://profiles.wordpress.org/dimadin">Milan Dinic</a>, <a href="http://profiles.wordpress.org/mitchoyoshitaka">mitcho (Michael Yoshitaka Erlewine)</a>, <a href="http://profiles.wordpress.org/usermrpapa">Mr Papa</a>, <a href="http://profiles.wordpress.org/Nao">Naoko Takano</a>, <a href="http://profiles.wordpress.org/naomicbush">Naomi</a>, <a href="http://profiles.wordpress.org/alex-ye">Nashwan Doaqan</a>, <a href="http://profiles.wordpress.org/natejacobs">NateJacobs</a>, <a href="http://profiles.wordpress.org/nathanrice">nathanrice</a>, <a href="http://profiles.wordpress.org/niallkennedy">Niall Kennedy</a>, <a href="http://profiles.wordpress.org/nickdaugherty">Nick Daugherty</a>, <a href="http://profiles.wordpress.org/celloexpressions">Nick Halsey</a>, <a href="http://profiles.wordpress.org/nickmomrik">Nick Momrik</a>, <a href="http://profiles.wordpress.org/nikv">Nikhil Vimal (NikV)</a>, <a href="http://profiles.wordpress.org/nbachiyski">Nikolay Bachiyski</a>, <a href="http://profiles.wordpress.org/noahsilverstein">noahsilverstein</a>, <a href="http://profiles.wordpress.org/nofearinc">nofearinc</a>, <a href="http://profiles.wordpress.org/nukaga">nukaga</a>, <a href="http://profiles.wordpress.org/nullvariable">nullvariable</a>, <a href="http://profiles.wordpress.org/butuzov">Oleg Butuzov</a>, <a href="http://profiles.wordpress.org/paolal">Paolo Belcastro</a>, <a href="http://profiles.wordpress.org/xparham">Parham</a>, <a href="http://profiles.wordpress.org/pbiron">Paul Biron</a>, <a href="http://profiles.wordpress.org/pauldewouters">Paul de Wouters</a>, <a href="http://profiles.wordpress.org/pavelevap">pavelevap</a>, <a href="http://profiles.wordpress.org/peterjaap">peterjaap</a>, <a href="http://profiles.wordpress.org/westi">Peter Westwood</a>, <a href="http://profiles.wordpress.org/philiparthurmoore">Philip Arthur Moore</a>, <a href="http://profiles.wordpress.org/mordauk">Pippin Williamson</a>, <a href="http://profiles.wordpress.org/plocha">plocha</a>, <a href="http://profiles.wordpress.org/pollett">Pollett</a>, <a href="http://profiles.wordpress.org/ptahdunbar">Ptah Dunbar</a>, <a href="http://profiles.wordpress.org/ramiy">Rami Yushuvaev</a>, <a href="http://profiles.wordpress.org/rasheed">Rasheed Bydousi</a>, <a href="http://profiles.wordpress.org/raybernard">RayBernard</a>, <a href="http://profiles.wordpress.org/rboren">rboren</a>, <a href="http://profiles.wordpress.org/greuben">Reuben Gunday</a>, <a href="http://profiles.wordpress.org/rfair404">rfair404</a>, <a href="http://profiles.wordpress.org/iamfriendly">Richard Tape</a>, <a href="http://profiles.wordpress.org/r3df">Rick Radko</a>, <a href="http://profiles.wordpress.org/miqrogroove">Robert Chapin</a>, <a href="http://profiles.wordpress.org/rdall">Robert Dall</a>, <a href="http://profiles.wordpress.org/rodrigosprimo">Rodrigo Primo</a>, <a href="http://profiles.wordpress.org/wpmuguru">Ron Rennick</a>, <a href="http://profiles.wordpress.org/rpattillo">rpattillo</a>, <a href="http://profiles.wordpress.org/ryan">Ryan Boren</a>, <a href="http://profiles.wordpress.org/rmccue">Ryan McCue</a>, <a href="http://profiles.wordpress.org/hotchkissconsulting">Sam Hotchkiss</a>, <a href="http://profiles.wordpress.org/coffee2code">Scott Reilly</a>, <a href="http://profiles.wordpress.org/scottsweb">scottsweb</a>, <a href="http://profiles.wordpress.org/wonderboymusic">Scott Taylor</a>, <a href="http://profiles.wordpress.org/scribu">scribu</a>, <a href="http://profiles.wordpress.org/scruffian">scruffian</a>, <a href="http://profiles.wordpress.org/tenpura">Seisuke Kuraishi (tenpura)</a>, <a href="http://profiles.wordpress.org/sergeybiryukov">Sergey Biryukov</a>, <a href="http://profiles.wordpress.org/shinichin">ShinichiN</a>, <a href="http://profiles.wordpress.org/pross">Simon Prosser</a>, <a href="http://profiles.wordpress.org/simonwheatley">Simon Wheatley</a>, <a href="http://profiles.wordpress.org/siobhan">Siobhan</a>, <a href="http://profiles.wordpress.org/siobhyb">Siobhan Bamber (siobhyb)</a>, <a href="http://profiles.wordpress.org/sirzooro">sirzooro</a>, <a href="http://profiles.wordpress.org/solarissmoke">solarissmoke</a>, <a href="http://profiles.wordpress.org/sillybean">Stephanie Leary</a>, <a href="http://profiles.wordpress.org/netweb">Stephen Edgar (@netweb)</a>, <a href="http://profiles.wordpress.org/stephenharris">Stephen Harris</a>, <a href="http://profiles.wordpress.org/strangerstudios">strangerstudios</a>, <a href="http://profiles.wordpress.org/sweetie089">sweetie089</a>, <a href="http://profiles.wordpress.org/swissspidy">swissspidy</a>, <a href="http://profiles.wordpress.org/miyauchi">Takayuki Miyauchi</a>, <a href="http://profiles.wordpress.org/tmtoy">Takuma Morikawa</a>, <a href="http://profiles.wordpress.org/tlovett1">Taylor Lovett</a>, <a href="http://profiles.wordpress.org/tivnet">tivnet</a>, <a href="http://profiles.wordpress.org/tobiasbg">TobiasBg</a>, <a href="http://profiles.wordpress.org/tomauger">Tom Auger</a>, <a href="http://profiles.wordpress.org/toscho">toscho</a>, <a href="http://profiles.wordpress.org/wpsmith">Travis Smith</a>, <a href="http://profiles.wordpress.org/sorich87">Ulrich Sossou</a>, <a href="http://profiles.wordpress.org/vericgar">vericgar</a>, <a href="http://profiles.wordpress.org/vinod-dalvi">Vinod Dalvi</a>, <a href="http://profiles.wordpress.org/westonruter">Weston Ruter</a>, <a href="http://profiles.wordpress.org/wikicms">wikicms</a>, <a href="http://profiles.wordpress.org/willnorris">Will Norris</a>, <a href="http://profiles.wordpress.org/wojtekszkutnik">Wojtek Szkutnik</a>, <a href="http://profiles.wordpress.org/wycks">wycks</a>, <a href="http://profiles.wordpress.org/yoavf">Yoav Farhi</a>, and <a href="http://profiles.wordpress.org/yurivictor">Yuri Victor</a>.</p>\n<p>Enjoy what may be one of your last few manual updates. See you soon for version 3.8!</p>\n";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:36:"http://wellformedweb.org/CommentAPI/";a:1:{s:10:"commentRss";a:1:{i:0;a:5:{s:4:"data";s:45:"http://wordpress.org/news/2013/10/basie/feed/";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:38:"http://purl.org/rss/1.0/modules/slash/";a:1:{s:8:"comments";a:1:{i:0;a:5:{s:4:"data";s:1:"0";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:7;a:6:{s:4:"data";s:45:"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:5:{s:0:"";a:7:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:33:"WordPress 3.7 Release Candidate 2";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:68:"http://wordpress.org/news/2013/10/wordpress-3-7-release-candidate-2/";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:8:"comments";a:1:{i:0;a:5:{s:4:"data";s:77:"http://wordpress.org/news/2013/10/wordpress-3-7-release-candidate-2/#comments";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Wed, 23 Oct 2013 00:05:30 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:8:"category";a:2:{i:0;a:5:{s:4:"data";s:11:"Development";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}i:1;a:5:{s:4:"data";s:8:"Releases";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:33:"http://wordpress.org/news/?p=2729";s:7:"attribs";a:1:{s:0:"";a:1:{s:11:"isPermaLink";s:5:"false";}}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:417:"The second release candidate of WordPress 3.7 is now available for testing! Those of you already testing WordPress 3.7 will be updated automatically to RC2. (Nice.) If you&#8217;d like to start testing, there&#8217;s no time like the present! Try the WordPress Beta Tester plugin (you’ll want “bleeding edge nightlies�?) or download the release candidate here (zip). Please post to the Alpha/Beta [&#8230;]";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:12:"Andrew Nacin";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:40:"http://purl.org/rss/1.0/modules/content/";a:1:{s:7:"encoded";a:1:{i:0;a:5:{s:4:"data";s:1183:"<p>The second release candidate of WordPress 3.7 is now available for testing!</p>\n<p>Those of you already testing WordPress 3.7 will be updated automatically to RC2. (<em>Nice.</em>) If you&#8217;d like to start testing, there&#8217;s no time like the present! Try the <a href="http://wordpress.org/extend/plugins/wordpress-beta-tester/">WordPress Beta Tester</a> plugin (you’ll want “bleeding edge nightlies�?) or <a href="http://wordpress.org/wordpress-3.7-RC2.zip">download the release candidate here</a> (zip). Please post to the <a href="http://wordpress.org/support/forum/alphabeta/">Alpha/Beta area in the support forums</a> if you think you&#8217;ve found a bug, and if any known issues are raised, you’ll be able to <a href="http://core.trac.wordpress.org/report/5">find them here</a>.</p>\n<p>Developers, please test your plugins and themes against WordPress 3.7. If there is a compatibility issue, let us know as soon as possible so we can deal with it before the final release.</p>\n<p>For more on WordPress 3.7, check out the <a href="http://wordpress.org/news/2013/10/wordpress-3-7-release-candidate/">announcement post for Release Candidate 1</a>.</p>\n";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:36:"http://wellformedweb.org/CommentAPI/";a:1:{s:10:"commentRss";a:1:{i:0;a:5:{s:4:"data";s:73:"http://wordpress.org/news/2013/10/wordpress-3-7-release-candidate-2/feed/";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:38:"http://purl.org/rss/1.0/modules/slash/";a:1:{s:8:"comments";a:1:{i:0;a:5:{s:4:"data";s:1:"0";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:8;a:6:{s:4:"data";s:45:"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:5:{s:0:"";a:7:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:18:"Upcoming WordCamps";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:55:"http://wordpress.org/news/2013/10/upcoming-wordcamps-4/";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:8:"comments";a:1:{i:0;a:5:{s:4:"data";s:64:"http://wordpress.org/news/2013/10/upcoming-wordcamps-4/#comments";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Tue, 22 Oct 2013 19:25:26 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:8:"category";a:2:{i:0;a:5:{s:4:"data";s:9:"Community";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}i:1;a:5:{s:4:"data";s:8:"WordCamp";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:33:"http://wordpress.org/news/?p=2723";s:7:"attribs";a:1:{s:0:"";a:1:{s:11:"isPermaLink";s:5:"false";}}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:368:"WordCamps are casual, locally-organized conferences that celebrate everything related to WordPress, and are a great opportunity to meet other WordPress users and professionals in your community. This has been a great year for WordCamps &#8212; there have been 56 so far in more than 20 countries, and there another 15 on the calendar before the year&#8217;s [&#8230;]";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:8:"Jen Mylo";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:40:"http://purl.org/rss/1.0/modules/content/";a:1:{s:7:"encoded";a:1:{i:0;a:5:{s:4:"data";s:3584:"<p><a href="http://central.wordcamp.org/">WordCamps</a> are casual, locally-organized conferences that celebrate everything related to WordPress, and are a great opportunity to meet other WordPress users and professionals in your community. This has been a great year for WordCamps &#8212; there have been 56 so far in more than 20 countries, and there another 15 on the calendar before the year&#8217;s over. If there&#8217;s one near you, check it out! In addition to getting to know your local WordPress community, most WordCamps attract some traveling visitors a well, giving you the chance to meet contributors to the WordPress open source project and <a href="http://make.wordpress.org/">get involved</a> yourself.</p>\n<p>Here are the WordCamps on the schedule for the rest of this year.</p>\n<p>October 25-27: <strong><a href="http://2013.boston.wordcamp.org/">WordCamp Boston</a></strong>, Boston, MA, USA<br />\nOctober 25-26: <strong><a href="http://2013.malaga.wordcamp.org/">WordCamp Malaga</a></strong>, Spain<br />\nOctober 26: <strong><a href="http://2013.nepal.wordcamp.org/">WordCamp Nepal</a></strong>, Kathmandu, Nepal<br />\nOctober 26: <strong><a href="http://2013.sofia.wordcamp.org/">WordCamp Sofia</a></strong>, Bulgaria<br />\nNovember 7: <strong><a href="http://2013.capetown.wordcamp.org/">WordCamp Cape Town</a></strong>, South Africa<br />\nNovember 9: <strong><a href="http://2013.porto.wordcamp.org/">WordCamp Porto</a></strong>, Portugal<br />\nNovember 9-10: <strong><a href="http://2013.kenya.wordcamp.org/">WordCamp Kenya</a></strong>, Nairobi, Kenya<br />\nNovember 15: <strong><a href="http://2013.edmonton.wordcamp.org/">WordCamp Edmonton</a></strong>, AB, Canada<br />\nNovember 16-17: <strong><a href="http://2013.orlando.wordcamp.org/">WordCamp Orlando</a></strong>, FL, USA<br />\nNovember 16: <strong><a href="http://2013.denver.wordcamp.org/">WordCamp Denver</a></strong>, CO, USA<br />\nNovember 23-24: <strong><a href="http://2013.london.wordcamp.org/">WordCamp London</a></strong>, UK<br />\nNovember 23-24: <strong><a href="http://2013.raleigh.wordcamp.org/">WordCamp Raleigh</a></strong>, NC, USA<br />\nNovember 23: <strong><a href="http://2013.saopaulo.wordcamp.org/">WordCamp São Paulo</a></strong>, Brazil<br />\nDecember 14: <strong><a href="http://2013.vegas.wordcamp.org/">WordCamp Las Vegas</a></strong>, NV, USA<br />\nDecember 14-15: <strong><a href="http://2013.sevilla.wordcamp.org/">WordCamp Sevilla</a></strong>, Spain</p>\n<p>No WordCamps on this list in your area? Not to worry! There are thriving <a href="http://wordpress.meetup.com/">WordPress meetups</a> all over the world where you can meet like-minded people, and we maintain a library of <a href="http://wordpress.tv/category/wordcamptv/">WordCamp videos</a> at <a href="http://wordpress.tv/">WordPress.tv</a>.</p>\n<h3>Get Involved</h3>\n<ul>\n<li>If you&#8217;re interested in organizing a WordCamp in your area, check out our <a href="http://plan.wordcamp.org/">WordCamp planning</a> site.</li>\n<li>If you&#8217;re interested in <a href="http://make.wordpress.org/community/meetup-interest-form/">starting a WordPress meetup</a> in your area, let us know and we can set up a group on meetup.com for you.</li>\n<li>And speaking of WordCamp videos, we&#8217;ve recently enabled volunteer-generated subtitles/closed captioning of the videos on WordPress.tv to make them more accessible. Interested in helping? Check out the <a href="http://wordpress.tv/using-amara-org-to-caption-or-subtitle-a-wordpress-tv-video/">WordPress.tv subtitling instructions</a>.</li>\n</ul>\n";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:36:"http://wellformedweb.org/CommentAPI/";a:1:{s:10:"commentRss";a:1:{i:0;a:5:{s:4:"data";s:60:"http://wordpress.org/news/2013/10/upcoming-wordcamps-4/feed/";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:38:"http://purl.org/rss/1.0/modules/slash/";a:1:{s:8:"comments";a:1:{i:0;a:5:{s:4:"data";s:1:"0";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:9;a:6:{s:4:"data";s:45:"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:5:{s:0:"";a:7:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:31:"WordPress 3.7 Release Candidate";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:66:"http://wordpress.org/news/2013/10/wordpress-3-7-release-candidate/";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:8:"comments";a:1:{i:0;a:5:{s:4:"data";s:75:"http://wordpress.org/news/2013/10/wordpress-3-7-release-candidate/#comments";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Fri, 18 Oct 2013 19:52:14 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:8:"category";a:2:{i:0;a:5:{s:4:"data";s:11:"Development";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}i:1;a:5:{s:4:"data";s:8:"Releases";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:33:"http://wordpress.org/news/?p=2718";s:7:"attribs";a:1:{s:0:"";a:1:{s:11:"isPermaLink";s:5:"false";}}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:331:"The first release candidate for WordPress 3.7 is now available! In RC 1, we&#8217;ve made some adjustments to the update process to make it more reliable than ever. We hope to ship WordPress 3.7 next week, but we need your help to get there. If you haven’t tested 3.7 yet, there’s no time like the present. (Please, [&#8230;]";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:12:"Andrew Nacin";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:40:"http://purl.org/rss/1.0/modules/content/";a:1:{s:7:"encoded";a:1:{i:0;a:5:{s:4:"data";s:2274:"<p>The first release candidate for WordPress 3.7 is now available!</p>\n<p>In RC 1, we&#8217;ve made some adjustments to the update process to make it more reliable than ever. We hope to ship WordPress 3.7 <em>next week</em>, but we need your help to get there. If you haven’t tested 3.7 yet, there’s no time like the present. (Please, not on a production site, unless you’re adventurous.)</p>\n<p>WordPress 3.7 introduces <strong>automatic background updates</strong> for security and minor releases (like updating from 3.7 to 3.7.1). These are really easy to test  — RC 1 will update every 12 hours or so to the latest development version, and then email you the results. (You may get two emails: one for debugging, and one all users of 3.7 will receive.) If something went wrong, you can report it.</p>\n<p><strong>Think you’ve found a bug? </strong>Please post to the <a href="http://wordpress.org/support/forum/alphabeta/">Alpha/Beta area in the support forums</a>. If any known issues come up, you’ll be able to <a href="http://core.trac.wordpress.org/report/5">find them here</a>.</p>\n<p>To test WordPress 3.7 RC1, try the <a href="http://wordpress.org/extend/plugins/wordpress-beta-tester/">WordPress Beta Tester</a> plugin (you’ll want “bleeding edge nightlies�?). Or you can <a href="http://wordpress.org/wordpress-3.7-RC1.zip">download the release candidate here</a> (zip). If you’d like to learn more about what&#8217;s new in WordPress 3.7, visit the awesome About screen in your dashboard (<strong><img alt="" src="http://i0.wp.com/core.svn.wordpress.org/branches/3.6/wp-content/themes/twentyten/images/wordpress.png?w=692" data-recalc-dims="1" /> → About</strong> in the toolbar). There, you can also see if your install is eligible for background updates. WordPress won’t automatically update, for example, if you’re using version control like Subversion or Git.</p>\n<p><strong>Developers,</strong> please test your plugins and themes against WordPress 3.7, so that if there is a compatibility issue, we can figure it out before the final release. Make sure you post any issues to the support forums.</p>\n<p><em>WordPress three seven</em><br />\n<em>A self-updating engine</em><br />\n<em>Lies beneath the hood</em></p>\n";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:36:"http://wellformedweb.org/CommentAPI/";a:1:{s:10:"commentRss";a:1:{i:0;a:5:{s:4:"data";s:71:"http://wordpress.org/news/2013/10/wordpress-3-7-release-candidate/feed/";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:38:"http://purl.org/rss/1.0/modules/slash/";a:1:{s:8:"comments";a:1:{i:0;a:5:{s:4:"data";s:1:"0";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}}}s:27:"http://www.w3.org/2005/Atom";a:1:{s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:0:"";s:7:"attribs";a:1:{s:0:"";a:3:{s:4:"href";s:31:"http://wordpress.org/news/feed/";s:3:"rel";s:4:"self";s:4:"type";s:19:"application/rss+xml";}}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:44:"http://purl.org/rss/1.0/modules/syndication/";a:2:{s:12:"updatePeriod";a:1:{i:0;a:5:{s:4:"data";s:6:"hourly";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:15:"updateFrequency";a:1:{i:0;a:5:{s:4:"data";s:1:"1";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}}}}}}}}s:4:"type";i:128;s:7:"headers";a:10:{s:3:"via";s:11:"1.1 ARM-005";s:10:"connection";s:5:"close";s:16:"proxy-connection";s:5:"close";s:4:"date";s:29:"Tue, 25 Feb 2014 04:08:55 GMT";s:12:"content-type";s:23:"text/xml; charset=UTF-8";s:6:"server";s:5:"nginx";s:4:"vary";s:15:"Accept-Encoding";s:10:"x-pingback";s:36:"http://wordpress.org/news/xmlrpc.php";s:13:"last-modified";s:29:"Thu, 23 Jan 2014 20:54:06 GMT";s:4:"x-nc";s:11:"HIT lax 250";}s:5:"build";s:14:"20130910223210";}', 'no');
INSERT INTO `goStores_Vista_wp_options` (`option_id`, `option_name`, `option_value`, `autoload`) VALUES
(151, '_transient_timeout_feed_mod_867bd5c64f85878d03a060509cd2f92c', '1393344308', 'no'),
(152, '_transient_feed_mod_867bd5c64f85878d03a060509cd2f92c', '1393301108', 'no'),
(157, '_transient_timeout_dash_4077549d03da2e451c8b5f002294ff51', '1393344309', 'no'),
(158, '_transient_dash_4077549d03da2e451c8b5f002294ff51', '<div class="rss-widget"><ul><li><a class=''rsswidget'' href=''http://wordpress.org/news/2014/01/wordpress-3-8-1/'' title=''After six weeks and more than 9.3 million downloads of WordPress 3.8, we’re pleased to announce WordPress 3.8.1 is now available. Version 3.8.1 is a maintenance releases that addresses 31 bugs in 3.8, including various fixes and improvements for the new dashboard design and new themes admin screen. An issue with taxonomy queries in WP_Query […]''>WordPress 3.8.1 Maintenance Release</a> <span class="rss-date">January 23, 2014</span><div class=''rssSummary''>After six weeks and more than 9.3 million downloads of WordPress 3.8, we’re pleased to announce WordPress 3.8.1 is now available. Version 3.8.1 is a maintenance releases that addresses 31 bugs in 3.8, including various fixes and improvements for the new dashboard design and new themes admin screen. An issue with taxonomy queries in WP_Query […]</div></li></ul></div><div class="rss-widget"><ul><li><a class=''rsswidget'' href=''http://wptavern.com/hexa-a-free-colorful-wordpress-theme-highlighting-post-formats?utm_source=rss&#038;utm_medium=rss&#038;utm_campaign=hexa-a-free-colorful-wordpress-theme-highlighting-post-formats'' title=''The latest trend in WordPress blogging themes is to put post formats on center stage with a colorful palette selected to highlight the variety of content. Hexa is a beautiful new example of this trend in action. The theme launched last week on WordPress.com and hit WordPress.org over the weekend.  Named for the geometric shapes used throughout the theme, Hexa connects each post to the next with a colorful line extending from the hexagonal icon designated for each. This bright, geometric design is perfect for crystallizing your thoughts into structured posts. Big Featured Images One of the distinguishing features of this design is the large (842 pixels wide) featured image area above posts, as seen on the index and archive pages. If you’re switching to Hexa, appropriately-sized featured images are something important to consider. However, you can always regenerate thumbnails. Hidden Extras  Hexa keeps its three widget areas neatly out of site with a unique pull down section, activated by the corresponding icon in the header. The icon menu in the header also pulls down a hidden search bar, navigation and social icons. Anything peripheral to the content is kept out of sight unless opened by the visitor. Custom Header, Background and Menu Hexa’s customization options are built into WordPress’ native customizer. You can add your own header or background image. The theme has support for one custom menu and its design matches the color palette:  Check out the Hexa demo to see this theme in action. Self-hosted WordPress sites can download Hexa for free via the “Add New�? theme menu. If you like Hexa, you may also be interested in Sorbet, another theme with a similar structure for widgets, post formats and social links.''>WPTavern: Hexa: A Free Colorful WordPress Theme Highlighting Post Formats</a></li><li><a class=''rsswidget'' href=''http://wordpress.tv/2014/02/24/hanni-ros-being-part-of-wordpress/'' title=''    ''>WordPress.tv: Hanni Ros: Being Part of WordPress</a></li><li><a class=''rsswidget'' href=''http://ma.tt/2014/02/whatsapp-takeaway/'' title=''For better or worse, a great deal of investment in technology is driven by pattern matching. In that world any company (including Automattic) that generally eschews hype, is largely subscription driven, and has a small number of employees relative to its audience should be thrilled at the 19 billion dollar acquisition of WhatsApp. The deal is incredible. This has kicked off another round of pattern matching and halo effects, which are currently incredibly favorable but will evolve over the coming years based on how things go post-integration, just like the public perceptions of Geocities, Youtube, Doubleclick, Bebo, and Skype wildly shifted based largely on the press coverage over their latest traded value. I’m thrilled with the outcome for WhatsApp and the manner in which they built their company, their product, and I hope they bring more of that thinking to Facebook, but I don’t think they should become a playbook any more than Instagram should inspire a no-revenue playbook. The pattern we should take away from this story is that there is no pattern. (In Perl, “there’s more than one way to do it�? or Tim Toady.) As an entrepreneur making decisions for your company, always go back to your first principles of what’s important to you and why you started in the first place. As a journalist, try not to fit everyone into arcs you’ve seen before or ascribe value to previous coverage (or lack of coverage). As an investor try to evaluate every situation on its unique merits. Should founders be CEOs or not? Well, it depends on the founders, the company, and what it means to be CEO, not what an over-normalized sample of a few hundred companies did before in completely different contexts. There are also products that succeed with design that seems childish or terrible on the surface (Myspace, eBay, Snapchat). A lot of what it comes down to is have you made something people want, and are they finding out about it from their friends. That’s often the realm people think of as marketing. The best marketers in the world don’t fit our preconceptions of what that word means because they’re in hoodies instead of suits and create environments and ecosystems rather than the traditional trappings of marketing. Update: From @dsa, here’s a great follow-up read on Techcrunch: What Games Are: Flappy Bird, Patterns, And Context.''>Matt: WhatsApp Takeaway</a></li></ul></div><div class="rss-widget"><ul><li class=''dashboard-news-plugin''><span>Popular Plugin:</span> <a href=''http://wordpress.org/plugins/wordpress-importer/'' class=''dashboard-news-plugin-link''>WordPress Importer</a></h5>&nbsp;<span>(<a href=''plugin-install.php?tab=plugin-information&amp;plugin=wordpress-importer&amp;_wpnonce=1261a2484a&amp;TB_iframe=true&amp;width=600&amp;height=800'' class=''thickbox'' title=''WordPress Importer''>Install</a>)</span></li></ul></div>', 'no'),
(149, '_transient_timeout_feed_867bd5c64f85878d03a060509cd2f92c', '1393344308', 'no');
INSERT INTO `goStores_Vista_wp_options` (`option_id`, `option_name`, `option_value`, `autoload`) VALUES
(150, '_transient_feed_867bd5c64f85878d03a060509cd2f92c', 'a:4:{s:5:"child";a:1:{s:0:"";a:1:{s:3:"rss";a:1:{i:0;a:6:{s:4:"data";s:3:"\n\n\n";s:7:"attribs";a:1:{s:0:"";a:1:{s:7:"version";s:3:"2.0";}}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:1:{s:0:"";a:1:{s:7:"channel";a:1:{i:0;a:6:{s:4:"data";s:61:"\n	\n	\n	\n	\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:1:{s:0:"";a:5:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:16:"WordPress Planet";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:28:"http://planet.wordpress.org/";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:8:"language";a:1:{i:0;a:5:{s:4:"data";s:2:"en";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:47:"WordPress Planet - http://planet.wordpress.org/";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"item";a:50:{i:0;a:6:{s:4:"data";s:13:"\n	\n	\n	\n	\n	\n	\n";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:2:{s:0:"";a:5:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:73:"WPTavern: Hexa: A Free Colorful WordPress Theme Highlighting Post Formats";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:28:"http://wptavern.com/?p=17636";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:188:"http://wptavern.com/hexa-a-free-colorful-wordpress-theme-highlighting-post-formats?utm_source=rss&utm_medium=rss&utm_campaign=hexa-a-free-colorful-wordpress-theme-highlighting-post-formats";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:3546:"<p>The latest trend in WordPress blogging themes is to put post formats on center stage with a colorful palette selected to highlight the variety of content. <a href="http://wordpress.org/themes/hex" target="_blank">Hexa</a> is a beautiful new example of this trend in action. The theme <a href="https://en.blog.wordpress.com/2014/02/18/tuned-balloon-yumblog-lens-hexa-singl-hm-magazine/" target="_blank">launched</a> last week on WordPress.com and hit WordPress.org over the weekend.</p>\n<p><a href="http://wptavern.com/hexa-a-free-colorful-wordpress-theme-highlighting-post-formats/hexa" rel="attachment wp-att-17642"><img src="http://wptavern.com/wp-content/uploads/2014/02/hexa.png" alt="hexa" width="1024" height="768" class="aligncenter size-full wp-image-17642" /></a></p>\n<p>Named for the geometric shapes used throughout the theme, Hexa connects each post to the next with a colorful line extending from the hexagonal icon designated for each. This bright, geometric design is perfect for crystallizing your thoughts into structured posts.</p>\n<h3>Big Featured Images</h3>\n<p><a href="http://wptavern.com/hexa-a-free-colorful-wordpress-theme-highlighting-post-formats/hexa-featured" rel="attachment wp-att-17678"><img src="http://wptavern.com/wp-content/uploads/2014/02/hexa-featured.png" alt="hexa-featured" width="300" height="270" class="alignright size-full wp-image-17678" /></a>One of the distinguishing features of this design is the large (842 pixels wide) featured image area above posts, as seen on the index and archive pages.</p>\n<p>If you&#8217;re switching to Hexa, appropriately-sized featured images are something important to consider. However, you can always <a href="http://wordpress.org/plugins/regenerate-thumbnails/" target="_blank">regenerate thumbnails</a>.</p>\n<h3>Hidden Extras</h3>\n<p><a href="http://wptavern.com/hexa-a-free-colorful-wordpress-theme-highlighting-post-formats/widget-areas" rel="attachment wp-att-17681"><img src="http://wptavern.com/wp-content/uploads/2014/02/widget-areas-300x238.png" alt="widget-areas" width="300" height="238" class="alignleft size-medium wp-image-17681" /></a></p>\n<p>Hexa keeps its three widget areas neatly out of site with a unique pull down section, activated by the corresponding icon in the header.</p>\n<p>The icon menu in the header also pulls down a hidden search bar, navigation and social icons. Anything peripheral to the content is kept out of sight unless opened by the visitor.</p>\n<h3>Custom Header, Background and Menu</h3>\n<p>Hexa&#8217;s customization options are built into WordPress&#8217; native customizer. You can add your own header or background image. The theme has support for one custom menu and its design matches the color palette:</p>\n<p><a href="http://wptavern.com/hexa-a-free-colorful-wordpress-theme-highlighting-post-formats/hexa-menu-2" rel="attachment wp-att-17698"><img src="http://wptavern.com/wp-content/uploads/2014/02/hexa-menu.jpg" alt="hexa-menu" width="837" height="360" class="aligncenter size-full wp-image-17698" /></a></p>\n<p>Check out the <a href="http://hexademo.wordpress.com/">Hexa demo</a> to see this theme in action. Self-hosted WordPress sites can <a href="http://wordpress.org/themes/hex" target="_blank">download Hexa</a> for free via the &#8220;Add New&#8221; theme menu. If you like Hexa, you may also be interested in <a href="http://wptavern.com/sorbet-a-free-wordpress-theme-from-automattic" target="_blank">Sorbet</a>, another theme with a similar structure for widgets, post formats and social links.</p>";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Mon, 24 Feb 2014 23:14:53 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:13:"Sarah Gooding";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:1;a:6:{s:4:"data";s:13:"\n	\n	\n	\n	\n	\n	\n";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:2:{s:0:"";a:5:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:48:"WordPress.tv: Hanni Ros: Being Part of WordPress";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:28:"http://wordpress.tv/?p=31484";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:65:"http://wordpress.tv/2014/02/24/hanni-ros-being-part-of-wordpress/";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:689:"<div id="v-7vk9HmrD-1" class="video-player">\n</div><br />  <a rel="nofollow" href="http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/31484/"><img alt="" border="0" src="http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/31484/" /></a> <img alt="" border="0" src="http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=31484&subd=wptv&ref=&feed=1" width="1" height="1" /><div><a href="http://wordpress.tv/2014/02/24/hanni-ros-being-part-of-wordpress/"><img alt="wceu &#8211; Being Part of WordPress &#8211; Hanni Ross" src="http://videos.videopress.com/7vk9HmrD/wceu-being-part-of-wordpress-hanni-ross_std.original.jpg" width="160" height="120" /></a></div>";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Mon, 24 Feb 2014 18:11:24 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:12:"WordPress.tv";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:2;a:6:{s:4:"data";s:13:"\n	\n	\n	\n	\n	\n	\n";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:2:{s:0:"";a:5:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:23:"Matt: WhatsApp Takeaway";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:21:"http://ma.tt/?p=43494";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:39:"http://ma.tt/2014/02/whatsapp-takeaway/";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:3310:"<p><img class="alignright size-thumbnail wp-image-43496" src="http://i2.wp.com/s.ma.tt/files/2014/02/whatsapp.png?resize=195%2C195" alt="whatsapp" />For better or worse, a great deal of investment in technology is driven by <a href="http://cdixon.org/2012/03/07/the-problem-with-investing-based-on-pattern-recognition/">pattern matching</a>. In that world any company (including <a href="http://automattic.com/">Automattic</a>) that generally eschews hype, is largely subscription driven, and has a small number of employees relative to its audience should be thrilled at the <a href="http://recode.net/2014/02/19/facebook-price-for-having-no-phone-os-19-billion-a-must-have-apps-play-priceless/">19 billion dollar acquisition of WhatsApp</a>. The deal is incredible.</p>\n<p>This has kicked off another round of pattern matching and <a href="http://www.economist.com/node/14299211">halo effects</a>, which are currently incredibly favorable but will evolve over the coming years based on how things go post-integration, just like the public perceptions of Geocities, Youtube, Doubleclick, Bebo, and Skype wildly shifted based largely on the press coverage over their latest traded value.</p>\n<p>I&#8217;m thrilled with the outcome for <a href="http://www.whatsapp.com/">WhatsApp</a> and the manner in which they built their company, their product, and I hope they bring more of that thinking to Facebook, but I don&#8217;t think they should become a playbook any more than Instagram should inspire a no-revenue playbook. The pattern we should take away from this story is that <strong>there is no pattern</strong>. (In Perl, &#8220;<a href="http://www.perl.com/pub/1999/03/pm.html">there&#8217;s more than one way to do it</a>&#8221; or <a href="http://en.wikipedia.org/wiki/There''s_more_than_one_way_to_do_it">Tim Toady</a>.) As an entrepreneur making decisions for your company, always go back to your first principles of what&#8217;s important to you and why you started in the first place. As a journalist, try not to fit everyone into arcs you&#8217;ve seen before or ascribe value to previous coverage (or lack of coverage). As an investor try to evaluate every situation on its unique merits. Should founders be CEOs or not? Well, it depends on the founders, the company, and what it means to be CEO, not what an over-normalized sample of a few hundred companies did before in completely different contexts.</p>\n<p>There are also products that succeed with design that seems childish or terrible on the surface (Myspace, eBay, Snapchat). A lot of what it comes down to is <a href="http://paulgraham.com/good.html">have you made something people want</a>, and are they finding out about it from their friends. That&#8217;s often the realm people think of as marketing. The best marketers in the world don&#8217;t fit our preconceptions of what that word means because they&#8217;re in hoodies instead of suits and create environments and ecosystems rather than the traditional trappings of marketing.</p>\n<p><ins datetime="2014-02-24T19:09:19+00:00">Update: From <a href="https://twitter.com/dsa">@dsa</a>, here&#8217;s a great follow-up read on Techcrunch: <a href="http://techcrunch.com/2014/02/02/flappy-bird-patterns-and-context/">What Games Are: Flappy Bird, Patterns, And Context</a>.</ins></p>";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Mon, 24 Feb 2014 17:52:55 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:14:"Matt Mullenweg";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:3;a:6:{s:4:"data";s:13:"\n	\n	\n	\n	\n	\n	\n";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:2:{s:0:"";a:5:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:76:"WPTavern: Graph Paper Press Offers Customers WordPress Child Theme Generator";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:44:"http://wptavern.com?p=17549&preview_id=17549";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:196:"http://wptavern.com/graph-paper-press-offers-customers-wordpress-child-theme-generator?utm_source=rss&utm_medium=rss&utm_campaign=graph-paper-press-offers-customers-wordpress-child-theme-generator";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:4700:"<p>A child theme is defined in the <a title="https://codex.wordpress.org/Child_Themes" href="https://codex.wordpress.org/Child_Themes">WordPress codex</a> as a theme that inherits the functionality of another theme, called the parent theme. Child themes allow you to modify, or add to the functionality of that parent theme. A child theme is the safest and easiest way to modify an existing theme, whether you want to make a few tiny changes or extensive changes. Instead of modifying the theme files directly, you can create a child theme and override within.</p>\n<div id="attachment_17585" class="wp-caption aligncenter"><a href="http://wptavern.com/wp-content/uploads/2014/02/ChildThemeGeneratorFeaturedImage.png" rel="prettyphoto[17549]"><img class="size-large wp-image-17585" alt="Child theme Generator Featured Image" src="http://wptavern.com/wp-content/uploads/2014/02/ChildThemeGeneratorFeaturedImage-500x189.png" width="500" height="189" /></a><p class="wp-caption-text">photo credit: <a href="http://www.flickr.com/photos/tambako/3103173930/">Tambako the Jaguar</a> &#8211; <a href="http://creativecommons.org/licenses/by-nd/2.0/">cc</a></p></div>\n<p>Graph Paper Press has created a WordPress <a title="https://graphpaperpress.com/blog/wordpress-child-theme-generator-intro/" href="https://graphpaperpress.com/blog/wordpress-child-theme-generator-intro/">child theme generator</a> for their customers. Unfortunately, too many people make changes to their theme without using the child theme technique. If the theme is upgraded, the changes are usually lost. Graph Paper Press has an excellent explanation on why using child themes is important.</p>\n<blockquote><p>But Jake had spent hours and hours customizing the theme he downloaded and upgrading to the latest version would wipe out all of his changes.</p>\n<p>Jake was stuck. He could either upgrade his theme to the new version so he could take advantage of all the new features or stick with his older customized version. That’s not a place we want anyone to be in.</p></blockquote>\n<p>I&#8217;ve seen a lot of theme companies provide documentation explaining to customers how to create a child theme. Graph Paper Press on the other hand is the first company I&#8217;ve seen create a generator for their customers to use. This greatly decreases the chance a customer will create the child theme in the wrong way or place the files in the wrong location.</p>\n<p>To use <a title="http://graphpaperpress.com/wordpress-child-theme-generator/" href="http://graphpaperpress.com/wordpress-child-theme-generator/">the generator</a>, customers put the child theme name into the appropriate field and then select the parent theme. The advanced options show fields to add an author name, author URI, and a description. Once the fields have been filled, click the generate button. This produces a zip file to download.</p>\n<div id="attachment_17584" class="wp-caption aligncenter"><a href="http://wptavern.com/wp-content/uploads/2014/02/GraphPaperPressGenerator1.png" rel="prettyphoto[17549]"><img class="size-large wp-image-17584" alt="Step One Of The Generator" src="http://wptavern.com/wp-content/uploads/2014/02/GraphPaperPressGenerator1-500x282.png" width="500" height="282" /></a><p class="wp-caption-text">Step One Of The Generator</p></div>\n<p>The zip file contains a properly formatted <strong>style.css</strong> and <strong>functions.php</strong> file based on the names provided in the generator. CSS code added to the style.css file will override any styles defined within the parent theme. You can also add template files from the parent theme such as <strong>home.php</strong> and tweak them to your liking. Once you&#8217;re satisfied with the changes, upload and activate the theme in WordPress as you would with any other theme.</p>\n<h3>The Beginning Of A Trend?</h3>\n<p>Child themes are an easy way to make changes to themes without having to worry them being lost if the parent theme needs to be upgraded. They&#8217;re also a great way to organize changes made to a parent theme. This is a great move by Graph Paper Press and is something I&#8217;d like to see become standard with other commercial theme shops.</p>\n<p>Child plugins work on the same concept but are created and implemented differently. <a title="http://wptavern.com/how-to-extend-a-wordpress-plugin-without-losing-your-changes" href="http://wptavern.com/how-to-extend-a-wordpress-plugin-without-losing-your-changes">Read our guide</a> to learn how to create a child plugin.</p>\n<p><strong>Do you know of other commercial WordPress theme companies that offer their customers a child theme generator? If so, let me know about them in the comments.</strong></p>";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Mon, 24 Feb 2014 17:00:41 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:13:"Jeff Chandler";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:4;a:6:{s:4:"data";s:13:"\n	\n	\n	\n	\n	\n	\n";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:2:{s:0:"";a:5:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:76:"WPTavern: Give All Editors In WordPress A New Look With The WP Editor Plugin";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:28:"http://wptavern.com/?p=17522";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:196:"http://wptavern.com/give-all-editors-in-wordpress-a-new-look-with-the-wp-editor-plugin?utm_source=rss&utm_medium=rss&utm_campaign=give-all-editors-in-wordpress-a-new-look-with-the-wp-editor-plugin";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:4874:"<p><a title="http://wordpress.org/plugins/wp-editor/" href="http://wordpress.org/plugins/wp-editor/">WP Editor</a> is a free WordPress plugin developed by <a title="http://profiles.wordpress.org/benjaminprojas/" href="http://profiles.wordpress.org/benjaminprojas/">Benjamin Projas.</a> It replaces the default<strong> plugin, theme, post, and page</strong> editors and is integrated with <a title="http://codemirror.net/" href="http://codemirror.net/">CodeMirror</a> and <a title="http://fancybox.net/" href="http://fancybox.net/">Fancybox</a>. By integrating these two technologies, the editor resembles an environment coders will be familiar with.</p>\n<p>The first thing I noticed when writing my first post with the plugin enabled was the inability to use the <strong>TAB key</strong> to move to the next line. I had to manually click inside the editor window to begin writing my post. I found out this plugin only manipulates the Text or HTML version of the editor. At first, I thought the editor-style.css file that&#8217;s part of Stargazer was overriding WP Post Editor. However, after I switched themes, I determined WP Editor doesn&#8217;t alter the Visual editor in any way.</p>\n<div id="attachment_17591" class="wp-caption aligncenter"><a href="http://wptavern.com/wp-content/uploads/2014/02/WPPostEditor1.png" rel="prettyphoto[17522]"><img class="size-large wp-image-17591" alt="WordPress Text Editor Using Lesser Dark Theme" src="http://wptavern.com/wp-content/uploads/2014/02/WPPostEditor1-500x169.png" width="500" height="169" /></a><p class="wp-caption-text">WordPress Text Editor Using Lesser Dark Theme</p></div>\n<p>The settings page contains five different sections: <strong>Main settings, Theme Editor, Plugin Editor, Post Editor, and Overview</strong>. They&#8217;re self-explanatory but you&#8217;ll want to visit the main settings page first. By default, WP Post Editor hides the WordPress version of the theme and plugin editor links and will load the WP Editor version of the theme and plugin editors. You can turn them back on from the main settings page.</p>\n<div id="attachment_17592" class="wp-caption aligncenter"><a href="http://wptavern.com/wp-content/uploads/2014/02/WPPostEditor2.png" rel="prettyphoto[17522]"><img class="size-large wp-image-17592" alt="WP Post Editor Main Settings" src="http://wptavern.com/wp-content/uploads/2014/02/WPPostEditor2-500x364.png" width="500" height="364" /></a><p class="wp-caption-text">WP Post Editor Main Settings</p></div>\n<p>WP Post Editor ships with twelve different themes. I&#8217;ve been looking for a way to darken the post editor and this plugin accomplishes that by offering twelve different themes. The downside to using this plugin is that each registered user who has access to the post editor will see the WP Post Editor version. It would be great if the editor and themes could be tied to users, perhaps through their profile. Also, depending on the post editor theme selected, some colors are hard to see.</p>\n<div id="attachment_17593" class="wp-caption aligncenter"><a href="http://wptavern.com/wp-content/uploads/2014/02/WPPostEditor3.png" rel="prettyphoto[17522]"><img class="size-large wp-image-17593" alt="Some Colors Hard To See " src="http://wptavern.com/wp-content/uploads/2014/02/WPPostEditor3-500x259.png" width="500" height="259" /></a><p class="wp-caption-text">Some Colors Hard To See</p></div>\n<p>The strength of this plugin lies within the plugin and theme editors. WP Post Editor has built-in support for file uploading. This is a killer feature because it enables files to be uploaded without the use of FTP. Uploading files is quick and painless. The code within the editor is a step up from what WordPress offers out of the box. It&#8217;s color coded and features line numbers. You can also download the file or the entire plugin from within the editor.</p>\n<div id="attachment_17594" class="wp-caption aligncenter"><a href="http://wptavern.com/wp-content/uploads/2014/02/WPPostEditor4.png" rel="prettyphoto[17522]"><img class="size-large wp-image-17594" alt="WP Editor Version Of The Plugin Editor" src="http://wptavern.com/wp-content/uploads/2014/02/WPPostEditor4-500x211.png" width="500" height="211" /></a><p class="wp-caption-text">WP Editor Version Of The Plugin Editor</p></div>\n<h3>Nice Plugin But Doesn&#8217;t Solve My Problem</h3>\n<p>Overall, WP Editor is a neat plugin containing a myriad of options to change the look and feel of each editor in WordPress. Since I&#8217;ve grown accustomed to the visual editor, thanks in large part to the use of <a title="https://codex.wordpress.org/Editor_Style" href="https://codex.wordpress.org/Editor_Style">style-editor.css</a>, I don&#8217;t see myself using this plugin in the future. My search for a plugin that changes the post editor to a darker background color without it being a global change continues.</p>";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Mon, 24 Feb 2014 14:00:10 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:13:"Jeff Chandler";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:5;a:6:{s:4:"data";s:13:"\n	\n	\n	\n	\n	\n	\n";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:2:{s:0:"";a:5:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:59:"WordPress.tv: Stanko Metodiev: WordPress – From the Start";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:28:"http://wordpress.tv/?p=30759";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:72:"http://wordpress.tv/2014/02/24/stanko-metodiev-wordpress-from-the-start/";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:669:"<div id="v-Cx5HOJqA-1" class="video-player">\n</div><br />  <a rel="nofollow" href="http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/30759/"><img alt="" border="0" src="http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/30759/" /></a> <img alt="" border="0" src="http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=30759&subd=wptv&ref=&feed=1" width="1" height="1" /><div><a href="http://wordpress.tv/2014/02/24/stanko-metodiev-wordpress-from-the-start/"><img alt="Stanko Metodiev: WordPress – From the Start" src="http://videos.videopress.com/Cx5HOJqA/video-11b80cfce2_scruberthumbnail_0.jpg" width="160" height="120" /></a></div>";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Mon, 24 Feb 2014 12:29:02 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:12:"WordPress.tv";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:6;a:6:{s:4:"data";s:13:"\n	\n	\n	\n	\n	\n	\n";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:2:{s:0:"";a:5:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:124:"WordPress.tv: Ruth Carter: Blogging And Social Media Horror Stories From The Legal Trenches (And How To Avoid The Same Fate)";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:28:"http://wordpress.tv/?p=31454";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:139:"http://wordpress.tv/2014/02/24/ruth-carter-blogging-and-social-media-horror-stories-from-the-legal-trenches-and-how-to-avoid-the-same-fate/";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:795:"<div id="v-oOq9iMVj-1" class="video-player">\n</div><br />  <a rel="nofollow" href="http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/31454/"><img alt="" border="0" src="http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/31454/" /></a> <img alt="" border="0" src="http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=31454&subd=wptv&ref=&feed=1" width="1" height="1" /><div><a href="http://wordpress.tv/2014/02/24/ruth-carter-blogging-and-social-media-horror-stories-from-the-legal-trenches-and-how-to-avoid-the-same-fate/"><img alt="Ruth Carter: Blogging And Social Media Horror Stories From The Legal Trenches (And How To Avoid The Same Fate)" src="http://videos.videopress.com/oOq9iMVj/video-c48f03d387_std.original.jpg" width="160" height="120" /></a></div>";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Mon, 24 Feb 2014 09:27:31 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:12:"WordPress.tv";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:7;a:6:{s:4:"data";s:13:"\n	\n	\n	\n	\n	\n	\n";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:2:{s:0:"";a:5:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:63:"WPTavern: Big Performance Improvements Coming in BuddyPress 2.0";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:28:"http://wptavern.com/?p=17571";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:170:"http://wptavern.com/big-performance-improvements-coming-to-buddypress-2-0?utm_source=rss&utm_medium=rss&utm_campaign=big-performance-improvements-coming-to-buddypress-2-0";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:3920:"<p>BuddyPress 2.0, due sometime in mid-April, officially <a href="http://wptavern.com/buddypress-2-0-development-kicks-off-today-release-set-for-mid-april" target="_blank">kicked off development</a> a couple weeks ago. This release will include some exciting, visible new features, including the ability to <a href="http://wptavern.com/buddypress-2-0-to-add-profile-editing-in-the-wordpress-admin" target="_blank">edit BuddyPress profiles in the WordPress admin</a>. But there are also some major improvements happening under the hood that will help BuddyPress to scale better in the near future.</p>\n<p>Moving the user &#8216;last_activity&#8217; data out of the wp_usermeta table has been a on the <a href="https://buddypress.trac.wordpress.org/milestone/2.0">roadmap</a> for awhile, but what does that really mean and who will it affect?</p>\n<p>The &#8216;last_activity&#8217; data is what you see displayed on user profiles:</p>\n<p><a href="http://wptavern.com/big-performance-improvements-coming-to-buddypress-2-0/last-active" rel="attachment wp-att-17575"><img src="http://wptavern.com/wp-content/uploads/2014/02/last-active.jpg" alt="last-active" width="543" height="330" class="aligncenter size-full wp-image-17575" /></a></p>\n<p>This data is also used within BuddyPress to sort results and to determine whether a user is a valid site member. In an <a href="http://bpdevel.wordpress.com/2014/02/21/user-last_activity-data-and-buddypress-2-0/" target="_blank">update</a> last week, BuddyPress core developer Boone Gorges explained why the issue has developed into what he calls &#8220;a perennial performance bottleneck&#8221;:</p>\n<blockquote><p>In the case of users, the information was stored in wp_usermeta. This table gets exceptionally bloated on busy sites, and it’s not properly indexed for the sorts of ORDER BY queries we were performing on it.</p></blockquote>\n<p>Gorges put <a href="https://buddypress.trac.wordpress.org/changeset/7860" target="_blank">a fix</a> in place to address the issue. BuddyPress 2.0 will now store user last_activity data in its own row within the wp_bp_activity table, even if the site has the Activity component disabled. <strong>&#8220;The performance improvements are pretty extreme,&#8221;</strong> Gorges said and promised to post benchmarks as development for BuddyPress 2.0 approaches release.</p>\n<p>When applying the <a href="https://buddypress.trac.wordpress.org/ticket/5128#comment:7" target="_blank">first patch</a> to the issue, Gorges shared a few preliminary metrics that should give you an idea of the performance improvements in this fix:</p>\n<blockquote><p>Basically, the main query went from about 57ms to .3ms. Roughly two orders of magnitude improvement. This will become more dramatic on larger sites (usermeta&#8217;s performance will degrade in a greater-than-linear fashion), especially where usermeta is filled with lots of other junk from other plugins.</p></blockquote>\n<p>&#8216;Last_activty&#8217; data will be indefinitely mirrored in both the old and new locations in order to maintain backwards compatibility with plugins. However, plugin authors are encouraged to update their extensions to get data via the BuddyPress API functions instead of the old method. Gorges offers an example in his <a href="http://bpdevel.wordpress.com/2014/02/21/user-last_activity-data-and-buddypress-2-0/" target="_blank">update</a> and lists a few plugins from the WordPress Plugin Directory that will need to be updated.</p>\n<p>Plugin developers who want to take advantage of these performance improvements have plenty of time to prepare an updated version to have on deck to coincide with the 2.0 release. Leave a comment on the <a href="http://bpdevel.wordpress.com/2014/02/21/user-last_activity-data-and-buddypress-2-0/" target="_blank">BuddyPress Development blog</a> if you have any questions regarding the changes or need help updating your code.</p>";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Mon, 24 Feb 2014 02:52:22 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:13:"Sarah Gooding";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:8;a:6:{s:4:"data";s:13:"\n	\n	\n	\n	\n	\n	\n";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:2:{s:0:"";a:5:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:78:"WordPress.tv: Hristo Chakarov: Choosing The Right JS Framework/Library/Toolkit";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:28:"http://wordpress.tv/?p=30009";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:93:"http://wordpress.tv/2014/02/23/hristo-chakarov-choosing-the-right-js-frameworklibrarytoolkit/";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:709:"<div id="v-sMrd09RR-1" class="video-player">\n</div><br />  <a rel="nofollow" href="http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/30009/"><img alt="" border="0" src="http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/30009/" /></a> <img alt="" border="0" src="http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=30009&subd=wptv&ref=&feed=1" width="1" height="1" /><div><a href="http://wordpress.tv/2014/02/23/hristo-chakarov-choosing-the-right-js-frameworklibrarytoolkit/"><img alt="Hristo Chakarov: Choosing The Right JS Framework/Library/Toolkit" src="http://videos.videopress.com/sMrd09RR/video-3c40dea0d5_scruberthumbnail_0.jpg" width="160" height="120" /></a></div>";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Mon, 24 Feb 2014 00:40:14 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:12:"WordPress.tv";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:9;a:6:{s:4:"data";s:13:"\n	\n	\n	\n	\n	\n	\n";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:2:{s:0:"";a:5:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:54:"WordPress.tv: Mario Peshev: Choosing A WordPress Theme";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:28:"http://wordpress.tv/?p=30757";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:71:"http://wordpress.tv/2014/02/23/mario-peshev-choosing-a-wordpress-theme/";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:663:"<div id="v-6WOFeiny-1" class="video-player">\n</div><br />  <a rel="nofollow" href="http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/30757/"><img alt="" border="0" src="http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/30757/" /></a> <img alt="" border="0" src="http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=30757&subd=wptv&ref=&feed=1" width="1" height="1" /><div><a href="http://wordpress.tv/2014/02/23/mario-peshev-choosing-a-wordpress-theme/"><img alt="Mario Peshev: Choosing A WordPress Theme" src="http://videos.videopress.com/6WOFeiny/video-5d02f93ec2_scruberthumbnail_0.jpg" width="160" height="120" /></a></div>";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Mon, 24 Feb 2014 00:37:31 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:12:"WordPress.tv";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:10;a:6:{s:4:"data";s:13:"\n	\n	\n	\n	\n	\n	\n";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:2:{s:0:"";a:5:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:37:"WordPress.tv: Matt Mullenweg: Q&amp;A";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:28:"http://wordpress.tv/?p=31487";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:49:"http://wordpress.tv/2014/02/23/matt-mullenweg-qa/";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:617:"<div id="v-ylQ5fY3a-1" class="video-player">\n</div><br />  <a rel="nofollow" href="http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/31487/"><img alt="" border="0" src="http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/31487/" /></a> <img alt="" border="0" src="http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=31487&subd=wptv&ref=&feed=1" width="1" height="1" /><div><a href="http://wordpress.tv/2014/02/23/matt-mullenweg-qa/"><img alt="wceu-MattMullenweg1" src="http://videos.videopress.com/ylQ5fY3a/wceu-mattmullenweg1_std.original.jpg" width="160" height="120" /></a></div>";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Sun, 23 Feb 2014 22:15:29 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:12:"WordPress.tv";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:11;a:6:{s:4:"data";s:13:"\n	\n	\n	\n	\n	\n	\n";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:2:{s:0:"";a:5:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:37:"WordPress.tv: Svetlin Nakov: WPdotNet";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:28:"http://wordpress.tv/?p=30751";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:54:"http://wordpress.tv/2014/02/22/svetlin-nakov-wpdotnet/";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:629:"<div id="v-nCBqjMkC-1" class="video-player">\n</div><br />  <a rel="nofollow" href="http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/30751/"><img alt="" border="0" src="http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/30751/" /></a> <img alt="" border="0" src="http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=30751&subd=wptv&ref=&feed=1" width="1" height="1" /><div><a href="http://wordpress.tv/2014/02/22/svetlin-nakov-wpdotnet/"><img alt="Svetlin Nakov: WPdotNet" src="http://videos.videopress.com/nCBqjMkC/video-e2499272cd_scruberthumbnail_0.jpg" width="160" height="120" /></a></div>";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Sun, 23 Feb 2014 00:34:51 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:12:"WordPress.tv";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:12;a:6:{s:4:"data";s:13:"\n	\n	\n	\n	\n	\n	\n";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:2:{s:0:"";a:5:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:82:"WordPress.tv: Hristo Pandjarov: How To Make WordPress Life Easier Using The WP-CLI";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:28:"http://wordpress.tv/?p=30735";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:99:"http://wordpress.tv/2014/02/22/hristo-pandjarov-how-to-make-wordpress-life-easier-using-the-wp-cli/";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:719:"<div id="v-YpiB74jL-1" class="video-player">\n</div><br />  <a rel="nofollow" href="http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/30735/"><img alt="" border="0" src="http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/30735/" /></a> <img alt="" border="0" src="http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=30735&subd=wptv&ref=&feed=1" width="1" height="1" /><div><a href="http://wordpress.tv/2014/02/22/hristo-pandjarov-how-to-make-wordpress-life-easier-using-the-wp-cli/"><img alt="Hristo Pandjarov: How To Make WordPress Life Easier Using The WP-CLI" src="http://videos.videopress.com/YpiB74jL/video-a8d3921fd8_scruberthumbnail_0.jpg" width="160" height="120" /></a></div>";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Sun, 23 Feb 2014 00:26:41 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:12:"WordPress.tv";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:13;a:6:{s:4:"data";s:13:"\n	\n	\n	\n	\n	\n	\n";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:2:{s:0:"";a:5:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:86:"WPTavern: WPWeekly Episode 139 – Interview With Chris Wallace Co-Founder Of UpThemes";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:44:"http://wptavern.com?p=17578&preview_id=17578";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:208:"http://wptavern.com/wpweekly-episode-139-interview-with-chris-wallace-co-founder-of-upthemes?utm_source=rss&utm_medium=rss&utm_campaign=wpweekly-episode-139-interview-with-chris-wallace-co-founder-of-upthemes";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:4171:"<p>In this episode, <a title="http://www.marcuscouch.com/" href="http://www.marcuscouch.com/">Marcus Couch</a> and I sat down with Chris Wallace, co-founder of <a title="https://upthemes.com" href="https://upthemes.com">UpThemes</a> and discussed in detail the reasons behind the <a title="https://upthemes.com/open-letter/" href="https://upthemes.com/open-letter/">open letter</a> published by the company. We learned how Chris got involved with WordPress theme development and the circumstances leading to the creation of UpThemes.</p>\n<p>Chris explained how hard it was to make a profit on commercial themes and how early development decisions played a large role in revenue disappearing nearly causing the company to fail. Last but not least, we talked about the trend of theme shops simplifying their products while relying on plugins to provide specific functionality.</p>\n<p>Near the end of the interview, Chris gave us a heads up on a new product they are working on called <a title="http://issuepress.co/" href="http://issuepress.co/">IssuePress</a>. It enables developers to use the Github repository issue tracker to provide support.</p>\n<h2>Stories Discussed:</h2>\n<p><a title="http://wptavern.com/duo-security-plugin-vulnerability-affecting-a-subset-of-wordpress-multisite-networks" href="http://wptavern.com/duo-security-plugin-vulnerability-affecting-a-subset-of-wordpress-multisite-networks">Duo Security Plugin Vulnerability Affecting A Subset Of WordPress Multisite Networks</a><br />\n<a title="http://wptavern.com/aesop-story-engine-now-available-on-wordpress-org" href="http://wptavern.com/aesop-story-engine-now-available-on-wordpress-org">Aesop Story Engine Now Available On WordPress.org</a><br />\n<a title="http://wptavern.com/tips-for-promoting-newly-released-wordpress-plugins" href="http://wptavern.com/tips-for-promoting-newly-released-wordpress-plugins">Tips For Promoting Newly Released WordPress Plugins</a><br />\n<a title="http://wptavern.com/adopt-me-plugin-tag-is-now-in-use-on-wordpress-org" href="http://wptavern.com/adopt-me-plugin-tag-is-now-in-use-on-wordpress-org">“Adopt-Me�? Plugin Tag Is Now in Use in the WordPress Plugin Directory</a></p>\n<h2>Plugins Picked By Marcus:</h2>\n<p><a title="http://wordpress.org/plugins/wp-pipes/" href="http://wordpress.org/plugins/wp-pipes/">WP Pipes</a> makes a similar WordPress based “service�? just like Yahoo Pipes!</p>\n<ul>\n<li>Here are things you can do with WP Pipes (just like Yahoo Pipes):</li>\n<li>Get Posts from WordPress Posts &gt; Export as RSS Feed</li>\n<li>Get Posts from WordPress Posts &gt; Export as iTunes Podcast</li>\n<li>Get Posts from WordPress Posts &gt; Export as Google XML Sitemap</li>\n<li>Get Documents from WordPress &gt; Export to Google Drive</li>\n<li>Get WooCommerce Products &gt; Export as RSS Feed or Google XML Sitemap</li>\n</ul>\n<p><a title="http://wordpress.org/plugins/wp-construction-mode/" href="http://wordpress.org/plugins/wp-construction-mode/">WP Construction Mode</a> can set the entire website or specific pages under construction or maintenance. Admin can still view the site, perfect for developing new websites or pages</p>\n<p><a title="http://wordpress.org/plugins/link-images-to-none/" href="http://wordpress.org/plugins/link-images-to-none/">Link Images to None</a> &#8211; Automatically Link images to none in selecting and uploading images in WordPress.</p>\n<h2>WPWeekly Meta:</h2>\n<p><strong>Next Episode:</strong> Friday, February 28th 3 P.M. Eastern &#8211; Dre Armeda and Tony Perez Of <a title="http://sucuri.net/" href="http://sucuri.net/">Sucuri Security</a></p>\n<p><strong>Subscribe To WPWeekly Via Itunes: </strong><a href="https://itunes.apple.com/us/podcast/wordpress-weekly/id694849738" target="_blank">Click here to subscribe</a></p>\n<p><strong>Subscribe To WPWeekly Via RSS: </strong><a href="http://www.wptavern.com/feed/podcast" target="_blank">Click here to subscribe</a></p>\n<p><strong>Subscribe To WPWeekly Via Stitcher Radio: </strong><a href="http://www.stitcher.com/podcast/wordpress-weekly-podcast?refid=stpr" target="_blank">Click here to subscribe</a></p>\n<p><strong>Listen To Episode #139:</strong><br />\n</p>";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Sat, 22 Feb 2014 01:51:47 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:13:"Jeff Chandler";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:14;a:6:{s:4:"data";s:13:"\n	\n	\n	\n	\n	\n	\n";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:2:{s:0:"";a:5:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:47:"WordPress.tv: Ivelina Dimova: WooCommerce Magic";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:28:"http://wordpress.tv/?p=30733";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:64:"http://wordpress.tv/2014/02/21/ivelina-dimova-woocommerce-magic/";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:649:"<div id="v-tk4N8AOv-1" class="video-player">\n</div><br />  <a rel="nofollow" href="http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/30733/"><img alt="" border="0" src="http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/30733/" /></a> <img alt="" border="0" src="http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=30733&subd=wptv&ref=&feed=1" width="1" height="1" /><div><a href="http://wordpress.tv/2014/02/21/ivelina-dimova-woocommerce-magic/"><img alt="Ivelina Dimova: WooCommerce Magic" src="http://videos.videopress.com/tk4N8AOv/video-cfa6750973_scruberthumbnail_0.jpg" width="160" height="120" /></a></div>";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Sat, 22 Feb 2014 00:17:06 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:12:"WordPress.tv";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:15;a:6:{s:4:"data";s:13:"\n	\n	\n	\n	\n	\n	\n";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:2:{s:0:"";a:5:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:63:"WordPress.tv: Stefan Chekanov: How To Make Money With WordPress";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:28:"http://wordpress.tv/?p=30755";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:80:"http://wordpress.tv/2014/02/21/stefan-chekanov-how-to-make-money-with-wordpress/";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:681:"<div id="v-r9GcymVX-1" class="video-player">\n</div><br />  <a rel="nofollow" href="http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/30755/"><img alt="" border="0" src="http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/30755/" /></a> <img alt="" border="0" src="http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=30755&subd=wptv&ref=&feed=1" width="1" height="1" /><div><a href="http://wordpress.tv/2014/02/21/stefan-chekanov-how-to-make-money-with-wordpress/"><img alt="Stefan Chekanov: How To Make Money With WordPress" src="http://videos.videopress.com/r9GcymVX/video-7e532ad64b_scruberthumbnail_0.jpg" width="160" height="120" /></a></div>";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Sat, 22 Feb 2014 00:11:03 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:12:"WordPress.tv";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:16;a:6:{s:4:"data";s:13:"\n	\n	\n	\n	\n	\n	\n";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:2:{s:0:"";a:5:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:51:"WPTavern: How to Stop WordPress From Sending Emails";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:28:"http://wptavern.com/?p=17552";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:146:"http://wptavern.com/how-to-stop-wordpress-from-sending-emails?utm_source=rss&utm_medium=rss&utm_campaign=how-to-stop-wordpress-from-sending-emails";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:3609:"<p><a href="http://wptavern.com/how-to-stop-wordpress-from-sending-emails/empty-mailbox" rel="attachment wp-att-17567"><img src="http://wptavern.com/wp-content/uploads/2014/02/empty-mailbox.jpg" alt="empty-mailbox" width="1020" height="550" class="aligncenter size-full wp-image-17567" /></a></p>\n<p>WordPress doesn&#8217;t send out too many emails. They&#8217;re usually only generated for an important notice, or when an action is required on your part. However, there are a few different circumstances under which you may not want WordPress to send any emails.</p>\n<p>For example, when working on a development site, or even a production site, you may inadvertently trigger emails that send to real users when testing or making changes.</p>\n<p>The best developers are able to stay invisible. Ideally, you don&#8217;t want any users to know or suspect that you are working on the site, so it&#8217;s important to suppress emails that might be triggered by your work. Fortunately, there are two plugins that will do this for you automatically.</p>\n<h3>Stop Emails</h3>\n<p>The <a href="http://wordpress.org/plugins/stop-emails/" target="_blank">Stop Emails</a> plugin, created by Sal Ferrarello, works silently to prevent any outgoing emails from being sent using wp_mail() function. WordPress will continue to act normally, as if the emails were sent successfully.</p>\n<p>When the plugin is active, you&#8217;ll see a notice in the admin area to remind you that emails are not currently being sent.</p>\n<p><a href="http://wptavern.com/how-to-stop-wordpress-from-sending-emails/no-emails-notice" rel="attachment wp-att-17557"><img src="http://wptavern.com/wp-content/uploads/2014/02/no-emails-notice.png" alt="no-emails-notice" width="995" height="113" class="aligncenter size-full wp-image-17557" /></a></p>\n<p>Stop Emails also has a filter that you can use, which will allow you to log emails and send the information to the php_error.log:</p>\n<pre class="brush: php; title: ; notranslate">add_filter(''fe_stop_emails_log_email'', ''__return_true'');</pre>\n<h3>Disable Emails</h3>\n<p><a href="http://wordpress.org/plugins/disable-emails/" target="_blank">Disable Emails</a> is a similar plugin, created by WordPress plugin developer Ross McKay. It stops any and all emails, using the standard <a href="http://codex.wordpress.org/Function_Reference/wp_mail" target="_blank">wp_mail()</a> function by replacing it with an empty function. Disable Emails is different in that it is totally silent and does not show an admin notice to remind you that emails are stopped.</p>\n<p>It also has a more explanatory readme.txt file that cites several scenarios wherein you might consider shutting WordPress emails off:</p>\n<ul>\n<li>Demonstration websites that allow users to do things that normally send emails</li>\n<li>Development / test websites with live data that might email real customers</li>\n<li>Bulk-loading data into websites which might trigger emails</li>\n<li>Adding new sites into multisite installations</li>\n</ul>\n<p>Both of these plugins are aimed at developers who probably want to turn emails off temporarily or only on a development site. You could also use the plugin to create a totally silent WordPress site that never sends out any notifications, although this is probably not recommended.</p>\n<p>Email notifications are still one of the easiest ways to keep your finger on the pulse of your website when you don&#8217;t visit every day. If you opt to use one of these plugins temporarily on a live site, it&#8217;s important to remember to turn the plugin off when you&#8217;re finished working.</p>";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Fri, 21 Feb 2014 12:03:24 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:13:"Sarah Gooding";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:17;a:6:{s:4:"data";s:13:"\n	\n	\n	\n	\n	\n	\n";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:2:{s:0:"";a:5:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:83:"WPTavern: “Adopt-Me�? Plugin Tag Is Now in Use in the WordPress Plugin Directory";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:28:"http://wptavern.com/?p=17499";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:164:"http://wptavern.com/adopt-me-plugin-tag-is-now-in-use-on-wordpress-org?utm_source=rss&utm_medium=rss&utm_campaign=adopt-me-plugin-tag-is-now-in-use-on-wordpress-org";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:4526:"<p><a href="http://wptavern.com/adopt-me-plugin-tag-is-now-in-use-on-wordpress-org/adopt-me-yellow" rel="attachment wp-att-17539"><img src="http://wptavern.com/wp-content/uploads/2014/02/adopt-me-yellow.jpg" alt="adopt-me-yellow" width="700" height="167" class="aligncenter size-full wp-image-17539" /></a></p>\n<p>Recently we explored the question of whether or not a clear path for WordPress.org plugin adoption could help to <a href="http://wptavern.com/could-wordpress-plugin-adoption-lower-the-rate-of-abandonment" target="_blank">lower the rate of abandonment</a>. Some have suggested that having a standard (unofficial) adoption tag might help to bring more exposure to plugins that need a new owner.</p>\n<p>&#8220;Adopt-Me&#8221; was suggested as one possible tag for developers to use to identify plugins that they would prefer to adopt out rather than abandon. WordPress developer <a href="http://www.foellmann.de/christian/">Christian Foellmann</a> is the first to make use of the tag. If you visit the &#8220;<a href="http://wordpress.org/plugins/tags/adopt-me" target="_blank">adopt-me</a>&#8221; plugin tag page, you&#8217;ll find his <a href="http://wordpress.org/plugins/google-analytics-mu/" target="_blank">Google Analytics MU</a> plugin available for adoption.</p>\n<p>Foellmann put his plugin up for adoption because he was no longer able to provide adequate support for it. &#8220;<span class="pullquote alignleft">I really believe that you have to &#8216;choose your battles&#8217; when it comes to open source contribution</span>,&#8221; he said. &#8220;You need to make sure that you do not stretch yourself too thin. So I finally realized that I can only support a plugin (project) properly if I deploy it myself.&#8221;</p>\n<h3>&#8220;Free to a Good Home&#8221;</h3>\n<p>Foellmann has a rather unique reason for wanting to find the plugin a new home. &#8220;I run all my sites in multisite installations so the tracking of a complete network is something really appealing at first,&#8221; he said. &#8220;Until you realize the implications of EU and especially German privacy law. When it comes to user tracking the functionality of the plugin can get you into hot water &#8211; fast.&#8221; It&#8217;s for this reason that he&#8217;s decided to remove the plugin from his toolbox.</p>\n<p>Already on the lookout for a best practice for plugin adoption, Foellmann saw our recent <a href="http://wptavern.com/could-wordpress-plugin-adoption-lower-the-rate-of-abandonment" target="_blank">article</a> and decided to be the first to use the &#8220;adopt-me&#8221; tag in hopes of keeping his plugin alive. He said that the ideal new owner would be a current user who is wiling to keep development open on Github. Foellmann will happily transfer over the Github repo.</p>\n<h3>Will the &#8220;Adopt-Me&#8221; tag take off?</h3>\n<p>The &#8220;adopt-me&#8221; tag will never catch on if nobody knows about it. Though the tag is technically unofficial, it will require developers to use it and recommend it, if there&#8217;s any possibility of it becoming a useful designation on WordPress.org.</p>\n<p>When I discussed the matter of an unofficial tag with Samuel &#8220;Otto&#8221; Wood in a previous conversation, he had little hope of it gaining any traction. His thoughts:</p>\n<blockquote><p>I don’t think it will take off because it’s edge-casey and relies on authors giving away their plugins intentionally instead of simply letting them die from neglect.</p></blockquote>\n<p>His assessment would indicate that most developers who abandon their plugins are likely not motivated enough to put their extensions on the path to adoption, even if there is a known tag.</p>\n<p>Foellmann has more hope for his <a href="http://wordpress.org/plugins/google-analytics-mu/" target="_blank">Google Analytics MU</a> plugin, which is actually a fork of a plugin that he originally tried to adopt. Since there was no process at the time and the plugin&#8217;s author was unreachable, he was forced to fork the original plugin.</p>\n<p>This type of situation may be a contributing factor to the repository having so many plugins which seem to perform the same function. No path for adoption makes it easier to fork an existing work to make small changes or updates.</p>\n<p>When I asked Foellmann if he thinks the &#8220;adopt-me&#8221; tag will take off, he said, &#8220;I really hope so. It might reduce the number of corpses rotting away in the repo.&#8221;</p>\n<p>Is anyone else planning on making use of the tag?</p>";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Fri, 21 Feb 2014 01:57:54 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:13:"Sarah Gooding";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:18;a:6:{s:4:"data";s:13:"\n	\n	\n	\n	\n	\n	\n";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:2:{s:0:"";a:5:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:67:"WordPress.tv: Stefan Kanev: Test-Driven Development And Refactoring";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:28:"http://wordpress.tv/?p=30753";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:84:"http://wordpress.tv/2014/02/20/stefan-kanev-test-driven-development-and-refactoring/";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:689:"<div id="v-m7MbpFrF-1" class="video-player">\n</div><br />  <a rel="nofollow" href="http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/30753/"><img alt="" border="0" src="http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/30753/" /></a> <img alt="" border="0" src="http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=30753&subd=wptv&ref=&feed=1" width="1" height="1" /><div><a href="http://wordpress.tv/2014/02/20/stefan-kanev-test-driven-development-and-refactoring/"><img alt="Stefan Kanev: Test-Driven Development And Refactoring" src="http://videos.videopress.com/m7MbpFrF/video-c99f0d694b_scruberthumbnail_0.jpg" width="160" height="120" /></a></div>";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Thu, 20 Feb 2014 23:53:42 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:12:"WordPress.tv";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:19;a:6:{s:4:"data";s:13:"\n	\n	\n	\n	\n	\n	\n";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:2:{s:0:"";a:5:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:55:"WPTavern: Bob Dunn Launches New WordPress Learning Site";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:28:"http://wptavern.com/?p=17444";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:154:"http://wptavern.com/bob-dunn-launches-new-wordpress-learning-site?utm_source=rss&utm_medium=rss&utm_campaign=bob-dunn-launches-new-wordpress-learning-site";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:9522:"<p><a href="http://wptavern.com/wp-content/uploads/2014/02/BobDunn.jpg" rel="prettyphoto[17444]"><img class="alignright size-thumbnail wp-image-17504" alt="Bob Dunn" src="http://wptavern.com/wp-content/uploads/2014/02/BobDunn-150x150.jpg" width="150" height="150" /></a>Bob Dunn, who&#8217;s been teaching WordPress for years, has launched an <a title="http://bobwptutorials.com/" href="http://bobwptutorials.com/">all new website</a> dedicated to helping people learn WordPress. The new site is filled with tutorials, up to date information about WordPress, and in the near future, complimentary eBooks. I got in touch with Bob and asked him a few questions about the new site.</p>\n<p><strong>How will Bobwptutorials differentiate itself from other WordPress learning sites?</strong></p>\n<p>When I was thinking about what this new service might look like, I kept hearing the voices of the thousands of people I have trained. They shared their frustrations with listening to audio without the visual references they needed. Some of them had tried other video tutorials but couldn&#8217;t keep up and absorb the information because the trainer&#8217;s pace was too fast.</p>\n<p><a href="http://wptavern.com/wp-content/uploads/2014/02/BobWPTutorialsFrontpage.png" rel="prettyphoto[17444]"><img class="aligncenter size-large wp-image-17502" alt="Landing Page For BobWPTutorials" src="http://wptavern.com/wp-content/uploads/2014/02/BobWPTutorialsFrontpage-500x114.png" width="500" height="114" /></a></p>\n<p>Everyone learns differently and people need to find the instructional style that works best for them. My teaching style is different from other WordPress trainers. My tutorials are less formal, less scripted and more like I am having a conversation with my students. I give them a little more time to take in the information so it makes more sense. I provide screenshots as well, so students who learn better through visual styles can get what they need. That&#8217;s not everyone&#8217;s style of learning, but some people are naturally drawn to my approach.</p>\n<p>But what really sets <a title="http://bobwptutorials.com" href="http://bobwptutorials.com">BobWPTutorials</a> apart from the others is that I have a deep focus on two themes, <strong>Genesis Child Themes</strong> and <strong>WooThemes</strong> so members can explore the themes thoroughly and figure out what they need upfront, before they make a purchase. This has been a recurring issue with people who have come to me after having a bad experience. They have bought a theme and now they find it isn&#8217;t the one that will work best for their needs.</p>\n<div id="attachment_17506" class="wp-caption aligncenter"><a href="http://wptavern.com/wp-content/uploads/2014/02/FreeVideosOffered.png" rel="prettyphoto[17444]"><img class="size-large wp-image-17506" alt="A Sample Of The Free Videos Available" src="http://wptavern.com/wp-content/uploads/2014/02/FreeVideosOffered-500x257.png" width="500" height="257" /></a><p class="wp-caption-text">A Sample Of The Free Videos Available</p></div>\n<p>So I wanted to hit that pain point. For each theme, members get an overview tutorial that lets them know what they can and cannot do with it out-of-the-box, without customizations. (<em>Because most people who work with me fear code.</em>) One of the hardest things for users to do is to visualize what their site might look like by just looking at the theme demo. The second video helps members set up their chosen theme step by step, primarily that all-important home page. In this second video, I also give them other setup options, so they understand they are not stuck with the exact look of the theme provider&#8217;s demo.</p>\n<p>Lastly, I have added <strong>Video Highlights</strong>. This is a separate text and screenshot instruction that goes over the major points of the video. This way a member can revisit the important details without having to watch the entire video again.</p>\n<p><strong>Based on your experience, what is the most common area of WordPress people struggle with?</strong></p>\n<p>Wow, where do I start? I think in a general sense, it’s the non-intuitiveness of the interface. Lots of smart people get lost there and some of the simplest features are well-hidden. One example: During a training session, I shared how to expand the editor window by dragging the edged corner. You cannot imagine how many “<em>ah-ha&#8217;s</em>&#8221; I heard in the audience. One person even shared that they had been frustrated by that for six months.</p>\n<div id="attachment_17508" class="wp-caption aligncenter"><a href="http://wptavern.com/wp-content/uploads/2014/02/WordPressThemeRepositoryThemeCount.png" rel="prettyphoto[17444]"><img class="size-large wp-image-17508" alt="Lots Of Themes To Choose From" src="http://wptavern.com/wp-content/uploads/2014/02/WordPressThemeRepositoryThemeCount-500x130.png" width="500" height="130" /></a><p class="wp-caption-text">Lots Of Themes To Choose From</p></div>\n<p>Another thing people struggle with is theme choice. I know several WordPress people who say “<em>just grab one and start with it</em>�?. But I have seen too many people struggle because they hadn’t thought through what they need their theme to do. Some will wallow in the sea of themes for months, frustrated and still not finding what they are looking for.</p>\n<p>Those are just two of the areas users struggle with. It really depends on the person and their comfort level with technology. I know some very smart people who have Masters and Doctorates, but, still, they find it all very confusing.</p>\n<p><strong>On average, what demographic represents the majority of your customers?</strong></p>\n<p>It’s all over the board, but my one-on-one training is skewed toward the 40+ crowd. If I had to choose, I&#8217;d say it&#8217;s stronger on the female side. Often, they are people who are at a certain age and changing careers, starting a new business, stepping into the world of technology, or wanting to grow their hobby or interest. A lot of people in that age bracket feel they have been left behind by technology. I tend to attract them probably because of my age and my patience, maybe. You need to be a very patient person to be a WordPress trainer.</p>\n<p>I have dealt with all ages, skill levels, genders and ethnic backgrounds. I’m a pretty laid-back guy with an open mind and a love for people.</p>\n<p><strong>WordPress is an ever-evolving piece of software. Are you finding it harder or easier to explain how it works to new users?</strong></p>\n<p>It&#8217;s true, it keeps me on the ball, keeping up with the changes and communicating them to my clients. But I wouldn’t say it’s any harder to explain as time passes. It can always be a challenge to teach an old dog a new trick. But it&#8217;s also what I love about my job. Constantly learning new things and finding ways to make the new and difficult easy for the next person to understand. I love that things change and evolve.</p>\n<p><strong>Out of curiosity, what membership plugin are you using for Bobwptutorials and why did you choose it over others?</strong></p>\n<p>I&#8217;m using <a title="http://www.woothemes.com/woocommerce/" href="http://www.woothemes.com/woocommerce/">Woo Commerce</a> and a combination of extensions, including <a title="http://www.woothemes.com/products/groups-woocommerce/" href="http://www.woothemes.com/products/groups-woocommerce/">Groups</a> and <a title="http://www.woothemes.com/products/woocommerce-subscriptions/" href="http://www.woothemes.com/products/woocommerce-subscriptions/">Subscriptions</a>. My choice had a lot to do with my history with WooThemes, and, yes, Genesis child themes. With my personal training and Bobwptutorials, I focus on Genesis child themes and WooThemes. Why? Because I have used them both since I started with WordPress back in 2008 and I know and trust them.</p>\n<p><a href="http://wptavern.com/wp-content/uploads/2014/02/WooCommerceGrey.png" rel="prettyphoto[17444]"><img class="aligncenter size-large wp-image-17507" alt="Woo Commerce Grey" src="http://wptavern.com/wp-content/uploads/2014/02/WooCommerceGrey-500x125.png" width="500" height="125" /></a></p>\n<p>My site <a title="http://bobwp.com" href="http://bobwp.com">bobwp.com</a> is built on a Genesis child theme, so I wanted to make my second site with a WooTheme, you know, to share the love. When I first came up with the idea of this site, I contacted Matt at WooThemes, laid it out and said, can I make this work with a WooTheme and WooCommerce (<em>the latter of which I already had some experience with</em>)? He said yes, so that decided that. I love things that are simple, and if I can use something I already know well, I’m on it. I have tried a couple of membership plugins in the past on other sites, some I like, some not so much. But I can say there are some really good membership plugins out there. This was just the best route for me to go for this site.</p>\n<h3>Bob Is The Man</h3>\n<p>Be sure to check out the four free videos he&#8217;s made available. For example, <a title="http://bobwptutorials.com/free-video-tutorial-differences-posts-pages/" href="http://bobwptutorials.com/free-video-tutorial-differences-posts-pages/">this video</a> explains the differences between posts and pages. I found it to be informative without being boring. If you are having trouble learning WordPress and need a patient individual to help guide you through the trenches, Bob Dunn is an excellent choice.</p>";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Thu, 20 Feb 2014 23:28:34 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:13:"Jeff Chandler";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:20;a:6:{s:4:"data";s:13:"\n	\n	\n	\n	\n	\n	\n";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:2:{s:0:"";a:5:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:65:"WPTavern: Speed Up WordPress Development With The Titan Framework";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:28:"http://wptavern.com/?p=17167";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:174:"http://wptavern.com/speed-up-wordpress-development-with-the-titan-framework?utm_source=rss&utm_medium=rss&utm_campaign=speed-up-wordpress-development-with-the-titan-framework";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:7169:"<p>The <a href="http://wordpress.org/plugins/titan-framework/">Titan Framework</a> is a new WordPress options framework that was released on WordPress.org this week. This set of tools was created to make it easy for WordPress theme and plugin developers to add options to their projects. This first release contains more than 20 options, including meta boxes, Google font selector, a media uploader, multicheck categories and taxonomies, theme customizer options and more.</p>\n<p><a href="https://www.titanframework.net/" target="_blank">Titan</a> claims to be the easiest options framework you&#8217;ll ever use. With just a few simple lines of code you can quickly add customization options that are easy for clients to use and understand. For example, to get an instance of the Titan Framework for your plugin, you&#8217;d add just one line to the the main plugin file:</p>\n<pre class="brush: php; light: true; title: ; notranslate">$titan = TitanFramework::getInstance( ''my-plugin'' );</pre>\n<p>Setting up an admin page and menu for your options is as easy as adding a couple lines of code:</p>\n<pre class="brush: php; title: ; notranslate">$panel = $titan-&gt;createAdminPanel( array(\n    name =&gt; ''Theme Options'',\n) );</pre>\n<p>This helps to keep your code clean with the Titan engine powering the details related to building options.</p>\n<h3>The Titan Framework Was Built For Efficiency</h3>\n<p><a href="http://wptavern.com/speed-up-wordpress-development-with-the-titan-framework/me2" rel="attachment wp-att-17477"><img src="http://wptavern.com/wp-content/uploads/2014/02/me2.jpg" alt="me2" width="250" height="250" class="alignright size-full wp-image-17477" /></a>I had the chance to speak with <a href="http://www.gambit.ph/" target="_blank">Benjamin Intal</a>, Titan Framework&#8217;s creator, to ask him why he decided to put another WordPress options framework out into the wild, despite the fact that there are already so many. Intal said that Titan resulted from a bit of spring cleaning he completed on his themes.</p>\n<p>&#8220;When I started creating WordPress themes 4 years ago, as my number of projects grew, I had a hard time managing all the code from the different themes I had,&#8221; he said. &#8220;By instinct, I started unifying all the similar code to make things more manageable. After months of work, I ended up with a huge framework that handled everything the theme needed.&#8221;</p>\n<p>From there his private framework evolved as he learned more about WordPress best practices. Intal began removing much of the functionality and turning it into plugins:</p>\n<blockquote><p>My mindset was that every feature should be included with the theme. As I learned more and more about the ins and outs of WordPress, I learned that what I did was a big no no. So now, I&#8217;m dissecting those themes, and turning its innards into plugins. One of those is the Titan Framework.</p></blockquote>\n<p>Intal&#8217;s spring cleaning resulted in a powerful set of options that speed up development. He uses it regularly in client projects. In one example he needed to provide information on various locations on a map, so he created a custom post type for locations and Titan powers most of the meta box options for inputting custom fields such as latitude, longitude and other location properties.</p>\n<p>While Intal maintains the framework for the purpose of efficiency in his own work, it&#8217;s now something that anyone can use. &#8220;Titan Framework focuses on ease of use,&#8221; he said. <strong>&#8220;For me, that translates to minimal coding and fewer things to remember.&#8221;</strong></p>\n<p>When creating the Titan Framework, Intal wanted to make a standardized way of adding options, so that it&#8217;s easy for developers to remember how to accomplish common tasks. He described the problem he was trying to solve and how Titan can improve your workflow:</p>\n<blockquote><p>In WordPress, admin options, custom fields and theme customizer controls are all different from each other. These are set up differently and getting the saved values for each type is performed differently. Titan Framework unifies all these so that you won&#8217;t really have to know whether you&#8217;re using an admin option, a custom field or a customizer control. Everything is just an option. Because of this, getting your saved values is just one simple method: the getOption method.</p></blockquote>\n<h3>How to Include the Titan Framework in Your Project</h3>\n<p><a href="http://wptavern.com/speed-up-wordpress-development-with-the-titan-framework/options-2" rel="attachment wp-att-17484"><img src="http://wptavern.com/wp-content/uploads/2014/02/options.jpg" alt="options" width="918" height="298" class="aligncenter size-full wp-image-17484" /></a><br />\nCurrently, if you want to use Titan with your work, you&#8217;ll need to have the plugin activated alongside your own theme or plugin. This will allow you to call the framework&#8217;s functions inside your project. Refer to the developers&#8217; <a href="https://www.titanframework.net/docs/" target="_blank">documentation</a> on the Titan project page for further instructions and a snippet for checking to see if Titan has been activated.</p>\n<p>&#8220;Ideally, Titan should always be a plugin that&#8217;s separate from your theme or plugin so that Titan can be updated for bug fixes or new features,&#8221; Intal said. However, he recognizes that some developers might want to bundle the framework within their projects. He plans on performing an update soon that will make that possible.</p>\n<h3>Future Additions to the Titan Framework</h3>\n<p>Intal has plans to expand the number of options in the framework, which currently includes most of the basics. He&#8217;ll be adding a palette selector, widget area selector and menu selector further down the road.</p>\n<p>He also plans to include functionality for easily creating and selecting widget areas, as well as new functions for creating shortcodes.</p>\n<p>Ital said that what he&#8217;s trying to accomplish with Titan is not based on a desire to improve deficiencies he&#8217;s seen in other frameworks. &#8220;When I was in the process of creating Titan Framework, I honestly did not dive into the other existing frameworks since I already had everything I needed to complete it,&#8221; he said. &#8220;I&#8217;ve just started now to check out what&#8217;s out there and I&#8217;m finding that there are a lot of great frameworks such as Redux and OptionTree.&#8221;</p>\n<p>Of course, if you&#8217;re trying to learn how to code plugin and theme options from the inside out, then using an options framework is not the way to go. The idea behind using a framework is to save yourself time in development and focus on building your project. There&#8217;s no need to reinvent the wheel every time you need to add a few options. Titan saves you the hassle of having to code them from scratch. For more information and examples on how to use it, check out the Titan Framework <a href="https://www.titanframework.net/" target="_blank">homepage</a> and <a href="https://www.titanframework.net/docs/" target="_blank">documentation</a>.</p>";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Thu, 20 Feb 2014 21:46:12 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:13:"Sarah Gooding";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:21;a:6:{s:4:"data";s:13:"\n	\n	\n	\n	\n	\n	\n";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:2:{s:0:"";a:5:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:71:"WordPress.tv: Brian Messenlehner: WordPress As An Application Framework";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:28:"http://wordpress.tv/?p=30745";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:88:"http://wordpress.tv/2014/02/20/brian-messenlehner-wordpress-as-an-application-framework/";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:691:"<div id="v-EyR8BIyI-1" class="video-player">\n</div><br />  <a rel="nofollow" href="http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/30745/"><img alt="" border="0" src="http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/30745/" /></a> <img alt="" border="0" src="http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=30745&subd=wptv&ref=&feed=1" width="1" height="1" /><div><a href="http://wordpress.tv/2014/02/20/brian-messenlehner-wordpress-as-an-application-framework/"><img alt="Brian Messenlehner: WordPress As An Application Framework" src="http://videos.videopress.com/EyR8BIyI/video-d33bfb387f_std.original.jpg" width="160" height="120" /></a></div>";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Thu, 20 Feb 2014 19:34:52 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:12:"WordPress.tv";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:22;a:6:{s:4:"data";s:13:"\n	\n	\n	\n	\n	\n	\n";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:2:{s:0:"";a:5:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:67:"WordPress.tv: Mike Little: 10 Years Of WordPress A Founder’s View";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:28:"http://wordpress.tv/?p=31554";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:81:"http://wordpress.tv/2014/02/20/mike-little-10-years-of-wordpress-a-founders-view/";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:684:"<div id="v-XFJ3A7jd-1" class="video-player">\n</div><br />  <a rel="nofollow" href="http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/31554/"><img alt="" border="0" src="http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/31554/" /></a> <img alt="" border="0" src="http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=31554&subd=wptv&ref=&feed=1" width="1" height="1" /><div><a href="http://wordpress.tv/2014/02/20/mike-little-10-years-of-wordpress-a-founders-view/"><img alt="Mike Little: 10 Years Of WordPress A Founder&#8217;s View" src="http://videos.videopress.com/XFJ3A7jd/video-1ca8b4cb55_std.original.jpg" width="160" height="120" /></a></div>";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Thu, 20 Feb 2014 19:23:38 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:12:"WordPress.tv";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:23;a:6:{s:4:"data";s:13:"\n	\n	\n	\n	\n	\n	\n";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:2:{s:0:"";a:5:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:71:"WPTavern: WordPress Theme Shops Move Toward Preserving Data Portability";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:28:"http://wptavern.com/?p=17381";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:188:"http://wptavern.com/wordpress-theme-shops-move-towards-preserving-data-portability?utm_source=rss&utm_medium=rss&utm_campaign=wordpress-theme-shops-move-towards-preserving-data-portability";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:6572:"<div id="attachment_17420" class="wp-caption aligncenter"><a href="http://wptavern.com/wordpress-theme-shops-move-towards-preserving-data-portability/blue-suitcase" rel="attachment wp-att-17420"><img src="http://wptavern.com/wp-content/uploads/2014/02/blue-suitcase.jpg" alt="photo credit: kthread - cc" width="800" height="435" class="size-full wp-image-17420" /></a><p class="wp-caption-text">photo credit: <a href="http://www.flickr.com/photos/kthread/3495877554/">kthread</a> &#8211; <a href="http://creativecommons.org/licenses/by-sa/2.0/">cc</a></p></div>\n<p>In the old days, WordPress theme developers used to build loads of specific functionality into their themes, i.e. recipes, portfolios, testimonials, analytics, fundraising capabilities, custom post types etc. Commercial theme providers competed fiercely with one another to see who could pack the most functionality into their offerings. Many companies sought to become a one-stop-shop for everything an individual or business might need in order to launch an online presence.</p>\n<p>The practice of locking users into using a theme by tying their content/data to the use of the theme is now highly discouraged. WordPress theme shops have slowly started to separate function from design in favor of preserving data portability.</p>\n<p><a href="http://wptavern.com/wp-content/uploads/2014/02/restaurant.png" rel="prettyphoto[17381]"><img src="http://wptavern.com/wp-content/uploads/2014/02/restaurant1.png" alt="restaurant" width="400" height="252" class="alignright size-full wp-image-17408" /></a>This past week we&#8217;ve seen more evidence of this trend as two major theme providers have released plugins for functionality that users might previously have expected to find within themes. Justin Tadlock, who has long been a vocal advocate of <a href="http://justintadlock.com/archives/2013/09/14/why-custom-post-types-belong-in-plugins" target="_blank">data portability in themes</a>, released a new free <a href="http://themehybrid.com/weblog/restaurant-wordpress-plugin" target="_blank">Restaurant</a> plugin. The plugin allows restaurants to manage a food and beverage menu and works as a companion to themes.</p>\n<p>WooThemes released <a href="http://www.woothemes.com/2014/02/introducing-projects-our-brand-new-portfolio-plugin-for-wordpress/" target="_blank">Projects</a> this week, a new plugin to handle portfolio capabilities. They said that preserving data portability is one of the main reasons behind this decision:</p>\n<blockquote><p>You’ve probably already noticed that our product strategy has deviated to separating features and code wherever possible, shifting our functionality into plugins, rather than bundling into each theme&#8230;It also ensures your data is portable, which aligns with a core WordPress philosophy.</p></blockquote>\n<p>UpThemes&#8217; recent <a href="https://upthemes.com/open-letter/" target="_blank">open letter to the WordPress Community</a> is further demonstration that the tides are turning in favor of data portability. In it, they openly admit that it was impossible for them to continue to support all of the extra stuff that they had been building into themes:</p>\n<blockquote><p>Gone are the days of locking custom post types in a theme. No longer do we build pluginesque functionality into the core of a theme. We now build themes that rely on existing, awesome plugins that offer features that can be used with other themes, should you choose to update your design or build your own theme.</p></blockquote>\n<p>UpThemes is starting fresh and making use of plugins such as <a href="http://wordpress.org/plugins/church-theme-content/" target="_blank">Church Theme Content</a> and <a href="http://wordpress.org/plugins/recipe-schema/" target="_blank">Recipe Schema</a> to add extra functionality, instead of packing it all into themes.</p>\n<p>We&#8217;re witnessing the end of an era in WordPress theme development. Bloat is no longer acceptable. Theme authors are creating leaner products with a stronger focus on designing for specific use cases. Anything extra is plugin territory.</p>\n<p>This should be quite liberating for theme authors who no longer bear the pressure of having to pack all kinds of complex functionality and options into their products. Themes and plugins will no longer overlap as heavily as they have in the past but will act as compliments to one another.</p>\n<h3>Tips For Consumers</h3>\n<div id="attachment_17423" class="wp-caption aligncenter"><a href="http://wptavern.com/wordpress-theme-shops-move-towards-preserving-data-portability/portable" rel="attachment wp-att-17423"><img src="http://wptavern.com/wp-content/uploads/2014/02/portable.jpg" alt="photo credit: Leo Reynolds - cc" width="1018" height="546" class="size-full wp-image-17423" /></a><p class="wp-caption-text">photo credit: <a href="http://www.flickr.com/photos/lwr/3509878550/">Leo Reynolds</a> &#8211; <a href="http://creativecommons.org/licenses/by-nc-sa/2.0/">cc</a></p></div>\n<p>If you&#8217;re looking at this issue from a consumer standpoint, the most important thing to remember is that you are the guardian of your own data. If you choose a theme that locks you in, you are the one who will suffer the inconvenience of trying to transfer data when you change to a new theme.</p>\n<p>Before installing a new theme, whether its free or commercial, ask yourself if you&#8217;ll be able to take all of your data with you, if and when you decide to stop using that theme. If the theme advertises dozens of capabilities, examine each of them to make sure that they don&#8217;t tie you down.</p>\n<p>Last year we discussed this issue in a post about <a href="http://wptavern.com/why-you-should-never-add-analytics-code-to-your-wordpress-theme" target="_blank">why you should never add analytics code to your WordPress theme</a>. This is because analytics have nothing to do with the design of the theme. It&#8217;s a function that you&#8217;ll need to maintain throughout years of using WordPress with many different themes. You don&#8217;t want to have to transfer that data every time. Store it in a plugin and be done with it.</p>\n<p>The same goes for portfolios, testimonials, recipes and custom post types. You&#8217;re likely to want this data on your website for years to come. Make sure that the theme you choose will give you that freedom. Find plugin substitutes for any data-driven functionality that is built into your theme. It&#8217;s not as convenient, but ultimately you&#8217;ll be glad that you kept your data separate from the design.</p>";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Thu, 20 Feb 2014 13:01:09 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:13:"Sarah Gooding";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:24;a:6:{s:4:"data";s:13:"\n	\n	\n	\n	\n	\n	\n";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:2:{s:0:"";a:5:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:61:"WPTavern: Tips For Promoting Newly Released WordPress Plugins";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:28:"http://wptavern.com/?p=17390";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:166:"http://wptavern.com/tips-for-promoting-newly-released-wordpress-plugins?utm_source=rss&utm_medium=rss&utm_campaign=tips-for-promoting-newly-released-wordpress-plugins";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:4939:"<p>So you just created and released a cool WordPress plugin that solves a problem. It&#8217;s now among 29,000 other plugins on the <a href="http://wordpress.org/plugins/" title="http://wordpress.org/plugins/">plugin directory</a>. How do you tell the world your plugin exists? WordPress.org doesn&#8217;t have an area to publish press releases or announcements of new plugins.</p>\n<div id="attachment_16677" class="wp-caption aligncenter"><a href="http://i1.wp.com/wptavern.com/wp-content/uploads/2014/02/yellow-plug.jpg" rel="prettyphoto[17390]"><img src="http://i1.wp.com/wptavern.com/wp-content/uploads/2014/02/yellow-plug.jpg?resize=500%2C235" alt="photo credit: jono dot com - cc" class="size-large wp-image-16677" /></a><p class="wp-caption-text">photo credit: <a href="http://www.flickr.com/photos/jono/4867550/">jono dot com</a> &#8211; <a href="http://creativecommons.org/licenses/by-nc-sa/2.0/">cc</a></p></div>\n<p>However, all plugins published to the repository show up on the <a href="http://wordpress.org/plugins/browse/new/" title="http://wordpress.org/plugins/browse/new/">newest plugins list</a>. This list has an RSS feed but you have to <a href="http://wordpress.org/plugins/rss/browse/new/" title="http://wordpress.org/plugins/rss/browse/new/">know where to look</a> to subscribe to it. In WordPress 3.8, the dashboard widget showing the newest plugins released was removed.</p>\n<div id="attachment_17393" class="wp-caption aligncenter"><a href="http://i2.wp.com/wptavern.com/wp-content/uploads/2014/02/NewestPluginsReleased.png" rel="prettyphoto[17390]"><img src="http://i2.wp.com/wptavern.com/wp-content/uploads/2014/02/NewestPluginsReleased.png?resize=500%2C212" alt="News Plugins Released On WordPress.org" class="size-large wp-image-17393" /></a><p class="wp-caption-text">News Plugins Released On WordPress.org</p></div>\n<h3>If Your Plugin Solves a Problem, We Want To Hear About It</h3>\n<p>The best way to get your plugin noticed is to contact authors of websites that primarily focus on WordPress. For example, you can <a href="http://wptavern.com/contact-me" title="http://wptavern.com/contact-me">contact us</a>. When pitching your plugin, don&#8217;t pretend it&#8217;s a sales pitch. Provide the name of the plugin, it&#8217;s target audience and the problem it solves. There is no guarantee that WPTavern or any other website will write about your plugin, even if that information is provided. But it&#8217;s worth a shot.</p>\n<p>When we write about plugins on WPTavern, they&#8217;re either cool, innovative, or solve a problem for a large number of users. One of the hardest things to do as a writer is to write about something that is not interesting. The plugins reviewed on WPTavern are seen by a huge audience. I love hearing stories from new plugin authors of how an article on WPTavern put their plugin on the map.</p>\n<h3>WordPress Podcast Dedicated To Plugins</h3>\n<p><a href="http://wppluginsatoz.com/" title="http://wppluginsatoz.com/">Plugins A-Z</a> is a podcast dedicated to WordPress plugins. Hosted by Marcus Couch and John Overall, they discuss new plugins that have caught their eye. You can get in touch with them via <a href="http://wppluginsatoz.com/contact/" title="http://wppluginsatoz.com/contact/">their contact form</a>. Don&#8217;t only submit information about your plugin, but extend an offer to be on their show as a guest. Who knows a plugin better than the person who created it?</p>\n<h3>Subreddit Dedicated To WordPress Plugins</h3>\n<p><a href="http://i0.wp.com/wptavern.com/wp-content/uploads/2014/02/RedditLogo.jpg" rel="prettyphoto[17390]"><img src="http://i0.wp.com/wptavern.com/wp-content/uploads/2014/02/RedditLogo.jpg?resize=118%2C44" alt="Reddit Logo" class="alignright size-full wp-image-16194" /></a>A few weeks ago, <a href="http://wptavern.com/add-these-subreddits-to-your-list-of-wordpress-watering-holes" title="http://wptavern.com/add-these-subreddits-to-your-list-of-wordpress-watering-holes">we mentioned</a> Reddit was a good place to hang out if you enjoyed discussing WordPress topics. There is a <a href="http://www.reddit.com/r/WordpressPlugins" title="http://www.reddit.com/r/WordpressPlugins">subreddit available</a> dedicated to WordPress plugins. Developers are welcome to show off their plugins for feedback and offer custom development services when needed.</p>\n<h3>Plugin Developers Are Problem Solvers</h3>\n<p>In general, plugin developers are not looking for fame. Most plugins are solutions to a problem or scratch a developer&#8217;s itch. By releasing a plugin into the wild, the hope is it will solve the same problem for others. Thank you to every plugin developer who has placed their code onto the WordPress.org plugin repository. More often then not, those plugins are solutions to problems.</p>\n<p><strong>If you know any other outlets authors can use to promote their new plugins, please share them in the comments.  </strong></p>";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Thu, 20 Feb 2014 02:28:58 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:13:"Jeff Chandler";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:25;a:6:{s:4:"data";s:13:"\n	\n	\n	\n	\n	\n	\n";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:2:{s:0:"";a:5:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:91:"WPTavern: Own Your Content: Postcard Social Sharing App Launches With WordPress Integration";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:28:"http://wptavern.com/?p=17326";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:224:"http://wptavern.com/own-your-content-postcard-social-sharing-app-launches-with-wordpress-integration?utm_source=rss&utm_medium=rss&utm_campaign=own-your-content-postcard-social-sharing-app-launches-with-wordpress-integration";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:5397:"<p><a href="http://i1.wp.com/wptavern.com/wp-content/uploads/2014/02/postcard-app.jpg" rel="prettyphoto[17326]"><img src="http://i1.wp.com/wptavern.com/wp-content/uploads/2014/02/postcard-app.jpg?resize=301%2C500" alt="postcard-app" class="alignright size-large wp-image-17329" /></a><a href="http://www.postcardsocial.net/" target="_blank">Postcard</a> is a new free social sharing <a href="https://itunes.apple.com/us/app/postcard-write-once-share/id589678038?ls=1&mt=8" target="_blank">app for iOS</a> that landed in the app store today. The app makes it easy for you to share content from your phone to multiple social networks at once.</p>\n<p>The golden feature of this app is its &#8220;Custom Network&#8221; capability, which allows you to share to your own website. Many times people will share content, such as a quick status or photo, to Facebook or Twitter. The content is then hosted on the social networks, which gobble up all the traffic.</p>\n<p>Postcard addresses this problem by allowing you to set your own website as the &#8220;host&#8221; network and direct all the traffic to your site where the content is hosted.</p>\n<h3>WordPress Plugin Connects Postcard to Your Website</h3>\n<p>Given that WordPress is the world&#8217;s leading publishing platform, Postcard&#8217;s creator decided to launch with WordPress integration available from day one.</p>\n<p>This plugin performs two main functions:</p>\n<ol>\n<li>Links the Postcard App to your WordPress site</li>\n<li>Makes it possible to display content sent via Postcard on your site</li>\n</ol>\n<p>When you send your content to be hosted on your site, you won&#8217;t have any of the character restrictions that come with sharing to other social networks. The plugin creates shareable permalinks attached to the messages that you share to Facebook, Twitter and other networks.</p>\n<p>The Postcard WordPress plugin also gives you a number of shortcodes to use in the post/page editor for inserting content that comes from the app. The shortcodes make it easy to display an archive, feed or gallery of your Postcard content. The content can also be filtered using the designated attributes, such as tags or count:</p>\n<pre>[postcard-feed tags="interesting,useful"]</pre>\n<p>The <a href="http://wordpress.org/plugins/postcard-social/" target="_blank">Postcard Social Networking Plugin</a> is available for free on WordPress.org. With the plugin and the app working hand-in-hand, you can create an archive of all the data that you share to social networks from your phone, even if you don&#8217;t choose to use shortcodes to display it on the front-end.</p>\n<h3>Own Your Content and Boost Traffic to Your WordPress Site</h3>\n<p><a href="http://bitwit.ca/" target="_blank">Kyle Newsome</a>, the app&#8217;s creator, said that the ability to share to your own website is the feature that he is the most excited about: &#8220;It represents most strongly why I started building this app in the first place &#8211; to help people solve content ownership and control issues I see prevalent in the shape of social media today.&#8221;</p>\n<p>Newsome designed Postcard to be a tool that can help people to keep their website content fresh. <strong>&#8220;There is a big opportunity with this app to make sure your website doesn&#8217;t go stale as you post regular short form content to social networks,&#8221;</strong> he said. Since many people are already putting quite a bit of effort into updating their social networks, Postcard gives you a way to broadcast to all of them while passing the resulting traffic on to your own website.</p>\n<p>One important thing to note is that Postcard doesn&#8217;t store your content or use it to create a social network of any kind. I asked Newsome to clarify how it works. &#8220;It doesn&#8217;t store data or use 3rd party servers,&#8221; he said. &#8220;All credentials are local and securely stored on the phone.&#8221; This is an important distinction when comparing Postcard to other apps that claim to let you own your own data. If you use the Custom Network feature, the app simply couriers that data to your site where you own the content.</p>\n<h3>An App to Fundamentally Change How We Use Social Networks</h3>\n<p>Postcard presents a new way to interact with social networks. When announcing the upcoming launch, Newsome said, <strong>&#8220;For those of us who are active content creators, I think this marks a very important change in the way we use social media.&#8221;</strong> Having your own website as the canonical source for the content you create has value beyond the traffic that you gain. That link to your site and the fact that you host the data assigns ownership of that content to you. It also provides a lasting archive of your content that can be sorted and presented in any way that you choose.</p>\n<p>Right now <a href="https://itunes.apple.com/us/app/postcard-write-once-share/id589678038?ls=1&mt=8" target="_blank">Postcard</a> is only available for iOS. I asked Newsome if an Android app is in the works. He replied, &#8220;Yes, cross-platform is in the plan. I&#8217;m looking at ways to hit both desktop and more mobile platforms.&#8221; As soon as these tools are available, Postcard will be set to double, if not triple its user base, given that Android currently dominates the smartphone market. We&#8217;ll keep you updated as these tools continue to develop.</p>";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Wed, 19 Feb 2014 21:01:23 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:13:"Sarah Gooding";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:26;a:6:{s:4:"data";s:13:"\n	\n	\n	\n	\n	\n	\n";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:2:{s:0:"";a:5:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:70:"WPTavern: How To Extend A WordPress Plugin Without Losing Your Changes";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:28:"http://wptavern.com/?p=17319";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:184:"http://wptavern.com/how-to-extend-a-wordpress-plugin-without-losing-your-changes?utm_source=rss&utm_medium=rss&utm_campaign=how-to-extend-a-wordpress-plugin-without-losing-your-changes";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:4551:"<p>While there is not an official way to create child plugins, the topic <a title="http://wordpress.org/ideas/topic/child-plugins" href="http://wordpress.org/ideas/topic/child-plugins">has been discussed</a> in the WordPress community over the past few years. I caught up with Ian Dunn who submitted the idea three years ago to see if it still has merit.</p>\n<blockquote><p>From an architectural standpoint, creating a child plugin isn&#8217;t really practical. It works for themes because they have a very specific, defined set of behaviors, but plugins are completely different.</p></blockquote>\n<p>Ian recently <a title="http://iandunn.name/the-right-way-to-customize-a-wordpress-plugin/" href="http://iandunn.name/the-right-way-to-customize-a-wordpress-plugin/">published a post</a> highlighting the right way to customize plugins. The first suggestion he offered is to get in touch with the plugin author and let them know what changes you&#8217;d like to see.</p>\n<p>If that doesn&#8217;t work, the next step is to extend the plugin without modifying its core. The easiest way to accomplish this is to create a <a title="http://iandunn.name/the-right-way-to-customize-a-wordpress-plugin/" href="http://iandunn.name/the-right-way-to-customize-a-wordpress-plugin/">functionality plugin</a> that will run alongside it. You can take things one step further by using <a title="http://wordpress.org/plugins/plugin-dependencies/" href="http://wordpress.org/plugins/plugin-dependencies/">Plugin Dependencies</a> by Scribu to control when the functionality plugin is activated. Plugin Dependencies allow you to specify if a parent plugin is deactivated, it will also deactivate the plugin dependent upon it.</p>\n<div id="attachment_17339" class="wp-caption aligncenter"><a href="http://i2.wp.com/wptavern.com/wp-content/uploads/2014/02/PluginDependenciesInAction.png" rel="prettyphoto[17319]"><img class="size-large wp-image-17339" alt="What Plugin Dependencies Does" src="http://i2.wp.com/wptavern.com/wp-content/uploads/2014/02/PluginDependenciesInAction.png?resize=500%2C155" /></a><p class="wp-caption-text">What Plugin Dependencies Does</p></div>\n<p><a title="http://make.wordpress.org/docs/plugin-developer-handbook/hooks/" href="http://make.wordpress.org/docs/plugin-developer-handbook/hooks/">Hooks</a> are a way for one piece of code to interact with and modify another piece of code. If the plugin you want to modify offers hooks, you can use them to extend the plugins functionality. According to Ian, if the developer added hooks, you just need to write a separate plugin that runs alongside the plugin you’re customizing and register callbacks for the custom hooks that the plugin provides.</p>\n<div id="attachment_17344" class="wp-caption aligncenter"><a href="http://i0.wp.com/wptavern.com/wp-content/uploads/2014/02/CodeSnippetsInAction.png" rel="prettyphoto[17319]"><img class="size-large wp-image-17344" alt="Code Snippets In Action" src="http://i0.wp.com/wptavern.com/wp-content/uploads/2014/02/CodeSnippetsInAction.png?resize=477%2C500" /></a><p class="wp-caption-text">Code Snippets In Action</p></div>\n<p><a title="http://wordpress.org/plugins/code-snippets/" href="http://wordpress.org/plugins/code-snippets/">Code Snippets</a> by Shea Bunge is an easy way to manage code snippets to extend plugins. Code Snippets is cool because it adds a GUI to create and manage code snippets. The snippets are executed as if they are located within the themes functions.php file. This added benefit alleviates the possibility of functions.php filling up with hundreds of lines of extra code. Using Code Snippets to extend plugins instead of functions.php prevents the changes from being lost when a user switches themes.</p>\n<h3>In Summary</h3>\n<p>The mantra of never editing core WordPress files should be observed for plugins and themes. The goal is to extend or remove functionality without having those changes disappear after an upgrade. It&#8217;s frowned upon to place code snippets within a theme&#8217;s functions.php file. Instead, use a functionality plugin or use the Code Snippets plugin to manage them. Plugin authors are encouraged to add hooks where they&#8217;ll make the most impact. If you&#8217;re unsure on how to add custom hooks to your plugin, there is a <a title="http://make.wordpress.org/docs/plugin-developer-handbook/hooks/creating-custom-hooks/" href="http://make.wordpress.org/docs/plugin-developer-handbook/hooks/creating-custom-hooks/">great explanation</a> available within the plugin developer handbook.</p>";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Wed, 19 Feb 2014 20:36:29 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:13:"Jeff Chandler";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:27;a:6:{s:4:"data";s:13:"\n	\n	\n	\n	\n	\n	\n";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:2:{s:0:"";a:5:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:66:"WordPress.tv: Ryan Markel: Contributing To WordPress Without Code!";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:28:"http://wordpress.tv/?p=30737";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:82:"http://wordpress.tv/2014/02/19/ryan-markel-contributing-to-wordpress-without-code/";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:680:"<div id="v-PzmAAn4H-1" class="video-player">\n</div><br />  <a rel="nofollow" href="http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/30737/"><img alt="" border="0" src="http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/30737/" /></a> <img alt="" border="0" src="http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=30737&subd=wptv&ref=&feed=1" width="1" height="1" /><div><a href="http://wordpress.tv/2014/02/19/ryan-markel-contributing-to-wordpress-without-code/"><img alt="Ryan Markel: Contributing To WordPress Without Code!" src="http://videos.videopress.com/PzmAAn4H/video-1ade089939_std.original.jpg" width="160" height="120" /></a></div>";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Wed, 19 Feb 2014 18:43:45 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:12:"WordPress.tv";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:28;a:6:{s:4:"data";s:13:"\n	\n	\n	\n	\n	\n	\n";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:2:{s:0:"";a:5:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:78:"WPTavern: New Plugin Adds bbPress and BuddyPress Conditionals to Query Monitor";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:28:"http://wptavern.com/?p=17309";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:200:"http://wptavern.com/new-plugin-adds-bbpress-and-buddypress-conditionals-to-query-monitor?utm_source=rss&utm_medium=rss&utm_campaign=new-plugin-adds-bbpress-and-buddypress-conditionals-to-query-monitor";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:2649:"<p>John Blackbourn&#8217;s <a href="http://wordpress.org/plugins/query-monitor/" target="_blank">Query Monitor</a> has quickly become a favorite debugging plugin for WordPress developers ever since it was <a href="http://wptavern.com/query-monitor-a-remarkably-comprehensive-debugging-plugin-for-wordpress" target="_blank">released</a> last November. The plugin has 227 stars on <a href="https://github.com/johnbillion/query-monitor/" target="_blank">github</a> and has been downloaded more than 5,000 times from WordPress.org.</p>\n<p>One of the unique features of Query Monitor is the ability to narrow things down by plugin or theme. For example, it displays the template filename for the current page, available body classes and active parent and child themes.</p>\n<p>Query Monitor also highlights all the <a href="http://codex.wordpress.org/Conditional_Tags" target="_blank">WordPress conditionals</a> on the current page. However, if you&#8217;re using bbPress or BuddyPress, the plugin isn&#8217;t able to pick up on these specific conditionals. The good news is that <a href="http://netweb.com.au/" target="_blank">Stephen Edgar</a> created a separate plugin to do just that.</p>\n<p><a href="http://wordpress.org/plugins/query-monitor-bbpress-buddypress-conditionals/" target="_blank">Query Monitor bbPress &amp; BuddyPress Conditionals</a> is now available on WordPress.org. When you add it to your bbPress or BuddyPress-powered site, you&#8217;ll be able to view conditionals related to those plugins:</p>\n<p><a href="http://i1.wp.com/wptavern.com/wp-content/uploads/2014/02/bb-bp-conditionals.jpg" rel="prettyphoto[17309]"><img src="http://i1.wp.com/wptavern.com/wp-content/uploads/2014/02/bb-bp-conditionals.jpg?resize=815%2C473" alt="bb-bp-conditionals" class="aligncenter size-full wp-image-17310" /></a></p>\n<p>In the example above you can see the plugin in action on a BuddyPress site with additional conditionals displayed:</p>\n<ul>\n<li>is_buddypress()</li>\n<li>bp_is_activity_component()</li>\n<li>bp_is_directory()</li>\n</ul>\n<p>The ability to quickly view these conditionals is useful when creating bbPress/BuddyPress themes and plugins. It can also be handy when working with new and unfamiliar extensions, as you try to track down what&#8217;s happening on the current page. From there you can visit the <a href="http://codex.buddypress.org/developer/template-tag-reference/#is_-functions" target="_blank">BuddyPress template tags codex page</a> or the <a href="http://codex.bbpress.org/bbpress-conditional-tags/" target="_blank">bbPress conditional tags</a> reference for more information on working with these conditionals.</p>";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Wed, 19 Feb 2014 17:35:03 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:13:"Sarah Gooding";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:29;a:6:{s:4:"data";s:13:"\n	\n	\n	\n	\n	\n	\n";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:2:{s:0:"";a:5:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:21:"Matt: Bay Area Events";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:21:"http://ma.tt/?p=43489";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:37:"http://ma.tt/2014/02/bay-area-events/";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:1521:"<p><img class="alignnone size-full wp-image-42042" src="http://i0.wp.com/s.ma.tt/files/2012/10/DSC01504.jpg?resize=604%2C403" alt="DSC01504" /></p>\n<p>I have a few engagements in the coming week in the San Francisco area and online:</p>\n<ul>\n<li>Later today I&#8217;ll be on the <a href="http://dradcast.com/">WordPress-focused podcast Dradcast</a>.</li>\n<li>This evening there will be a <a href="https://supporters.eff.org/civicrm/event/info?reset=1&id=75">Patent Happy Hour co-hosted by Engine Advocacy, EFF, and Automattic</a>.</li>\n<li>On Thursday the 20th I&#8217;ll be speaking with <a href="http://thecornice.com/">Kent Goldman</a> as part of the <a href="https://www.eventbrite.com/e/dorm-room-fund-stanford-fireside-chat-with-matt-mullenweg-tickets-10637305467?ref=esfb">First Round Capital Dorm Room Fund Speaker Series at Stanford Graduate School of Business</a>.</li>\n<li>Friday the 21st I&#8217;ll be talking with <a href="http://reidhoffman.org/">Reid Hoffman</a> as part of the LinkedIn Speaker Series at their campus, <a href="http://www.ustream.tv/channel/linkedin-speakerseries">and it will also be broadcast online</a>.</li>\n<li>Tuesday the 25th I&#8217;ll be on the <a href="http://wpthinktank.com/">WP Think Tank panel discussion</a> with a number of other notable WordPress community members.</li>\n<li>On Wednesday the 26th I&#8217;ll be<a href="http://www.commonwealthclub.org/events/2014-02-26/ben-rattray-tech-good"> interviewing Ben Rattray of Change.org at the Commonwealth Club</a>.</li>\n</ul>";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Wed, 19 Feb 2014 16:29:35 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:14:"Matt Mullenweg";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:30;a:6:{s:4:"data";s:13:"\n	\n	\n	\n	\n	\n	\n";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:2:{s:0:"";a:5:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:80:"Mark Jaquith: Don’t use template_redirect to load an alternative template file";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:40:"http://markjaquith.wordpress.com/?p=4825";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:91:"http://markjaquith.wordpress.com/2014/02/19/template_redirect-is-not-for-loading-templates/";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:1984:"<p><code>template_redirect</code> is a popular WordPress hook, for good reason. When it runs, WordPress has made its main query. All objects have been instantiated, but no output has been sent to the browser. It is your last stop to hook in and redirect the user somewhere else, and the best place to do so if you need full knowledge of the queried objects. But what it is <strong>not</strong> good for is loading an alternative template.</p>\n<p>I see code like this a lot:</p>\n<pre class="brush: php; light: true; title: ; notranslate">\nadd_action( ''template_redirect'', ''my_callback'' );\n\nfunction my_callback() {\n  if ( some_condition() ) {\n    include( SOME_PATH . ''/some-custom-file.php'' );\n    exit();\n  }\n}\n</pre>\n<p>The problem with this code is that anything hooked in to <code>template_redirect</code> <em>after</em> this code isn&#8217;t going to run! This can break sites and lead to very odd bugs. If you want to load an alternative template, there&#8217;s a filter hook for that: <code>template_include</code>.</p>\n<pre class="brush: php; light: true; title: ; notranslate">\nadd_filter( ''template_include'', ''my_callback'' );\n\nfunction my_callback( $original_template ) {\n  if ( some_condition() ) {\n    return SOME_PATH . ''/some-custom-file.php'';\n  } else {\n    return $original_template;\n  }\n}\n</pre>\n<p>Same effect, but doesn&#8217;t interfere with other plugin or theme code! This distinction should be easy to remember:</p>\n<ul>\n<li>template_<strong>redirect</strong> is for <strong>redirects</strong>.</li>\n<li>template_<strong>include</strong> is for <strong>includes</strong>.</li>\n</ul><br />  <a rel="nofollow" href="http://feeds.wordpress.com/1.0/gocomments/markjaquith.wordpress.com/4825/"><img alt="" border="0" src="http://feeds.wordpress.com/1.0/comments/markjaquith.wordpress.com/4825/" /></a> <img alt="" border="0" src="http://stats.wordpress.com/b.gif?host=markjaquith.wordpress.com&blog=316&post=4825&subd=markjaquith&ref=&feed=1" width="1" height="1" />";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Wed, 19 Feb 2014 15:19:09 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:12:"Mark Jaquith";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:31;a:6:{s:4:"data";s:13:"\n	\n	\n	\n	\n	\n	\n";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:2:{s:0:"";a:5:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:76:"WordPress.tv: Luis Rull: Jetpack: El plugin para hacerte la vida más fácil";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:28:"http://wordpress.tv/?p=25346";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:90:"http://wordpress.tv/2014/02/19/luis-rull-jetpack-el-plugin-para-hacerte-la-vida-mas-facil/";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:698:"<div id="v-B2RbcWom-1" class="video-player">\n</div><br />  <a rel="nofollow" href="http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/25346/"><img alt="" border="0" src="http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/25346/" /></a> <img alt="" border="0" src="http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=25346&subd=wptv&ref=&feed=1" width="1" height="1" /><div><a href="http://wordpress.tv/2014/02/19/luis-rull-jetpack-el-plugin-para-hacerte-la-vida-mas-facil/"><img alt="Luis Rull: Jetpack: El plugin para hacerte la vida más fácil" src="http://videos.videopress.com/B2RbcWom/video-6564c5259e_std.original.jpg" width="160" height="120" /></a></div>";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Wed, 19 Feb 2014 07:20:54 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:12:"WordPress.tv";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:32;a:6:{s:4:"data";s:13:"\n	\n	\n	\n	\n	\n	\n";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:2:{s:0:"";a:5:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:83:"WPTavern: Easily Edit Featured Images In Bulk With The Quick Featured Images Plugin";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:28:"http://wptavern.com/?p=17226";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:210:"http://wptavern.com/easily-edit-featured-images-in-bulk-with-the-quick-featured-images-plugin?utm_source=rss&utm_medium=rss&utm_campaign=easily-edit-featured-images-in-bulk-with-the-quick-featured-images-plugin";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:5710:"<p>As more WordPress themes require the use of featured images to look their best, managing those images on a per-post basis can be a time consuming task. Luckily, there is a plugin available that makes things easier. It&#8217;s called <a title="http://wordpress.org/plugins/quick-featured-images" href="http://wordpress.org/plugins/quick-featured-images">Quick Featured Images</a> developed by <a title="http://stehle-internet.de/" href="http://stehle-internet.de/">Martin Stehle</a>.</p>\n<div id="attachment_17304" class="wp-caption aligncenter"><a href="http://i0.wp.com/wptavern.com/wp-content/uploads/2014/02/QuickFeaturedImageHeader.png" rel="prettyphoto[17226]"><img class="size-large wp-image-17304" alt="Quick Featured Images Plugin Header" src="http://i0.wp.com/wptavern.com/wp-content/uploads/2014/02/QuickFeaturedImageHeader.png?resize=500%2C180" /></a><p class="wp-caption-text">Quick Featured Images Plugin Header</p></div>\n<p>Although it&#8217;s hard to make out due to the <a title="http://wordpress.org/plugins/quick-featured-images/screenshots/" href="http://wordpress.org/plugins/quick-featured-images/screenshots/">poor screenshots</a> on the WordPress plugin repository, the plugin adds three specific actions that are controllable via filters.</p>\n<ol>\n<li><strong>Adding featured images:</strong> You can set and replace an image as the new featured image to hundreds of posts in one go.</li>\n<li><strong>Exchanging featured images:</strong> You can replace or update an existing featured image with another image in one go.</li>\n<li><strong>Deleting featured images:</strong> You can remove any existing featured image from its attributed posts in one go.</li>\n</ol>\n<p>After activating, you&#8217;ll find the tools in <strong>Media &#8211; Quick Featured Image.</strong> I immediately noticed how different the page was versus the rest of the WordPress backend.</p>\n<div id="attachment_17297" class="wp-caption aligncenter"><a href="http://i0.wp.com/wptavern.com/wp-content/uploads/2014/02/QuickFeaturedImagesAdminPage.png" rel="prettyphoto[17226]"><img class="size-large wp-image-17297" alt="Crazy Background Image With Colorful Progress Bar" src="http://i0.wp.com/wptavern.com/wp-content/uploads/2014/02/QuickFeaturedImagesAdminPage.png?resize=500%2C310" /></a><p class="wp-caption-text">Crazy Background Image With Colorful Progress Bar</p></div>\n<p>I wouldn&#8217;t mind the colors used for the progress bar if it were not for the background image. It&#8217;s distracting and unnecessary. The WordPress backend is not an area where plugin authors should take the liberty of being cute using background images like the one in the screenshot. I want every settings page to be consistent with what ships with WordPress core. I don&#8217;t want to be surprised by pretty images or weird colors.</p>\n<h3>So How Does It Work?</h3>\n<p>I found it difficult to get past the first step of the process. The first three options all have links to choose an image. Naturally, I clicked on those links thinking it would open the media library allowing me to select an image. But none of the links worked. There is an area that allows me to select an image underneath the settings shown in the screenshot. However, the choose image links should work the same way.</p>\n<div id="attachment_17300" class="wp-caption aligncenter"><a href="http://i0.wp.com/wptavern.com/wp-content/uploads/2014/02/QuickFeaturedImagesChooseLinksDontWork.png" rel="prettyphoto[17226]"><img class="size-large wp-image-17300" alt="Choose Links Don''t Work" src="http://i0.wp.com/wptavern.com/wp-content/uploads/2014/02/QuickFeaturedImagesChooseLinksDontWork.png?resize=500%2C275" /></a><p class="wp-caption-text">Choose Links Don&#8217;t Work</p></div>\n<p>Once I selected an image, I moved on to step two. From here, I can select from a number of filters. These filters give users the ability to specifically control which posts are modified.</p>\n<div id="attachment_17301" class="wp-caption aligncenter"><a href="http://i0.wp.com/wptavern.com/wp-content/uploads/2014/02/QuickFeaturedImagesAddFilters.png" rel="prettyphoto[17226]"><img class="size-large wp-image-17301" alt="Filters Control Which Posts Are Modified" src="http://i0.wp.com/wptavern.com/wp-content/uploads/2014/02/QuickFeaturedImagesAddFilters.png?resize=500%2C425" /></a><p class="wp-caption-text">Filters Control Which Posts Are Modified</p></div>\n<p>The next page refines the filter used. In my example, I used the tag filter and chose Nodeki as my tag. Quick Featured Images detected three posts with the applied tag. Use caution as the changes applied can not be undone.</p>\n<div id="attachment_17302" class="wp-caption aligncenter"><a href="http://i0.wp.com/wptavern.com/wp-content/uploads/2014/02/QuickFeatureImageApplyChanges.png" rel="prettyphoto[17226]"><img class="size-large wp-image-17302" alt="Apply Changes To Posts" src="http://i0.wp.com/wptavern.com/wp-content/uploads/2014/02/QuickFeatureImageApplyChanges.png?resize=500%2C205" /></a><p class="wp-caption-text">Apply Changes To Posts</p></div>\n<p>After applying the changes, I double checked all three posts to see if the featured image had been changed. Each post showed the new image I chose in step one.</p>\n<h3>Quick Featured Images Works As Advertised</h3>\n<p>Aside from the colors, background image, and the choose image links in step one, this plugin worked as advertised. The handful of filters available to narrow down posts, including custom post types and custom taxonomies make it easy to apply changes to a specific subset of content. If you need to edit featured images for a number of posts, especially if it&#8217;s to use the same image, this plugin should do the trick.</p>";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Wed, 19 Feb 2014 01:54:47 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:13:"Jeff Chandler";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:33;a:6:{s:4:"data";s:13:"\n	\n	\n	\n	\n	\n	\n";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:2:{s:0:"";a:5:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:67:"WPTavern: This Week On WPWeekly: Chris Wallace, Founder Of UpThemes";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:28:"http://wptavern.com/?p=17290";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:174:"http://wptavern.com/this-week-on-wpweekly-chris-wallace-founder-of-upthemes?utm_source=rss&utm_medium=rss&utm_campaign=this-week-on-wpweekly-chris-wallace-founder-of-upthemes";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:1327:"<p><a href="http://i1.wp.com/wptavern.com/wp-content/uploads/2014/02/UpThemesLogo.jpg" rel="prettyphoto[17290]"><img src="http://i1.wp.com/wptavern.com/wp-content/uploads/2014/02/UpThemesLogo.jpg?resize=131%2C61" alt="UpThemes Logo" class="alignright size-full wp-image-16664" /></a>On this weeks edition of WordPress Weekly, Chris Wallace founder of <a href="https://upthemes.com/" title="https://upthemes.com/">UpThemes.com</a> will be our guest. We&#8217;re going to dive deeper into the reasons why their <a href="http://wptavern.com/upthemes-publishes-open-letter-sounds-wakeup-call-to-other-wordpress-theme-shops" title="http://wptavern.com/upthemes-publishes-open-letter-sounds-wakeup-call-to-other-wordpress-theme-shops">open letter</a> was written and published to the WordPress theme community. We&#8217;ll talk about what the state of WordPress themes are in 2014 and what UpThemes plans are for the future. I labeled their open letter as a wakeup call for theme developers, we&#8217;ll see if Chris agrees.</p>\n<p>This weeks episode will be recorded one hour earlier than normal to accommodate our guest. Recording time will be <strong>2 P.M.</strong> Eastern instead of 3 P.M. If you have any questions or concerns you&#8217;d like me to bring up to Chris during the episode, please leave them in the comments.</p>";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Wed, 19 Feb 2014 00:38:11 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:13:"Jeff Chandler";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:34;a:6:{s:4:"data";s:13:"\n	\n	\n	\n	\n	\n	\n";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:2:{s:0:"";a:5:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:106:"WPTavern: How To Prevent WordPress Plugins From Activating On Sites With Incompatible Hosting Environments";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:28:"http://wptavern.com/?p=17232";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:256:"http://wptavern.com/how-to-prevent-wordpress-plugins-from-activating-on-sites-with-incompatible-hosting-environments?utm_source=rss&utm_medium=rss&utm_campaign=how-to-prevent-wordpress-plugins-from-activating-on-sites-with-incompatible-hosting-environments";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:5302:"<p>It&#8217;s frustrating for plugin authors when users mark their plugin as broken when in fact, it&#8217;s an incompatibility with the user&#8217;s hosting environment. Too many broken plugin reports could damage the reputation of the author even if it&#8217;s not his/her fault. Pressing Matters <a title="http://pressing-matters.io/how-wordpress-plugins-can-avoid-being-marked-as-broken-by-users/" href="http://pressing-matters.io/how-wordpress-plugins-can-avoid-being-marked-as-broken-by-users/">proposed a solution</a> to the problem that while good for developers, is not great for users.</p>\n<h3>Adding Two More Sections Of Data To The Plugin Header File</h3>\n<p><a href="http://i0.wp.com/wptavern.com/wp-content/uploads/2014/02/UsualPluginMetaInformation.png" rel="prettyphoto[17232]"><img src="http://i0.wp.com/wptavern.com/wp-content/uploads/2014/02/UsualPluginMetaInformation.png?resize=188%2C117" alt="Normal Plugin Meta Information Within the Plugin Header File" class="alignright size-full wp-image-17284" /></a>Their first request is for two additional sections of meta-information to be added to the plugin <a title="http://codex.wordpress.org/File_Header" href="http://codex.wordpress.org/File_Header">file header</a>. This way, developers could specify the minimum PHP and MySQL requirements needed to successfully use the plugin. As a plugin user myself, I don&#8217;t like this method because I don&#8217;t think users should have to worry about what version of PHP or MySQL is running on their webhosting server. The plugin should either work or gracefully display an error message explaining why it won&#8217;t without causing the entire website to crash.</p>\n<p>The second technique uses an explicit <em>if statement</em> to check whether the minimum system requirements are met. If not, a prompt would be displayed informing the user the plugin is incompatible and then ask the user to upgrade. The last part of this solution is confusing. What would the user need to upgrade? It&#8217;s not like they can upgrade PHP and MySQL versions on shared hosting servers.</p>\n<h3>Gary Pendergast Has A Better Way Of Accomplishing The Goal</h3>\n<p>WordPress Developer Gary Pendergast has a better way of accomplishing the same goal. Using the code <a title="http://pento.net/2014/02/18/dont-let-your-plugin-be-activated-on-incompatible-sites/" href="http://pento.net/2014/02/18/dont-let-your-plugin-be-activated-on-incompatible-sites/">in his post</a>, plugins are only activated if a specific version of WordPress or higher is installed. With this technique, plugin authors maintain full control over when plugins are activated. If an incompatible version of WordPress is detected, a disabled notice will appear and the plugin remains deactivated.</p>\n<p>Gary&#8217;s code snippet republished with permission:</p>\n<pre class="brush: php; title: ; notranslate">//  In this example, only allow activation on WordPress 3.7 or higher\nclass MyPlugin {\n    function __construct() {\n        add_action( ''admin_init'', array( $this, ''check_version'' ) );\n\n        // Don''t run anything else in the plugin, if we''re on an incompatible WordPress version\n        if ( ! self::compatible_version() ) {\n            return;\n        }\n    }\n\n    // The primary sanity check, automatically disable the plugin on activation if it doesn''t\n    // meet minimum requirements.\n    static function activation_check() {\n        if ( ! self::compatible_version() ) {\n            deactivate_plugins( plugin_basename( __FILE__ ) );\n            wp_die( __( ''My Plugin requires WordPress 3.7 or higher!'', ''my-plugin'' ) );\n        }\n    }\n\n    // The backup sanity check, in case the plugin is activated in a weird way,\n    // or the versions change after activation.\n    function check_version() {\n        if ( ! self::compatible_version() ) {\n            if ( is_plugin_active( plugin_basename( __FILE__ ) ) ) {\n                deactivate_plugins( plugin_basename( __FILE__ ) );\n                add_action( ''admin_notices'', array( $this, ''disabled_notice'' ) );\n                if ( isset( $_GET[''activate''] ) ) {\n                    unset( $_GET[''activate''] );\n                }\n            }\n        }\n    }\n\n    function disabled_notice() {\n       echo ''&lt;strong&gt;'' . esc_html__( ''My Plugin requires WordPress 3.7 or higher!'', ''my-plugin'' ) . ''&lt;/strong&gt;'';\n    } \n\n    static function compatible_version() {\n        if ( version_compare( $GLOBALS[''wp_version''], ''3.7'', ''&lt;'' ) ) {\n             return false;\n         }\n\n        // Add sanity checks for other version requirements here\n\n        return true;\n    }\n}\n\nglobal $myplugin;\n$myplugin = new MyPlugin();\n\nregister_activation_hook( __FILE__, array( ''MyPlugin'', ''activation_check'' ) );\n</pre>\n<p>According to Gary:</p>\n<blockquote><p>It’s only a little extra code when added to a plugin, provides complete protection, and won’t cause any weirdness on the front end of your site. It’ll just deactivate itself either on activation, or when someone visits wp-admin.</p></blockquote>\n<p>It&#8217;s a bit of code that can go a long way towards making sure users are not ambushed with a broken site when activating a plugin that is incompatible with their setup. If you know a better technique, I&#8217;d love to hear about it in the comments.</p>";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Tue, 18 Feb 2014 23:45:55 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:13:"Jeff Chandler";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:35;a:6:{s:4:"data";s:13:"\n	\n	\n	\n	\n	\n	\n";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:2:{s:0:"";a:5:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:73:"WPTavern: Anders Norén on Achieving Simplicity in WordPress Theme Design";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:28:"http://wptavern.com/?p=17199";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:188:"http://wptavern.com/anders-noren-on-achieving-simplicity-in-wordpress-theme-design?utm_source=rss&utm_medium=rss&utm_campaign=anders-noren-on-achieving-simplicity-in-wordpress-theme-design";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:8822:"<p>Swedish designer Anders Norén is relatively new to the world of WordPress theme development but his breathtakingly simple themes are a refreshing addition to the ecosystem. Last August, Norén released <a href="http://wordpress.org/themes/lingonberry" target="_blank">Lingonberry</a>, a responsive, retina-ready theme with beautiful typography.</p>\n<p><a href="http://i1.wp.com/wptavern.com/wp-content/uploads/2014/02/lingonberry.jpg" rel="prettyphoto[17199]"><img src="http://i1.wp.com/wptavern.com/wp-content/uploads/2014/02/lingonberry.jpg?resize=690%2C401" alt="lingonberry" class="aligncenter size-full wp-image-17251" /></a></p>\n<p>Delighted by the success of Lingonberry, which has received more than 8,000 downloads from WordPress.org, Norén decided to develop more themes. In the past week, he&#8217;s added to his collection on WordPress.org with the release of two elegant blogging themes: <a href="http://wordpress.org/themes/wilson" target="_blank">Wilson</a> and <a href="http://wordpress.org/themes/hemingway" target="_blank">Hemingway</a>.</p>\n<p><a href="http://i1.wp.com/wptavern.com/wp-content/uploads/2014/02/wilson-hemingway.jpg" rel="prettyphoto[17199]"><img src="http://i1.wp.com/wptavern.com/wp-content/uploads/2014/02/wilson-hemingway.jpg?resize=911%2C276" alt="wilson-hemingway" class="aligncenter size-full wp-image-17254" /></a></p>\n<p>Demos for <a href="http://www.andersnoren.se/themes/wilson/" target="_blank">Wilson</a> and <a href="http://andersnoren.se/themes/hemingway/" target="_blank">Hemingway</a> can be found on Norén&#8217;s <a href="http://www.andersnoren.se/teman/" target="_blank">themes page</a>, along with <a href="http://www.andersnoren.se/teman/lasseter-wordpress-theme/" target="_blank">Lasseter</a>, his first commercial product, which is sold through <a href="http://www.mojo-themes.com/item/lasseter-wordpress-theme/" target="_blank">Mojo Themes</a>.</p>\n<h3>No Framework: Norén Starts From Scratch</h3>\n<p><a href="http://i1.wp.com/wptavern.com/wp-content/uploads/2014/02/noren.jpeg" rel="prettyphoto[17199]"><img src="http://i1.wp.com/wptavern.com/wp-content/uploads/2014/02/noren.jpeg?resize=200%2C200" alt="noren" class="alignright size-full wp-image-17256" /></a>I had the opportunity to chat with Anders Norén to get an inside look into his design and development process. His approach to crafting themes might be considered &#8220;old school&#8221; but he says it drives him to improve.</p>\n<p>When beginning something new, he takes only the essentials from previous works and uses them as building blocks. &#8220;Every time I start work on a new theme, I strip down my latest theme to the bare essentials and take it from there,&#8221; he said. <strong>&#8220;I could probably save myself some time by using a formal framework as a starting point, but I think it’s healthy to keep in touch with the fundamentals and rewrite old code.</strong> My understanding of WordPress gets a little better every time. That’s what I tell myself, at least.&#8221;</p>\n<h3>Designing to Learn</h3>\n<p>Although Norén makes a little bit of money from his commercial theme, he said that the primary reason he creates themes is to learn new things. &#8220;If I couldn&#8217;t make money from it, I’d do it for free,&#8221; he said. &#8220;It’s a great learning experience as well.&#8221; Norén described how valuable the WordPress theme review process was when he first started developing themes:</p>\n<blockquote><p>When I submitted the first version of Lingonberry, the list of errors the automated theme scanning detected covered the screen. The first version of Wilson, my latest theme, had zero errors. Going through the process of submitting Lingonberry to WordPress.org and getting it approved taught me as much about WordPress theme development as six months of client work. I would recommend anyone working with WordPress development to do it at least once.</p></blockquote>\n<p>In addition to learning, Norén also creates themes for the pure enjoyment of seeing other people use them. &#8220;The reason Lingonberry wasn’t the last theme I submitted to WordPress.org was the response,&#8221; he said. &#8220;Seeing Lingonberry being used in a thousand different ways by thousands of people around the world was amazing – still is, for that matter. It’s an indescribable feeling. It’s a great acid test for your code as well.&#8221;</p>\n<h3>Keys to Achieving Simplicity in WordPress Theme Design</h3>\n<p>I asked Norén what his guiding principle is when it comes to design. Not surprisingly, his answer echoes the sentiments of successful designers around the world: &#8220;I strive for simplicity,&#8221; he said.</p>\n<p>When it comes to achieving simplicity in the context of a WordPress theme, Norén has a few pointers for what that looks like. &#8220;In terms of visual design, that means that everything is secondary to the content,&#8221; he said. &#8220;Reduce the design to the bare necessities. <span class="pullquote alignleft">Remove the excessive stuff until it hurts.</span>&#8221;</p>\n<p>There&#8217;s a fine line between simple and painfully stark, but Norén knows not to cross it. &#8220;Simplicity is always my goal,&#8221; he said. &#8220;But I never take it as far as I would like to. Simplicity is really, really hard. Still, there are a lot of people in the WordPress community who are doing it right. <a href="http://okaythemes.com/" target="_blank">Okay Themes</a> and <a href="http://www.themezilla.com/" target="_blank">Themezilla</a> are two examples.&#8221;</p>\n<h3>Crafting Themes For Specific Use Cases</h3>\n<p>Norén isn&#8217;t fond of the previous trend in WordPress theme development, where products claim to do everything short of cooking your bacon and folding your laundry. He&#8217;s not willing to dump all of this functionality into his themes.</p>\n<p>&#8220;When it comes to designing the functionality, some people want themes with dozens of theme options and custom page builders with twenty content types,&#8221; he said. &#8220;That’s fine, but it’s not the kind of theme that I’m interested in developing. <span class="pullquote alignleft">I want to build themes that look and work great the moment they’re activated.</span> And, of course, themes that are responsive. There’s no excuse for releasing a theme that isn&#8217;t responsive in 2014.&#8221;</p>\n<p>Instead of packing a million options into his themes in hopes of selling to every possible type of customer, Norén opts for creating themes with specific use cases and providing minimal options. The results highlight the difference between a carefully crafted product and something that&#8217;s mass produced. There&#8217;s no comparison.</p>\n<h3>Finding the Courage to Sell a Commercial Product</h3>\n<p>So far, Norén has released more free themes than commercial ones, which is not often the case if one makes it his business to develop themes. I asked him if he&#8217;s planning to create a theme shop of his own in the future.</p>\n<p>&#8220;I think the reason why I’ve released most of my themes for free is a combination of <a href="http://www.mojo-themes.com/item/lasseter-wordpress-theme/" target="_blank">Lasseter</a>&#8216;s lack of success and the enjoyment I get from seeing people use what I&#8217;ve made,&#8221; he said. &#8220;That said, it’s not like it’s impossible to charge for something and have it be successful.&#8221; In terms of dollars and cents, Norén said his first attempt at selling a WordPress theme hasn&#8217;t been worth the effort.</p>\n<p>&#8220;It really comes down to insecurity on my part,&#8221; he confessed. &#8220;<span class="pullquote alignleft">It&#8217;s easy to surpass expectations when you give something away for free.</span> The bar for free WordPress themes is still pretty low, even as more and more high quality themes are being released.&#8221;</p>\n<p>However, the success of his free themes on WordPress.org is bringing him courage when looking at a possible future in the commercial theme business. &#8220;Seeing the popularity of Hemingway and Wilson, I’m starting to feel ready to give premium themes another go. I have a few ideas that I have been kicking around. It would be great for it to grow to the point where creating a theme shop would be feasible, but I’m not planning on it.&#8221;</p>\n<p>Anders Norén is one of the pioneers in the current WordPress theme revolution aimed at bringing themes back to the basics. Whether he brings his design principles into a full-fledged commercial effort or keeps them alive in the form of a hobby, his work inspires others to consider the value of keeping it simple. &#8220;Whatever happens, I have no intention to stop developing WordPress themes,&#8221; he said. &#8220;I&#8217;m having too much fun.&#8221;</p>";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Tue, 18 Feb 2014 22:05:27 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:13:"Sarah Gooding";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:36;a:6:{s:4:"data";s:13:"\n	\n	\n	\n	\n	\n	\n";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:2:{s:0:"";a:5:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:106:"WordPress.tv: Jean-François Arseneault et Emmanuelle Demeules: UN WordPress, DEUX portails, TROIS leçons";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:28:"http://wordpress.tv/?p=22695";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:71:"http://wordpress.tv/2014/02/18/un-wordpress-deux-portails-trois-lecons/";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:709:"<div id="v-t5ttYEyA-1" class="video-player">\n</div><br />  <a rel="nofollow" href="http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/22695/"><img alt="" border="0" src="http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/22695/" /></a> <img alt="" border="0" src="http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=22695&subd=wptv&ref=&feed=1" width="1" height="1" /><div><a href="http://wordpress.tv/2014/02/18/un-wordpress-deux-portails-trois-lecons/"><img alt="Jean-François Arseneault et Emmanuelle Demeules: UN WordPress, DEUX portails, TROIS leçons" src="http://videos.videopress.com/t5ttYEyA/video-7ca4d29ef5_std.original.jpg" width="160" height="120" /></a></div>";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Tue, 18 Feb 2014 19:21:57 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:12:"WordPress.tv";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:37;a:6:{s:4:"data";s:13:"\n	\n	\n	\n	\n	\n	\n";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:2:{s:0:"";a:5:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:59:"WPTavern: Aesop Story Engine Now Available On WordPress.org";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:28:"http://wptavern.com/?p=17118";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:162:"http://wptavern.com/aesop-story-engine-now-available-on-wordpress-org?utm_source=rss&utm_medium=rss&utm_campaign=aesop-story-engine-now-available-on-wordpress-org";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:3607:"<p><a href="http://i2.wp.com/wptavern.com/wp-content/uploads/2014/01/aesop1.png" rel="prettyphoto[17118]"><img src="http://i2.wp.com/wptavern.com/wp-content/uploads/2014/01/aesop1.png?resize=640%2C480" alt="aesop" class="aligncenter size-full wp-image-15676" /></a></p>\n<p>The Aesop Storytelling Engine was created to empower the art of digital storytelling by making it easy for WordPress publishers to create interactive, feature-rich posts. Before Aesop came on the scene, these types of long-form storytelling posts often required quite a bit of code and were not easy for your average user to create.</p>\n<p>The project reached another milestone today with the <a href="https://wordpress.org/plugins/aesop-story-engine/" target="_blank">The Aesop Story Engine plugin</a> now approved for WordPress.org. This further broadens Aesop&#8217;s audience to millions of WordPress users and enables notification for updates within the admin. The core storytelling engine includes more than a dozen storytelling components, which are created on the fly as you design a story within a WordPress post.</p>\n<p><a href="http://i1.wp.com/wptavern.com/wp-content/uploads/2014/02/storytelling-components.png" rel="prettyphoto[17118]"><img src="http://i1.wp.com/wptavern.com/wp-content/uploads/2014/02/storytelling-components.png?resize=1025%2C665" alt="storytelling-components" class="aligncenter size-full wp-image-17211" /></a></p>\n<h3>Theming Aesop Story Engine</h3>\n<p>It&#8217;s important to note that the plugin provides only basic styles and will not look like the <a href="http://playground.aesopstories.com" title="Aesop Demos" target="_blank">demos</a> you may have seen, especially as pertains to Timeline and Chapter components. To get the most out of Aesop you&#8217;ll need a theme that supports it.</p>\n<p>If you want to adapt your theme or develop a new one for Aesop, <a href="http://developers.aesopstories.com" target="_blank">documentation</a> is available. It covers the markup that is generated for each of the components and includes information on actions, filters, custom meta and <a href="http://developers.aesopstories.com/docs/theme-implementation/" target="_blank">theme implementation</a>.</p>\n<p>After the plugin <a href="http://wptavern.com/aesop-wordpress-storytelling-plugin-is-now-fully-funded" target="_blank">reached its funding goals</a> at the end of January, work began on refining the story telling engine and developing commercial themes for the project. I checked in with Nick Haskins, Aesop&#8217;s creator, and he said that he&#8217;s got one commercial theme in beta. &#8220;Now that the plugin is out, themes are the priority,&#8221; Haskins said. Backers of the project are currently beta testing the first theme and he hopes to have one available in approximately two weeks.</p>\n<p>In the meantime, if you&#8217;re looking for a basic theme example, download the <a href="https://github.com/bearded-avenger/aesop-sample-theme" target="_blank">Aesop Theme Sample</a> from github. It demonstrates how to implement the story engine component design. Please note that the sample theme only includes styles for the single story as an example.</p>\n<p>More information on the open source storytelling engine is available on the plugin&#8217;s <a href="http://aesopstories.com/story-engine/" target="_blank">homepage</a>. For an in depth look at the future of Aesop, check out our recent <a href="http://wptavern.com/wpweekly-episode-136-nick-haskins-creator-of-the-aesop-storytelling-engine" target="_blank">interview with Nick Haskins</a> on the WordPress Weekly podcast.</p>";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Tue, 18 Feb 2014 18:19:07 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:13:"Sarah Gooding";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:38;a:6:{s:4:"data";s:13:"\n	\n	\n	\n	\n	\n	\n";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:2:{s:0:"";a:5:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:19:"Matt: North on Maps";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:21:"http://ma.tt/?p=43487";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:35:"http://ma.tt/2014/02/north-on-maps/";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:178:"<p><a href="http://america.aljazeera.com/opinions/2014/2/maps-cartographycolonialismnortheurocentricglobe.html">How the north ended up on top of the map</a> by Nick Danforth.</p>";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Tue, 18 Feb 2014 15:31:40 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:14:"Matt Mullenweg";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:39;a:6:{s:4:"data";s:13:"\n	\n	\n	\n	\n	\n	\n";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:2:{s:0:"";a:5:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:50:"WordPress.tv: Bill Murphy: eCommerce con WordPress";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:28:"http://wordpress.tv/?p=25248";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:67:"http://wordpress.tv/2014/02/18/bill-murphy-ecommerce-con-wordpress/";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:649:"<div id="v-8KwsaF4D-1" class="video-player">\n</div><br />  <a rel="nofollow" href="http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/25248/"><img alt="" border="0" src="http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/25248/" /></a> <img alt="" border="0" src="http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=25248&subd=wptv&ref=&feed=1" width="1" height="1" /><div><a href="http://wordpress.tv/2014/02/18/bill-murphy-ecommerce-con-wordpress/"><img alt="Bill Murphy: eCommerce con WordPress" src="http://videos.videopress.com/8KwsaF4D/video-c2f7963743_std.original.jpg" width="160" height="120" /></a></div>";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Tue, 18 Feb 2014 07:10:14 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:12:"WordPress.tv";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:40;a:6:{s:4:"data";s:13:"\n	\n	\n	\n	\n	\n	\n";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:2:{s:0:"";a:5:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:94:"WPTavern: Duo Security Plugin Vulnerability Affecting A Subset Of WordPress Multisite Networks";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:28:"http://wptavern.com/?p=17191";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:232:"http://wptavern.com/duo-security-plugin-vulnerability-affecting-a-subset-of-wordpress-multisite-networks?utm_source=rss&utm_medium=rss&utm_campaign=duo-security-plugin-vulnerability-affecting-a-subset-of-wordpress-multisite-networks";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:3034:"<p><a href="http://i0.wp.com/wptavern.com/wp-content/uploads/2014/02/Duologo.png" rel="prettyphoto[17191]"><img class="alignright size-full wp-image-17201" alt="Duo Logo" src="http://i0.wp.com/wptavern.com/wp-content/uploads/2014/02/Duologo.png?resize=154%2C54" /></a>Duo Security is a business that provides two-factor authentication services across multiple platforms. Late last week, the company <a title="https://www.duosecurity.com/blog/wordpress-multisite-vulnerability-in-two-factor-authentication" href="https://www.duosecurity.com/blog/wordpress-multisite-vulnerability-in-two-factor-authentication">announced on their blog</a> they discovered a security vulnerability in their <a title="https://github.com/duosecurity/duo_wordpress" href="https://github.com/duosecurity/duo_wordpress">WordPress plugin</a>. According to Duo, the vulnerability only affects WordPress Multisite installations where the plugin is enabled on an individual per-site basis. The vulnerability may allow a user of one site within a Multisite network to bypass the second factor of authentication of another site within the same network. Within their <a title="https://www.duosecurity.com/psa/DUOPSA2014004" href="https://www.duosecurity.com/psa/DUOPSA2014004">customer bulletin</a>, they offered the following example:</p>\n<blockquote><p>A multisite WordPress deployment has two sites, Site1 and Site2, with the Duo WordPress plugin enabled for Site1 but disabled for Site2. Under normal circumstances, users logging into Site1 will be prompted for primary credentials and second-factor authentication; Site2 users will be prompted only for primary credentials. A Site1 user may force-browse to the login URL of Site2, which will authenticate the user (as part of the same WordPress multisite network), and redirect them back to Site1, without prompting for second-factor authentication.</p></blockquote>\n<p>To clarify who might be at risk, Duo outlined these three criteria:</p>\n<ul>\n<li>Only WordPress “Multisite�? deployments that have chosen to deploy the plugin on an individual site basis are affected.</li>\n<li>Normal WordPress deployments or Multisite deployments with the plugin enabled globally are <strong>NOT</strong> affected.</li>\n<li>The user must still present correct primary authentication (eg. username and password); only the second factor is bypassed.</li>\n</ul>\n<p>Duo discovered the vulnerability is not restricted to just their plugin. The company says the vulnerability exists in other two-factor authentication plugins and they have contacted those vendors to share their findings. If you use a two-factor authentication plugin other than Duo, you&#8217;re encouraged to contact the author or vendor. Ask them if their plugin contains the vulnerability and whether or not it&#8217;s been fixed.</p>\n<p>Duo has yet to announce they have permanently fixed the problem but have recommended a workaround for WordPress Multisite deployments: <em>enable duo_wordpress globally, and disable it for specific user roles.</em></p>";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Tue, 18 Feb 2014 05:16:27 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:13:"Jeff Chandler";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:41;a:6:{s:4:"data";s:13:"\n	\n	\n	\n	\n	\n	\n";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:2:{s:0:"";a:5:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:71:"WPTavern: WordPress Power Menus Plugin: Limit Access to Pages and Posts";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:28:"http://wptavern.com/?p=17177";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:184:"http://wptavern.com/wordpress-power-menus-plugin-limit-access-to-pages-and-posts?utm_source=rss&utm_medium=rss&utm_campaign=wordpress-power-menus-plugin-limit-access-to-pages-and-posts";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:2177:"<p><a href="http://i0.wp.com/wptavern.com/wp-content/uploads/2014/02/power.jpg" rel="prettyphoto[17177]"><img src="http://i0.wp.com/wptavern.com/wp-content/uploads/2014/02/power.jpg?resize=1025%2C577" alt="car" class="aligncenter size-full wp-image-17186" /></a></p>\n<p>Power Menus is a new WordPress plugin designed to make it simple to control menu items. The plugin handles both access and visibility on individual menu items and includes the following options:</p>\n<ul>\n<li>Control visibility of menu items for logged-in or non-logged-in users</li>\n<li>Show or hide items per user role</li>\n<li>Limit access to posts and pages</li>\n<li>Redirect users without required access permissions to a chosen page</li>\n</ul>\n<p>Once the plugin is installed, all of the options are found under <strong>Appearance > Menus</strong>. Here you can set the secure page that visitors will be redirected to when they do not have access. If you don&#8217;t set the secure page, the default behavior is that the menu item will be hidden but direct access to the URL will still be available.</p>\n<p>Power Menus makes it convenient to provide selective access to published content. Although WordPress already has a built-in password-protected visibility option for content, the feature can be cumbersome since you have to provide passwords and the URL to those permitted to access it. With Power Menus enabled, you can include the post/page in your menu and control its visibility based on whether or not a user is logged in or based on user role.</p>\n<p><a href="http://i1.wp.com/wptavern.com/wp-content/uploads/2014/02/power-menus.png" rel="prettyphoto[17177]"><img src="http://i1.wp.com/wptavern.com/wp-content/uploads/2014/02/power-menus.png?resize=1001%2C739" alt="power-menus" class="aligncenter size-full wp-image-17180" /></a></p>\n<p>I tested Power Menus and found the plugin to be very easy and intuitive to use. This is one that you may want to add to your plugin favorites, as it&#8217;s one of those handy tools you&#8217;ll probably need from time to time. <a href="http://wordpress.org/plugins/power-menus/" target="_blank">Download Power Menus</a> for free from WordPress.org.</p>";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Tue, 18 Feb 2014 03:56:30 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:13:"Sarah Gooding";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:42;a:6:{s:4:"data";s:13:"\n	\n	\n	\n	\n	\n	\n";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:2:{s:0:"";a:5:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:62:"WordPress.tv: Mario Peshev: WordPress Setup for Large Projects";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:28:"http://wordpress.tv/?p=27593";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:81:"http://wordpress.tv/2014/02/17/mario-peshev-wordpress-setup-for-large-projects-2/";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:681:"<div id="v-GqnmJVzu-1" class="video-player">\n</div><br />  <a rel="nofollow" href="http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/27593/"><img alt="" border="0" src="http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/27593/" /></a> <img alt="" border="0" src="http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=27593&subd=wptv&ref=&feed=1" width="1" height="1" /><div><a href="http://wordpress.tv/2014/02/17/mario-peshev-wordpress-setup-for-large-projects-2/"><img alt="Mario Peshev: WordPress Setup for Large Projects" src="http://videos.videopress.com/GqnmJVzu/video-fcec9578d6_scruberthumbnail_2.jpg" width="160" height="120" /></a></div>";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Tue, 18 Feb 2014 01:16:45 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:12:"WordPress.tv";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:43;a:6:{s:4:"data";s:13:"\n	\n	\n	\n	\n	\n	\n";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:2:{s:0:"";a:5:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:89:"WPTavern: Open Source Federal Learning Registry Offers A Plugin For WordPress Integration";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:28:"http://wptavern.com/?p=17123";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:222:"http://wptavern.com/open-source-federal-learning-registry-offers-a-plugin-for-wordpress-integration?utm_source=rss&utm_medium=rss&utm_campaign=open-source-federal-learning-registry-offers-a-plugin-for-wordpress-integration";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:5585:"<p><a href="http://i2.wp.com/wptavern.com/wp-content/uploads/2014/02/learning-registry.jpg" rel="prettyphoto[17123]"><img src="http://i2.wp.com/wptavern.com/wp-content/uploads/2014/02/learning-registry.jpg?resize=1025%2C486" alt="learning-registry" class="aligncenter size-full wp-image-17125" /></a></p>\n<p>The <a href="http://learningregistry.org/" target="_blank">Learning Registry</a> is an open source initiative dedicated to bringing together high quality digital learning resources from federal agencies and public and private organizations around the web. The registry is available for anyone to use &#8211; educators, publishers and developers are encouraged to tap into the database and add resources that haven&#8217;t yet been shared. It currently contains more than 414,000 resources.</p>\n<p>It&#8217;s not easy to discover educational resources using traditional search engines. However, the Learning Registry makes it possible for educators to find the specific materials that they need. You can test drive the registry search at the bottom of the <a href="http://learningregistry.org/" target="_blank">homepage</a>. Browse by subject or search by keyword:</p>\n<p><a href="http://i0.wp.com/wptavern.com/wp-content/uploads/2014/02/registry-test-drive.jpg" rel="prettyphoto[17123]"><img src="http://i0.wp.com/wptavern.com/wp-content/uploads/2014/02/registry-test-drive.jpg?resize=678%2C334" alt="registry-test-drive" class="aligncenter size-full wp-image-17128" /></a></p>\n<p>You can also browse by standard, i.e. Common Core Mathematics or Common Core English Language Arts.</p>\n<p>With the principles of open data making their way into education, we&#8217;re about to see an explosion of digital learning resources as content publishers begin to recognize the value of sharing to the registry. Developers can then use this data to build apps that connect educators to the learning materials.</p>\n<h3>Learning Registry WordPress Plugin</h3>\n<p>WordPress-powered websites can display data from the Learning Registry using the plugin created by the <a href="http://www.adlnet.gov/" target="_blank">Advanced Distributed Learning</a> development team. The <a href="https://github.com/adlnet/LR-Wordpress-Plugin" target="_blank">LR-Wordpress-Plugin</a> includes widgets for retrieving resources by subject, national standard, or arbitrary search terms.</p>\n<p>As part of the set-up process you&#8217;ll also be required to install the <a href="http://wordpress.org/plugins/json-api/" target="_blank">JSON API</a> plugin and <a href="http://wordpress.org/extend/plugins/widgetize-pages-light/" target="_blank">Widgetize Pages Light</a>. The LR-Wordpress-Plugin requires a few more extra steps of configuration to get everything up and running, but once you&#8217;re finished you&#8217;ll have access to a handy array of widgets for displaying data from the Learning Registry:</p>\n<p><a href="http://i2.wp.com/wptavern.com/wp-content/uploads/2014/02/lr-widgets.jpg" rel="prettyphoto[17123]"><img src="http://i2.wp.com/wptavern.com/wp-content/uploads/2014/02/lr-widgets.jpg?resize=664%2C584" alt="lr-widgets" class="aligncenter size-full wp-image-17142" /></a></p>\n<p>The most powerful of the packaged widgets provides the ability to search the registry directly from your website. During the set-up process you&#8217;ll create and designate the search results page where the information will be displayed. I hooked everything up in a test environment and found that it was able to search and retrieve data as advertsised. You can see a live example of the plugin in action at <a href="http://free.ed.gov/" target="_blank">free.ed.gov</a>:</p>\n<p><a href="http://i1.wp.com/wptavern.com/wp-content/uploads/2014/02/free.jpg" rel="prettyphoto[17123]"><img src="http://i1.wp.com/wptavern.com/wp-content/uploads/2014/02/free.jpg?resize=1025%2C520" alt="free" class="aligncenter size-full wp-image-17149" /></a></p>\n<p>If you operate a WordPress website related to learning or education, then integrating the Learning Registry plugin is an excellent way to provide access to a huge database of resources.</p>\n<p>Richard Culatta, the director of the US Education Department&#8217;s office of educational technology, wants to make the registry more useful for educators by getting more experts involved in curating the content. Since anyone can add data, it&#8217;s imperative to find helpful ways to classify the information so that educators can find the best content for their students without a lot of searching.</p>\n<p>Developers can <a href="http://learningregistry.org/developers" target="_blank">support</a> this endeavor by creating apps for displaying data and tools that make it easy for publishers to submit resources. Check out the <a href="http://docs.learningregistry.org/en/latest/start/20min.html" target="_blank">documentation</a> for more details on getting started.</p>\n<p>The Learning Registry is an open source, government-funded initiative that everyone can get behind. By providing open access to thousands of teaching resources, educators in poorly-funded school districts and perhaps other parts of the world are able to quickly find high quality resources for their students. In this digital era, educational funding doesn&#8217;t have to limit the quality of available resources for teachers. With a commitment to open access and open contribution, the <a href="http://learningregistry.org/" target="_blank">Learning Registry</a> project has the potential to efficiently deliver academic resources on a much larger scale than we&#8217;ve ever seen before.</p>";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Mon, 17 Feb 2014 22:08:09 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:13:"Sarah Gooding";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:44;a:6:{s:4:"data";s:13:"\n	\n	\n	\n	\n	\n	\n";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:2:{s:0:"";a:5:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:77:"WordPress.tv: Mike Schroder: Administra WordPress automáticamente con WP-CLI";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:28:"http://wordpress.tv/?p=25350";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:93:"http://wordpress.tv/2014/02/17/mike-schroder-administra-wordpress-automaticamente-con-wp-cli/";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:702:"<div id="v-F62k93Ya-1" class="video-player">\n</div><br />  <a rel="nofollow" href="http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/25350/"><img alt="" border="0" src="http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/25350/" /></a> <img alt="" border="0" src="http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=25350&subd=wptv&ref=&feed=1" width="1" height="1" /><div><a href="http://wordpress.tv/2014/02/17/mike-schroder-administra-wordpress-automaticamente-con-wp-cli/"><img alt="Mike Schroder: Administra WordPress automáticamente con WP-CLI" src="http://videos.videopress.com/F62k93Ya/video-c74ccd206e_std.original.jpg" width="160" height="120" /></a></div>";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Mon, 17 Feb 2014 18:17:45 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:12:"WordPress.tv";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:45;a:6:{s:4:"data";s:13:"\n	\n	\n	\n	\n	\n	\n";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:2:{s:0:"";a:5:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:55:"WPTavern: 18 Free WordPress Themes Built With Bootstrap";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:28:"http://wptavern.com/?p=17066";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:154:"http://wptavern.com/18-free-wordpress-themes-built-with-bootstrap?utm_source=rss&utm_medium=rss&utm_campaign=18-free-wordpress-themes-built-with-bootstrap";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:12422:"<p><a href="http://i2.wp.com/wptavern.com/wp-content/uploads/2014/02/bootstrap.png" rel="prettyphoto[17066]"><img src="http://i2.wp.com/wptavern.com/wp-content/uploads/2014/02/bootstrap.png?resize=250%2C250" alt="bootstrap" class="alignright size-full wp-image-17068" /></a>Last year Bootstrap joined the flat design craze with its 3.0 release and a new <a href="http://getbootstrap.com/examples/theme/" target="_blank">optional theme</a>. The default box model and basic UI components have been greatly improved. Bootstrap 3.1 introduced an official <a href="http://getbootstrap.com/css/#sass" target="_blank">Sass</a> port, further expanding the framework&#8217;s toolbox.</p>\n<p>Awhile back, we featured <a href="http://wptavern.com/10-free-wordpress-themes-based-on-the-foundation-framework">WordPress themes built using the Foundation front-end framework</a>. Since Bootstrap has been around longer, its user base is larger, which has resulted in more WordPress themes. Here&#8217;s a selection of the best, built with Bootstrap 3.</p>\n<h3>Inkness</h3>\n<p><a href="http://i2.wp.com/wptavern.com/wp-content/uploads/2014/02/responsive-inkness-shot.png" rel="prettyphoto[17066]"><img src="http://i2.wp.com/wptavern.com/wp-content/uploads/2014/02/responsive-inkness-shot.png?resize=968%2C468" alt="responsive-inkness-shot" class="aligncenter size-full wp-image-17074" /></a></p>\n<p>Inkness is a retina-ready WordPress theme, featuring a grid-based home page and multiple page layouts.<br />\n<strong><a href="http://demo.inkhive.com/inkness/" target="_blank">Download</a> | <a href="http://wordpress.org/themes/inkness" target="_blank">Demo</a></strong></p>\n<h3>Fullby</h3>\n<p><a href="http://i0.wp.com/wptavern.com/wp-content/uploads/2014/01/fullby.jpg" rel="prettyphoto[17066]"><img src="http://i0.wp.com/wptavern.com/wp-content/uploads/2014/01/fullby.jpg?resize=800%2C371" alt="fullby" class="aligncenter size-full wp-image-14808" /></a><br />\nFullby was inspired by the Twenty Fourteen default theme and built with Bootstrap under the hood. The homepage includes a fluid grid for displaying posts and a featured content area at the top.</p>\n<p><strong><a href="http://www.marchettidesign.net/fullby/" target="_blank">Download</a> | <a href="http://www.marchettidesign.net/fullby/demo/" target="_blank">Demo</a><strong></p>\n<h3>WP Knowledge Base</h3>\n<p><a href="http://i2.wp.com/wptavern.com/wp-content/uploads/2013/12/responsive-knowledgebase-theme.jpg" rel="prettyphoto[17066]"><img src="http://i2.wp.com/wptavern.com/wp-content/uploads/2013/12/responsive-knowledgebase-theme.jpg?resize=603%2C396" alt="responsive-knowledgebase-theme" class="aligncenter size-full wp-image-12691" /></a></p>\n<p>WP Knowledge Base is a theme for creating a multi-product knowledge base. It&#8217;s compatible with a number of Bootstrap plugins and includes support for bbPress.</p>\n<p><strong><a href="http://wordpress.org/themes/wp-knowledge-base" target="_blank">Download</a> | <a href="http://ipanelthemes.com/kb/" target="_blank">Demo</a><strong></p>\n<h3>Arcade Basic</h3>\n<p><a href="http://i2.wp.com/wptavern.com/wp-content/uploads/2014/02/arcade-responsive.png" rel="prettyphoto[17066]"><img src="http://i2.wp.com/wptavern.com/wp-content/uploads/2014/02/arcade-responsive.png?resize=675%2C427" alt="arcade-responsive" class="aligncenter size-full wp-image-16886" /></a></p>\n<p>Arcade Basic is a beautiful theme with a bold homepage design and many options built into WordPress&#8217; customizer feature. It supports post formats and includes special styles for Jetpack galleries.</p>\n<p><strong><a href="http://wordpress.org/themes/arcade-basic" target="_blank">Download</a> | <a href="http://demos.bavotasan.com/arcade/" target="_blank">Demo</a><strong></p>\n<h3>Stanley WP</h3>\n<p><a href="http://i0.wp.com/wptavern.com/wp-content/uploads/2014/01/stanleywp.png" rel="prettyphoto[17066]"><img src="http://i0.wp.com/wptavern.com/wp-content/uploads/2014/01/stanleywp.png?resize=1025%2C567" alt="stanleywp" class="aligncenter size-full wp-image-15896" /></a></p>\n<p>Stanley WP is a unique theme that works well for personal branding. It&#8217;s packaged with a drag-and-drop homepage builder and three different page templates.</p>\n<p><strong><a href="http://gentsthemes.com/themes/stanleywp-twitter-bootstrap-wordpress-theme/" target="_blank">Download</a> | <a href="http://gentsthemes.com/demo/stanleywp/" target="_blank">Demo</a><strong></p>\n<h3>GovFresh WP</h3>\n<p><a href="http://i2.wp.com/wptavern.com/wp-content/uploads/2014/01/govfreshwp.png" rel="prettyphoto[17066]"><img src="http://i2.wp.com/wptavern.com/wp-content/uploads/2014/01/govfreshwp.png?resize=671%2C374" alt="govfreshwp" class="aligncenter size-full wp-image-15633" /></a></p>\n<p>GovFresh was created specifically for governments and comes with a list of <a href="http://wp.govfresh.com/plugins/" target="_blank">recommended plugins</a> to extend the theme.</p>\n<p><strong><a href="https://github.com/govfresh/govpress" target="_blank">Download</a> | <a href="http://wp.govfresh.com/" target="_blank">Demo</a><strong></p>\n<h3>Romangie</h3>\n<p><a href="http://i0.wp.com/wptavern.com/wp-content/uploads/2013/12/romangie.png" rel="prettyphoto[17066]"><img src="http://i0.wp.com/wptavern.com/wp-content/uploads/2013/12/romangie.png?resize=905%2C884" alt="romangie" class="aligncenter size-full wp-image-13516" /></a><br />\nRomangie is a retina-ready theme with support for post formats. It provides a quality browsing experience for users on mobile devices and desktops.</p>\n<p><strong><a href="http://wordpress.org/themes/romangie" target="_blank">Download</a> | <a href="http://themes.tobscore.com/romangie/demo/" target="_blank">Demo</a><strong></p>\n<h3>Blain</h3>\n<p><a href="http://i0.wp.com/wptavern.com/wp-content/uploads/2014/02/blain.png" rel="prettyphoto[17066]"><img src="http://i0.wp.com/wptavern.com/wp-content/uploads/2014/02/blain.png?resize=968%2C468" alt="blain" class="aligncenter size-full wp-image-17083" /></a></p>\n<p>Blain sports a minimalist design with a responsive slider, customizable header and footer, four page layouts and custom widgets for displaying recent posts and thumbnails.</p>\n<p><strong><a href="http://inkhive.com/product/blain/" target="_blank">Download</a> | <a href="http://demo.inkhive.com/blain/" target="_blank">Demo</a><strong></p>\n<h3>Adament</h3>\n<p><a href="http://i1.wp.com/wptavern.com/wp-content/uploads/2014/02/adament.png" rel="prettyphoto[17066]"><img src="http://i1.wp.com/wptavern.com/wp-content/uploads/2014/02/adament.png?resize=900%2C538" alt="adament" class="aligncenter size-full wp-image-17084" /></a></p>\n<p><strong><a href="http://www.fabthemes.com/adament/" target="_blank">Download</a> | <a href="http://demo.fabthemes.com/adament/" target="_blank">Demo</a><strong></p>\n<h3>Lobster</h3>\n<p><a href="http://i0.wp.com/wptavern.com/wp-content/uploads/2014/02/lobster.png" rel="prettyphoto[17066]"><img src="http://i0.wp.com/wptavern.com/wp-content/uploads/2014/02/lobster.png?resize=600%2C450" alt="lobster" class="aligncenter size-full wp-image-17086" /></a><br />\nLobster is named after the font featured in the theme. The background and page layouts are fully customizable and the theme includes support for post formats, bbPress and BuddyPress.</p>\n<p><strong><a href="http://wordpress.org/themes/lobster" target="_blank">Download</a> | <a href="http://cyberdesigncraft.com/themes/wordpress/lobster/" target="_blank">Demo</a><strong></p>\n<h3>Revera</h3>\n<p><a href="http://i1.wp.com/wptavern.com/wp-content/uploads/2014/02/revera.png" rel="prettyphoto[17066]"><img src="http://i1.wp.com/wptavern.com/wp-content/uploads/2014/02/revera.png?resize=900%2C575" alt="revera" class="aligncenter size-full wp-image-17087" /></a></p>\n<p>Revera features a big slider on the homepage, configurable banner advertisement spaces and a custom portfolio page template.</p>\n<p><strong><a href="http://www.fabthemes.com/revera/" target="_blank">Download</a> | <a href="http://demo.fabthemes.com/revera/" target="_blank">Demo</a><strong></p>\n<h3>Unite</h3>\n<p><a href="http://i0.wp.com/wptavern.com/wp-content/uploads/2014/02/unite.png" rel="prettyphoto[17066]"><img src="http://i0.wp.com/wptavern.com/wp-content/uploads/2014/02/unite.png?resize=880%2C660" alt="unite" class="aligncenter size-full wp-image-17089" /></a></p>\n<p>Unite sports a flat design for wedding websites, although it can be used with other types of creative websites with a focus on images. All of the colors are easily customizable via the theme options.</p>\n<p><strong><a href="http://wordpress.org/themes/unite" target="_blank">Download</a> | <a href="http://colorlib.com/unite/" target="_blank">Demo</a><strong></p>\n<h3>Flat Theme</h3>\n<p><a href="http://i0.wp.com/wptavern.com/wp-content/uploads/2014/02/flat-theme.png" rel="prettyphoto[17066]"><img src="http://i0.wp.com/wptavern.com/wp-content/uploads/2014/02/flat-theme.png?resize=900%2C439" alt="flat-theme" class="aligncenter size-full wp-image-17091" /></a></p>\n<p>The Flat Theme features a filterable portfolio and a host of extra page designs, including pricing tables, about us, services, custom 404, contact page, career, FAQ, P=privacy and terms of use</p>\n<p><strong><a href="http://shapebootstrap.net/item/flat-theme-best-free-responsive-multipurpose-wordpress-theme/" target="_blank">Download</a> | <a href="http://shapebootstrap.net/demo/wordpress/flat_theme/" target="_blank">Demo</a><strong></p>\n<h3>Nova Lite</h3>\n<p><a href="http://i1.wp.com/wptavern.com/wp-content/uploads/2014/02/nova.png" rel="prettyphoto[17066]"><img src="http://i1.wp.com/wptavern.com/wp-content/uploads/2014/02/nova.png?resize=880%2C660" alt="nova" class="aligncenter size-full wp-image-17092" /></a></p>\n<p>Nova Lite is a tumblog-style theme that allows you to create unlimited custom sidebars.</p>\n<p><strong><a href="http://wordpress.org/themes/nova-lite" target="_blank">Download</a> | <a href="http://themeinprogress.com/demo/nova/" target="_blank">Demo</a><strong></p>\n<h3>Wembley</h3>\n<p><a href="http://i0.wp.com/wptavern.com/wp-content/uploads/2014/02/wembley.png" rel="prettyphoto[17066]"><img src="http://i0.wp.com/wptavern.com/wp-content/uploads/2014/02/wembley.png?resize=900%2C730" alt="wembley" class="aligncenter size-full wp-image-17094" /></a></p>\n<p>Wembley is a portfolio theme built with Bootstrap. It makes it easy to upload a logo, change the main color scheme and configure the banner ads.</p>\n<p><strong><a href="http://www.fabthemes.com/wembley/" target="_blank">Download </a>| <a href="http://demo.fabthemes.com/wembley/" target="_blank">Demo</a><strong></p>\n<h3>Flat</h3>\n<p><a href="http://i0.wp.com/wptavern.com/wp-content/uploads/2014/02/flat.png" rel="prettyphoto[17066]"><img src="http://i0.wp.com/wptavern.com/wp-content/uploads/2014/02/flat.png?resize=880%2C660" alt="flat" class="aligncenter size-full wp-image-17115" /></a></p>\n<p>Flat is a blogging theme based on Bootstrap. It features an off-canvas sidebar and a customizable blurred background.</p>\n<p><strong><a href="http://wordpress.org/themes/flat" target="_blank">Download</a> | <a href="http://demo.yoarts.com/flatblog" target="_blank">Demo</a><strong></p>\n<h3>Vangard</h3>\n<p><a href="http://i2.wp.com/wptavern.com/wp-content/uploads/2014/02/vangard1.png" rel="prettyphoto[17066]"><img src="http://i2.wp.com/wptavern.com/wp-content/uploads/2014/02/vangard1.png?resize=900%2C542" alt="vangard" class="aligncenter size-full wp-image-17098" /></a></p>\n<p>The Vangard theme sports a customizable jQuery content slider, welcome section, widgetized footer and a blog-oriented homepage.</p>\n<p><strong><a href="http://www.fabthemes.com/vangard/" target="_blank">Download</a> | <a href="http://demo.fabthemes.com/vangard/" target="_blank">Demo</a><strong></p>\n<h3>Ward</h3>\n<p><a href="http://i2.wp.com/wptavern.com/wp-content/uploads/2014/02/ward.png" rel="prettyphoto[17066]"><img src="http://i2.wp.com/wptavern.com/wp-content/uploads/2014/02/ward.png?resize=600%2C450" alt="ward" class="aligncenter size-full wp-image-17101" /></a></p>\n<p>Ward has a unique layout and includes support for post formats. It&#8217;s easy to customize using WordPress&#8217; built-in customizer and is compatible with both bbPress &amp; BuddyPress.</p>\n<p><strong><a href="http://wordpress.org/themes/ward" target="_blank">Download</a> | <a href="http://demos.bavotasan.com/ward-pro/" target="_blank">Demo</a><strong></p>";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Mon, 17 Feb 2014 08:54:49 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:13:"Sarah Gooding";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:46;a:6:{s:4:"data";s:13:"\n	\n	\n	\n	\n	\n	\n";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:2:{s:0:"";a:5:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:61:"WordPress.tv: Brent Shepherd: Wooing eCommerce With WordPress";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:28:"http://wordpress.tv/?p=31274";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:78:"http://wordpress.tv/2014/02/15/brent-shepherd-wooing-ecommerce-with-wordpress/";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:671:"<div id="v-hah765iA-1" class="video-player">\n</div><br />  <a rel="nofollow" href="http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/31274/"><img alt="" border="0" src="http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/31274/" /></a> <img alt="" border="0" src="http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=31274&subd=wptv&ref=&feed=1" width="1" height="1" /><div><a href="http://wordpress.tv/2014/02/15/brent-shepherd-wooing-ecommerce-with-wordpress/"><img alt="Brent Shepherd: Wooing eCommerce With WordPress" src="http://videos.videopress.com/hah765iA/video-42d78ef613_std.original.jpg" width="160" height="120" /></a></div>";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Sat, 15 Feb 2014 18:22:23 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:12:"WordPress.tv";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:47;a:6:{s:4:"data";s:13:"\n	\n	\n	\n	\n	\n	\n";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:2:{s:0:"";a:5:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:82:"WordPress.tv: Joe Manna: Insider’s Guide To Marketing And Selling With WordPress";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:28:"http://wordpress.tv/?p=31245";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:96:"http://wordpress.tv/2014/02/15/joe-manna-insiders-guide-to-marketing-and-selling-with-wordpress/";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:710:"<div id="v-0CSB7ui8-1" class="video-player">\n</div><br />  <a rel="nofollow" href="http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/31245/"><img alt="" border="0" src="http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/31245/" /></a> <img alt="" border="0" src="http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=31245&subd=wptv&ref=&feed=1" width="1" height="1" /><div><a href="http://wordpress.tv/2014/02/15/joe-manna-insiders-guide-to-marketing-and-selling-with-wordpress/"><img alt="Joe Manna: Insider’s Guide To Marketing And Selling With WordPress" src="http://videos.videopress.com/0CSB7ui8/video-923de1ee00_std.original.jpg" width="160" height="120" /></a></div>";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Sat, 15 Feb 2014 17:38:40 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:12:"WordPress.tv";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:48;a:6:{s:4:"data";s:13:"\n	\n	\n	\n	\n	\n	\n";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:2:{s:0:"";a:5:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:75:"WordPress.tv: Elisa Camahort Page: Monetize Your WordPress Website And Blog";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:28:"http://wordpress.tv/?p=31243";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:92:"http://wordpress.tv/2014/02/15/elisa-camahort-page-monetize-your-wordpress-website-and-blog/";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:699:"<div id="v-VoXUGLni-1" class="video-player">\n</div><br />  <a rel="nofollow" href="http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/31243/"><img alt="" border="0" src="http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/31243/" /></a> <img alt="" border="0" src="http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=31243&subd=wptv&ref=&feed=1" width="1" height="1" /><div><a href="http://wordpress.tv/2014/02/15/elisa-camahort-page-monetize-your-wordpress-website-and-blog/"><img alt="Elisa Camahort Page: Monetize Your WordPress Website And Blog" src="http://videos.videopress.com/VoXUGLni/video-2c6bc9ed1a_std.original.jpg" width="160" height="120" /></a></div>";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Sat, 15 Feb 2014 16:01:44 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:12:"WordPress.tv";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:49;a:6:{s:4:"data";s:13:"\n	\n	\n	\n	\n	\n	\n";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:2:{s:0:"";a:5:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:63:"WPTavern: WooThemes Replaces Theme Club With All Themes Package";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:28:"http://wptavern.com/?p=16999";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:170:"http://wptavern.com/woothemes-replaces-theme-club-with-all-themes-package?utm_source=rss&utm_medium=rss&utm_campaign=woothemes-replaces-theme-club-with-all-themes-package";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:2654:"<p><a href="http://i0.wp.com/wptavern.com/wp-content/uploads/2009/09/woothemeslogo.png" rel="prettyphoto[16999]"><img class="alignright size-full wp-image-2368" alt="woothemes logo" src="http://i0.wp.com/wptavern.com/wp-content/uploads/2009/09/woothemeslogo.png?resize=171%2C52" /></a>WooThemes <a title="http://www.woothemes.com/2014/02/all-themes-in-a-single-package/" href="http://www.woothemes.com/2014/02/all-themes-in-a-single-package/">has announced</a> they will no longer be offering subscriptions to their theme club, a concept they helped pioneer in 2008. With a monthly subscription, buyers would gain access to all available themes as well as themes released during their subscription period.</p>\n<p>The theme club has been replaced by a new package called <strong>ATP</strong> or <strong>All Themes Package</strong>. For a yearly fee, buyers gain access to the entire WooThemes catalog. Some of their customers <a title="https://www.woothemes.com/2014/02/all-themes-in-a-single-package/#comment-918591" href="https://www.woothemes.com/2014/02/all-themes-in-a-single-package/#comment-918591">are upset</a> because the monthly cost was easier to handle than a lump sum every year. However, WooThemes has grandfathered theme club subscribers into the new package and has given them one free year of access. They&#8217;ll also save money in the long run since the yearly fee is cheaper than the original 12 month plan.</p>\n<div id="attachment_17041" class="wp-caption aligncenter"><a href="http://i1.wp.com/wptavern.com/wp-content/uploads/2014/02/AllThemesPackagePrice.png" rel="prettyphoto[16999]"><img class="size-large wp-image-17041" alt="All Themes Package Normal Price" src="http://i1.wp.com/wptavern.com/wp-content/uploads/2014/02/AllThemesPackagePrice.png?resize=500%2C231" /></a><p class="wp-caption-text">All Themes Package Normal Price</p></div>\n<p>Those who are grandfathered into the new package won&#8217;t have to pay the full price of $399 to renew their account. Since WooThemes offers renewals at 50% of their normal price, grandfathered users will only have to pay $200 to renew. In summary, this is an excellent turn of events for previous theme club members.</p>\n<p>Compared to the <a title="http://wptavern.com/major-pricing-changes-at-woothemes" href="http://wptavern.com/major-pricing-changes-at-woothemes">major price change debacle</a> to Woo Commerce last year, this has been easier for customers to support. WooThemes clearly communicated the changes without putting the blame on their customers.</p>\n<p><strong>If you&#8217;re a WooThemes club member, let us know what you think in the comments.<br />\n</strong></p>";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Sat, 15 Feb 2014 01:26:58 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:13:"Jeff Chandler";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}}}}}}}}}}}}s:4:"type";i:128;s:7:"headers";a:11:{s:3:"via";s:11:"1.1 ARM-005";s:10:"connection";s:5:"close";s:16:"proxy-connection";s:5:"close";s:14:"content-length";s:6:"189995";s:4:"date";s:29:"Tue, 25 Feb 2014 04:08:56 GMT";s:12:"content-type";s:8:"text/xml";s:6:"server";s:5:"nginx";s:4:"vary";s:15:"Accept-Encoding";s:13:"last-modified";s:29:"Tue, 25 Feb 2014 04:00:12 GMT";s:4:"x-nc";s:11:"HIT lax 250";s:13:"accept-ranges";s:5:"bytes";}s:5:"build";s:14:"20130910223210";}', 'no');
INSERT INTO `goStores_Vista_wp_options` (`option_id`, `option_name`, `option_value`, `autoload`) VALUES
(155, '_transient_timeout_feed_mod_b9388c83948825c1edaef0d856b7b109', '1393344309', 'no'),
(156, '_transient_feed_mod_b9388c83948825c1edaef0d856b7b109', '1393301109', 'no'),
(153, '_transient_timeout_feed_b9388c83948825c1edaef0d856b7b109', '1393344309', 'no'),
(154, '_transient_feed_b9388c83948825c1edaef0d856b7b109', 'a:4:{s:5:"child";a:1:{s:0:"";a:1:{s:3:"rss";a:1:{i:0;a:6:{s:4:"data";s:3:"\n	\n";s:7:"attribs";a:1:{s:0:"";a:1:{s:7:"version";s:3:"2.0";}}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:1:{s:0:"";a:1:{s:7:"channel";a:1:{i:0;a:6:{s:4:"data";s:72:"\n		\n		\n		\n		\n		\n		\n				\n\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n\n	";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:2:{s:0:"";a:7:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:39:"WordPress Plugins » View: Most Popular";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:44:"http://wordpress.org/plugins/browse/popular/";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:39:"WordPress Plugins » View: Most Popular";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:8:"language";a:1:{i:0;a:5:{s:4:"data";s:5:"en-US";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Tue, 25 Feb 2014 03:44:21 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:9:"generator";a:1:{i:0;a:5:{s:4:"data";s:25:"http://bbpress.org/?v=1.1";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"item";a:15:{i:0;a:6:{s:4:"data";s:30:"\n			\n			\n			\n			\n			\n			\n					";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:2:{s:0:"";a:5:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:14:"Contact Form 7";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:54:"http://wordpress.org/plugins/contact-form-7/#post-2141";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Thu, 02 Aug 2007 12:45:03 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:34:"2141@http://wordpress.org/plugins/";s:7:"attribs";a:1:{s:0:"";a:1:{s:11:"isPermaLink";s:5:"false";}}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:54:"Just another contact form plugin. Simple but flexible.";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:16:"Takayuki Miyoshi";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:1;a:6:{s:4:"data";s:30:"\n			\n			\n			\n			\n			\n			\n					";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:2:{s:0:"";a:5:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:19:"All in One SEO Pack";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:58:"http://wordpress.org/plugins/all-in-one-seo-pack/#post-753";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Fri, 30 Mar 2007 20:08:18 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:33:"753@http://wordpress.org/plugins/";s:7:"attribs";a:1:{s:0:"";a:1:{s:11:"isPermaLink";s:5:"false";}}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:126:"All in One SEO Pack is a WordPress SEO plugin to automatically optimize your WordPress blog for Search Engines such as Google.";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:8:"uberdose";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:2;a:6:{s:4:"data";s:30:"\n			\n			\n			\n			\n			\n			\n					";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:2:{s:0:"";a:5:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:24:"Jetpack by WordPress.com";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:48:"http://wordpress.org/plugins/jetpack/#post-23862";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Thu, 20 Jan 2011 02:21:38 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:35:"23862@http://wordpress.org/plugins/";s:7:"attribs";a:1:{s:0:"";a:1:{s:11:"isPermaLink";s:5:"false";}}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:104:"Supercharge your WordPress site with powerful features previously only available to WordPress.com users.";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:9:"Tim Moore";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:3;a:6:{s:4:"data";s:30:"\n			\n			\n			\n			\n			\n			\n					";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:2:{s:0:"";a:5:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:22:"WordPress SEO by Yoast";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:53:"http://wordpress.org/plugins/wordpress-seo/#post-8321";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Thu, 01 Jan 2009 20:34:44 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:34:"8321@http://wordpress.org/plugins/";s:7:"attribs";a:1:{s:0:"";a:1:{s:11:"isPermaLink";s:5:"false";}}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:131:"Improve your WordPress SEO: Write better content and have a fully optimized WordPress site using the WordPress SEO plugin by Yoast.";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:13:"Joost de Valk";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:4;a:6:{s:4:"data";s:30:"\n			\n			\n			\n			\n			\n			\n					";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:2:{s:0:"";a:5:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:33:"WooCommerce - excelling eCommerce";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:52:"http://wordpress.org/plugins/woocommerce/#post-29860";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Mon, 05 Sep 2011 08:13:36 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:35:"29860@http://wordpress.org/plugins/";s:7:"attribs";a:1:{s:0:"";a:1:{s:11:"isPermaLink";s:5:"false";}}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:97:"WooCommerce is a powerful, extendable eCommerce plugin that helps you sell anything. Beautifully.";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:9:"WooThemes";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:5;a:6:{s:4:"data";s:30:"\n			\n			\n			\n			\n			\n			\n					";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:2:{s:0:"";a:5:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:18:"WordPress Importer";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:59:"http://wordpress.org/plugins/wordpress-importer/#post-18101";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Thu, 20 May 2010 17:42:45 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:35:"18101@http://wordpress.org/plugins/";s:7:"attribs";a:1:{s:0:"";a:1:{s:11:"isPermaLink";s:5:"false";}}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:101:"Import posts, pages, comments, custom fields, categories, tags and more from a WordPress export file.";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:14:"Brian Colinger";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:6;a:6:{s:4:"data";s:30:"\n			\n			\n			\n			\n			\n			\n					";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:2:{s:0:"";a:5:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:30:"Google Analytics for WordPress";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:70:"http://wordpress.org/plugins/google-analytics-for-wordpress/#post-2316";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Fri, 14 Sep 2007 12:15:27 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:34:"2316@http://wordpress.org/plugins/";s:7:"attribs";a:1:{s:0:"";a:1:{s:11:"isPermaLink";s:5:"false";}}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:145:"Track your WordPress site easily and with lots of metadata: views per author &#38; category, automatic tracking of outbound clicks and pageviews.";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:13:"Joost de Valk";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:7;a:6:{s:4:"data";s:30:"\n			\n			\n			\n			\n			\n			\n					";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:2:{s:0:"";a:5:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:19:"Google XML Sitemaps";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:63:"http://wordpress.org/plugins/google-sitemap-generator/#post-132";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Fri, 09 Mar 2007 22:31:32 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:33:"132@http://wordpress.org/plugins/";s:7:"attribs";a:1:{s:0:"";a:1:{s:11:"isPermaLink";s:5:"false";}}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:105:"This plugin will generate a special XML sitemap which will help search engines to better index your blog.";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:5:"Arnee";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:8;a:6:{s:4:"data";s:30:"\n			\n			\n			\n			\n			\n			\n					";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:2:{s:0:"";a:5:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:7:"Akismet";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:45:"http://wordpress.org/plugins/akismet/#post-15";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Fri, 09 Mar 2007 22:11:30 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:32:"15@http://wordpress.org/plugins/";s:7:"attribs";a:1:{s:0:"";a:1:{s:11:"isPermaLink";s:5:"false";}}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:98:"Akismet checks your comments against the Akismet web service to see if they look like spam or not.";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:14:"Matt Mullenweg";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:9;a:6:{s:4:"data";s:30:"\n			\n			\n			\n			\n			\n			\n					";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:2:{s:0:"";a:5:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:11:"WP-PageNavi";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:50:"http://wordpress.org/plugins/wp-pagenavi/#post-363";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Fri, 09 Mar 2007 23:17:57 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:33:"363@http://wordpress.org/plugins/";s:7:"attribs";a:1:{s:0:"";a:1:{s:11:"isPermaLink";s:5:"false";}}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:49:"Adds a more advanced paging navigation interface.";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:11:"Lester Chan";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:10;a:6:{s:4:"data";s:30:"\n			\n			\n			\n			\n			\n			\n					";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:2:{s:0:"";a:5:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:15:"NextGEN Gallery";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:55:"http://wordpress.org/plugins/nextgen-gallery/#post-1169";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Mon, 23 Apr 2007 20:08:06 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:34:"1169@http://wordpress.org/plugins/";s:7:"attribs";a:1:{s:0:"";a:1:{s:11:"isPermaLink";s:5:"false";}}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:122:"The most popular WordPress gallery plugin and one of the most popular plugins of all time with over 7.5 million downloads.";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:9:"Alex Rabe";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:11;a:6:{s:4:"data";s:30:"\n			\n			\n			\n			\n			\n			\n					";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:2:{s:0:"";a:5:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:12:"Contact Form";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:60:"http://wordpress.org/plugins/contact-form-plugin/#post-26890";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Thu, 26 May 2011 07:34:58 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:35:"26890@http://wordpress.org/plugins/";s:7:"attribs";a:1:{s:0:"";a:1:{s:11:"isPermaLink";s:5:"false";}}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:43:"Add Contact Form to your WordPress website.";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:11:"bestwebsoft";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:12;a:6:{s:4:"data";s:30:"\n			\n			\n			\n			\n			\n			\n					";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:2:{s:0:"";a:5:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:15:"BackUpWordPress";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:55:"http://wordpress.org/plugins/backupwordpress/#post-2236";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Sun, 02 Sep 2007 21:15:07 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:34:"2236@http://wordpress.org/plugins/";s:7:"attribs";a:1:{s:0:"";a:1:{s:11:"isPermaLink";s:5:"false";}}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:60:"Simple automated back ups of your WordPress powered website.";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:11:"Tom Willmot";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:13;a:6:{s:4:"data";s:30:"\n			\n			\n			\n			\n			\n			\n					";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:2:{s:0:"";a:5:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:16:"TinyMCE Advanced";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:56:"http://wordpress.org/plugins/tinymce-advanced/#post-2082";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Wed, 27 Jun 2007 15:00:26 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:34:"2082@http://wordpress.org/plugins/";s:7:"attribs";a:1:{s:0:"";a:1:{s:11:"isPermaLink";s:5:"false";}}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:71:"Enables the advanced features of TinyMCE, the WordPress WYSIWYG editor.";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:10:"Andrew Ozz";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}i:14;a:6:{s:4:"data";s:30:"\n			\n			\n			\n			\n			\n			\n					";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";s:5:"child";a:2:{s:0:"";a:5:{s:5:"title";a:1:{i:0;a:5:{s:4:"data";s:14:"WP Super Cache";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:54:"http://wordpress.org/plugins/wp-super-cache/#post-2572";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:7:"pubDate";a:1:{i:0;a:5:{s:4:"data";s:31:"Mon, 05 Nov 2007 11:40:04 +0000";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:4:"guid";a:1:{i:0;a:5:{s:4:"data";s:34:"2572@http://wordpress.org/plugins/";s:7:"attribs";a:1:{s:0:"";a:1:{s:11:"isPermaLink";s:5:"false";}}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}s:11:"description";a:1:{i:0;a:5:{s:4:"data";s:73:"A very fast caching engine for WordPress that produces static html files.";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}s:32:"http://purl.org/dc/elements/1.1/";a:1:{s:7:"creator";a:1:{i:0;a:5:{s:4:"data";s:16:"Donncha O Caoimh";s:7:"attribs";a:0:{}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}}}s:27:"http://www.w3.org/2005/Atom";a:1:{s:4:"link";a:1:{i:0;a:5:{s:4:"data";s:0:"";s:7:"attribs";a:1:{s:0:"";a:3:{s:4:"href";s:45:"http://wordpress.org/plugins/rss/view/popular";s:3:"rel";s:4:"self";s:4:"type";s:19:"application/rss+xml";}}s:8:"xml_base";s:0:"";s:17:"xml_base_explicit";b:0;s:8:"xml_lang";s:0:"";}}}}}}}}}}}}s:4:"type";i:128;s:7:"headers";a:12:{s:3:"via";s:11:"1.1 ARM-005";s:10:"connection";s:5:"close";s:16:"proxy-connection";s:5:"close";s:7:"expires";s:29:"Tue, 25 Feb 2014 04:19:22 GMT";s:4:"date";s:29:"Tue, 25 Feb 2014 04:08:58 GMT";s:12:"content-type";s:23:"text/xml; charset=UTF-8";s:6:"server";s:5:"nginx";s:4:"vary";s:15:"Accept-Encoding";s:13:"cache-control";s:0:"";s:6:"pragma";s:0:"";s:13:"last-modified";s:31:"Tue, 25 Feb 2014 03:44:22 +0000";s:4:"x-nc";s:11:"HIT lax 250";}s:5:"build";s:14:"20130910223210";}', 'no'),
(128, '_transient_timeout_plugin_slugs', '1393387743', 'no'),
(129, '_transient_plugin_slugs', 'a:3:{i:0;s:19:"akismet/akismet.php";i:1;s:37:"custom-admin-bar/custom-admin-bar.php";i:2;s:9:"hello.php";}', 'no'),
(135, 'recently_activated', 'a:1:{s:51:"wp-gallery-custom-links/wp-gallery-custom-links.php";i:1393244730;}', 'yes'),
(136, '_site_transient_timeout_poptags_40cd750bba9870f18aada2478b24840a', '1393255381', 'yes'),
(137, '_site_transient_poptags_40cd750bba9870f18aada2478b24840a', 'a:40:{s:6:"widget";a:3:{s:4:"name";s:6:"widget";s:4:"slug";s:6:"widget";s:5:"count";s:4:"3898";}s:4:"post";a:3:{s:4:"name";s:4:"Post";s:4:"slug";s:4:"post";s:5:"count";s:4:"2456";}s:6:"plugin";a:3:{s:4:"name";s:6:"plugin";s:4:"slug";s:6:"plugin";s:5:"count";s:4:"2344";}s:5:"admin";a:3:{s:4:"name";s:5:"admin";s:4:"slug";s:5:"admin";s:5:"count";s:4:"1930";}s:5:"posts";a:3:{s:4:"name";s:5:"posts";s:4:"slug";s:5:"posts";s:5:"count";s:4:"1856";}s:7:"sidebar";a:3:{s:4:"name";s:7:"sidebar";s:4:"slug";s:7:"sidebar";s:5:"count";s:4:"1583";}s:7:"twitter";a:3:{s:4:"name";s:7:"twitter";s:4:"slug";s:7:"twitter";s:5:"count";s:4:"1329";}s:6:"google";a:3:{s:4:"name";s:6:"google";s:4:"slug";s:6:"google";s:5:"count";s:4:"1325";}s:8:"comments";a:3:{s:4:"name";s:8:"comments";s:4:"slug";s:8:"comments";s:5:"count";s:4:"1310";}s:6:"images";a:3:{s:4:"name";s:6:"images";s:4:"slug";s:6:"images";s:5:"count";s:4:"1260";}s:4:"page";a:3:{s:4:"name";s:4:"page";s:4:"slug";s:4:"page";s:5:"count";s:4:"1225";}s:5:"image";a:3:{s:4:"name";s:5:"image";s:4:"slug";s:5:"image";s:5:"count";s:4:"1121";}s:9:"shortcode";a:3:{s:4:"name";s:9:"shortcode";s:4:"slug";s:9:"shortcode";s:5:"count";s:4:"1000";}s:8:"facebook";a:3:{s:4:"name";s:8:"Facebook";s:4:"slug";s:8:"facebook";s:5:"count";s:3:"982";}s:5:"links";a:3:{s:4:"name";s:5:"links";s:4:"slug";s:5:"links";s:5:"count";s:3:"974";}s:3:"seo";a:3:{s:4:"name";s:3:"seo";s:4:"slug";s:3:"seo";s:5:"count";s:3:"950";}s:9:"wordpress";a:3:{s:4:"name";s:9:"wordpress";s:4:"slug";s:9:"wordpress";s:5:"count";s:3:"844";}s:7:"gallery";a:3:{s:4:"name";s:7:"gallery";s:4:"slug";s:7:"gallery";s:5:"count";s:3:"821";}s:6:"social";a:3:{s:4:"name";s:6:"social";s:4:"slug";s:6:"social";s:5:"count";s:3:"780";}s:3:"rss";a:3:{s:4:"name";s:3:"rss";s:4:"slug";s:3:"rss";s:5:"count";s:3:"722";}s:7:"widgets";a:3:{s:4:"name";s:7:"widgets";s:4:"slug";s:7:"widgets";s:5:"count";s:3:"686";}s:6:"jquery";a:3:{s:4:"name";s:6:"jquery";s:4:"slug";s:6:"jquery";s:5:"count";s:3:"681";}s:5:"pages";a:3:{s:4:"name";s:5:"pages";s:4:"slug";s:5:"pages";s:5:"count";s:3:"678";}s:5:"email";a:3:{s:4:"name";s:5:"email";s:4:"slug";s:5:"email";s:5:"count";s:3:"623";}s:4:"ajax";a:3:{s:4:"name";s:4:"AJAX";s:4:"slug";s:4:"ajax";s:5:"count";s:3:"615";}s:5:"media";a:3:{s:4:"name";s:5:"media";s:4:"slug";s:5:"media";s:5:"count";s:3:"595";}s:10:"javascript";a:3:{s:4:"name";s:10:"javascript";s:4:"slug";s:10:"javascript";s:5:"count";s:3:"572";}s:5:"video";a:3:{s:4:"name";s:5:"video";s:4:"slug";s:5:"video";s:5:"count";s:3:"570";}s:10:"buddypress";a:3:{s:4:"name";s:10:"buddypress";s:4:"slug";s:10:"buddypress";s:5:"count";s:3:"541";}s:4:"feed";a:3:{s:4:"name";s:4:"feed";s:4:"slug";s:4:"feed";s:5:"count";s:3:"539";}s:7:"content";a:3:{s:4:"name";s:7:"content";s:4:"slug";s:7:"content";s:5:"count";s:3:"530";}s:5:"photo";a:3:{s:4:"name";s:5:"photo";s:4:"slug";s:5:"photo";s:5:"count";s:3:"522";}s:4:"link";a:3:{s:4:"name";s:4:"link";s:4:"slug";s:4:"link";s:5:"count";s:3:"506";}s:6:"photos";a:3:{s:4:"name";s:6:"photos";s:4:"slug";s:6:"photos";s:5:"count";s:3:"505";}s:5:"login";a:3:{s:4:"name";s:5:"login";s:4:"slug";s:5:"login";s:5:"count";s:3:"471";}s:4:"spam";a:3:{s:4:"name";s:4:"spam";s:4:"slug";s:4:"spam";s:5:"count";s:3:"458";}s:5:"stats";a:3:{s:4:"name";s:5:"stats";s:4:"slug";s:5:"stats";s:5:"count";s:3:"453";}s:8:"category";a:3:{s:4:"name";s:8:"category";s:4:"slug";s:8:"category";s:5:"count";s:3:"452";}s:7:"youtube";a:3:{s:4:"name";s:7:"youtube";s:4:"slug";s:7:"youtube";s:5:"count";s:3:"436";}s:7:"comment";a:3:{s:4:"name";s:7:"comment";s:4:"slug";s:7:"comment";s:5:"count";s:3:"432";}}', 'yes'),
(141, '_transient_is_multi_author', '0', 'yes'),
(142, '_transient_twentyfourteen_category_count', '1', 'yes'),
(159, 'wdcab', 'a:5:{s:7:"enabled";s:1:"1";s:5:"title";s:18:"Back To Main Store";s:10:"title_link";s:65:"http://localhost/vistacart/admins";s:5:"links";a:0:{}s:14:"disabled_menus";s:0:"";}', 'yes');

INSERT INTO `goStores_Vista_wp_postmeta` (`meta_id`, `post_id`, `meta_key`, `meta_value`) VALUES
(1, 2, '_wp_page_template', 'default');

INSERT INTO `goStores_Vista_wp_posts` (`ID`, `post_author`, `post_date`, `post_date_gmt`, `post_content`, `post_title`, `post_excerpt`, `post_status`, `comment_status`, `ping_status`, `post_password`, `post_name`, `to_ping`, `pinged`, `post_modified`, `post_modified_gmt`, `post_content_filtered`, `post_parent`, `guid`, `menu_order`, `post_type`, `post_mime_type`, `comment_count`) VALUES
(1, 1, '2014-02-24 11:55:05', '2014-02-24 11:55:05', 'Welcome to WordPress. This is your first post. Edit or delete it, then start blogging!', 'Hello world!', '', 'publish', 'open', 'open', '', 'hello-world', '', '', '2014-02-24 11:55:05', '2014-02-24 11:55:05', '', 0, 'http://localhost/vistacart/app/webroot/blog/?p=1', 0, 'post', '', 1),
(2, 1, '2014-02-24 11:55:05', '2014-02-24 11:55:05', 'This is an example page. It''s different from a blog post because it will stay in one place and will show up in your site navigation (in most themes). Most people start with an About page that introduces them to potential site visitors. It might say something like this:\n\n<blockquote>Hi there! I''m a bike messenger by day, aspiring actor by night, and this is my blog. I live in Los Angeles, have a great dog named Jack, and I like pi&#241;a coladas. (And gettin'' caught in the rain.)</blockquote>\n\n...or something like this:\n\n<blockquote>The XYZ Doohickey Company was founded in 1971, and has been providing quality doohickeys to the public ever since. Located in Gotham City, XYZ employs over 2,000 people and does all kinds of awesome things for the Gotham community.</blockquote>\n\nAs a new WordPress user, you should go to <a href="http://localhost/vistacart/app/webroot/blog/wp-admin/">your dashboard</a> to delete this page and create new pages for your content. Have fun!', 'Sample Page', '', 'publish', 'open', 'open', '', 'sample-page', '', '', '2014-02-24 11:55:05', '2014-02-24 11:55:05', '', 0, 'http://localhost/vistacart/app/webroot/blog/?page_id=2', 0, 'page', '', 0),
(3, 1, '2014-02-24 11:55:18', '0000-00-00 00:00:00', '', 'Auto Draft', '', 'auto-draft', 'open', 'open', '', '', '', '', '2014-02-24 11:55:18', '0000-00-00 00:00:00', '', 0, 'http://localhost/vistacart/app/webroot/blog/?p=3', 0, 'post', '', 0),
(4, 1, '2014-02-24 12:23:21', '0000-00-00 00:00:00', '', 'Auto Draft', '', 'auto-draft', 'open', 'open', '', '', '', '', '2014-02-24 12:23:21', '0000-00-00 00:00:00', '', 0, 'http://localhost/vistacart/app/webroot/blog/?page_id=4', 0, 'page', '', 0),
(5, 1, '2014-02-24 12:23:48', '0000-00-00 00:00:00', '', 'Auto Draft', '', 'auto-draft', 'open', 'open', '', '', '', '', '2014-02-24 12:23:48', '0000-00-00 00:00:00', '', 0, 'http://localhost/vistacart/app/webroot/blog/?page_id=5', 0, 'page', '', 0);

INSERT INTO `goStores_Vista_wp_terms` (`term_id`, `name`, `slug`, `term_group`) VALUES
(1, 'Uncategorized', 'uncategorized', 0);

INSERT INTO `goStores_Vista_wp_term_relationships` (`object_id`, `term_taxonomy_id`, `term_order`) VALUES
(1, 1, 0);

INSERT INTO `goStores_Vista_wp_term_taxonomy` (`term_taxonomy_id`, `term_id`, `taxonomy`, `description`, `parent`, `count`) VALUES
(1, 1, 'category', '', 0, 1);

INSERT INTO `goStores_Vista_wp_usermeta` (`umeta_id`, `user_id`, `meta_key`, `meta_value`) VALUES
(1, 1, 'first_name', ''),
(2, 1, 'last_name', ''),
(3, 1, 'nickname', 'admin'),
(4, 1, 'description', ''),
(5, 1, 'rich_editing', 'true'),
(6, 1, 'comment_shortcuts', 'false'),
(7, 1, 'admin_color', 'fresh'),
(8, 1, 'use_ssl', '0'),
(9, 1, 'show_admin_bar_front', 'true'),
(10, 1, 'Vista_wp_capabilities', 'a:1:{s:13:"administrator";b:1;}'),
(11, 1, 'Vista_wp_user_level', '10'),
(12, 1, 'dismissed_wp_pointers', 'wp330_toolbar,wp330_saving_widgets,wp340_choose_image_from_library,wp340_customize_current_theme_link,wp350_media,wp360_revisions,wp360_locks'),
(13, 1, 'show_welcome_panel', '1'),
(14, 1, 'Vista_wp_dashboard_quick_press_last_post_id', '3'),
(15, 1, 'managenav-menuscolumnshidden', 'a:4:{i:0;s:11:"link-target";i:1;s:11:"css-classes";i:2;s:3:"xfn";i:3;s:11:"description";}'),
(16, 1, 'metaboxhidden_nav-menus', 'a:3:{i:0;s:8:"add-post";i:1;s:12:"add-post_tag";i:2;s:15:"add-post_format";}');

INSERT INTO `goStores_Vista_wp_users` (`ID`, `user_login`, `user_pass`, `user_nicename`, `user_email`, `user_url`, `user_registered`, `user_activation_key`, `user_status`, `display_name`) VALUES
(1, 'admin', '$P$BgRq1DV/Y74En4Cf7dThW1Vu18ujXl0', 'admin', 'jamessmith121212@gmail.com', '', '2014-02-24 11:55:05', '', 0, 'admin');

INSERT INTO `goStores_ProductServices` (`nServiceId`, `vServiceName`, `vServiceDescription`, `nSCatId`, `nPId`, `price`, `nQty`, `vType`, `vBillingInterval`, `nBillingDuration`, `nStatus`, `dLastUpdated`) VALUES
(1, 'Free Trial', 'Free Trial', 1, 1, 0.00, 100, 'free', 'M', 14, 0, '2012-12-19 15:50:09');

INSERT INTO `goStores_Banners` (`nBannerId`, `vBannerText`, `vBannerUrl`, `vBannerImageId`, `vActive`, `showcount`, `clickcount`, `eType`) VALUES
(9, 'GoStores', '', 776, '1', '', '', 'Header'),
(10, 'GoStores', '', 780, '1', '', '', 'Header'),
(11, 'GoStores', '', 781, '0', '', '', 'Header'),
(13, 'GoStores', '', 824, '1', '', '', 'Header');

INSERT INTO `goStores_files` (`file_id`, `file_orig_name`, `file_extension`, `file_mime_type`, `file_type`, `file_width`, `file_height`, `file_play_time`, `file_size`, `file_path`, `file_status`, `file_title`, `file_caption`, `file_tmp_name`, `created_on`, `created_by`) VALUES
(776, 'banner1315847750.jpg', 'jpg', 'image/jpeg', '', 988, 337, 0, 102557, 'me91hb3xfh0.jpg', NULL, NULL, NULL, NULL, NULL, 0),
(780, 'banner1315856405.jpg', 'jpg', 'image/jpeg', '', 988, 337, 0, 139726, 'meacd2x9hpq.jpg', NULL, NULL, NULL, NULL, NULL, 0),
(781, 'banner1315850451.jpg', 'jpg', 'image/jpeg', '', 988, 337, 0, 137194, 'meaclpwk0on.jpg', NULL, NULL, NULL, NULL, NULL, 0),
(824, 'banner.jpg', 'jpg', 'image/jpeg', '', 1250, 400, 0, 326193, 'mf4d5362byd.jpg', NULL, NULL, NULL, NULL, NULL, 0),
(846, 'screen5.jpg', 'jpg', 'image/jpeg', '', 400, 231, 0, 92656, 'mgt5uqvtpbd.jpg', NULL, NULL, NULL, NULL, NULL, 0),
(847, 'screen2.jpg', 'jpg', 'image/jpeg', '', 400, 231, 0, 49011, 'mgt5ylasmyr.jpg', NULL, NULL, NULL, NULL, NULL, 0),
(848, 'screen3.jpg', 'jpg', 'image/jpeg', '', 400, 231, 0, 41185, 'mgt62bcr2b6.jpg', NULL, NULL, NULL, NULL, NULL, 0),
(849, 'screen4.jpg', 'jpg', 'image/jpeg', '', 400, 231, 0, 37790, 'mgt7ao0kecp.jpg', NULL, NULL, NULL, NULL, NULL, 0),
(850, 'screen1.jpg', 'jpg', 'image/jpeg', '', 400, 231, 0, 34610, 'mgt7azc4209.jpg', NULL, NULL, NULL, NULL, NULL, 0),
(851, 'screen6.jpg', 'jpg', 'image/jpeg', '', 400, 231, 0, 34063, 'mgt7bbctolm.jpg', NULL, NULL, NULL, NULL, NULL, 0),
(852, 'screen7.jpg', 'jpg', 'image/jpeg', '', 400, 231, 0, 49721, 'mgt7cut79wl.jpg', NULL, NULL, NULL, NULL, NULL, 0),
(853, 'screen8.jpg', 'jpg', 'image/jpeg', '', 400, 231, 0, 57425, 'mgt7ddhjn0s.jpg', NULL, NULL, NULL, NULL, NULL, 0),
(854, 'screen9.jpg', 'jpg', 'image/jpeg', '', 400, 231, 0, 50962, 'mgt7dqpo0d8.jpg', NULL, NULL, NULL, NULL, NULL, 0),
(855, 'screen10.jpg', 'jpg', 'image/jpeg', '', 400, 231, 0, 42304, 'mgt7ek4w45m.jpg', NULL, NULL, NULL, NULL, NULL, 0),
(856, 'screen11.jpg', 'jpg', 'image/jpeg', '', 400, 231, 0, 51930, 'mgt7exu4ops.jpg', NULL, NULL, NULL, NULL, NULL, 0),
(857, 'screen12.jpg', 'jpg', 'image/jpeg', '', 400, 231, 0, 42350, 'mgt7fev1i3a.jpg', NULL, NULL, NULL, NULL, NULL, 0);


INSERT INTO `goStores_DemoScreenshots` (`nScreenId`, `vScreenImageId`, `vActive`, `eType`) VALUES
(1, 846, '1', 'User'),
(2, 847, '1', 'User'),
(3, 848, '1', 'User'),
(4, 849, '1', 'User'),
(5, 850, '1', 'User'),
(6, 851, '1', 'User'),
(7, 852, '1', 'Admin'),
(8, 853, '1', 'Admin'),
(9, 854, '1', 'Admin'),
(10, 855, '1', 'Admin'),
(11, 856, '1', 'Admin'),
(12, 857, '1', 'Admin');

INSERT INTO `goStores_tld_godaddy` (`nId`, `nDuration`, `eType`, `vProductid`, `vTld`) VALUES
	(1, 1, 'Registration', '350001', 'com'),
	(2, 2, 'Registration', '350002', 'com'),
	(3, 3, 'Registration', '350003', 'com'),
	(4, 4, 'Registration', '350004', 'com'),
	(5, 5, 'Registration', '350005', 'com'),
	(6, 6, 'Registration', '350006', 'com'),
	(7, 7, 'Registration', '350007', 'com'),
	(8, 8, 'Registration', '350008', 'com'),
	(9, 9, 'Registration', '350009', 'com'),
	(10, 10, 'Registration', '350010', 'com'),
	(11, 1, 'Renewal', '15212', 'bz'),
	(12, 1, 'Renewal', '19140', 'me'),
	(13, 1, 'Renewal', '19850', 'in'),
	(14, 1, 'Renewal', '50801', 'mobi'),
	(15, 1, 'Renewal', '51000', 'co.in'),
	(16, 1, 'Renewal', '51100', 'firm.in'),
	(17, 1, 'Renewal', '51200', 'gen.in'),
	(18, 1, 'Renewal', '51300', 'ind.in'),
	(19, 1, 'Renewal', '51400', 'net.in'),
	(20, 1, 'Renewal', '350012', 'com'),
	(21, 2, 'Renewal', '350013', 'com'),
	(22, 3, 'Renewal', '350014', 'com'),
	(23, 4, 'Renewal', '350015', 'com'),
	(24, 5, 'Renewal', '350016', 'com'),
	(25, 6, 'Renewal', '350017', 'com'),
	(26, 7, 'Renewal', '350018', 'com'),
	(27, 8, 'Renewal', '350019', 'com'),
	(28, 9, 'Renewal', '350020', 'com'),
	(29, 10, 'Renewal', '350021', 'com'),
	(30, 1, 'Transfer', '350011', 'com'),
	(31, 1, 'Registration', '350076', 'BIZ'),
	(32, 2, 'Registration', '350077', 'BIZ'),
	(33, 3, 'Registration', '350078', 'BIZ'),
	(34, 4, 'Registration', '350079', 'BIZ'),
	(35, 5, 'Registration', '350080', 'BIZ'),
	(36, 6, 'Registration', '350081', 'BIZ'),
	(37, 7, 'Registration', '350082', 'BIZ'),
	(38, 8, 'Registration', '350083', 'BIZ'),
	(39, 9, 'Registration', '350084', 'BIZ'),
	(40, 10, 'Registration', '350085', 'BIZ'),
	(41, 1, 'Transfer', '350086', 'BIZ'),
	(42, 1, 'Renewal', '350087', 'BIZ'),
	(43, 2, 'Renewal', '350088', 'BIZ'),
	(44, 3, 'Renewal', '350089', 'BIZ'),
	(45, 4, 'Renewal', '350090', 'BIZ'),
	(46, 5, 'Renewal', '350091', 'BIZ'),
	(47, 6, 'Renewal', '350092', 'BIZ'),
	(48, 7, 'Renewal', '350093', 'BIZ'),
	(49, 8, 'Renewal', '350094', 'BIZ'),
	(50, 9, 'Renewal', '350095', 'BIZ'),
	(51, 10, 'Renewal', '350096', 'BIZ'),
	(52, 1, 'Registration', '9850', 'IN'),
	(53, 2, 'Registration', '9851', 'IN'),
	(54, 3, 'Registration', '9852', 'IN'),
	(55, 4, 'Registration', '9853', 'IN'),
	(56, 5, 'Registration', '9854', 'IN'),
	(57, 6, 'Registration', '9855', 'IN'),
	(58, 7, 'Registration', '9856', 'IN'),
	(59, 8, 'Registration', '9857', 'IN'),
	(60, 9, 'Registration', '9858', 'IN'),
	(61, 10, 'Registration', '9859', 'IN'),
	(62, 1, 'Transfer', '9860', 'IN'),
	(63, 1, 'Renewal', '19850', 'IN'),
	(64, 2, 'Renewal', '19851', 'IN'),
	(65, 3, 'Renewal', '19852', 'IN'),
	(66, 4, 'Renewal', '19853', 'IN'),
	(67, 5, 'Renewal', '19854', 'IN'),
	(68, 6, 'Renewal', '19855', 'IN'),
	(69, 7, 'Renewal', '19856', 'IN'),
	(70, 8, 'Renewal', '19857', 'IN'),
	(71, 9, 'Renewal', '19858', 'IN'),
	(72, 10, 'Renewal', '19859', 'IN'),
	(73, 1, 'Registration', '350051', 'INFO'),
	(74, 2, 'Registration', '350052', 'INFO'),
	(75, 3, 'Registration', '350053', 'INFO'),
	(76, 4, 'Registration', '350054', 'INFO'),
	(77, 5, 'Registration', '350055', 'INFO'),
	(78, 6, 'Registration', '350056', 'INFO'),
	(79, 7, 'Registration', '350057', 'INFO'),
	(80, 8, 'Registration', '350058', 'INFO'),
	(81, 9, 'Registration', '350059', 'INFO'),
	(82, 10, 'Registration', '350060', 'INFO'),
	(83, 1, 'Transfer', '350061', 'INFO'),
	(84, 1, 'Renewal', '350062', 'INFO'),
	(85, 2, 'Renewal', '350063', 'INFO'),
	(86, 3, 'Renewal', '350064', 'INFO'),
	(87, 4, 'Renewal', '350065', 'INFO'),
	(88, 5, 'Renewal', '350066', 'INFO'),
	(89, 6, 'Renewal', '350067', 'INFO'),
	(90, 7, 'Renewal', '350068', 'INFO'),
	(91, 8, 'Renewal', '350069', 'INFO'),
	(92, 9, 'Renewal', '350070', 'INFO'),
	(93, 10, 'Renewal', '350071', 'INFO'),
	(94, 1, 'Registration', '40801', 'MOBI'),
	(95, 2, 'Registration', '40802', 'MOBI'),
	(96, 3, 'Registration', '40803', 'MOBI'),
	(97, 4, 'Registration', '40804', 'MOBI'),
	(98, 5, 'Registration', '40805', 'MOBI'),
	(99, 6, 'Registration', '40806', 'MOBI'),
	(100, 7, 'Registration', '40807', 'MOBI'),
	(101, 8, 'Registration', '40808', 'MOBI'),
	(102, 9, 'Registration', '40809', 'MOBI'),
	(103, 10, 'Registration', '40810', 'MOBI'),
	(104, 1, 'Transfer', '40811', 'MOBI'),
	(105, 1, 'Renewal', '50801', 'MOBI'),
	(106, 2, 'Renewal', '50802', 'MOBI'),
	(107, 3, 'Renewal', '50803', 'MOBI'),
	(108, 4, 'Renewal', '50804', 'MOBI'),
	(109, 5, 'Renewal', '50805', 'MOBI'),
	(110, 6, 'Renewal', '50806', 'MOBI'),
	(111, 7, 'Renewal', '50807', 'MOBI'),
	(112, 8, 'Renewal', '50808', 'MOBI'),
	(113, 9, 'Renewal', '50809', 'MOBI'),
	(114, 10, 'Renewal', '50810', 'MOBI'),
	(115, 1, 'Registration', '350030', 'NET '),
	(116, 2, 'Registration', '350031', 'NET '),
	(117, 3, 'Registration', '350032', 'NET '),
	(118, 4, 'Registration', '350033', 'NET '),
	(119, 5, 'Registration', '350034', 'NET '),
	(120, 6, 'Registration', '350035', 'NET '),
	(121, 7, 'Registration', '350036', 'NET '),
	(122, 8, 'Registration', '350037', 'NET '),
	(123, 9, 'Registration', '350038', 'NET '),
	(124, 10, 'Registration', '350039', 'NET '),
	(125, 1, 'Transfer', '350040', 'NET '),
	(126, 1, 'Renewal', '350041', 'NET '),
	(127, 2, 'Renewal', '350042', 'NET '),
	(128, 3, 'Renewal', '350043', 'NET '),
	(129, 4, 'Renewal', '350044', 'NET '),
	(130, 5, 'Renewal', '350045', 'NET '),
	(131, 6, 'Renewal', '350046', 'NET '),
	(132, 7, 'Renewal', '350047', 'NET '),
	(133, 8, 'Renewal', '350048', 'NET '),
	(134, 9, 'Renewal', '350049', 'NET '),
	(135, 10, 'Renewal', '350050', 'NET '),
	(136, 1, 'Registration', '350150', 'ORG'),
	(137, 2, 'Registration', '350151', 'ORG'),
	(138, 3, 'Registration', '350152', 'ORG'),
	(139, 4, 'Registration', '350153', 'ORG'),
	(140, 5, 'Registration', '350154', 'ORG'),
	(141, 6, 'Registration', '350155', 'ORG'),
	(142, 7, 'Registration', '350156', 'ORG'),
	(143, 8, 'Registration', '350157', 'ORG'),
	(144, 9, 'Registration', '350158', 'ORG'),
	(145, 10, 'Registration', '350159', 'ORG'),
	(146, 1, 'Transfer', '350160', 'ORG'),
	(147, 1, 'Renewal', '350161', 'ORG'),
	(148, 2, 'Renewal', '350162', 'ORG'),
	(149, 3, 'Renewal', '350163', 'ORG'),
	(150, 4, 'Renewal', '350164', 'ORG'),
	(151, 5, 'Renewal', '350165', 'ORG'),
	(152, 6, 'Renewal', '350166', 'ORG'),
	(153, 7, 'Renewal', '350167', 'ORG'),
	(154, 8, 'Renewal', '350168', 'ORG'),
	(155, 9, 'Renewal', '350169', 'ORG'),
	(156, 10, 'Renewal', '350170', 'ORG'),
	(157, 1, 'Registration', '350126', 'US'),
	(158, 2, 'Registration', '350127', 'US'),
	(159, 3, 'Registration', '350128', 'US'),
	(160, 4, 'Registration', '350129', 'US'),
	(161, 5, 'Registration', '350130', 'US'),
	(162, 6, 'Registration', '350131', 'US'),
	(163, 7, 'Registration', '350132', 'US'),
	(164, 8, 'Registration', '350133', 'US'),
	(165, 9, 'Registration', '350134', 'US'),
	(166, 10, 'Registration', '350135', 'US'),
	(167, 1, 'Transfer', '350136', 'US'),
	(168, 1, 'Renewal', '350137', 'US'),
	(169, 2, 'Renewal', '350138', 'US'),
	(170, 3, 'Renewal', '350139', 'US'),
	(171, 4, 'Renewal', '350140', 'US'),
	(172, 5, 'Renewal', '350141', 'US'),
	(173, 6, 'Renewal', '350142', 'US'),
	(174, 7, 'Renewal', '350143', 'US'),
	(175, 8, 'Renewal', '350144', 'US'),
	(176, 9, 'Renewal', '350145', 'US'),
	(177, 10, 'Renewal', '350146', 'US'),
	(178, 1, 'Registration', '350101', 'WS'),
	(179, 2, 'Registration', '350102', 'WS'),
	(180, 3, 'Registration', '350103', 'WS'),
	(181, 4, 'Registration', '350104', 'WS'),
	(182, 5, 'Registration', '350105', 'WS'),
	(183, 6, 'Registration', '350106', 'WS'),
	(184, 7, 'Registration', '350107', 'WS'),
	(185, 8, 'Registration', '350108', 'WS'),
	(186, 9, 'Registration', '350109', 'WS'),
	(187, 10, 'Registration', '350110', 'WS'),
	(188, 1, 'Renewal', '350112', 'WS'),
	(189, 2, 'Renewal', '350113', 'WS'),
	(190, 3, 'Renewal', '350114', 'WS'),
	(191, 4, 'Renewal', '350115', 'WS'),
	(192, 5, 'Renewal', '350116', 'WS'),
	(193, 6, 'Renewal', '350117', 'WS'),
	(194, 7, 'Renewal', '350118', 'WS'),
	(195, 8, 'Renewal', '350119', 'WS'),
	(196, 9, 'Renewal', '350120', 'WS'),
	(197, 10, 'Renewal', '350121', 'WS'),
	(198, 1, 'Transfer', '350811', 'WS');

INSERT INTO `goStores_Settings` (`settingfield`, `settinglabel`, `value`, `groupLabel`, `type`, `fieldOrder`, `helpText`) VALUES ('paypal_bn_code', 'Paypal BN Code', NULL, 'Payment', '', '', 'Build Notation ID Code is a unique identifier that tells PayPal how much volume comes in through merchants who use your integrated Paypal solution');

INSERT INTO `goStores_Settings` (`settingfield`, `settinglabel`, `value`, `groupLabel`, `type`, `fieldOrder`, `helpText`) VALUES ('paypaladvanced_bn_code', 'Paypal Advanced BN Code', NULL, 'Payment', '', '', 'Build Notation ID Code is a unique identifier that tells PayPal how much volume comes in through merchants who use your integrated Paypal solution');

INSERT INTO `goStores_Settings` (`settingfield`, `settinglabel`, `value`, `groupLabel`, `type`, `fieldOrder`, `helpText`) VALUES ('paypalpro_bn_code', 'Paypalpro BN Code', NULL, 'Payment', '', '', 'Build Notation ID Code is a unique identifier that tells PayPal how much volume comes in through merchants who use your integrated Paypal solution');

INSERT INTO `goStores_Settings` (`settingfield`, `settinglabel`, `value`, `groupLabel`, `type`, `helpText`) VALUES ('site_operation_mode', 'Site Operation Mode', 'S', 'Server Settings', 'radio', 'Choose the option \'single server\' if your website and store installations are in same server else \'multiple server\'');

INSERT INTO `goStores_Settings` (`settingfield`, `settinglabel`, `value`, `groupLabel`, `type`, `helpText`) VALUES ('site_operation_park_domain', 'Temporary URLs', 'N', 'Server Settings', 'radio', 'If you have chosen \'Yes\', please configure your server setings to \'Allow users to park subdomains/domains of the server\'s hostname\'');

INSERT INTO `goStores_Settings` (`settingfield`, `settinglabel`, `value`, `groupLabel`, `type`, `fieldOrder`, `helpText`) VALUES ('enableDomiainRegistration', 'Enable Domain Registration', 'N', 'Domain Registrar', 'checkbox', 0, 'Enable Domain Registration');

INSERT INTO `goStores_Vista_cmspages` (`id`, `title`, `content`, `type`, `status`) VALUES 
(13, 'Registration confirm mail to admin user', '<p>&nbsp;</p>\r\n<p>&nbsp;</p>\r\n<p><em><span style="font-size: larger;">Hi Dear [User_Name],<br />\r\n</span></em></p>\r\n<p><em><span style="font-size: larger;">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; You are  Registered as admin user  with&nbsp; [SITE_NAME] is completed......<br />\r\n</span></em></p>\r\n<p><em><span style="font-size: larger;">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Your User Name is&nbsp; : [User_Name]</span></em> </p>\r\n<p>&nbsp;&nbsp;<em><span style="font-size: larger;">&nbsp;&nbsp;&nbsp; Your Password is&nbsp;&nbsp;&nbsp;&nbsp; :&nbsp; [PASSWORD]</span></em></p>\r\n<p><em><span style="font-size: larger;">&nbsp; [LOGIN_URL]<br />\r\n</span></em></p>\r\n<p><em><span style="font-size: larger;">Thanks and Regards,<br />\r\n</span></em></p>\r\n<p><em><span style="font-size: larger;">Administrator [SITE_NAME]<br />\r\n</span></em></p>', 'email', 'Y'),
(14, 'Contact us mail for admin', '<p>&nbsp;</p>\r\n<p>Dear Administrator,</p>\r\n<p>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; A new contact us request has been received at [SITE_NAME]. Please find the details below</p>\r\n<p>Name: [name]</p>\r\n<p>Email: [email]</p>\r\n<p>Message:- [message]</p>', 'email', 'Y');

UPDATE `goStores_Vista_users` SET `usertype`='Retail', `reg_status`='R' WHERE  `id`=1 LIMIT 1;

UPDATE `goStores_Settings` SET `helpText`='Would you like your site linked to LinkedIn?' WHERE  `settingfield`='enable_ln' AND `settinglabel`='Enable LinkedIn' AND `groupLabel`='Social Settings' AND `type`='checkbox' AND `fieldOrder`=0  LIMIT 1;

UPDATE `goStores_ProductPermission` SET `vPermissions` = 'app/webroot/img/,app/webroot/img/products/,app/webroot/img/csv/,app/tmp/,app/tmp/logs/,app/tmp/sessions/,app/tmp/cache/,app/tmp/cache/models/,app/tmp/cache/views/,app/tmp/cache/persistent/,app/webroot/files/,app/webroot/files/File,app/webroot/files/Flash,app/webroot/files/Image,app/webroot/files/Media,app/webroot/files/Graph,app/config/database.php,app/webroot/config.php,app/webroot/img/SiteLogo.gif,app/webroot/img/SiteLogo_disp.gif,app/webroot/blog/wp-content/,app/webroot/blog/wp-config.php,app/controllers/components/pple.xml,app/webroot/configxml.xml,app/webroot/moneybooker.txt,' WHERE `goStores_ProductPermission`.`nId` = 1;

INSERT INTO `sptbl_lookup` (`vLookUpName`,`vLookUpValue`) VALUES ('HomeFooterContent','How can we help you?');
UPDATE sptbl_lookup set vLookUpValue='en' where vLookUpName='DefaultLang';
UPDATE sptbl_lookup set vLookUpValue='1' where vLookUpName='LangChoice';
UPDATE sptbl_lookup set vLookUpValue='1' where vLookUpName='AutoLock';
UPDATE sptbl_lookup set vLookUpValue='1' where vLookUpName='VerifyTemplate';
UPDATE sptbl_lookup set vLookUpValue='1' where vLookUpName='VerifyKB';
UPDATE `sptbl_lookup` set `vLookUpValue`=4.3 where `vLookUpName`='Version';
INSERT INTO `sptbl_lookup` (`vLookUpName`) VALUES ('SMTPUsername');
INSERT INTO `sptbl_lookup` (`vLookUpName`) VALUES ('SMTPPassword');
INSERT INTO `sptbl_lookup` (`vLookUpName`) VALUES ('SMTPEnableSSL'); 

INSERT INTO `sptbl_templates` (`nTemplateId`, `dDate`, `vTemplateTitle`, `tTemplateDesc`, `nStaffId`, `vStatus`) VALUES ('1', '2013-07-26 00:00:00', 'installer_mail', '<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<title></title>
<table width="600" cellspacing="0" cellpadding="0" border="0" style="border:1px solid #ccc; background-color:#FDFDFD; ">
    <tbody>
        <tr>
            <td height="5" colspan="3"></td>
        </tr>
        <tr>
            <td width="5"></td>
            <td width="586"><table width="100%" cellspacing="0" cellpadding="0" border="0">
    <tbody>
        <tr>
            <td height="56" style="background-color:#324148; ">;
                <table width="100%" cellspacing="0" cellpadding="0" border="0">
                    <tbody>
                        <tr>
                            <td width="2%" height="80">&#160;</td>
                            <td width="37%">{SITE_LOGO}</td>
                            <td width="61%"><p style="font-family:Arial, Helvetica, sans-serif; font-size:12px; color:#CCCCCC; text-align:right; padding:0 15px 0 0; ">{Date}</p></td>
                        </tr>
                    </tbody>
                </table></td>
        </tr>
        <tr>
            <td height="10">&#160;</td>
        </tr>
        <tr>
            <td>&#160;</td>
        </tr>
        <tr>
            <td><table width="100%" cellspacing="0" cellpadding="0" border="0">
                    <tbody>
                        <tr>
                            <td width="2%">&#160;</td>
                            <td width="28%">{MAIL_CONTENT}</td>
                            <td width="2%">&#160;</td>
                        </tr>
                        <tr>
                            <td>&#160;</td>
                            <td>&#160;</td>
                            <td>&#160;</td>
                        </tr>
                        <tr>
                            <td>&#160;</td>
                            <td>&#160;</td>
                            <td>&#160;</td>
                        </tr>
                        <tr>
                            <td>&#160;</td>
                            <td>&#160;</td>
                            <td>&#160;</td>
                        </tr>
                    </tbody>
                </table></td>
        </tr>
        <tr>
            <td><table width="100%" cellspacing="0" cellpadding="0" border="0">
                    <tbody>
                        <tr>
                            <td height="30" style="background-color:#324148; "><p style="color:#FFFFFF; font-family:Arial, Helvetica, sans-serif; font-size:12px; padding:0 0 0 15px; ">{COPYRIGHT}</p></td>
                        </tr>
                    </tbody>
                </table></td>
        </tr>
    </tbody>
                </table></td>
                <td width="4">&#160;</td>
        </tr>
        <tr>
            <td height="10" colspan="3">&#160;</td>
        </tr>     </tbody> </table> <p>&#160;</p></meta>', '0', '0');